;;(load "initogl")
(define pickdot ())

; Create OpenGL window
(oglwin '.gl :width 300 :height 300)
(pack  .gl :expand 'yes :fill 'both)

; Initialization of viewing parameters
(.gl 'eval 
	:matrixmode 'projection 
	:loadidentity 
	:ortho -5 5 -5 5 -5 5 
	:matrixmode 'modelview 
	:loadidentity 
	:enable 'map1vertex3 
	:mapgrid1 100 0 1 
) 

; Initial control point coordinates
(define   cpoints '((-4 -4 0) (-2 4 0) (2 -4 0)(4 4 0)))

; Code to render curve and control points
(define  curve (.gl 'newlist))
(define  dots (.gl 'newlist))

(define (computecurve )
  (let ((tmp ()))
    (catch (.gl 'deletelist curve))
     (catch (.gl 'deletelist dots))
    (eval `(.gl 'newlist curve :map1 'map1vertex3 0 1 3 4 
              ,@(apply append  cpoints)
	    :evalmesh1 'line 0 100) () )

    (do ((i 0(+ i 1)))
         ((>= i  4))
	(set! tmp (append tmp `(:loadname ,i
		:begin points :vertex ,@(list-ref cpoints i) :end)))
    )
    (apply  .gl 'newlist dots :initnames :pushname -1 :pointsize 4 tmp)
))
(computecurve)


; Code to figure out which control point was picked
(define ( pick_point  x y )
  (let ((l ()))
    (set!  l (.gl 'select 100 :matrixmode 'projection 
	    :pushmatrix 
	    :loadidentity 
	    :pickmatrix x y 4 4
	    :ortho -5 5 -5 5 -5 5 
	    :matrixmode 'modelview 
	    :call dots 
	    :matrixmode 'projection
	    :popmatrix 
	    :matrixmode 'modelview ))

    (set!  pickdot ())
     (format #t "pick point l=~s~%" l)
    ;;(when (and (pair? l)(list? (car l)))  ;;; This is not bug of ss
      (do ((hit 0))
        ((null? l))
        (set! hit (pop l))
;;;     (set!  pickvtx (list-ref hit 3))
        (if (< (length hit) 4)
              ()   ;;;continue
          (begin
            (set!  pickdot (list-ref hit 3))
           ;;(set!  pickz (list-ref hit 1))
           ;;(format #t  "pick point ~a ~a~%" x y)
           (format #t  "vtx ~a~%" pickdot)
           ;;(format #t  "world coords ~a~%" (vector-ref vtx pickvtx))
           (format #t  "world coords ~a~%"
                  (.gl 'unproject x y 0))
              (set! l ())   ;;;break
          )
        )
      )
  ;; )
))    
;foreach hit $l {
;	set pickdot [lindex $hit 3]
;	if {$pickdot=={}} continue
;	puts "vtx $pickdot"
;	puts "world coords [.gl unproject $x $y 0]"
;	break
;    }
;}

; Code to drag the picked control point
(define (move_point  x y )
   ( when (not (null? pickdot))
        
	(set! cpoints (lreplace cpoints pickdot pickdot 
		(.gl 'unproject x y 0)))
	(format #t "cpoints:~s~%" cpoints)
        (computecurve)
	(.gl 'redraw)
   )
)

(.gl 'main :clear 'colorbuffer 
	:color 1 1 1 
	:call curve 
	:call dots) 

(bind .gl "<Button-1>" (lambda(x y)(pick_point x y )))

(bind .gl "<B1-Motion>" (lambda(x y)(move_point x y )))


