
;;;(load "initogl")
(oglwin '.gl :width 300 :height 300)
(pack  .gl :expand 'yes :fill 'both)

(define nx 4)
(define  ny 4)
(define controlpts 
	'(-1.5 -1.5 4   -0.5 -1.5 2.0   0.5 -1.5 -1.0   1.5 -1.5 2.0 
	-1.5 -0.5 1.0   -0.5 -0.5 3   0.5 -0.5 0   1.5 -0.5 3 
	-1.5 0.5 4.0   -0.5 0.5 0   0.5 0.5 3   1.5 0.5 4 
	-1.5 1.5 -2.0   -0.5 1.5 -2.0   0.5 1.5 0   1.5 1.5 -1))

(define vstride (* nx 3))

(eval `(.gl 'eval 
	:matrixmode 'projection 
	:loadidentity 
	:ortho -4 4 -4 4 -4 4 
	:map2 'map2vertex3 0 1 3 nx 0 1 vstride ny ,@controlpts
	:enable 'map2vertex3 
	:enable 'autonormal 
	:material 'frontandback 'ambientanddiffuse 0.5 0.5 0.5 
	:material 'frontandback 'specular 1 1 1 
	:material 'frontandback 'shininess 50 
	:shademodel 'smooth 
	:frontface 'cw
	:lightmodel 'lightmodeltwoside 1 
	:enable 'light0 
	:enable 'lighting 
	:enable 'depthtest) () )

(.gl 'main 
	:clear 'colorbuffer 'depthbuffer 
	:mapgrid2 20 0 1 20 0 1 
	:evalmesh2 'fill 0 20 0 20)

(define  xrot 0)
(define  yrot 0)
(define  pmode 'fill)
(define mouse-x 0)
(define mouse-y 0)

(bind .gl "<Button-1>" (lambda(x y)(set!  mouse-x x)(set! mouse-y y)))
(bind .gl "<B1-Motion>" (lambda (x y) 
    (set! xrot (+  xrot (- x mouse-x))) 
    (set! yrot (+  yrot (- y mouse-y))) 
    (set! mouse-x x)
    (set! mouse-y y)
    (.gl 'eval :matrixmode 'modelview 
            :loadidentity 
            :rotate yrot 1 0 0
            :rotate xrot 0 1 0)
    (.gl 'redraw)
))

(bind .gl "<Button-3>" (lambda () 
    (if (equal? pmode 'fill) ( set! pmode 'line)( set! pmode 'fill))
    (.gl 'eval :polygonmode 'frontandback pmode)
    (.gl 'redraw)
))


