/****  stack machine 03.9.26
   see note.cc   stack.scm
   change combination image of as
   args JSR argn .... arg1 FUNC func
   when JSR   stack image  is    func env arg1 ... argn
   for stack   compiler     see m.scm

  2003.11.18 New version based on m.scm(compiler)
  MPU stack is added
  03.12.2  stack_top,stack_init deleted  (old is backuped m.c-new-bak2)  

  03.12.15   compiler
    comp.c
  we need one path compiler!!!
***/

#define COMP_PROG
#include "lisp.h"

/** #define DEBUG  ***/

#ifdef DEBUG
#include <stdio.h>
extern FILE *stdout;
#endif

/*** #define DEBUG 1 ***/

#define CPCMAX 20000    /***  5000 is too small for log line command as tkogl ***/



#define CPUSH(x)  (*cpc_stack++=(x))
#define CPULL  (*--cpc_stack)
#define list1(x)  (SCONS(x,a_nil))

extern ptr s_macroexpand();

ptr get_value();
static ptr special_eval(),C_combi();
static ptr  set_var(),M_comp(),C_make_lambda(),C_make_macro(),C_combination();
static  C_else(), C_endif(),C_macro_eval(),C_call_cc();
static  C_blockout(),C_blockin(),func_eval();
/***
ptr CPC[CPCMAX];
ptr OUTCOMP[CPCMAX];
***/
extern PUSH_REG(),PULL_REG();
extern ptr *get_vector();

ptr *cpc_stack,*comp;
extern int narg,level;
extern int evalflag;   /****  eval can't define   ***/
extern ptr scm;
static int label;  /*** need conflict TK???? ***/
static ptr access;
ptr block_stack,top_env,dummy_func,NOP,ALLOC0;

extern ptr k_load,k_set,k_warn,k_env,k_top,k_lambda,k_macro,k_func,k_tail_jump;
extern ptr k_define,k_jmp,k_label,k_block_out,k_block_in,k_BIND,k_letbind,k_stack_narg;
extern ptr k_lambda_begin,k_lambda_bind,k_IF,k_I,k_call_cc,k_F;
extern ptr k_jsr,k_exit,k_tail,k_frame,k_frame_list;
extern ptr k_lambda_end,k_macro_end,k_imm,k_alloc,k_dealloc,k_reg,k_macroalias;


extern ptr list2(),list3();
/***
init_comp(){
  ** call only once *
   dummy_func=list2(k_lambda,a_undef);
   sysprotect[syspro++]=dummy_func;
   sysprotect[syspro++]=NOP=list1(a_f);
   sysprotect[syspro++]=ALLOC0=list2(k_alloc,ZERO);
  comp=OUTCOMP;
  cpc_stack=CPC;
}
****/

int special_p(ptr x){
  int n;
  if(SREGP(x)) return 0;
#ifdef DEBUG 
   lwritestr(STDOUT,"special_p ");
    prin1(x,STDOUT); 
    newline(STDOUT); 
#endif
  if(CLOSUREP(x)){
      n=FTYPE(x);
#ifdef DEBUG
   lwritestr(STDOUT,"special_p closure: ");
      if(n&SPECIAL) 
           lwritestr(STDOUT,"SPECIAL");
       else
           lwritestr(STDOUT,"function");
    newline(STDOUT);
#endif
      if(n&SPECIAL) return SPECIAL;
   }
   /****
  x=assq(x,top_env);  
   if(x==a_f) return 0;
   x=CDR(x);
   if(x==a_unbdd) return SPECIAL;    *** to be modify  *
  ***/
   return 0;
}

static void c_intern(ptr var,ptr value){
  CAR(k_define)=top_env=SCONS(SCONS(var,value),top_env);  /** for protect **/
}

settop_var(ptr var,ptr value){
  ptr x;
   x=assq(var,top_env);
  if(x!=a_f){
     CDR(x)=value;
    }
  else{
   warning(var,"unbind-var-set");
  }
}  

ptr get_value(ptr var){
  ptr x;
#ifdef DEBUG 
   lwritestr(STDOUT,"get_value var: ");
  prin1(var,STDOUT);
    newline(STDOUT); 
#endif
   x=assq(var,a_env);
   if(x!=a_f){
      access=k_env;
      return CDR(x);
   }
   else{
      access=k_top;
      x=assq(var,top_env);
      if(x!=a_f){
           return CDR(x);
       }
      else{
        if(CAR(var)!=a_unbdd)
           return CAR(var);
        else{
           warning(var,"unbind-var-load");
           return a_undef;
         }
      }
   }
}         

static ptr set_var(ptr var,ptr value){
  ptr x;
   x=assq(var,a_env);
   if(x!=a_f){
      CDR(x)=value;
      return access=k_env;
   }
   else{
      access=k_top;
      x=assq(var,top_env);
      if(x!=a_f){
           CDR(x)=value;
       }
      else{
        if(CAR(x)!=a_unbdd)
             CAR(x)=value;
        else{
           warning(var,"unbind-var-set");
         }
      }
      return access;
   }
}


forget(int n){
  comp-=n;
}

outcom(ptr s){
#ifdef DEBUG 
  lwritestr(STDOUT,"outcom: ");
  prin1(s,STDOUT);
   newline(STDOUT);
#endif
  *comp++=s;
}

warning(ptr x,char *p){
  outcom(list3(k_warn,CMAKESTR(p),x));
}


int get_ftype(ptr func){
 Reg int k;
#ifdef DEBUG 
   lwritestr(STDOUT,"get_ftype "); 
  newline(STDOUT); 
  /****
  prin1(func,STDOUT); 
  printf(" address %x attr nil %x\n",func,ATTR(a_nil));
  printf(" STDOUT %x attr  %x\n",STDOUT,ATTR(STDOUT));
   ***/
#endif

  if(SREGP(func)){
     /** warning(func,"undefined function"); **/
     return LAMBDA;  /** 04.5.4 **/
     /***    error(E_nullfunc,func);    No good! (lambda (x) (x 8))  can't compile ***/
    }
  if(ATTR(func)==SR2) return LAMBDA;  /**** V2.0  ***/
  /***
  PRINT("ftype  2");
  newline(STDOUT); 
***/
  k=special_p(func);
   if(k) return k;
  /*** 
   PRINT("ftype  3");
  newline(STDOUT); 
***/
  if(!CLOSUREP(func)){
     if(CONSP(func)){
       if(CAR(func)==k_lambda)
            return LAMBDA;
       if(CAR(func)==k_macro)
            return MACRO;
      }
     warning(func,"undefined function");
     return LAMBDA;
  }
   return (int)FTYPE(func);
}

ptr specialp( ptr x){
int kind;
  if(SREGP(x)) return a_f;
  if(ATTR(x)==SYNTAXSYMBOL) x=CADR(x);
  if(SYMBOLP(x)) x=ATOMVAL(x);
  if(SREGP(x)||!CLOSUREP(x)) return a_f;
#ifdef DEBUG
  lwritestr(STDOUT,"specialp called: ");
  prin1(x,STDOUT);
  newline(STDOUT);
#endif
  kind=get_ftype(x);
   if(kind&SPECIAL){
          return CAR(CDR(x));
  }
  return a_f;
}

ptr s_specialp(int nar, ptr env){
 ptr x;
int kind;
  checknarg(nar-1);
  return specialp(*(stack-1));
}
  
/***
ptr C_macro_expand(ptr s){
 psh(s);
 s=s_macroexpand(1,a_env);  *** macroexpand.c ***
   printf("C_macro_expand %x\n",s);
   prin1(s,STDOUT);
   newline(STDOUT);
 pull();
 return s;
}
***/

ptr stack_to_list(int narg){   /***  (list  ...)  ***/
  Reg ptr cars=a_nil;
  Reg ptr *p;
  p=stack;
     if(narg==0) return a_nil;
     if(narg < 0) error(E_shortarg,a_nil);  /*** more detail  ***/
        psh(cars);
     loop:
          *(stack-1)=cars=CONS(*--p,cars);
            if(--narg)
             {
              goto loop;
             }
     return *pull();
  }


ptr stack_to_listS(int narg){  /*** (list* ....)  ***/
  Reg ptr cars;
  Reg ptr *p;
  p=stack;
     if(narg==0) return a_nil;
     if(narg < 0) error(E_shortarg,a_nil);  /*** more detail  ***/
        *stack++=cars=*--p;
     loop:
         if(--narg){
          *(stack-1)=cars=CONS(*--p,cars);
          goto loop;
         }
     return *pull();
  }


ptr stack_2_list(ptr *begin,ptr *end){
 ptr res=a_nil;
 while(begin<end){
   res=SCONS(*--end,res);
 }
 return res;
}

  


