/***   vm.c
   SS ver2.0  
   2007.9.15
   see vm-boot2.ss
***/

#include "lisp.h"

extern   ptr assq();
extern ptr reverse_list();
extern ptr k_LB;

extern int _length();

ptr *VPC;   /*** main PC register ***/
          /****  a list version  ***/

extern int silent_mode;

 ptr SYSREG[9];    /*** gbc must protect!!!  **/
/*** #define VPUSH(x)  (*pcst++=(x))
     #define VPULL  (*--pcst)
***/
/** #define TRACEP(f)   ((int)FTYPE(f)&TRACE) **/

#define MCFP(f)   ((int)FTYPE(f)&ALLOC)

int vmdeb;   /**** for debug of VM ***/

ptr *PCST;

void VPUSH(ptr x){
  *PCST=CONS(x,*PCST);
}

ptr VPULL(){
  ptr s;
  s=CAR(*PCST);
  *PCST=CDR(*PCST);
  return s;
}

ptr *SCM;
ptr *ST,*BA;
ptr *MULTIVAL;
ptr *VMENV;
ptr *ARGS;
int NARG;

/** int evalflag;   ***  eval can't define   ***/

extern int gbc_malloc,error_count;

static ptr *mcprint();
static ptr make_lambda(), make_macro();

static void Reg_Push(),Reg_Pull(),Pull_PCST(),VLOAD(),VSET(),
    VMIMM(), IMM_undef(),IMM_t(),IMM_f(),IMM_null(),LOADENV(),SETENV(),
     MAKE_LAMBDA(),
    MAKE_MACRO(),DEFINE(),BIND(),IF_SCM_BA(),VJMP(),IF_FALSE(),IF_TRUE(),
    LAMBDA_BIND(),
    FUNC(),PUSHARG(),VJSR(),TAIL_JMP(),RETURN(),CLOSURE_ENV(),LAMBDA_ARGS(),
    SCM_MULTI(),SCM_BA(),BA_SCM(),SCM_ST(),SCM_ARGS(),
    ST_SCM(),COPY_CC(),RESTORE_BA(),RESTORE_CC();

static void (* VMOP[])()={Reg_Push,Reg_Pull,Pull_PCST,VLOAD,VSET,
    VMIMM, IMM_undef,IMM_t,IMM_f,IMM_null,LOADENV,SETENV,MAKE_LAMBDA,
    MAKE_MACRO,DEFINE,BIND,IF_SCM_BA,VJMP,IF_FALSE,IF_TRUE,LAMBDA_BIND,
    FUNC,PUSHARG,VJSR,TAIL_JMP,RETURN,CLOSURE_ENV,LAMBDA_ARGS,
    SCM_MULTI,SCM_BA,BA_SCM,SCM_ST,SCM_ARGS,
    ST_SCM,COPY_CC,RESTORE_BA,RESTORE_CC};

ptr VM();
void DO_VM();

void init_VM(){
  ptr *st=SYSREG;
  SCM=st;
  *st++=a_nil;
  ST=st;
  *st++=a_nil;
  BA=st;
  *st++=a_f;
  MULTIVAL=st;
  *st++=a_nil;
  VMENV=st;
  *st++=a_nil;
  ARGS=st;
  *st++=a_nil;
  NARG=0;
  VPC=st;
  *st++=a_nil;
  PCST=st;
  *st++=a_nil;
  *st=0;  /***  end mark  **/
}

ptr  call_vm(ptr pc){
  VPUSH(*VPC);
  VPUSH(*VMENV);
  VPUSH(*ARGS);
  VM(pc);
  *ARGS=VPULL(); 
  *VMENV=VPULL(); 
  *VPC=VPULL(); 
  return *SCM;
}
  
ptr s_call_vm(int narg,ptr env){
  return call_vm(*(stack-1));
}

ptr VM(ptr pc){
  ptr x;
  *VPC=pc;
  while(CONSP(pc)){
    x=CAR(pc);
    pc=CDR(pc);
    *VPC=pc;
    DO_VM(x);
    pc=*VPC;
  }
 return *SCM;
} 
      
void DO_VM(ptr x){
  int n;
  n=GETNUM(CAR(x));
  (* VMOP[n])(CDR(x));
}

void Reg_Push(ptr x)
{
  int n;
  n=GETNUM(CAR(x));
  VPUSH(*(SYSREG+n));
}

void Reg_Pull(ptr x)
{
  int n;
  n=GETNUM(CAR(x));
  *(SYSREG+n)=VPULL();
}

void Pull_PCST(ptr x)
{
  int n;
  ptr pc;
  n=GETNUM(CAR(x));
  pc=*PCST;
    while(n>0){
   pc=CDR(pc);
   n--;
  }
  *PCST=pc;
}

void VLOAD(ptr x)
{
  ptr s;
  s=CAR(x);
  *SCM=ATOMVAL(s);
}
void VSET(ptr x)
{
  ptr s;
  s=CAR(x);
  ATOMVAL(s)=*SCM;
}

void VMIMM(ptr x)
{
  ptr s;
  s=CAR(x);
  *SCM=s;
}

void IMM_undef(ptr x)
{
  *SCM=a_undef;
}
void IMM_t(ptr x)
{
  *SCM=a_t;
}
void IMM_f(ptr x)
{
  *SCM=a_f;
}
void IMM_null(ptr x)
{
  *SCM=a_nil;
}

void LOADENV(ptr x)
{
  ptr s;
  s=CAR(x);
  s=assq(s,*VMENV);
  *SCM=CDR(s);
}

void SETENV(ptr x)
{
  ptr s;
  s=CAR(x);
  x=assq(s,*VMENV);
  CDR(x)=*SCM;
}

void MAKE_LAMBDA(ptr x)
{
  ptr s,p;
  s=CAR(x);
  p=CONS(*VMENV,a_nil);
  p=SCONS(MAKESINT(26),p);   /** 26 is CLOSURE-ENV i ??? **/
  p=SCONS(p,s);
  p=SCONS(a_lambda,p);        /***  CDR is list =PC  ***/
  ATTR(p)=LAMBDA;   /***  OK??  **/
  *SCM=p;
}

void MAKE_MACRO(ptr x)
{
  ptr s,p;
  s=CAR(x);
  p=CONS(*VMENV,a_nil);
  p=SCONS(MAKESINT(26),p);   /** 26 is CLOSURE-ENV i ??? **/
  p=SCONS(p,s);
  p=SCONS(a_macro,p);        /***  CDR is list =PC  ***/
  ATTR(p)=MACRO;
  *SCM=p;
}

void DEFINE(ptr x)
{
  ptr var,scm;
  var=CAR(x);
  scm=*SCM;
  if(ATOMVAL(var)==a_unbdd)
      ATOMVAL(var)=scm; /*** Caution!!!  Modify for TK  ***/
  else
     M_top_value_set(var,scm); /*** see intern.c  ***/
}

void BIND(ptr x)
{
  ptr s;
  s=CAR(x);
  s=CONS(s,*SCM);
  *VMENV=SCONS(s,*VMENV);
}

void VM_JMP(int n){
  ptr pc;
  pc=*VPC;
  while(n>0){
   pc=CDR(pc);
   n--;
  }
 *VPC=pc;
}
   
void IF_SCM_BA(ptr x)
{
  int n;
  if(*SCM==*BA){
    VM_JMP(GETNUM(CAR(x)));
  }
}

void VJMP(ptr x)
{
    VM_JMP(GETNUM(CAR(x)));
}

void IF_FALSE(ptr x)
{
  if(*SCM==a_f){
    VM_JMP(GETNUM(CAR(x)));
  }
}

void IF_TRUE(ptr x)
{
  if(*SCM!=a_f)
    VM_JMP(GETNUM(CAR(x)));   
}

void LAMBDA_BIND(ptr x)
{
  ptr s;
  s=CAR(x);
 
  if(CONSP(s)){
     s=CONS(CAR(s),*ARGS);
     *VMENV=SCONS(s,*VMENV);
  }
  else{
    x=*ARGS;
    s=CONS(s,CAR(x));
    *ARGS=CDR(x);
     *VMENV=SCONS(s,*VMENV);
   }
}

void FUNC(ptr x)
{
  ptr s;
  VPUSH(*SCM);
  *ARGS=a_nil;
}

void PUSHARG(ptr x)
{
  *ARGS=CONS(*SCM,*ARGS);
}


void ARGS2stack(ptr args,int n)
{
  while(n>0){
   *stack++=CAR(args);
   args=CDR(args);
   n--;
  }
}

void VJSR(ptr x)
{
  ptr s,st, (*addr)(),env;
  int attr,type;
   s=CAR(x);
   if(SINTP(s))
      NARG=GETNUM(s);
   else
     NARG=_length(*ARGS);
  st=VPULL();  
  VPUSH(*VPC);
  *ARGS=reverse_list(*ARGS);
  attr=ATTR(st);
  s=FTYPE(st);   /***  CAR   see lisp.h  ***/
  if(s==a_lambda){
      *VPC=CDR (st);
    }
  else if(s==a_macro)
      *VPC=CDR (st);
  else if((int)s&SUBR){
      addr= FBODY(st);
      ARGS2stack(*ARGS,NARG);
      env=FENV(st);
      *SCM=(*addr)(NARG,env);
      stack-=NARG;
      RETURN(s);
  }
  else{
    printf("VM Not supports  sr(1.99) call\n");
      RETURN(s);
 } 
}
void TAIL_JMP(ptr x)
{
  ptr s,st, (*addr)(),env;
  int attr,type;
   s=CAR(x);
   if(SINTP(s))
      NARG=GETNUM(s);
   else
     NARG=_length(*ARGS);
  st=*ST;
  /*** printf("TAIL: %x\n",st); **/
  *ARGS=reverse_list(*ARGS);
  attr=ATTR(st);
  s=FTYPE(st);   /***  CAR   see lisp.h  ***/
  if(s==a_lambda){
      *VPC=CDR (st);
    }
  else if(s==a_macro)
      *VPC=CDR (st);
  else if((int)s&SUBR){
      addr=FBODY(st);
      ARGS2stack(*ARGS,NARG);
      env=FENV(st);
      *SCM=(*addr)(NARG,env);
      stack-=NARG;
      RETURN(s);
  }
  else{
    printf("VM Not supports  sr(1.99) call\n");
      RETURN(s);
 }
}

void RETURN(ptr x){
   *VPC=VPULL();   
   *ARGS=VPULL();   
   *VMENV=VPULL();  
}

void CLOSURE_ENV(ptr x){
   ptr s;
   s=CAR(x);
   *VMENV=s;
}

void LAMBDA_ARGS(ptr x){
   ptr s;
   s=CAR(x);
   s=CONS(k_LB,s);   /*** :LAMBDA-BIND ****/
   *VMENV=SCONS(s,*VMENV);
}

void SCM_MULTI(ptr x){
   *MULTIVAL=*SCM;
}

void SCM_BA(ptr x){
   *BA=*SCM;
}

void BA_SCM(ptr x){
   *SCM=*BA;
}

void SCM_ST(ptr x){
   *ST=*SCM;
}

void SCM_ARGS(ptr x){
   ptr s,args;
  s=*SCM;
  args=*ARGS;
   while(CONSP(s)){
     args=SCONS(CAR(s),args);
     s=CDR(s);
   }
   *SCM=s;
   *ARGS=args;
}

void ST_SCM(ptr x){
   *SCM=*ST;
}
   
void COPY_CC(ptr x){    /***  stack also should be in CC  mada!!!  ***/
   ptr s;
   s=CONS(*ARGS,a_nil); 
   s=SCONS(*PCST,s);
   s=SCONS(*VPC,s);
   s=SCONS(*BA,s);
   *SCM=s;
}

void RESTORE_BA(ptr x){
   *SCM=CAR(*SCM);
   *BA=*SCM;
}

void RESTORE_CC(ptr x){
  ptr s;
   s=*SCM;
   *BA=CAR(s);
   s=CDR(s);
   *VPC=CAR(s);
   s=CDR(s);
   *PCST=CAR(s);
   s=CDR(s);
   *ARGS=CAR(s);
  if(CONSP(*MULTIVAL))
    *SCM=CAR(*MULTIVAL);
  else
    *SCM=a_undef;    /***  to be No-value!!!  mada  ***/
}



