/****  stack machine 03.9.26
   see note.cc   stack.scm
   change combination image of as
   args JSR argn .... arg1 FUNC func
   when JSR   stack image  is    func env arg1 ... argn
   for stack   compiler     see m.scm

  2003.11.18 New version based on m.scm(compiler)
  MPU stack is added
  03.12.2  stack_top,stack_init deleted  (old is backuped m.c-new-bak2)  

  03.12.15   compiler
    comp.c
  we need one path compiler!!!
***/

#define COMP_PROG
#include "lisp.h"

#ifdef DEBUG
#include <stdio.h>
extern FILE *stdout;
#endif

/*** #define DEBUG 1 ***/

#define CPCMAX 20000    /***  5000 is too small for log line command as tkogl ***/


#define MPUSH(x)  (*mpu_stack++=(x))
#define MPULL  (*--mpu_stack)

#define CPUSH(x)  (*cpc_stack++=(x))
#define CPULL  (*--cpc_stack)
#define list1(x)  (SCONS(x,a_nil))

extern ptr s_macroexpand();

ptr get_value();
static ptr special_eval(),C_combi();
static ptr  set_var(),M_comp(),C_make_lambda(),C_make_macro(),C_combination();
static  C_else(), C_endif(),C_macro_eval(),C_call_cc();
static  C_blockout(),C_blockin(),func_eval();

ptr CPC[CPCMAX];
ptr OUTCOMP[CPCMAX];

extern PUSH_REG(),PULL_REG();
extern ptr *get_vector();

extern ptr *mpu_stack;
ptr *cpc_stack,*comp;
extern int narg,level;
extern int evalflag;   /****  eval can't define   ***/
extern ptr scm;
static int label;  /*** need conflict TK???? ***/
static ptr access;
ptr block_stack,top_env,dummy_func,NOP,ALLOC0;

extern ptr k_load,k_set,k_warn,k_env,k_top,k_lambda,k_macro,k_func,k_tail_jump;
extern ptr k_define,k_jmp,k_label,k_block_out,k_block_in,k_BIND,k_letbind,k_stack_narg;
extern ptr k_lambda_begin,k_lambda_bind,k_IF,k_I,k_call_cc,k_F;
extern ptr k_jsr,k_exit,k_tail,k_frame,k_frame_list;
extern ptr k_lambda_end,k_macro_end,k_imm,k_alloc,k_dealloc,k_reg,k_macroalias;


extern ptr list2(),list3();

init_comp(){
  /*** call only once **/
   dummy_func=list2(k_lambda,a_undef);
   sysprotect[syspro++]=dummy_func;
   sysprotect[syspro++]=NOP=list1(a_f);
   sysprotect[syspro++]=ALLOC0=list2(k_alloc,ZERO);
  comp=OUTCOMP;
  cpc_stack=CPC;
}

clear_comp(){
  level=0;
  narg=0;
  scm=a_undef;
  /*** evalflag=0; **/
  cpc_stack=CPC;
  comp=OUTCOMP;
  a_env=a_nil;
  label=0;
  CAR(k_block_in)=block_stack=a_nil;/** for protect **/
  CAR(k_define)=top_env=a_nil;/** for protect **/
  *comp++=ALLOC0;   /****  for opt ***/
}

int special_p(ptr x){
  int n;
  if(SREGP(x)) return 0;
#ifdef DEBUG 
   lwritestr(STDOUT,"special_p ");
    prin1(x,STDOUT); 
    newline(STDOUT); 
#endif
  if(CLOSUREP(x)){
      n=FTYPE(x);
#ifdef DEBUG
   lwritestr(STDOUT,"special_p closure: ");
      if(n&SPECIAL) 
           lwritestr(STDOUT,"SPECIAL");
       else
           lwritestr(STDOUT,"function");
    newline(STDOUT);
#endif
      if(n&SPECIAL) return SPECIAL;
   }
  x=assq(x,top_env);  /*** in compiler env  ***/
   if(x==a_f) return 0;
   x=CDR(x);
   if(x==a_unbdd) return SPECIAL;    /**** to be modify  ***/
   return 0;
}

static void c_intern(ptr var,ptr value){
  CAR(k_define)=top_env=SCONS(SCONS(var,value),top_env);  /** for protect **/
}

settop_var(ptr var,ptr value){
  ptr x;
   x=assq(var,top_env);
  if(x!=a_f){
     CDR(x)=value;
    }
  else{
   warning(var,"unbind-var-set");
  }
}  

ptr get_value(ptr var){
  ptr x;
#ifdef DEBUG 
   lwritestr(STDOUT,"get_value var: ");
  prin1(var,STDOUT);
    newline(STDOUT); 
#endif
   x=assq(var,a_env);
   if(x!=a_f){
      access=k_env;
      return CDR(x);
   }
   else{
      access=k_top;
      x=assq(var,top_env);
      if(x!=a_f){
           return CDR(x);
       }
      else{
        if(CAR(var)!=a_unbdd)
           return CAR(var);
        else{
           warning(var,"unbind-var-load");
           return a_undef;
         }
      }
   }
}         

static ptr set_var(ptr var,ptr value){
  ptr x;
   x=assq(var,a_env);
   if(x!=a_f){
      CDR(x)=value;
      return access=k_env;
   }
   else{
      access=k_top;
      x=assq(var,top_env);
      if(x!=a_f){
           CDR(x)=value;
       }
      else{
        if(CAR(x)!=a_unbdd)
             CAR(x)=value;
        else{
           warning(var,"unbind-var-set");
         }
      }
      return access;
   }
}


forget(int n){
  comp-=n;
}

outcom(ptr s){
#ifdef DEBUG 
  lwritestr(STDOUT,"outcom: ");
  prin1(s,STDOUT);
   newline(STDOUT);
#endif
  *comp++=s;
}

warning(ptr x,char *p){
  outcom(list3(k_warn,CMAKESTR(p),x));
}

/***  (compile s [env])  ***/ 
ptr s_compile(int narg,ptr env){
 ptr s,v,*p,*q;
 int n,size,k;
  PUSH_REG();  /*** mc.c ***/
  MPUSH(level);
  clear_comp();
  if(narg==1){  
     s=*(stack-1);
     psh(a_nil);  /*** new 3.18 ***/
  }
  else if(narg==2){  /****  given env  ***/
     s=*(stack-2);
     a_env=*(stack-1);
  }
  else
     checknarg(narg-2);
   /*** printf("s_compile %x ",s); **/
    
   v=ATOMVAL(a_macroexpand);
   if(v!=a_undef){
     *(stack-2)=s=funcall(v,2,*(stack-1));
   }
  /***  printf("s_compile  macro %x \n",s);  ***/

  /***
  v=ATOMVAL(a_letdefine);
   if(v!=a_undef){
     psh(s);
     s=funcall(v,1,*(stack-2));
    pull();
    *(stack-2)=s;
   }
  ****/

   CPUSH(s);
   M_comp();
  /**  OUTCOMP  -> vector  **/
   n=comp-OUTCOMP;
   q=OUTCOMP;
   size=n*3/2+1;   /*** JMP opt estimate ***/
   k=size-n;
   /*** *comp++=list2(k_exit,a_t); ***/
   while(k--){
    *comp++=NOP;
   }

   s=makevector(size,NOP);
   p=get_vector(s,&size);
   while(n--){
     *p++=*q++; 
   }
  level=MPULL;
  PULL_REG();
   return s;
}

static ptr M_comp(){
  Reg ptr s,res;

   s=a_f;
#ifdef DEBUG
  lwritestr(STDOUT,"M-comp-enter");
   newline(STDOUT); 
#endif
 loop:
   if(CPC==cpc_stack){
#ifdef DEBUG
  /*** printf("\nM-comp-exit  pc %x scm %x\n",cpc_stack,scm);***/
  lwritestr(STDOUT,"M-comp-exit");
   newline(STDOUT); 
#endif
      return scm;
   }
   s=CPULL;

#ifdef DEBUG 
  /**printf("\nM-comp  pc %x stack  %x narg %d level %d\n",cpc_stack,stack,narg,level);***/
  lwritestr(STDOUT,"M-comp  s: ");
  lfflush(STDOUT);
   printf("OBJ %x OBJP %d\n ",s,OBJP(s));
   /*** printf("long %d",sizeof(long)); ***/
    printf("C_combi %x\n",((ptr)C_combi)); 
    fflush(stdout);
  if(SREGP(s)||(OBJP(s))){
       prin1(s,STDOUT); 
       newline(STDOUT); 
  }
#endif  
  if(SREGP(s)){
   scm=s; 
    res=list3(k_load,k_imm,s);
    outcom(res);
   }
  else if(OBJP(s)){
     if(CONSP(s)){
        scm= C_combination(s);
       }
      else if(SYMBOLP(s)){
         scm=(ptr)get_value(s);
         /****  04.4.18  for MACRO alias -> original function load!!! ***/
         /*** not complete  for  (define f +)   (define + -)  (f 6) ***/
         /***  see note-macro  04.4.18   ***/
         if(access==k_top){
             /*** res=function_name(scm); ***/
             if(!SREGP(scm)&&CONSP(scm)&&(CAR(scm)==k_macroalias))
                  s=CDR(scm);
            /***  if(res!=a_f) s=res; ***/
         }
         /******/
         res=list3(k_load,access,s);
         outcom(res);
      }
      else{
         scm=s;
         res=list3(k_load,k_imm,s);
         outcom(res);
        }
  }
  else
       ((void (*)())s)();
  goto loop;
}

int get_ftype(ptr func){
 Reg int k;
#ifdef DEBUG 
   lwritestr(STDOUT,"get_ftype "); 
  newline(STDOUT); 
  /****
  prin1(func,STDOUT); 
  printf(" address %x attr nil %x\n",func,ATTR(a_nil));
  printf(" STDOUT %x attr  %x\n",STDOUT,ATTR(STDOUT));
   ***/
#endif

  if(SREGP(func)){
     /** warning(func,"undefined function"); **/
     return LAMBDA;  /** 04.5.4 **/
     /***    error(E_nullfunc,func);    No good! (lambda (x) (x 8))  can't compile ***/
    }
  if(ATTR(func)==SR2) return LAMBDA;  /**** V2.0  ***/
  /***
  PRINT("ftype  2");
  newline(STDOUT); 
***/
  k=special_p(func);
   if(k) return k;
  /*** 
   PRINT("ftype  3");
  newline(STDOUT); 
***/
  if(!CLOSUREP(func)){
     if(CONSP(func)){
       if(CAR(func)==k_lambda)
            return LAMBDA;
       if(CAR(func)==k_macro)
            return MACRO;
      }
     warning(func,"undefined function");
     return LAMBDA;
  }
   return (int)FTYPE(func);
}

ptr specialp( ptr x){
int kind;
  if(SREGP(x)) return a_f;
  if(SYMBOLP(x)) x=ATOMVAL(x);
  if(SREGP(x)||!CLOSUREP(x)) return a_f;
#ifdef DEBUG
  lwritestr(STDOUT,"specialp called: ");
  prin1(x,STDOUT);
  newline(STDOUT);
#endif
  kind=get_ftype(x);
   if(kind&SPECIAL){
          return CAR(CDR(x));
  }
  return a_f;
}

ptr s_specialp(int nar, ptr env){
 ptr x;
int kind;
  checknarg(nar-1);
  return specialp(*(stack-1));
}
  
static ptr C_combi(){
  Reg ptr func,s,cdrs,z,name;
  Reg int kind;
  func=*(stack-1);
  s=CPULL;
#ifdef DEBUG
  lwritestr(STDOUT,"C_combi func: ");
  prin1(func,STDOUT);
  newline(STDOUT);
#endif
  kind=get_ftype(func);
  name=CAR(s);  
  cdrs=CDR(s);
#ifdef DEBUG
  lwritestr(STDOUT,"C_combi name: ");
  prin1(name,STDOUT);
  newline(STDOUT);
#endif

   if(kind&SPECIAL){
          stack--;  /** New   ***/
         /*** printf("special ");
          prin1(CAR(CDR(func)),STDOUT); ***/
          name=CAR(CDR(func));
          return special_eval(name,s);
    }
   if(kind&LAMBDA)   {
                /*** z=func_eval(func,cdrs);***/
                func_eval(func,cdrs);
                return a_undef;
            }
    else if(kind&MACRO){
          stack--;  /** New   ***/
          C_macro_eval(s);  /*** void!  ***/
          return a_undef;
        }
    else 
      error(E_illegal,func);
}


static ptr C_func(){
#ifdef DEBUG 
  lwritestr(STDOUT,"C_func scm: ");
  prin1(scm,STDOUT);
  newline(STDOUT);
#endif
  psh(scm); /*** function pushed  ***/
  outcom(CONS(k_func,a_nil));
}

static ptr C_func_tail(){
  psh(scm); /*** function pushed  ***/
  MPUSH(stack); /***  ????????????   *****/
  outcom(CONS(k_func,a_nil));
}

 
static ptr C_combination(ptr s){
  Reg ptr body;
  CPUSH(s);  
  CPUSH((ptr )C_combi);  
  CPUSH((ptr )C_func);  /*** New! ***/  
  CPUSH(CAR(s));  
}  


static ptr C_set(){
  ptr var,x;
  var=CPULL;
  x=set_var(var,scm);
  outcom(list3(k_set,x,var));
   /** scm=env_value_set(var,scm,a_env); ***/
  outcom(list3(k_load,k_imm,a_undef));
  scm=a_undef;
}
static ptr C_set_rec(){
  ptr var,x;
  var=CPULL;
  x=set_var(var,scm);
  outcom(list3(k_set,x,var));
   /** scm=env_value_set(var,scm,a_env); ***/
}

static s_bind(ptr var,ptr ss){
 ss=SCONS(var,ss);
 a_env=SCONS(ss,a_env);
}

static C_bind(){
ptr x;
x=CPULL;
#ifdef DEBUG 
lwritestr(STDOUT,"C_bind x: ");
prin1(x,STDOUT);
lwritestr(STDOUT,"  scm: ");
prin1(scm,STDOUT);
newline(STDOUT);
#endif

s_bind(x,scm);
outcom(list2(k_BIND,x));
}

static C_setenv(){
  ptr x,c;
  x=CPULL;
  c=assq(x,a_env);
  CDR(c)=scm;
  outcom(list3(k_set,k_env,x));
  /** scm=a_undef; ***/
}

static C_define(){
  ptr var,x;
   if(evalflag) error(E_define,a_define);
  var=CPULL;
  if(SREGP(var)||!SYMBOLP(var)) error(E_notsymb,var);
  /*** printf("define level %d\n",level);  ***/
  if(level==0)
         x=k_define;
  else
         x=k_BIND; /*** Caution!!! ***/
  outcom(list2(x,var));
  if(level==0)
     c_intern(var,scm);
  else
     s_bind(var,scm);
   scm=var;
  return scm;
}


static C_jsr(){
  ptr func;
  func=*(stack-narg-1);  /*** func  New!  ***/
  outcom(list2(k_jsr,MAKESINT(narg)));
  stack=MPULL;
  narg=MPULL;
  a_env=MPULL;
  stack--;  /*** drop func ***/
}

static C_tail(){
  ptr func;
  func=*(stack-narg-1);  /*** func  New!  ***/
  outcom(list2(k_tail_jump,MAKESINT(narg)));
  outcom(list2(k_exit,k_tail));  /*** New ***/
  stack=MPULL;
  narg=MPULL;
  a_env=MPULL;
  stack--;  /*** drop func ***/
}   


static C_if(){
    ptr lab;
       lab=CPULL;
       outcom(list3(k_IF,k_F,MAKESINT(lab)));
}

static block_out(){
  level++;
  label++;
  CPUSH(label);
  CPUSH(C_blockout);
}

static block_in(){
  CPUSH(label);
  CPUSH(C_blockin);
}

static C_blockout(){
  ptr lab;
  narg=MPULL;
  a_env=MPULL;
  level--;
  CAR(k_block_in)=block_stack=CDR(block_stack);
  lab=CPULL;
  outcom(list2(k_block_out,MAKESINT(lab)));
}

static C_blockin(){
  ptr lab;
  narg=0;
  lab=CPULL;
  /** level--;  ***/
  CAR(k_block_in)=block_stack=CONS(MAKESINT(lab),block_stack);
  outcom(list2(k_block_in,MAKESINT(lab)));
}

static C_stacknarg(){
  outcom(list1(k_stack_narg));
  psh(scm);
  narg++;
}

static C_letbind(){
  Reg ptr *sfree,v,vars,res,memo;
  Reg int n=narg;
#ifdef DEBUG 
  lwritestr(STDOUT,"C_letbind res: ");
#endif
   vars=CPULL;
  sfree=stack-n;
  memo=res=CONS(a_nil,a_nil);
   psh(res);
  while(narg){
   v=CAR(CAR(vars));
   scm=*sfree++;
   s_bind(v,scm);
   res=CDR(res)=SCONS(v,a_nil);
   vars=CDR(vars);
   narg--;
  }
  pull();
  stack-=n;
  res=CDR(memo);
#ifdef DEBUG
  prin1(res,STDOUT);
  newline(STDOUT);
#endif
  outcom(list2(k_letbind,res));
}

static C_vars_push(Reg ptr v){
 Reg ptr x;
  CPUSH(v);
}

static C_let_stacknarg(){
 narg++;
 psh(scm);
 outcom(list3(k_stack_narg,k_letbind,CAR(block_stack)));
}


static C_inits_push(Reg ptr v){
   Reg ptr x;
#ifdef DEBUG 
  lwritestr(STDOUT,"C_inits_push v: ");
  prin1(v,STDOUT);
  newline(STDOUT);
#endif
  v=reverse_list(v);
  while(CONSP(v)){
   x=CAR(v);
   CPUSH((ptr)C_let_stacknarg); /*** let_stack_narg ***/
   CPUSH(CADR(x));
   v=CDR(v);
  }
}

static func_eval(ptr func,ptr cdrs){
 Reg ptr *p;
 int n;
  MPUSH(a_env);
  MPUSH(narg);
  MPUSH(stack);

  CPUSH(C_jsr);
  n=_length(cdrs);
  p=cpc_stack+=(n+n);
  while(n--){
    *--p=CAR(cdrs);
     *--p=(ptr)C_stacknarg;  
    cdrs=CDR(cdrs);
   }
 narg=0;
 /*** level++;  * eval can't define  ***/
}

static tail_eval(ptr func,ptr args){
 Reg ptr *p,top,cdrs;
 int n;
  MPUSH(a_env);
  MPUSH(narg);
 /***  MPUSH(stack); ***/

  CPUSH(C_tail);
  cdrs=CDR(args);
  top=CAR(args);
  n=_length(cdrs);
  p=cpc_stack+=(n+n);
  while(n--){
    *--p=CAR(cdrs);
     *--p=(ptr)C_stacknarg;
    cdrs=CDR(cdrs);
   }
  CPUSH(C_func_tail);  /*** func_tail ***/
  CPUSH(top);
 narg=0;
 /*** level++;  * eval can't define  ***/
}

ptr C_macro_expand(ptr s){
   /*** toriaezu!!!    to be modyfy!!!   ***/
 psh(s);
 s=s_macroexpand(1,a_env);  /*** macroexpand.c ***/
  /***
   printf("C_macro_expand %x\n",s);
   prin1(s,STDOUT);
   newline(STDOUT);
  ***/
 pull();
 return s;
}

static C_macro_eval(ptr s){
   forget(2); /*** forget :func, get-value  ***/
   scm=C_macro_expand(s);
   CPUSH(scm);
}

static C_call_cc(){
  outcom(list1(k_call_cc));
}

static ptr special_eval(ptr func, ptr form){
Reg ptr args,x,v,*sfree,var,a,b=a_f;
int n;
#ifdef DEBUG
           lwritestr(STDOUT,"special_eval func: ");
           prin1(func,STDOUT);
           lwritestr(STDOUT," args: ");
           prin1(args,STDOUT);
           newline(STDOUT);
#endif
   forget(2); /** load, func **/
   args=CDR(form);
   if(func==a_setq){
                v=CAR(args);
                  args=CDR(args);
                 if(CONSP(v)){
                    error(E_notsymb,v);
                  }
                 else{
                   x=v;
                   args=CAR(args);
                  }
                 CPUSH(x);
                 CPUSH((ptr)C_set);
                 CPUSH(args);
               }
  else if(func==a_define){
                v=CAR(args);
                  args=CDR(args);
                 if(SREGP(v)) error(E_define,v);
                 if(CONSP(v)){
                     x=CAR(v);
                     args=CONS(CDR(v),args);
                     args=SCONS(a_lambda,args);
                  }
                 else{
                   x=v;
                   args=CAR(args);
                  }
                 CPUSH(x);
                 CPUSH((ptr)C_define);
                 CPUSH(args);
               }
  else if(func==a_begin){
      args=reverse_list(args);
      while(CONSP(args)){
        CPUSH(CAR(args));
        args=CDR(args);
      }
    }
  else if(func==a_lambda){
      scm=C_make_lambda(form,a_env);
       return  scm;
     }
 else if(func==a_macro){
      scm=C_make_macro(form,a_env);
      return scm;
     }
 else if(func==a_quote){
      scm=CAR(args);
      outcom(list3(k_load,k_imm,scm));
      return scm;
     }
  else if(func==a_if){
      if(CONSP(CDDR(args)))
           x=CAR(CDDR(args));
      else
          x=a_undef;
      label++;
      CPUSH(label);
      CPUSH(C_endif);
      CPUSH(x);
      CPUSH(label);
      label++;
      CPUSH(label);
      CPUSH(C_else);
      CPUSH(CADR(args));
      CPUSH(label);
      CPUSH(C_if);
      CPUSH(CAR(args));
     }
  else if(func==a_let){
     MPUSH(a_env);
     MPUSH(narg);
     evalflag=0;
     /** level++; ***/
     block_out();
     form=let_expand(form,NO);  /*** Not tail expansion ***/
     args=CDR(form);
     psh(form);
     CPUSH(CONS(a_begin,CDR(args)));
     v=CAR(args);
     C_vars_push(v);
     CPUSH(C_letbind);
     C_inits_push(v);
     pull();
     block_in();
     /** narg=0; ***/
  }
 else if(func==a_let_s){
     MPUSH(a_env);
     MPUSH(narg);
     evalflag=0;
     /** level++; ***/
     block_out();
      form=let_expand(form,NO);  /*** Not tail expansion ***/
     args=CDR(form);
     psh(form);

     CPUSH(CONS(a_begin,CDR(args)));
     v=CAR(args);
     n=3*_length(v);
     sfree=cpc_stack+=n;

     while(n){
       x=CAR(v);
       *--sfree=CADR(x);
       *--sfree=C_bind;
       *--sfree=CAR(x);
       n-=3;
       v=CDR(v);
     }
    pull();
     block_in();
     /**  narg=0;  ***/
  }


  else if(func==a_letrec){
     MPUSH(a_env);
     MPUSH(narg);
     evalflag=0;
     /** level++;***/
     block_out();
      form=let_expand(form,NO);  /*** Not tail expansion ***/
     args=CDR(form);
     psh(form);

     CPUSH(CONS(a_begin,CDR(args)));
     v=CAR(args);
     n=3*_length(v);
     sfree=cpc_stack+=n;

     while(n){
       x=CAR(v);
       *--sfree=CADR(x);
       *--sfree=C_set_rec;  /*** set_rec ***/
       *--sfree=CAR(x);
       n-=3;
       v=CDR(v);
     }
     v=CAR(args);
     while(CONSP(v)){
       x=CAR(v);
       CPUSH(CAR(x));
       CPUSH(C_bind);
       /** s_bind(CAR(x),a_undef); ***/
       v=CDR(v);
     }
      CPUSH(list2(a_quote,dummy_func)); 
     /*** scm=dummy_func;  * ONLY value not outcom!!! ***/
     pull();
     block_in();
     /** narg=0; ***/
  }
else if(func==a_call_cc){
      CPUSH(C_call_cc);
      /** PUSH((ptr)M_stacknarg);   **  New!!! ***/
      CPUSH(CAR(args));
   }
else if(func==a_tail_call){
     tail_eval(func,args);
 }
else if(func==a_load_reg){  /*** Now only a_env ***/
     scm=a_env;
     outcom(list3(k_load,k_reg,k_env));
 }
      
return a_undef;
}

static  C_else(){
 ptr lab,lab2;
   lab2=CPULL;
   lab=CPULL;
  outcom(list2(k_jmp,MAKESINT(lab)));
  outcom(list2(k_label,MAKESINT(lab2)));
}

static  C_endif(){
 ptr lab;
   lab=CPULL;
  outcom(list2(k_label,MAKESINT(lab)));
}

static lambda_bind(ptr var){
  ptr x;
  int i=0;
  psh(x);
  while(CONSP(var)){
    *(stack-1)=x=list2(k_frame,MAKESINT(i));
    s_bind(CAR(var),x);
    var=CDR(var);
    i++; 
 }
 if(SYMBOLP(var)){
     *(stack-1)=x=list2(k_frame_list,MAKESINT(i));
     s_bind(var,x);
  }
}


static C_lambda_begin(){
 ptr var;

  MPUSH(a_env);
  MPUSH(narg);
  MPUSH(stack);
  level++;   /*** New ***/
  var=CPULL;
  lambda_bind(var);
   narg=0;
}

static C_lambda_end(){
  ptr lab,s;
  lab=CPULL;
  stack=MPULL;
  narg=MPULL;
  a_env=MPULL;
  outcom(list2(k_exit,k_lambda));
  scm=list2(k_lambda,MAKESINT(lab));
  /** outcom(list2(k_lambda_end,MAKESINT(lab))); ***/
  /*** (:LAMBDA-END 1 :ALLOC 0)   ***/
     s=list3(MAKESINT(lab),k_alloc,ZERO);
    s=SCONS(k_lambda_end,s);
    outcom(s);

  level--;  /*** New ***/
}

static C_macro_end(){
  ptr lab,s;
  lab=CPULL;
  stack=MPULL;
  narg=MPULL;
  a_env=MPULL;
  outcom(list2(k_exit,k_macro));
  scm=list2(k_macro,MAKESINT(lab));
  /*** outcom(list2(k_lambda_end,MAKESINT(lab))); * No macro_end ***/
   /*** (:LAMBDA-END 1 :MACRO :ALLOC 0)   ***/
     s=list3(k_macro,k_alloc,ZERO);
     s=SCONS(MAKESINT(lab),s);
    s=SCONS(k_lambda_end,s);
    outcom(s);
  level--;  /*** New ***/
}

 
static ptr C_make_lambda(ptr args,ptr env){
  ptr s,var;
    /** s=CONS(a_lambda,args);***/
   s=args;
    psh(s);
    args=tail_expand(s);
  /***  for debug
    lwritestr(STDOUT," tail_expand: ");
    prin1(s,STDOUT);
    lwritec(STDOUT,'\n');
    prin1(args,STDOUT);
    lwritec(STDOUT,'\n');
  ***/
    args=CDR(args);
    var=CAR(args);
    pull();  /***  New? **/
    label++;
    /** outcom(list3(k_lambda_begin,MAKESINT(label),var)); ***/
    /***   to be final  ****/
    /***  (:LAMBDA-BEGIN 1 (x) :ALLOC 0)  ***/
    s=list3(var,k_alloc,ZERO);
    s=SCONS(MAKESINT(label),s);
    s=SCONS(k_lambda_begin,s);
    outcom(s);

    outcom(list3(k_lambda_bind,var,var));
    CPUSH(label);
    CPUSH(C_lambda_end);
    CPUSH(CONS(a_begin,CDR(args)));
    CPUSH(var);
    CPUSH(C_lambda_begin);
   return a_undef;
}

static ptr C_make_macro(ptr args,ptr env){
  ptr s,var;
    /*** s=CONS(a_lambda,args);
    psh(s);
    args=tail_expand(s);
    args=CDR(args);
    ***/
    args=CDR(args);
    var=CAR(args);
    label++;
   /**  outcom(list3(k_lambda_begin,MAKESINT(label),k_macro));***/
    /***  (:LAMBDA-BEGIN 1 :MACRO :ALLOC 0)  ***/
    s=list3(k_macro,k_alloc,ZERO);
    s=SCONS(MAKESINT(label),s);
    s=SCONS(k_lambda_begin,s);
    outcom(s);

    outcom(list3(k_lambda_bind,var,var));
    CPUSH(label);
    CPUSH(C_macro_end);
    CPUSH(CONS(a_begin,CDR(args)));
    CPUSH(var);
    CPUSH(C_lambda_begin);
   return a_undef;
}

    
  


