/*** readchar.c
****/

#ifndef WIN32
#else
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#undef WIN32_LEAN_AND_MEAN
#define WINH_LOAD
#endif
#include <sys/types.h>
#include <sys/time.h>
#include <unistd.h>
//#include <stdio.h>

#define  READCHAR_C

#include "lisp.h"
#include "ss_stream.h"

extern ptr socket_readbuf();

/****  un-read-char1ʸΤߤBACKUP
Ǥ롣see CL
****/
/*****  system depnd    functions   ***/
static ptr read_byte_char(ptr lpath){
   unsigned int acc,n,m;
   ptr x,stb;
   stb=STB(lpath);
   acc=(int) CAR(lpath);
     x=STB_UNREAD(stb);
      if(x!=SEOF){
        /** CADR(stb)=SEOF;  **/
        STB_UNREAD(stb)=SEOF;
        return x;
      }
   return lreadc(lpath);
}

ptr unreadchar(ptr x,ptr lpath){
   int acc;
    ptr stb=STB(lpath);
   acc=(int)CAR(lpath);
   if((FUNC_PORT&acc)&&(unread_ac&F_ACC(lpath)) ) /*** 1.99 ***/
      func_unread(x,lpath);
   else
         STB_UNREAD(stb)=x;
   return x;
 }


/******  below are Not system depend  ****/
ptr read_char(ptr lpath){
   unsigned int acc,n,m;
   ptr x;
   x=read_byte_char(lpath);
   if(!kanji_mode) return   x;
   if(x==SEOF) return x;
   if((n=CHAR_CODE(x)) <128) return   x;
   if(n>255) return x; /***  already checked in low level function ? ***/
   m=CHAR_CODE(lreadc(lpath));  /**  unread not exists ***/
   /*** printf("kanji %x %x\n",n,m);  ***/
   return   MAKECHAR((n<<8)+m);
}

 
ptr s_readchar(int narg,ptr env){
   ptr lpath;
   ptr x;
   if(narg==0) lpath=STDIN; /** stdin  */
   else if(narg==1) lpath=(*(stack-1));
   else
       checknarg(narg-1);
   return read_char(lpath);
}

ptr s_read_byte_char(int narg,ptr env){
   ptr lpath;
   unsigned int n;
   ptr x;
   if(narg==0) lpath=STDIN; /** stdin  */
   else if(narg==1) lpath=(*(stack-1));
   else
       checknarg(narg-1);
   return read_byte_char(lpath);
}


ptr s_unreadchar(int narg,ptr env){
   ptr x,lpath;
  int n;
    if(narg==1) lpath=STDIN; /** stdin  */
   else if(narg==2) lpath=(*(stack-1));
   else
     checknarg(narg-2);
   x=*(stack-narg);
  return unreadchar(x,lpath);
 }


ptr peekchar(ptr lpath){
  Reg int n; 
  Reg ptr c;
   if((lpath==a_keyinput)&&istty){
        n=sedinkey(NO,YES); /*** tty_peek(); ***/
       c=MAKECHAR(n);
        unreadchar(c,lpath);
        return c;
   }
    return unreadchar(read_char(lpath),lpath);
}


static ptr port_ready(ptr lpath){
 Reg int n,acc,soc;
 Reg ptr c;
 extern int tty_peek();

   if((lpath==a_keyinput)&&istty){
        n=tty_peek();
       if(n==-1) return a_f;
       /*** putchar(n);   echo ***/
       return a_t;
   }
   acc=(int)CAR(lpath);
   if(acc&SOCKET_PORT){
     c=socket_readbuf(lpath,NO);
     /** if(c!=a_f) return a_t; ***/ 
    /***  return c;  ***/
     if(c!=a_f) return c;
     soc=get_socket_fdp(lpath);
     if(!network_ready(soc,20)) return a_f;
     /*** return a_t; ***/
     return ONE;   /*** may be EOF  ***/
   }
   else if(acc&FUNC_PORT){
      return func_port_ready(lpath);
   }
    return unreadchar(read_char(lpath),lpath);
}

int stdin_ready()  /***  see socket.c  ***/
{
  int width,n;
  fd_set Mask,readOk;
  struct timeval timeout;

  FD_ZERO(&Mask);
  FD_SET(STDIN_FILENO,&Mask);
  width=1;
  readOk=Mask;
  timeout.tv_sec=0;
  timeout.tv_usec=0;  /***  No wait **/
  n=select(width,(fd_set *)&readOk,NULL,NULL,&timeout);
  if(n>0) return YES;
  return NO;
}


ptr s_peekchar(int narg,ptr env){
   unsigned int n,m;
   ptr x,lpath;
   if(narg==0) lpath=STDIN; /** stdin  */
   else if(narg==1) lpath=(*(stack-1));
   else
       checknarg(narg-1);
   return peekchar(lpath);
}

ptr s_port_ready(int narg,ptr env){
   unsigned int n,m;
   ptr x,lpath;
   if(narg==0) lpath=STDIN; /** stdin  */
   else if(narg==1) lpath=(*(stack-1));
   else
       checknarg(narg-1);
   if((lpath==a_keyinput)&&istty)
           return  tty_ready()?a_t:a_f;
   return port_ready(lpath);
  /*** if(x==a_f) return a_f;
    return a_t;   ***/
   /*** even if SEOF , see R5RS  ***/
  /** return (x==SEOF)?a_f:a_t; ***/
}


ptr s_writechar(int narg,ptr env){
   ptr x,lpath;
   if(narg==1) lpath=STDOUT; /** stdin  */
   else if(narg==2) lpath=(*(stack-1));
   else
       checknarg(narg-2);
   x=*(stack-narg);
   writechar(x,lpath);
   return x;
}

ptr writechar(ptr x,ptr lpath){
   Reg unsigned int n;
   n=CHAR_CODE(x);
   if(n>=256){
      lwritec(lpath,(n>>8));
   }
   lwritec(lpath,(n&0xff));
   return a_undef;
}

ptr s_back_writechar(int narg,ptr env){
   ptr x,lpath;
   checknarg(narg-1);
   lpath=(*(stack-1));
   return back_writechar(lpath);
}

ptr s_eofp(int narg,ptr env){
   ptr x;
       checknarg(narg-1);
   x=*(stack-1);
  return PRED(x==SEOF);
}

