/***  string ****/
/***  revised 2004.11.23   for kanji_mode  off! ***/
#define STR_PROG
#include "lisp.h"
#include <ctype.h>
#include <string.h>

extern ptr k_end,k_nocase;

extern    char *alloc_space();

ptr j_string_set();
ptr jstring_list();
ptr string_list();
#ifdef UTF8
#endif

unsigned char *jindex_euc(unsigned char *p,int ind, int len);
unsigned char *jindex_utf(unsigned char *p,int ind, int len);

unsigned char *get_string(ptr str,unsigned int *len){
  Reg unsigned char *p;   
   *len=(int)CDR(str);
    str=CAR(str);
   p=(unsigned char *)(++str);
  *(p+*len)=0;  /**** for C-program  ***/
   return p;
}

int scm_strcmp(Reg unsigned char *p,Reg unsigned char *q,Reg int n){
   while(n--){
     if(*p++!=*q++) return NO;
  }
return YES;
}

int scm_strcmp_ci(Reg unsigned char *p,Reg unsigned char *q,Reg int n){
   while(n--){
     if(tolower(*p++)!=tolower(*q++)) return NO;
  }
return YES;
}


ptr makestring(int i){
 int n;
      ptr c;
     char *p;
    /***  printf("makestring enter size %d\n",i); ***/
       psh(c=new_cell(STRING));
       CDR(c)=(ptr) i;/*** for gbc Caution!  ***/
    p=alloc_space(c, ++i);  /*** CAR(c) is set ***/
    /*** while(i--) *p++=0;    NULL character ***/
      pull();
    /***  printf("makestring return %x\n",c); ***/
   return c;
  }

ptr makestring_init(int i,int k){
 int n;
      ptr c;
    Reg  char *p;
    Reg int ku,kt;
    /**  printf("makestr init  enter size %d\n",i); **/
       psh(c=new_cell(STRING));
     if(k<256){
        CDR(c)=(ptr) i;/*** for gbc Caution!  ***/
         p=alloc_space(c, ++i);  /*** CAR(c) is set ***/
         while(i--) *p++=k;  
      }
    else if(k&0xff0000){  /** utf8  **/
        CDR(c)=(ptr) (i+i+i); /*** for gbc Caution!  ***/
         p=alloc_space(c, (i+i+i+2));  /*** CAR(c) is set ***/
         kt=k>>16;
         ku=k>>8;
         while(i--) {*p++=kt;*p++=ku;*p++=k;} ; 
     }
    else{
        CDR(c)=(ptr) (i+i); /*** for gbc Caution!  ***/
         p=alloc_space(c, (i+i+2));  /*** CAR(c) is set ***/
         ku=k>>8;
         while(i--) {*p++=ku;*p++=k;} ; 
      }
    pull();

    /***  printf("makestr init return %x\n",c); **/
   return c;
  }

ptr s_makestring(int narg,ptr env){
  int ini;
  if(narg==1)ini=' ';
  else if(narg==2) ini=CHAR_CODE(*(stack-1));
  else checknarg(narg-2);
 return makestring_init(SINT_NUMB(*(stack-narg)),ini);
}

ptr copy_str(ptr x){
 Reg ptr new;
 Reg unsigned char *p,*q;
 unsigned int n;
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  p=get_string(x,&n);
  new=makestring(n);
  p=get_string(x,&n);
  q=get_string(new,&n);
  while(n--) *q++=*p++;
 return new;
}


ptr s_string_copy(int narg,ptr env){
 Reg ptr x=*(stack-1);
  checknarg(narg-1);
  return copy_str(x);
}

ptr s_string_fill(int narg,ptr env){
 Reg ptr x=*(stack-2),c;
 Reg unsigned char *p;
 unsigned int n;
  int k,ku,kt;
  checknarg(narg-2);
  if(SREGP(x)||!STRINGP(x)) error(E_notstr,x);
  c=*(stack-1);
 if(!CHARP(c)) error(E_notchar,c);
 k=CHAR_CODE(c);
  p=get_string(x,&n);
  if(k<256)
     while(n--) *p++=k;
  else if(k&0xff0000){ /** utf8  ***/
     kt=k>>16;
     ku=k>>8;
     while(n>1){
        *p++=kt;
        *p++=ku;
        *p++=k;
        n-=3;
     }
  }
  else{
     ku=k>>8;
     while(n>1){
        *p++=ku;
        *p++=k;
        n-=2;
     }
 }
  return a_undef; 
}

ptr makestring_p(Reg char *q, Reg int i){
   Reg   char *p;
   ptr c;
     /** printf("makestring_p  enter %s size %d\n",q,i); **/
       psh(c=new_cell(STRING));
       CDR(c)=(ptr) i;/*** for gbc Caution!  ***/
    p=alloc_space(c, ++i);  /*** CAR(c) is set ***/
    while(i-->0) *p++=*q++;  
      pull();
    /**  printf("makestring_p   return %x\n",c); ***/
   return c;
  }

ptr make_str_c(char *str)    /*****  C string only!  ****/
 {
    return makestring_p(str,strlen(str));
 }


C_strcpy (Reg char *p,Reg char *q,Reg int n){
   while(n--)
      *q++=*p++;
   *q=0;
}

int pstrcpy(Reg char *buff,ptr s){
 unsigned int n;
 Reg unsigned int k;
 Reg unsigned char *p;
  if(SREGP(s)||!STRINGP(s)) error(E_notstr,s);
  p=get_string(s,&n);
  k=n;
  while(k--) *buff++=*p++;
  *buff=0;
  return n;
}

ptr string_equal(ptr sp,ptr sq){
 Reg unsigned char *p,*q;
 unsigned int n,m;
   p=get_string(sp,&n);
   q=get_string(sq,&m);
   if(n!=m) return a_f;
   return PRED(scm_strcmp(p,q,n));
}

ptr str_append(ptr u,ptr v){
unsigned int n,m,k;
unsigned char *p,*q,*r;
ptr x;
  if(SREGP(u)||!STRINGP(u)) error(E_notstr,u);
  if(SREGP(v)||!STRINGP(v)) error(E_notstr,v);
  p=get_string(u,&n);  
  q=get_string(v,&m);  
  /*** printf("str-app %s %s\n",p,q);  ***/
  x=makestring(n+m);
  p=get_string(u,&n);  
  q=get_string(v,&m);  
  r=get_string(x,&k);
  while(n--){
  *r++=*p++;
   }
  while(m--){
  *r++=*q++;
  }
  return x;
}

ptr s_strappend(int narg,ptr env){
 Reg ptr u,v,*sfree;

 if(narg==0) return a_nullstr;
 if(narg==1) return *(stack-1);
sfree=stack-narg;
 u=*sfree++;
 psh(u);
 narg--;
 while(narg--){
  v=*sfree++;
  u=*(stack-1)=str_append(u,v);
 }
pull();
return u;
}  

int char_stack_bytes(int narg)  /*** char in stack, then   count bytes ***/
{
  Reg int n=0,c;
  Reg ptr *sfree;
  sfree=stack-narg;
   while(narg--){
       c=(int)*sfree++;
       c=CHAR_CODE(c);
       if(c<256)
             n++;
       else if(c&0xff0000) /*utf8 */
             n+=3;
       else
             n+=2;
   }
   return   n;
}

ptr  s_string(int narg,ptr env){
   Reg ptr *sfree,s;
   unsigned int n;
   Reg unsigned char *p;
   n=char_stack_bytes(narg);
   if(n==0) return a_nullstr;
   s=makestring(n);
   p=get_string(s,&n);
   sfree=stack-narg;
  while(narg--){
       n=CHAR_CODE((int)(*sfree++));
       if(n<256) *p++=n;
       else if(n&0xff0000){  /** utf8  **/
           *p++=(n>>16);
           *p++=(n>>8);
           *p++=n;
        } 
       else{
           *p++=(n>>8);
           *p++=(n&0xff);
           }
   }
   return   s;
}
int char_list_bytes(ptr x)  /*** x is char list, then   count bytes ***/
{
  Reg int n=0,c;
   while(CONSP(x)){
       c=(int)CAR(x);
       c=CHAR_CODE(c);
       if(c<256)
             n++;
       else if(c&0xff0000) /** utf8 **/
              n+=3;
       else
             n+=2;
       x=CDR(x);
   }
   return   n;
}

ptr s_list_to_string(int narg,ptr env){
   Reg ptr x,s;
   unsigned int n;
   unsigned char *p;
   x=*(stack-1);
   checknarg(--narg);
   n=char_list_bytes(x);
   s=makestring(n);
   p=get_string(s,&n);
 /**  printf("list->string  x %x n %d p %x", x,n,p);
 prin1(x,STDOUT);
  **/
   /*** error  **/
   while(CONSP(x)){
       n=CHAR_CODE((int)(CAR(x)));
     /*** printf("list->string  c  %c %d ", n,n); **/
       if(n<256) *p++=n;
       else if(n&0xff0000){  /** utf8  **/
           *p++=(n>>16);
           *p++=(n>>8);
           *p++=n;
       }
       else{
           *p++=(n>>8);
           *p++=(n&0xff);
           }

       x=CDR(x);
   }
   return   s;
}

int euc_code(unsigned char b,unsigned char c)
{
  if((b>=0xa1)&&(b<=0xfe)){
        if((c>=0xa1)&&(c<=0xfe)) return 1;
    }
  else if((b==0x8e)&&(c>=0xa0)&&(c<=0xdf)) /**  kana  **/
     return 1;
  return 0;
}

int euc_first(unsigned char b)
{
  if((b==0x8e)||((b>=0xa1)&&(b<=0xfe))){
         return 1;
    }
  return 0;
}

unsigned char * jindex(unsigned char *p,int ind, int len){
  if(kanji_mode==3)
     return  jindex_utf(p,ind, len);
  else
     return  jindex_euc(p,ind, len);
}

unsigned char *jindex_euc(unsigned char *p,int ind, int len)
{
  unsigned char b;
  for(;;){
    /*** printf("ind %d len %d\n",ind,len); ***/
    if(len<0) return (unsigned char *)-1;  /*** Err **/
    if(ind==0) return p;
    b=*p++;
    len--;
    if(euc_first(b)&&euc_code(b,*p)){
           p++;
           len--;
     }
    ind--;
  }
}

unsigned char * jindex_utf(unsigned char *p,int ind, int len)
{
  unsigned char b;
  for(;;){
    /*** printf("ind %d len %d\n",ind,len); ***/
    if(len<0) return (unsigned char *)-1;  /*** Err **/
    if(ind==0) return p;
    b=*p++;
    len--;
    if(utf8_first(b)){
           p+=2;
           len-=2;
     }
    ind--;
  }
}


/***  len is simple bytes  ***/
int jstrlength(unsigned char *p,int len){
  if(kanji_mode==3) 
   return jstrlength_utf(p,len);
  else
   return jstrlength_euc(p,len);
}

int jstrlength_euc(unsigned char *p,int len)
{
  int j=0;
  unsigned char b;
  for(;;){
    if(len==0) return j;
    if(len<0) return -1;  /*** Err  not J-string**/
    b=*p++;
    len--;
    j++; 
    if(euc_first(b)&&euc_code(b,*p)){
           p++;
           len--;
     }
  }
}

int jstrlength_utf(unsigned char *p,int len)
{
  int j=0;
  unsigned char b;
  for(;;){
    if(len==0) return j;
    if(len<0) return -1;  /*** Err  not J-string**/
    b=*p++;
    len--;
    j++;
    if(utf8_first(b)){
           p+=2;
           len-=2;
     }
  }
}


int jstr_length(ptr str)
{
 int k;
  unsigned int j;
  unsigned char *p;
  p=get_string(str,&j);
  k=jstrlength(p,j);
  if(k<0) k=j;
  return k;
}

ptr s_string_length(int narg,ptr env)
{
  unsigned int j;
  ptr str=*(stack-1);
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  if(kanji_mode)
        j=jstr_length(str);
   else
        get_string(str,&j);
  return MAKESINT(j);
}

ptr s_string_byte_length(int narg,ptr env)
{
  unsigned int j;
  ptr str=*(stack-1);
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  get_string(str,&j);
  return MAKESINT(j);
}

ptr s_string_list(int narg,ptr env)
{
  ptr str=*(stack-1),res=a_nil;
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  if(kanji_mode) {
     res=jstring_list(str);
     if(res!=a_f) return res;
  }
  return string_list(str);
}

ptr s_string_byte_list(int narg,ptr env)
{
  int j;
  ptr str=*(stack-1),res=a_nil;
 checknarg(--narg);
  if (SREGP(str)||!STRINGP(str)) error(E_notstr, str);
  return string_list(str);
}

ptr string_list(ptr str)
{
  ptr res=a_nil;
  unsigned char *p;
  unsigned int j;

  p=get_string(str,&j);
  if(j==0) return a_nil;
  res=CONS(res,res);
  psh(res);
  while(j--){
     res=CDR(res)=CONS(MAKECHAR(*p++),a_nil);
  }
  res=*pull();
  return CDR(res);
}


unsigned char *jnext(unsigned char *p,ptr *ch)
{
  unsigned int b;
  b=*p++;
  if(kanji_mode==3){ /** utf8 **/
    if(utf8_first(b)){
            b=(b<<8)+*p++;
            *ch=MAKECHAR((b<<8)+(*p));
            return p+1;
      }
   }
  else if(euc_first(b)&&euc_code(b,*p)){
       *ch=MAKECHAR((b<<8)+(*p));
       return p+1;
    }
  *ch=MAKECHAR(b);
  return p;
}
 
ptr jstring_list(ptr str)
{
  int k;
  unsigned int j;
  ptr res=a_nil,ch;
  unsigned char *p;
  p=get_string(str,&j);
  if(j==0) return a_nil;
  k=jstrlength(p,j);
  if(k<0)
      return a_f;  /*** Not J-string ***/
   res=CONS(res,res); 
  psh(res);
  while(k--){
     p=jnext(p,&ch);
     res=CDR(res)=CONS(ch,a_nil);
  }
  res=*pull();
 return CDR(res);
}

ptr s_substring(int narg,ptr env)
{
  int index,end=-1,kmode=kanji_mode,shift;
  unsigned int k;
  ptr str,new,*base,start,endp;
  unsigned char *p,*q,*r;
  base=stack-narg;
  if((narg<3)||(narg>5) )
   checknarg(narg-5);
  str=*base++;
  if (SREGP(str)||!STRINGP(str)) error(E_notstr,str);
   p=get_string(str,&k);
  if(narg>3) {   /***  :end used ***/
    if(kmode){
        end=jstrlength(p,k);
          if(end==-1) {
               end=k;
               kmode=0;
          }
       }
     else
        end=k;
 }
  start=*base++;
  narg-=2;
  if(SINTP(start))
     index=SINT_NUMB(start);
  else if(start==k_end){
     index=end;
     if(SINTP(*base)) {
         index+=SINT_NUMB(*base++);
         narg--;
     }
 }
 else
       error(E_range,start);
  endp=*base++;
  narg--;
  if(SINTP(endp))
        end=SINT_NUMB(endp);
  else if(endp==k_end){
    if(end==-1){
       if(kmode){
         end=jstrlength(p,k);
          if(end==-1) {
               end=k;
               kmode=0;
          }
       }
     else
        end=k;
     }
 }
 else
       error(E_range,end);
  if(narg>0)
       end+=SINT_NUMB(*base);

  if (index < 0) error(E_range,start);
  if (end<index ) error(E_range,endp);
  if(end==index) return a_nullstr;
   if(kmode) return j_substring(p,k,index,end);
/***  not kanji ***/
    q=p+index;
    r=p+end;
   new=makestring(end-index);  /***  may be gbc occur  **/
   p=get_string(new,&k);
  while(q<r)
     *p++=*q++;
   return new;

}

ptr j_substring(unsigned char *p,unsigned int k,int index,int end)  /** k=size i, index<end ***/
{
  unsigned char *q,*r;
  ptr new;
     r=p+k;
     q=jindex(p,index,k);
    if((q==r)||(q==(unsigned char *)-1)){
        error(E_range,MAKESINT(index));
    } 
      r=jindex(p,end,k);
    if(r==(unsigned char *)-1){
         error(E_range,MAKESINT(end));
    }
   new=makestring(r-q);  /***  may be gbc occur  **/
   p=get_string(new,&k);
  while(q<r)
     *p++=*q++;
   return new;
}

ptr string_ref(ptr str,int index)
{
  unsigned int k;
  unsigned char *p,*q;
   p=get_string(str,&k);
   if(!kanji_mode){
      if(index>=k) error(E_range,MAKESINT(index));
      return MAKECHAR(*(p+index));
   }
     q=jindex(p,index,k);
    if((q==p+k)||(q==(unsigned char *)-1)){
        error(E_range,MAKESINT(index));
    }
   else{
     k=*q++;
     if(kanji_mode==3){
       if(utf8_first(k)){
        k=(k<<8)+*q++;
        k=(k<<8)+*q;
        }
     }
     else if(euc_code(k,*q))
        k=(k<<8)+*q;
   }
   return MAKECHAR(k);
}

ptr s_string_ref(int narg,ptr env)
{
  int index,k;
  ptr str;
  unsigned char *p,*q;
  checknarg(narg-2);
  str=*(stack-2);
  index=SINT_NUMB(*(stack-1));
  if (SREGP(str)||!STRINGP(str)) error(E_notstr,str);
  if (index < 0) error(E_range,*(stack-1));
   return string_ref(str,index);
}

ptr s_string_set(int narg,ptr env)
{
  int index;
 unsigned  int  k,j,s;
  ptr str,value;
  unsigned char *p,*q;
  checknarg(narg-3);
  str=*(stack-3);
  index=SINT_NUMB(*(stack-2));
  if (SREGP(str)||!STRINGP(str)) error(E_notstr,str);
  if (index < 0) error(E_range,*(stack-1));
  value=*(stack-1);
  if(!CHARP(value)) error(E_notchar,value);
    j=CHAR_CODE(value);
     p=get_string(str,&s);
   if(kanji_mode) return j_string_set(p,s,index,j);
   if(index>=s)error(E_range,MAKESINT(index));
    q=p+index;
   if(j>255){
         if(q>=(p+s-1))
                  error(E_range,MAKESINT(index));
        if(j>0xffff) *q++=(j>>16);  /* utf8 */
        *q++=(j>>8);
        *q=j&0xff;
      }
    else
        *q=j;
  return a_undef;
}

ptr j_string_set(unsigned char *p,int len,int index,int j)
{
  unsigned char *q;
     q=jindex(p,index,len);
    if(((int)q==-1)||(q==p+len)){
         error(E_range,MAKESINT(index));
         /** *(p+index)=j; ***/
     }
    else{
    if(j>255){
         /** if(q>=(p+len-1)) **/
         if(q>=(p+len+1-kanji_mode))
                  error(E_range,MAKESINT(index));
        if(kanji_mode==3) *q++=(j>>16);
        *q++=(j>>8);
        *q=j&0xff;
      }
    else
     {
      if(kanji_mode==3){
         if(utf8_first(*q)){
            *q++=j;
            *q++=' ';
            *q=' ';
          }
         else
          *q=j;
       }
      else if(euc_first(*q)){
            *q++=j;
            *q=' ';
       }
      else
        *q=j;
     }
  }
  return a_undef;
}

int STRLEN(ptr p){
unsigned int n;
 get_string(p,&n);
return n;
} 

unsigned char *FWSTR(ptr p){
unsigned int n;
 return get_string(p,&n);
}

/*** 04.4.24    ss  Bonus ***/
/***  (string-index s1 s2)   find s1 in s2 and return index ***/
static ptr jstring_index(unsigned char *p,int k,unsigned char *q,int j,int ci)
{
  unsigned char *r;
   int index=0;
  while(1){
    if(ci){
      if(scm_strcmp_ci(p,q,k)) return MAKESINT(index);
     }
    else
         if(scm_strcmp(p,q,k)) return MAKESINT(index);
    r=jindex(q,1,j);
    if((int)r==-1) return a_f;
    j=j-(r-q);
    q=r;
    index++;
   if(j<k) return a_f;
 }
}

ptr s_string_index(int narg,ptr env)
{
  int index;
  unsigned int k,j,ci=0;
  ptr s1,s2;
  unsigned char *p,*q;
  if(narg==3) {
     if(*(stack-1)!=k_nocase) error(E_keyword,*(stack-1));
     ci=1;
     s1=*(stack-3);
     s2=*(stack-2);
  }
  else if(narg==2){   
     s1=*(stack-2);
     s2=*(stack-1);
  }
  else
     checknarg(narg-2);
  if (SREGP(s1)||!STRINGP(s1)) error(E_notstr,s1);
  if (SREGP(s2)||!STRINGP(s2)) error(E_notstr,s2);
   p=get_string(s1,&k);
   q=get_string(s2,&j);
  index=0;
  if (k>j) return a_f;
   if(kanji_mode) return jstring_index(p,k,q,j,ci);
  while(1){
    if(ci){
      if(scm_strcmp_ci(p,q,k)) return MAKESINT(index);
     }
    else
         if(scm_strcmp(p,q,k)) return MAKESINT(index);
    q++;
    j--;
    index++;
   if(j<k) return a_f;
 } 
}

static ptr jstring_rindex(unsigned char *p,int k,unsigned char *q,int j,int ci)
{
   int index=0;
   int memo=-1;
  unsigned char *r;
  while(1){
    /** printf("%s %s %d %d %d %d\n",p,q,k,j,index,memo);***/
    if(ci){
      if(scm_strcmp_ci(p,q,k)) memo=index;
     }
    else
         if(scm_strcmp(p,q,k)) memo=index;
    r=jindex(q,1,j);
    if(r==(unsigned char *)-1) break;
    j=j-(r-q);
    q=r;
    index++;
   if(j<k) break;
 }
  if(memo==-1) return a_f;
return MAKESINT(memo);
}

/***  (string-rindex s1 s2)   find s1 in s2 from last and return index ***/
ptr s_string_rindex(int narg,ptr env)
{
  int index;
  unsigned int k,j,ci=0;
  ptr s1,s2;
  unsigned char *p,*q;
  if(narg==3) {
     if(*(stack-1)!=k_nocase) error(E_keyword,*(stack-1));
     ci=1;
     s1=*(stack-3);
     s2=*(stack-2);
  }
  else if(narg==2){
     s1=*(stack-2);
     s2=*(stack-1);
  }
  else
     checknarg(narg-2);
  if (SREGP(s1)||!STRINGP(s1)) error(E_notstr,s1);
  if (SREGP(s2)||!STRINGP(s2)) error(E_notstr,s2);
   p=get_string(s1,&k);
   q=get_string(s2,&j);
   if(kanji_mode) return jstring_rindex(p,k,q,j,ci);
  index=j-k;
  q=q+j-k;
  if (k>j) return a_f;
  while(1){
    if(ci){
        if(scm_strcmp_ci(p,q,k)) return MAKESINT(index);
     }   
    else
           if(scm_strcmp(p,q,k)) return MAKESINT(index);
    q--;
    j--;
    index--;
   if(j<k) return a_f;
 }
}



/****  from stream.c   hakaiteki,   NOT return str ***/
extend_str(ptr str,unsigned int n){
  ptr sp,new;
  unsigned int m;
  unsigned char *p,*q,*r;
      m=(n+8)&0xfffffff8;  /*** 8* ***/
      /*** printf("*** str ext**** m %d   n %d\n",m,n);  ***/
       new=makestring(m);
       p=get_string(str,&n);
       r=q=get_string(new,&m);
       while(n--) *q++=*p++;
       Myfree(CAR(str));         /***  ver 1.7 ***/
          MARK(new)=FREECELL;  /*** CONS ***/
          CAR(new)=a_nil;
          CDR(new)=free_cell;
          free_cell=new;
       sp=(ptr)r;
       CAR(--sp)=str;
       CAR(str)=sp;
       CDR(str)=(ptr)m;
 }

