/*** 
  comp_sr.c  03.12.20

  a little part of compile-file.ss
  see also comp.c
****/
#include "lisp.h"

extern ptr NOP,k_warn;
extern ptr  k_q,k_n,k_c,k_hatena;
extern ptr k_B,k_O,k_f,k_t,k_T,k_F,k_N,k_0,k_1,k__1,k_Q,k_u,k_C;
extern ptr k_J,k_TJ,k_JM,k_D,k_S,k_V,k_L,k_P,k_E,k_I,k_IT,k_IF,k_K,k_LM,k_LB,k_A,k_DA,k_ML,k_MM;
extern ptr k_load,k_set,k_warn,k_env,k_top,k_lambda,k_macro,k_func,k_tail_jump;
extern ptr k_define,k_jmp,k_label,k_block_out,k_block_in,k_bind,k_letbind,k_stack_narg;
extern ptr k_lambda_begin,k_lambda_bind,k_call_cc,k_jsr,k_exit,k_tail,k_frame,k_frame_list;
extern ptr k_lambda_end,k_macro_end,k_imm,k_alloc,k_dealloc,k_BIND,k_LT,k_reg;
extern ptr k_undef,k_make_lambda,k_make_macro;

extern ptr OUTCOMP[];   /*** we use this as working space !!! ***/
extern ptr *get_vector(); 

int sr_out(ptr v){
 Reg  ptr *p,*q,x;
 int i,n,k;

 p=get_vector(v,&n);  /*** COMPILED data ***/
 q=OUTCOMP;
 i=0;
 while(i++<n){
  x=*p++;
  if(CAR(x)==a_f) break;
  k=sr_out_sub(x,q);
  q+=k;
 }
 return (int)(q-OUTCOMP);
}

int sr_out_sub(ptr x,ptr *q){
 Reg ptr op,s;
 Reg int n;

 n=1;
 op=CAR(x);
 if(op==k_func)
    *q=k_F;
 else if(op==k_stack_narg)
    *q=k_N;
 else if(op==k_exit)
    *q=k_Q;
 else if(op==k_jsr){
    *q++=k_J;
     goto n2;
 }
 else if(op==k_tail_jump){
    *q++=k_TJ;
     goto n2;
 }
 else if(op==k_jmp){
    *q++=k_JM;
    *q++=CDDR(x);
    n=2;
 }
 else if(op==k_define){
    *q++=k_D;
     goto n2;
 }
 else if(op==k_set){
     x=CDR(x);
     s=CAR(x);
     if(s==k_frame){
         *q++=k_S;
         s=CADR(x);
         if(CONSP(s)) s=CAR(s); /*** (x . block) ***/
         *q++=s;
         n=2;
      }
     else if(s==k_top){
          *q++=k_T;
          *q++=CADR(x);
         n=2;
      }
     else if(s==k_env){
          *q++=k_V;
          s=CADR(x);
         if(CONSP(s)) s=CAR(s);
         *q++=s;
         n=2;
     }
     else
         error(5999,x);
  }
 else if(op==k_load){
     x=CDR(x);
     s=CAR(x);
     if(s==k_frame){
         *q++=k_L;
         s=CADR(x);
         if(CONSP(s)) s=CAR(s);
         *q++=s;
         n=2;
      }
     else if(s==k_top){
          *q++=k_P;
          *q++=CADR(x);
         n=2;
      }
     else if(s==k_env){
          *q++=k_E;
         s=CADR(x);
         if(CONSP(s)) s=CAR(s);
         *q++=s;
         n=2;
     }
     else if(s==k_imm){
          *q++=k_I;
          *q++=CADR(x);
         n=2;
      }
     else if(s==k_reg){
          *q++=k_reg;
          *q++=CADR(x);
         n=2;
      }
     else if(CONSP(CDR(x)))
         error(6999,x);
     else if(s==k_undef)
         *q=k_u;
      else if(s==k_T)
         *q=k_t;
      else if(s==k_F)
         *q=k_f;
      else if(s==a_nil)
         *q=k_n;
      else if(s==ZERO)
         *q=k_0;
      else if(s==ONE)
         *q=k_1;
      else if(s==MINUSONE)
         *q=k__1;
      else
         error(7999,x);
    }
 else if(op==k_IF){
     x=CDR(x);
     s=CAR(x);
    
     if(s==k_T){
        *q++=k_IT;
      }
     else
        *q++=k_IF;
      *q=CDDR(x);
     n=2;
   }
 else if(op==k_block_in)
     *q=k_K;
 else if(op==k_block_out)
     *q=k_O;
 else if(op==k_BIND){
     *q++=k_B;
     s=CADR(x);
     if(CONSP(s)) s=CAR(s);
     *q=s;
     n=2;
  }
 else if(op==k_label)
    n=0;   /*** No out ***/
 
 else if(op==k_call_cc)
    *q=k_C;
 else if(op==k_lambda_begin){
    *q++=k_LM;
    *q=CAR(CDDR(x));
    n=2;
 }
 else if(op==k_lambda_bind){
    x=CDR(x);
    *q++=k_LB;
    *q++=CAR(x);
    *q=CADR(x);
    n=3;
 }
 else if(op==k_alloc){
     *q++=k_A;
     goto n2;
 }
 else if(op==k_dealloc){
     *q++=k_DA;
     goto n2;
 }
 else if(op==k_make_lambda){
     *q++=k_ML;
     goto n2;
 }
 else if(op==k_make_macro){
     *q++=k_MM;
     goto n2;
 }
 else
     error(8999,x);
  return n;
n2:
   *q=CADR(x);
   return 2;
}

  

