/*** ratio.c
***/
#define  RATIO_C

#include "lisp.h" 

extern ptr minus();
#define minusp(x)   gsign(x)

extern checknarg();
extern double get_float();
extern ptr ffloor();
extern mpz_t mpzwork1,mpzwork2;

mpq_t mpqwork1, mpqwork2;

init_ratio(){
mpq_init(mpqwork1);
mpq_init(mpqwork2);
}

ptr mpq2rational(mpq_t num)  /***  use mpq_check16 for the last of call **/
{
 ptr z;
   z=new_cell(RATIO);
 psh(z);  /*** Mymalloc may call gbc!!! ***/
 RATIONAL(z)=Mymalloc(sizeof(MP_RAT));
  /** printf("size MP_RAT %x\n",sizeof(MP_RAT));   0x18  **/
 mpq_init(RATIONAL(z));
 mpq_set(RATIONAL(z),num);
 pull();
 return z;
}

static ptr getnumerator(ptr x)  /**x is ratio **/
{
  /**  MP_INT b; **/
   ptr res;
     mpq_get_num(mpzwork1,RATIONAL(x));
     return mpz_check16(mpzwork1);
}

static ptr getdenominator(ptr x)  /**x is ratio **/
{
  /**  MP_INT b; **/
   ptr res;
     mpq_get_den(mpzwork1,RATIONAL(x));
     return mpz_check16(mpzwork1);
}

static ptr mpq_check16(mpq_t x)
{
  Reg int n;
    mpq_get_den(mpzwork1,x);
  /***  if(mpz_fits_slong_p(mpzwork1)){   64bit!  ***/
   if(mpz_fits_sint_p(mpzwork1)){
      n=mpz_get_si(mpzwork1);
      if(n==1)
         return mpz_check16(mpq_numref(x));
    }
  return mpq2rational(x);
}


ptr mpz2rational(mpz_t num, mpz_t den)
{
 ptr z;
   z=new_cell(RATIO);
 psh(z);
 RATIONAL(z)=Mymalloc(sizeof(MP_RAT));
 mpq_init(RATIONAL(z));
 mpq_set_num(RATIONAL(z),num);
 mpq_set_den(RATIONAL(z),den);
 mpq_canonicalize(RATIONAL(z));
 pull();
 return z;
}

ptr intdiv_long(ptr big1,ptr big2){
 psh(big1);
 psh(big2);
 mpq_set_num(mpqwork1,BIGNUM(big1));
 mpq_set_den(mpqwork1,BIGNUM(big2));
 mpq_canonicalize(mpqwork1);
 big1=mpq_check16(mpqwork1);
 stack-=2;
 return big1;
}


ptr s_numerator(int narg,ptr env)
    
{ 
  Reg ptr x=*(stack-1);
   checknarg(narg-1);
   if(SREGP(x)){
       if(SINTP(x)) return x;
       goto err;
    }
   if(BIGINTP(x)) return x;
   if(RATIOP(x)) {
      return getnumerator(x);
   }
err:
   error(E_typemis,x);
}

ptr s_denominator(int narg,ptr env)
{ 
  Reg ptr x=*(stack-1);
   checknarg(narg-1);
   if(SREGP(x)){
       if(SINTP(x)) return ONE;
       goto err;
    }
   if(BIGINTP(x)) return ONE;
   if(RATIOP(x)) {
      return getdenominator(x);
   }
err:
   error(E_typemis,x);
}


checkratio(p)     /****  n/1->n   0/n -> 0   and  -u/v****/
  Reg ptr p;
{
  Reg ptr u,v;
   error(55555,p);
}

ptr ratio(p)
  Reg ptr p;   /*** p :integer -> ratio ***/
{
  Reg ptr x;
      psh(p);
      mpz_set_si(mpzwork2,1);
  if(SINTP(p)){
      pull();
      mpz_set_si(mpzwork1,SINT_NUMB(p));
      return mpz2rational(mpzwork1,mpzwork2);
     }
   x=mpz2rational(BIGNUM(p),mpzwork2);
   pull();
  return x;
}     

ptr ratiomul (u,v) 
  Reg ptr u,v ; 
{ 
  psh(u);
  psh(v);
  mpq_mul(mpqwork1,RATIONAL(u),RATIONAL(v));
  u=mpq_check16(mpqwork1);
  stack-=2;
  return u;
} 

static ptr inverse(u)
  Reg ptr u; 
{ 
   psh(u);
   mpq_inv(mpqwork1,RATIONAL(u));
   u=mpq_check16(mpqwork1);
   pull();
   return u;
}

ptr ratiodiv (u,v) 
  Reg ptr u,v ; 
{ 
 psh(u);
 psh(v);
 mpq_div(mpqwork1,RATIONAL(u),RATIONAL(v));
 u=mpq_check16(mpqwork1);
 stack-=2;
 return u;
}


ptr ratioadd (u,v) 
  Reg ptr u,v ; 
{ 
  psh(u);
 psh(v);
 mpq_add(mpqwork1,RATIONAL(u),RATIONAL(v));
  u= mpq_check16(mpqwork1);
  stack-=2;
  return u;
}

ptr ratiosub (u,v) 
  Reg ptr u,v ; 
{ 
  psh(u);
 psh(v);
 mpq_sub(mpqwork1,RATIONAL(u),RATIONAL(v));
  u= mpq_check16(mpqwork1);
  stack-=2;
  return u;
}


ptr ratiomod(u,v)
  Reg ptr u,v ; 
{ 
  Reg ptr q ,r,*sfree; 
      psh(u);
      psh(v);
     q=ratiodiv(u,v);
     sfree=stack;
     psh(q);
     *sfree=q=rfloor(q);
     *sfree=r=genmul(v,q);
     *sfree=r=gensub(u,r);
     if(gsign(v)){
                if( gsign(r)) goto owa;
            }
     else if(!gsign(r)) goto owa;
     r=genadd(r,v);
 owa:
   stack-=3;
   return r;
}

ptr ratioremain(u,v)
  Reg ptr u,v ; 
{ 
  Reg ptr q ,r,*sfree; 
      psh(u);
     psh(v);
     q=ratiodiv(u,v);
     sfree=stack;
     psh(q);
     *sfree=q=rfloor(q);
     *sfree=r=genmul(v,q);
     *sfree=r=gensub(u,r);
     if(gsign(u)){
                if( gsign(r)) goto owa;
                if(gsign(v)) r=genadd(r,v);
                 else r=gensub(r,v);
            }
     else if(gsign(r)){
          if(gsign(v))
                r=gensub(r,v);
          else
               r=genadd(r,v);
     }
 owa:
   stack-=3;
   return r;
} 


  
static ptr gcd2();

static ptr gcd (u,v ) 
Reg ptr u,v ; 
{ Reg ptr a , * sfree , temp ; 
Reg ptr Nil=a_nil ; 
 psh(u);
 psh(v);
sfree = stack;
alloc (2 ) ; 
 if(minusp(u))
    *sfree=u=minus(u);
   else
    *sfree=u;
 if(minusp(v))
    sfree[1]=v=minus(v);
   else
    sfree[1]=v;

      a=gcd2(u,v); 
   sp_pull (4) ; 
  return a;
}
/*** entry gcd2 expr 2 ***/ 
static ptr gcd2 (Reg ptr a, Reg ptr b ) 

{
  Reg ptr c;
  psh(a);
  psh(b);
  /*** above  by Mymalloc ***/
  psh(b);
loop:
if(zerop(a)){
    a=*pull();
   stack-=2;
   return a;
}

c=genremain(*(stack-1),a);
*(stack-1)=a;
a=c;
goto loop;
}

static ptr lcm (u,v ) 
Reg ptr u,v ; 
{ Reg ptr a , * sfree ; 
Reg ptr Nil=a_nil ; 

    psh(u);
    psh(v);
sfree = stack;
alloc (3 ) ; 
 if(minusp(u))
    *sfree=u=minus(u);
   else
    *sfree=u;
 if(minusp(v))
    sfree[1]=v=minus(v);
   else
    sfree[1]=v;
  sfree[2]=gcd2(u,v); 
  *sfree=a=genmul(u,v);
   a=fixdiv(a,sfree[2]);    
   sp_pull (5 ) ; 
  return a;
}

ptr s_gcd(int narg,ptr env)
 {
  /*** expr -1 ***/
  Reg ptr x=*(stack-1),u,v,*sfree;
    if (narg==0) return ZERO;
    sfree=stack-narg;
    u=*sfree++;
    if(narg==1) return ABS(u); 
    narg--;
    *stack++=u;
   loop:
    if((narg==0)||u==ONE) return *pull();
    x=*sfree++;
    narg--;
    if(!INTEGERP(x)) error(E_notint,v);
    if(zerop(x)) goto loop;
      *(stack-1)=u=gcd(u,x);
    goto loop;
 }
ptr s_lcm(int narg,ptr env)
 {
  /*** expr -1 ***/
  Reg ptr x=*(stack-1),u,v,*sfree;
    if (narg==0) return ONE;
      sfree=stack-narg;
    u=*sfree++;
    if(narg==1) return ABS(u);
    narg--;
    *stack++=u;
   loop:
    if((narg==0)||zerop(u)) return *pull();
     x=*sfree++;
    narg--;
    if(!INTEGERP(x)) error(E_notint,v);
      *(stack-1)=u=lcm(u,x);
    goto loop;
 }

  /***  double ->rational  ***/
ptr d2rational(double  x)
 {
    Reg ptr p;
     mpq_set_d(mpqwork1,x);
     p= mpq_check16(mpqwork1);
     return p;
 }

ptr rational(ptr x)
 {
    Reg int s,e,sign;
    Reg ptr p,q;
     psh(x);
     mpq_set_d(mpqwork1,FLONUM(x));     
     x= mpq_check16(mpqwork1);
     pull();
     return x;
 }

ptr s_rational(int narg,ptr env)
 {
    Reg ptr x=*(stack-1);
   checknarg(narg-1);
    if(INTEGERP(x)||RATIOP(x)) return x;
    if(DOUBLEP(x))  return rational (x);
    error(E_notnum,x);
 }

ptr s_rationalize(int narg,ptr env)
 {
   Reg ptr *s,x=*(stack-2),y;
   double e;
  double get_double();
   checknarg(narg-2);  /*** exp 2 ***/
  if(SREGP(x)){
      if(SINTP(x)) return x;
            goto  err;
      }
  else if(BIGINTP(x)||RATIOP(x))
           return x;
  else if(DOUBLEP(x)){
     
         ptr num,den;
          double d,e,u,v;
             long r,s,max;
            y=*(stack-1);
            v=FLONUM(x);
            e=get_float(y);
            d=1.0/e;
            if(d>(double)0x7fffffff)
                    max=0x7fffffff;
            else
                  max=d;
            if(max<1)
               return ffloor(v+0.5);
             /*** printf("%d e=%f \n",max,e);  ***/
            r=1;
            do{
              r+=1;
              s=u=r*v;
              u-=s;
              /**  printf("u=%f s=%d r=%d er %f\n",u,s,r,e*r); **/ 
              if(u<e*r) break;
              s+=1;
              u=1.0-u;
              if(u<e*r) break;
            }while(r<max);
           num=bignum(s);
           den=bignum(r);
           return gendiv(num,den); 
      }
    err: error(E_notnum, x);
}

