/***  s_car.c
***/

#include "lisp.h"
extern void checknarg();
extern void init_sub();
#define NOTCONS(x)  (SREGP(x)||ATOM(x))
/*  caar etc.  */
ptr s_car(int narg,ptr env)
    
 {
    Reg ptr x=*(stack-1);
    checknarg(narg-1);
    if(NOTCONS(x)) return error(E_notlist,x);
    return CAR(x);
 }

ptr s_cdr(int narg,ptr env)
    
 {
    Reg ptr x=*(stack-1);
    checknarg(narg-1);
    if(NOTCONS(x)){
       return error(E_notlist,x);
     }
    return CDR(x);
 }

ptr _car(x)
    Reg ptr x;
 {
    /* 8.4   for nil */
    if(NOTCONS(x)) return error(E_notlist,x);
    return CAR(x);
 }
ptr _cdr(x)
    Reg ptr x;
 {
    if(NOTCONS(x)) return error(E_notlist,x);
    return CDR(x);
 }

ptr _caar(x)
    Reg ptr x;
 {
    if(NOTCONS(x)) return error(E_notlist,x);
    x=CAR(x);
    if(NOTCONS(x)) return error(E_notlist,x);
    return CAR(x);
 }

ptr _cadr(x)
    Reg ptr x;
 {
    if(NOTCONS(x)) return error(E_notlist,x);
    x=CDR(x);
    if(NOTCONS(x)) return error(E_notlist,x);
    return CAR(x);
 }

ptr _cdar(x)
    Reg ptr x;
 {
    if(NOTCONS(x)) return error(E_notlist,x);
    x=CAR(x);
    if(NOTCONS(x)) return error(E_notlist,x);
    return CDR(x);
 }

ptr _cddr(x)
    Reg ptr x;
 {
    if(NOTCONS(x)) return error(E_notlist,x);
    x=CDR(x);
    if(NOTCONS(x)) return error(E_notlist,x);
    return CDR(x);
 }

ptr s_caar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _caar(*(stack-1));
 }

ptr s_cadr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cadr(*(stack-1));
 }

ptr s_cdar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdar(*(stack-1));
 }
ptr s_cddr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cddr(*(stack-1));
 }
ptr s_caaar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _car(_caar(*(stack-1)));
 }
ptr s_caadr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _car(_cadr(*(stack-1)));
 }
ptr s_cadar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _car(_cdar(*(stack-1)));
 }
ptr s_caddr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _car(_cddr(*(stack-1)));
 }
ptr s_cdaar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdr(_caar(*(stack-1)));
 }
ptr s_cdadr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdr(_cadr(*(stack-1)));
 }
ptr s_cddar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdr(_cdar(*(stack-1)));
 }
ptr s_cdddr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdr(_cddr(*(stack-1)));
 }

/** 4!  **/ 
ptr s_caaaar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _caar(_caar(*(stack-1)));
 }
ptr s_caaadr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _caar(_cadr(*(stack-1)));
 }
ptr s_caadar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _caar(_cdar(*(stack-1)));
 }
ptr s_caaddr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _caar(_cddr(*(stack-1)));
 }
ptr s_cadaar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cadr(_caar(*(stack-1)));
 }
ptr s_cadadr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cadr(_cadr(*(stack-1)));
 }
ptr s_caddar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cadr(_cdar(*(stack-1)));
 }
ptr s_cadddr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cadr(_cddr(*(stack-1)));
 }
 
ptr s_cdaaar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdar(_caar(*(stack-1)));
 }
ptr s_cdaadr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdar(_cadr(*(stack-1)));
 }
ptr s_cdadar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdar(_cdar(*(stack-1)));
 }
ptr s_cdaddr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cdar(_cddr(*(stack-1)));
 }
ptr s_cddaar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cddr(_caar(*(stack-1)));
 }
ptr s_cddadr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cddr(_cadr(*(stack-1)));
 }
ptr s_cdddar(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cddr(_cdar(*(stack-1)));
 }
ptr s_cddddr(int narg,ptr env)
    
 {
    checknarg(narg-1);
    return _cddr(_cddr(*(stack-1)));
 }


struct  sys_subr  car_func[]=
  {
{"car", s_car, 1,0},
{"cdr", s_cdr, 1,0},

{"caar", s_caar, 1,0},
{"cadr", s_cadr, 1,0},
{"cdar", s_cdar, 1,0},
{"cddr", s_cddr, 1,0},

{"caaar", s_caaar, 1,0},
{"caadr", s_caadr, 1,0},
{"cadar", s_cadar, 1,0},
{"caddr", s_caddr, 1,0},
{"cdaar", s_cdaar, 1,0},
{"cdadr", s_cdadr, 1,0},
{"cddar", s_cddar, 1,0},
{"cdddr", s_cdddr, 1,0},

{"caaaar", s_caaaar, 1,0},
{"caaadr", s_caaadr, 1,0},
{"caadar", s_caadar, 1,0},
{"caaddr", s_caaddr, 1,0},
{"cadaar", s_cadaar, 1,0},
{"cadadr", s_cadadr, 1,0},
{"caddar", s_caddar, 1,0},
{"cadddr", s_cadddr, 1,0},

{"cdaaar", s_cdaaar, 1,0},
{"cdaadr", s_cdaadr, 1,0},
{"cdadar", s_cdadar, 1,0},
{"cdaddr", s_cdaddr, 1,0},
{"cddaar", s_cddaar, 1,0},
{"cddadr", s_cddadr, 1,0},
{"cdddar", s_cdddar, 1,0},
{"cddddr", s_cddddr, 1,0},
 {NULL,NULL,0,0},
 };

init_car(){
init_sub(car_func,SLAMBDA);
}


