/***  socket.c 
    Cf. C for Linux  P.136
    04.7.14
    socket program  for ss
***/

#ifdef WIN32
//#include <windows.h>
#include <winsock.h>
#define WINH_LOAD
#include <sys/types.h>
#include <sys/time.h>
//#include <netinet/in.h>
//#include <netdb.h>
#else
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <sys/time.h>   /***  need for Mac OS  by Tokuda ***/
#endif

#include <stdio.h>

#include <string.h>

#define  SOCKET_C

#include "lisp.h"
#include "ss_stream.h"
#define NETBUFMAX  4096

/** char netbuf[1024]; **/

/*** NETSOCKET
    ATTR=NETSOCKET
        CDR=INT  (socket fdp)
        CAR is NULL or
          (CONS (CONS read-location . buffer) (CONS write-location . buffer))
             location are SINT
             buffers are by Mymalloc

    CAR=0x11 =  sock_addr   CDR=struct sock_addr_in *  by Myalloc
***/
extern ptr makenewstream();

static ptr open_socket();  /***  cons of soc addr ***/

static ptr make_socket(int soc,int rw){
  ptr x,buf;
   if(rw==YES){
        buf=CONS(ZERO,Mymalloc(NETBUFMAX+1));
        ATTR(buf)=NETSOCKET;
        psh(buf);
        buf=CONS(ZERO,Mymalloc(NETBUFMAX+1));
        ATTR(buf)=NETSOCKET;
        buf=SCONS(buf,*(stack-1));
        x=CONS(buf,soc);
        pull();
    }
  else
      x=CONS(NULL,soc);
  ATTR(x)=NETSOCKET;
  return x;
}

/****  socket for client ***/
check_addr(ptr addr){
   Reg int attr;
    if(SREGP(addr)||!NETSOCKETP(addr)) error(E_notsocket,addr);
     attr=(int)CAR(addr);
    if(attr!=sock_addr) error(E_notsocket,addr);
}

ptr s_socket_connect(int narg,ptr env)
 {
   Reg int soc;
    ptr addr;
    checknarg(narg-1);
    addr=*(stack-1);
    check_addr(addr);
    soc=socket_connect(CDR(addr)); 
   return open_socket(SCONS(make_socket(soc,YES),addr),network_ac);
}

ptr s_socket_listen(int narg,ptr env)
 {
    ptr addr;
   Reg int soc;
    checknarg(narg-1);
    addr=*(stack-1);
    check_addr(addr);
    soc=socket_listen(CDR(addr),NO);
   return open_socket(SCONS(make_socket(soc,NO),addr),listen_ac);
}

ptr s_port_used(int narg,ptr env)
 {
    ptr addr;
   Reg int soc;
    checknarg(narg-1);
    addr=*(stack-1);
    check_addr(addr);
    return socket_listen(CDR(addr),YES);
}


int get_socket_fdp(ptr lpath)
{
  ptr q;
  int soc;
   q=ST_SOC(lpath);
   q=CAR(q);  /*** socket ss data  ***/
   return ((int)CDR(q)&0xffff);
}

void set_socket_fdp(ptr lpath,int fdp)
{
  Reg ptr q;
  Reg int soc;
   q=ST_SOC(lpath);
   q=CAR(q);  /*** socket ss data  ***/
   soc=((int)CDR(q)&0xffff0000)|fdp;
   CDR(q)=(ptr)soc;
}


ptr  get_socket_data(ptr lpath)
{
  ptr q;
  int soc;
   q=ST_SOC(lpath);
   return CAR(q);  /*** socket ss data  ***/
}


struct sockaddr_in * get_sock_addr(ptr lpath)
{
  ptr q;
  int soc;
   q=ST_SOC(lpath);
   q=CDR(q);  /*** sockaddr  ss data  ***/
   return (struct sockaddr_in *)CDR(q);
}

ptr s_socket_accept(int narg,ptr env)
 {
    ptr lpath,res;     /***  socket stream  **/
   Reg int soc,acc,wait;
   struct sockaddr_in *pfrom,*me;
   struct sockaddr_in * get_sock_addr();
    if(narg==1){
       lpath=*(stack-1);
       wait=0;
   }
    else {
         checknarg(narg-2);
         lpath=*(stack-2);
         wait=GETNUM(*(stack-1));
     }
    if(SREGP(lpath)||!STREAMP(lpath)) error(E_notstream,lpath);
    soc=get_socket_fdp(lpath);
    if((wait>0)&&!network_ready(soc,wait)) return a_f;
    pfrom=(struct sockaddr_in *)Mymalloc(sizeof(struct sockaddr_in));
    memset((char *)pfrom,0,sizeof(struct sockaddr_in)); /*** clear  **/
    acc=socket_accept(soc,pfrom);
    res=CONS(sock_addr,pfrom);
    ATTR(res)=NETSOCKET;
    psh(res);
    res= open_socket(SCONS(make_socket(acc,YES),res),network_ac);
    pull();
    me=get_sock_addr(lpath);
    pfrom->sin_port=me->sin_port;  
    return res;
}


static ptr open_socket(ptr soc_addr,int access)  /***  cons of soc addr ***/
 {
   psh(soc_addr);
   /***  SEOF is UNREADC  for SOCKET_PORT specially  ***/
   soc_addr= makenewstream ( access|SOCKET_PORT,SEOF,SEOF,soc_addr) ;
   pull();
   return soc_addr;
}


/*** for server  ***/
int socket_listen(struct sockaddr_in *me,int check)
{
  int soc,len,opt;
   /*** get socket ***/
    soc=socket(AF_INET,SOCK_STREAM,0);
    if(soc<0)  error(E_socket,a_f) ;  /*** error   ***/
     /*** enable reuse port immediately  ***/
   len= setsockopt(soc,SOL_SOCKET,SO_REUSEADDR,(char *)&opt,sizeof(int));
   if(len!=0) {
          close(soc);
           error(E_socket,a_f);
     }
     /** connect ***/
  if(bind(soc,me,sizeof(struct sockaddr_in))<0){
            if(check) goto used;
            perror("bind fail");
            goto err;
        }
  if(check) goto unused;
  if(listen(soc,SOMAXCONN)<0) {
        perror("listen  fail");
     goto err;   /*** 128  ***/
  }
  return soc;
 used:
    close(soc);
    return a_t;
unused:
    close(soc);
    return a_f;
 err:
      close(soc);
      error(E_socket,a_f);

}

/***  for client  **/
int socket_connect(struct sockaddr_in *pserver){
  int soc,len,opt;
/*** get socket ***/
  soc=socket(AF_INET,SOCK_STREAM,0);
  if(soc<0)  error(E_socket,a_f);  /*** error ***/
   len= setsockopt(soc,SOL_SOCKET,SO_REUSEADDR,(char *)&opt,sizeof(int));
   if(len!=0) {
         close(soc);
         error(E_socket,a_f);
     }
  /** connect ***/
  if(connect(soc,(struct sockaddr *)pserver,sizeof(struct sockaddr))==-1){
     fprintf(stderr,"can't connect\n");
     close(soc);
     error(E_network,a_f);
  }
 return soc;
}

int socket_accept(int soc,struct sockaddr_in *pfrom){
  int len,acc;
    len=sizeof(struct sockaddr_in);
   acc=accept(soc,pfrom,&len);
   return acc;
}
/****  input,output ***/
/*** readflag=YES readc, NO peek maybe return a_f  ***/
ptr socket_readbuf(ptr lpath,int readflag){
  Reg ptr soc_buff;
  Reg int soc,loc;
  unsigned char *buf;
  soc_buff=get_socket_data(lpath);
  soc=(int)CDR(soc_buff)&0xffff;
  soc_buff=CAR(soc_buff);
  if(soc_buff==NULL) return a_f;
  soc_buff=CAR(soc_buff); /**  (read-loc . buff)  ***/
  loc=GETNUM(CAR(soc_buff));
   buf=(char *)CDR(soc_buff);
  if(loc==0){
       if(!readflag)  return a_f;
       if((loc=recv(soc,buf,NETBUFMAX,0))<0){
           perror("recv fail");
           error(E_recv,MAKESINT(soc));
       }
       if(loc==0){
               /***  eof  ***/
              /** fprintf(stderr,"recv: %d EOF",soc); ***/
              return SEOF;
       }
       *(buf+loc)=0;
       CAR(soc_buff)=MAKESINT(loc); 
   }
  lpath=MAKECHAR(*buf);
  if(!readflag){
     return MAKESINT(loc);  /*** 05.2.14  ***/
      /***  return lpath;  ***/
  }
   memcpydown_s(buf,buf+1,loc);
  CAR(soc_buff)=MAKESINT(--loc); 
  return lpath;
}

ptr socket_readc(ptr lpath)
{
  Reg ptr c;
    c=socket_readbuf(lpath,YES);
    /*** printf("socket_readc %x\n",c); ***/
    return c;
}

socket_writec(ptr lpath,int c){
  ptr soc_buff;
  int soc,loc;
  char *buf;
  soc_buff=get_socket_data(lpath);
  soc=(int)CDR(soc_buff)&0xffff;
  soc_buff=CAR(soc_buff);
  soc_buff=CDR(soc_buff); /**  (write-loc . buff)  ***/
  loc=GETNUM(CAR(soc_buff));
  buf=(char *)CDR(soc_buff);
  if(c=='\n'){
      *(buf+loc)=c;
      sock_send(soc,buf,loc+1);
      CAR(soc_buff)=ZERO;
      return;
   }
  *(buf+loc)=c;
  CAR(soc_buff)=MAKESINT(++loc);
  if(loc==NETBUFMAX){
      sock_send(soc,buf,loc);
      CAR(soc_buff)=ZERO;
  }
}

socket_flush(ptr lpath){
  ptr soc_buff;
  int soc,loc;
  char *buf;
  soc_buff=get_socket_data(lpath);
  soc=(int)CDR(soc_buff)&0xffff;
  soc_buff=CAR(soc_buff);
  soc_buff=CDR(soc_buff); /**  (write-loc . buff)  ***/
  loc=GETNUM(CAR(soc_buff));
  if(loc==0) return;
  buf=(char *)CDR(soc_buff);
      sock_send(soc,buf,loc);
      CAR(soc_buff)=ZERO;
      return;
}


socket_writestr(ptr lpath,char *buf){
  int soc;
  socket_flush(lpath);
  soc=get_socket_fdp(lpath);
  sock_send(soc,buf,strlen(buf));
}

int sock_send(int soc,char *buf,int size){
 int len;
if((len=send(soc,buf,size,0))<0){
               perror("send fail");
               error(E_send,MAKESINT(soc));
            }
   return len;
}

int network_ready(int soc,int wait)
{
  int width,n;
  fd_set Mask,readOk;
  struct timeval timeout;

  FD_ZERO(&Mask);
  FD_SET(soc,&Mask);
  width=soc+1;
  readOk=Mask;
  timeout.tv_sec=0;
  timeout.tv_usec=wait*500;  /***  40  msec wait defaut **/
  n=select(width,(fd_set *)&readOk,NULL,NULL,&timeout);
  if(n>0) return YES;
  return NO;
}


