/***   vm.c
   SS ver2.0  
   2007.9.15
   see vm-boot2.ss
   2010.5.4  revised
   2010.5.30  SCM,VPC are MACRO
   2010.6.1  MPU  stack version
      but Not speed up at boot
   this file is incomplete for CALL/CC

***/

#include "lisp.h"
#include <stdlib.h>
#include <setjmp.h>
#include <signal.h>
#include <stdio.h>

extern   ptr assq();
extern ptr reverse_list();
extern ptr k_LB,k_T;
extern ptr s_vm_compile();
extern void error();
extern jmp_buf user_env[];


extern int _length();
int input_flag=0;
int input_line=0;   /*** mc.c in 1.99 ***/
/***
int input_flag=0;
int input_line=0;
***/
/***  ptr VPC;   ** main PC register ***/
          /****  a list version  ***/

extern int silent_mode;

#define RETURN_NUM 16   /*** op number  ***/
#define CLOSURE_ENV_NUM 17   /*** op number  ***/

 ptr SYSREG[16];    /*** gbc must protect!!!  **/
#define VPUSH(x)  (*mpu_stack++=(x))
#define VPULL()   (*--mpu_stack)

#define TRACEP(f)   ((int)FTYPE(f)&TRACE) 

#define MCFP(f)   ((int)FTYPE(f)&ALLOC)

#define SCM SYSREG[0]
#define ST SYSREG[1]
#define BA SYSREG[2]
#define MULTIVAL SYSREG[3]
#define VMENV SYSREG[4]
#define ARGS SYSREG[5]
#define VPC SYSREG[6]
/** #define PCST SYSREG[7] **/
#define PCST (mpu_stack-1);

int vmdeb;   /**** for debug of VM ***/

/***
void VPUSH(ptr x){
  PCST=CONS(x,PCST);
}

ptr VPULL(){
  ptr s;
  s=CAR(PCST);
  PCST=CDR(PCST);
  return s;
}
***/
/****
ptr SCM;
ptr ST,BA;
ptr MULTIVAL;
ptr VMENV;
ptr ARGS;
****/
int NARG;

int evalflag;  /***  eval can't define   ***/
void print_SCM();

extern int gbc_malloc,error_count;

static ptr *mcprint();
static ptr make_lambda(), make_macro();

static void Reg_Push(),Reg_Pull(),Pull_PCST(),VLOAD(),VSET(),
    VMIMM(), IMM_undef(),IMM_t(),IMM_f(),IMM_null(),
    IMM_0(),IMM_1(),
     LOADENV(),SETENV(),
     MAKE_LAMBDA(),
    MAKE_MACRO(),DEFINE(),BIND(),IF_SCM_BA(),JMP2(),FALSE2(),TRUE2(),
    LAMBDA_BIND(),
    FUNC(),
    PUSHARG(),
    VJSR(),TAIL_JMP(),
    RETURN(),
    CLOSURE_ENV(),
    LAMBDA_ARGS(),
    Push_ENV(),Pull_ENV(),Push_ARGS(),
    TRUE2(),Pull_reg(),
    SCM_MULTI(),MULTI_SCM(),SCM_BA(),BA_SCM(),SCM_ST(),SCM_ARGS(),
    ST_SCM(),COPY_CC(),RESTORE_BA(),RESTORE_CC(),LAMBDA_LAST(),ENV_SCM();

static void (* VMOP[])()={VLOAD,VSET,VMIMM, 
LOADENV,SETENV,
MAKE_LAMBDA, MAKE_MACRO,
DEFINE,BIND,
JMP2,FALSE2,
LAMBDA_BIND, FUNC,
PUSHARG,VJSR,TAIL_JMP,RETURN,CLOSURE_ENV,LAMBDA_ARGS,
TRUE2,
    SCM_MULTI,MULTI_SCM,
    SCM_BA,BA_SCM,
     SCM_ST,SCM_ARGS, ST_SCM,
   COPY_CC,RESTORE_CC,
IMM_undef,IMM_t,IMM_f,IMM_null,
IMM_0,IMM_1,
Push_ENV,Pull_ENV,Pull_reg,Pull_PCST,
Push_ARGS,
VMIMM,VMIMM,VMIMM,VMIMM   /*** dummy   never appear ***/
,LAMBDA_LAST,ENV_SCM
   };

ptr VM();
void DO_VM();
extern void init_vmcomp();
static ptr return_tail;

void init_VM(){
  ptr *st=SYSREG,s;
  int i;
  for(i=0;i<8;i++) *(st+i)=a_nil;
 
   BA=CONS(a_f,a_nil);  /***  BA=(#f)  ***/

  init_vmcomp(st+8);
  mpu_stack=MPU;
  s=MAKESINT(RETURN_NUM);
  s=CONS(s,a_nil);
  s=SCONS(s,a_nil);
  VPUSH(s);  /*** ((16)) ==((RETURN))  ***/
  return_tail=s;  /*** for trace to tail  ***/
}

/**** clearenv   ***/
ptr  call_vm(ptr pc,ptr env){
   ptr s;
  /* PRINT("CALL-VM"); */
  VPUSH(SCM);
  VPUSH(VPC);
  VPUSH(VMENV);
  VPUSH(ARGS);
  VMENV=env;
  VPC=a_nil;  /*** for immedidatly return  2010.5.17  ***/
  VM(pc);
  s=SCM;
  ARGS=VPULL(); 
  VMENV=VPULL(); 
  VPC=VPULL(); 
  SCM=VPULL(); 
  return s;
}
  
ptr s_call_vm(int narg,ptr env){
 ptr ev;
  if(narg==1) ev=a_nil;  /*** clearenv ***/
  else if(narg==2) ev=*(stack-1);       /*** to be modify  ***/
  else {
      error(E_argover,*(stack-1));
      return;
  }
  return call_vm(*(stack-narg),ev);
}

ptr VM(ptr pc){
  ptr x;
  VPC=pc;
/***
   PRINT("VM: ");
   prin1(pc,STDOUT);
***/ 
 while(CONSP(pc)){
    x=CAR(pc);
/***
   PRINT("DO-VM: ");
   prin1(x,STDOUT);
   newline(STDOUT);
***/
    pc=CDR(pc);
    VPC=pc;
    DO_VM(x);
    pc=VPC;
  }
 return SCM;
} 
      
void DO_VM(ptr x){
  int n;
  if(x==a_nil){
    fatal_error(999,VPC);
    printf("VM System error\n");
    exit(999); 
  }
  n=GETNUM(CAR(x));
  (* VMOP[n])(CDR(x));
}

void Reg_Push(ptr x)
{
  int n;
  n=GETNUM(CAR(x));
  VPUSH(*(SYSREG+n));
}

void Push_ENV(ptr x){
  VPUSH(VMENV);
}
void Push_ARGS(ptr x){
  VPUSH(ARGS);
}

void Pull_reg(ptr x)
{
  int n;
  n=GETNUM(CAR(x));
  *(SYSREG+n)=VPULL();
}
void Pull_ENV(ptr x){
VMENV=VPULL();
}

void Pull_PCST(ptr x)
{
  int n;
  ptr pc;
  n=GETNUM(CAR(x));
 mpu_stack-=n;
/**** 
  pc=PCST;
    while(n>0){
   pc=CDR(pc);
   n--;
  }
  PCST=pc;
 ***/
}

void VLOAD(ptr x)
{
  ptr s,val;
/***
  PRINT("LOAD ");
  prin1(x,STDOUT);
  newline(STDOUT);
***/
  s=CAR(x);
  val=load_top(s);   /*** see var.c  tklink need  2010.5.30 ***/
  /***  val=ATOMVAL(s);  ***/
  SCM=val;
       psh_his(list2(s,val));   /*** variable  history **/
  /*** if(val==a_unbdd) error(E_unbdd,CAR(x));  ***/
}
void VSET(ptr x)
{
  ptr s;
  s=CAR(x);
  /*** ATOMVAL(s)=SCM;  ***/
     M_top_value_set(s,SCM); /*** see intern.c for trace ***/
}

void VMIMM(ptr x)
{
  ptr s;
  s=CAR(x);
  SCM=s;
  // MULTIVAL=a_undef;
}

void IMM_undef(ptr x)
{
  SCM=a_undef;
  //MULTIVAL=a_undef;
}
void IMM_t(ptr x)
{
  SCM=a_t;
  //MULTIVAL=a_undef;
}
void IMM_f(ptr x)
{
  SCM=a_f;
  //MULTIVAL=a_undef;
}
void IMM_null(ptr x)
{
  SCM=a_nil;
  //MULTIVAL=a_undef;
}
void IMM_0(ptr x)
{
  SCM=ZERO;
  //MULTIVAL=a_undef;
}
void IMM_1(ptr x)
{
  SCM=ONE;
 // MULTIVAL=a_undef;
}


void LOADENV(ptr x)
{
  ptr s,val;
  s=CAR(x);
/***
  prin1(s,STDOUT);
  PRINT(" LOADENV ");
***/
  val=assq(s,VMENV);
  if(val==a_f){
       PRINT("Env variable Not bind");
       newline(STDOUT);
       error(E_unbdd,s);
   }
   val=CDR(val);
       psh_his(list2(s,val));   /*** variable  history **/
  SCM=val;
/****
  prin1(SCM,STDOUT);
  newline(STDOUT);
***/
  //MULTIVAL=a_undef;
}

void SETENV(ptr x)
{
  ptr s,trace;
  s=CAR(x);
  x=assq(s,VMENV);
  if(x==a_f) return (void) error(E_system,s);
  CDR(x)=SCM;
  trace=ATOMVAL(a_tracevars);
  if(trace!=a_nil){
      trace=assq(s,trace);
      if(trace!=a_f) { 
        PRINT("trace ENV var:");
        trace_var_cmds(CDR(trace));
      }
  }
}

void MAKE_CLOSURE(ptr x,int attr)
{
  ptr s,p,args;
  s=CAR(x);
  args=CAR(s); /*** (LAMBDA-ARGS ...)  ***/
  args=CADR(args);
  s=CDR(s);
  p=CONS(VMENV,a_nil);
  p=SCONS(MAKESINT(CLOSURE_ENV_NUM),p);   /** 17 is CLOSURE-ENV i ??? **/
  p=SCONS(p,s);
  /***   p=SCONS(a_lambda,p);          CDR is list =PC  ***/
  /***  BAD  p=SCONS(p,a_nil);   CAR is list =PC, CDR is reserved for info ***/
  p=SCONS(a_nil,p); 
  p=SCONS((ptr)(SR2+1),p);   /***  TYPE   as SINT and macro is recognized by attr  ***/
  /***  CAR is TYPE, CADR is reserved for info, CDDR is list-sr2 ***/
  ATTR(p)=attr;   /***  Ver2.0  **/
  SCM=p;  /* save **/
  s=CONS(k_LB,args);
  s=SCONS(s,a_nil);
  CADR(p)=s;
}
void MAKE_LAMBDA(ptr x){
   MAKE_CLOSURE(x,SR2);
}

void MAKE_MACRO(ptr x)
{
   MAKE_CLOSURE(x,SR2MACRO);
}

void DEFINE(ptr x)
{
  ptr var,scm,env;
  var=CAR(x);
  scm=SCM;
  if(ATOMVAL(var)==a_unbdd)
      ATOMVAL(var)=scm; /*** Caution!!!  Modify for TK  ***/
  else
     M_top_value_set(var,scm); /*** see intern.c  ***/
    if(!SREGP(scm)&&CLOSUREP(scm)){
       if(ATTR(scm)==SR2){
           env=FENV(scm);
           x=CONS(k_T,var);
           FENV(scm)=SCONS(x,env);
        }
    }
   /** SCM=var;  ***/
}

void BIND(ptr x)
{
  ptr s;
  s=CAR(x);
  s=CONS(s,SCM);
  VMENV=SCONS(s,VMENV);
}

void VM_JMP(int n){
  ptr pc;
  pc=VPC;
  while(n>0){
   pc=CDR(pc);
   n--;
  }
 VPC=pc;
}
   

void JMP2(ptr x)
{
    VM_JMP(GETNUM(CAR(x)));
}

void FALSE2(ptr x)
{
  if(SCM==a_f){
    VM_JMP(GETNUM(CAR(x)));
  }
}

void TRUE2(ptr x)
{
  if(SCM!=a_f)
    VM_JMP(GETNUM(CAR(x)));   
}

void LAMBDA_BIND(ptr x)
{
  ptr s;
  s=CAR(x);
 
  if(CONSP(s)){
     //SCM=ARGS;
     s=CONS(CAR(s),ARGS);
     VMENV=SCONS(s,VMENV);
     ARGS=a_nil;
  }
  else{
    x=ARGS;
    if(x==a_nil)   return error(E_shortarg,s);
  //  SCM=CAR(x); 
    s=CONS(s,CAR(x));
    ARGS=CDR(x);
     VMENV=SCONS(s,VMENV);
   }
}
void LAMBDA_LAST(ptr x)
{
  ptr s;
  s=CAR(x);

  if(CONSP(s)){
     SCM=ARGS;
     s=CONS(CAR(s),ARGS);
     VMENV=SCONS(s,VMENV);
     ARGS=a_nil;
  }
  else{
    x=ARGS;
    if(x==a_nil)   return error(E_shortarg,s);
     SCM=CAR(x);
    s=CONS(s,SCM);
    ARGS=CDR(x);
     VMENV=SCONS(s,VMENV);
    if(ARGS!=a_nil) {
          x=ARGS;
          ARGS=a_nil;
         error(E_argover,x);
         }
   }
}

void FUNC(ptr x)
{
  ptr s;
   s=CAR(x);  /*** tail-f  **/
  if(s==a_f){
       VPUSH(VMENV);
       VPUSH(ARGS);
   }
  VPUSH(SCM);  /** F-object  **/
 // MULTIVAL=a_undef;
  ARGS=a_nil;
}

void PUSHARG(ptr x)  /*** PUSH in vm.ss  ***/
{
  ARGS=CONS(SCM,ARGS);
}


void ARGS2stack(ptr args,int n)
{
  while(n>0){
   *stack++=CAR(args);
   args=CDR(args);
   n--;
  }
}
stack2args(int n){
   ptr s=a_nil;
   int k=1;
   NARG=n;
   while(n>0){
     s=SCONS(*(stack-k),s);
     n--;
     k++;
   }
  ARGS=s;
}

ptr sr2_funcall(ptr func,int nar){
   /****  func is sr2 ***/
     /****
        PRINT("sr2_funcall");
        prin1(func,STDOUT);
        newline(STDOUT);
      ****/
       if(TRACEP(func)) trace_in(func,ARGS);
       VPUSH(VPC); /*** save  ***/
       VPUSH(VMENV);
       VPUSH(ARGS);
       VPUSH(func);  /*** for trace  ***/
       VPUSH(a_nil); /*** for immediately return ***/
       stack2args(nar);
       VM(FBODY(func));
       VPC=VPULL();
      return SCM; 
}       

ptr s_funbody(int narg,ptr env){
  ptr f;
  
   checknarg(narg-1);
   f=*(stack-1);
   if(SREGP(f)) return a_f;
   if(SYMBOLP(f)) f=ATOMVAL(f);
   if(SREGP(f)) return a_f;
   if(CLOSUREP(f)) return FBODY(f);
   return a_f;
}  

void VJSR(ptr x)  /*** JSR in vm.ss **/
{
  ptr s,st, (*addr)(),env;
  int attr,type,narg;
  // MULTIVAL=a_undef;
   s=CAR(x);
   if(SINTP(s))
      NARG=GETNUM(s);
   else
     NARG=_length(ARGS);
  /***  st=VPULL();  Func-object  ***/ 
   st=*PCST; /*** Func-object , keep for trace  ***/ 
  VPUSH(VPC);
  if(SREGP(st)) goto error;
  /***   ARGS=reverse_list(ARGS);   ***/
  attr=ATTR(st);
  if(attr&CLOSURE){
       /*** psh_his(CDR(assq(k_T,FENV(st))));    Function history **/
       psh_his(assq(k_T,FENV(st)));   /*** Function history **/
   }
  else
      goto error;
  s=FTYPE(st);   /***  CAR   see lisp.h  ***/
  if((int)s&TRACE)  trace_in(st,ARGS);  /*** trace.c  ***/
  if(attr==SR2){
      VPC=FBODY(st);  /***  CDDR st  ***/
      return;
    }
  else if(attr==SR2MACRO){
      VPC=FBODY(st);  /***  CDDR st  ***/
      return;
  }
  else if((int)s&SUBR){
      addr=(ptr (* )() )FBODY(st);
      ARGS2stack(ARGS,NARG);
      env=FENV(st);
      narg=NARG;
      SCM=(*addr)(NARG,env);   /*** may be change NARG ***/
      stack-=narg;
/***
     PRINT("***  SYSTEM FUNCTION CALL ");
     prin1(st,STDOUT);
     newline(STDOUT);
   ***/ 
     RETURN(a_f);
     return;
  }
  else
     ;
error:
    printf("VM Not supports  sr(1.99) call attr=%x  st=%x\n",attr,st);
    prin1(st,STDOUT);
    newline(STDOUT);
    error(E_system,ARGS);
    RETURN(s);
}
void TAIL_JMP(ptr x)  /*** narg  level  **/
{
  ptr s,st, (*addr)(),env;
  int attr,type,narg,tr;
   // MULTIVAL=a_undef;
  st=VPULL(); /*** Func-object  ***/ 
   s=CAR(x);
   if(SINTP(s))
      NARG=GETNUM(s);
   else
     NARG=_length(ARGS);
  Pull_PCST(CDR(x));
  /*** printf("TAIL: %x\n",st); **/
  attr=ATTR(st);
  s=FTYPE(st);   /***  CAR   see lisp.h  ***/
  if(tr=((int)s&TRACE))  trace_in(st,ARGS);  /*** trace.c  ***/
  if(attr==SR2){
     if(tr){
        VPUSH(VMENV);
        VPUSH(ARGS);
        VPUSH(st);
        VPUSH(return_tail);
      } 
      VPC=FBODY(st);
    }
  else if(attr==SR2MACRO){
      VPC=FBODY(st);
  }
  else if((int)s&SUBR){
      addr=(ptr (*)())FBODY(st);
      ARGS2stack(ARGS,NARG);
      env=FENV(st);
      narg=NARG;
      SCM=(*addr)(NARG,env);
      stack-=narg;
      if(tr)  trace_out(st,SCM);  /*** trace.c  ***/
      RETURN(a_t);
  }
  else{
    printf("VM Not supports  sr(1.99) call *TAIL* attr=%x  st=%x\n",attr,st);
    prin1(st,STDOUT);
    printf("\n");
      RETURN(s);
 }
}

void RETURN(ptr x){
   VPC=VPULL();   
   x=VPULL(); /*** Func, OBJ used for trace ***/
   ARGS=VPULL();   
   VMENV=VPULL();  
   if(TRACEP(x)) trace_out(x,SCM);
/*** 
   PRINT("** RETURN ** ");
   prin1(SCM,STDOUT);
   prin1(x,STDOUT);
   newline(STDOUT);
***/
}

void CLOSURE_ENV(ptr x){
   ptr s;
   s=CAR(x);
   VMENV=s;
}

void LAMBDA_ARGS(ptr x){
   ptr s;
   s=CAR(x);
   s=CONS(k_LB,s);   /*** :LAMBDA-BIND ****/
   VMENV=SCONS(s,VMENV);
}

void SCM_MULTI(ptr x){
   MULTIVAL=SCM;
   if(CONSP(SCM))
      SCM=CAR(SCM);
   else
      SCM=a_undef;  /***  if SCM==() else error ***/
}
void MULTI_SCM(ptr x){
   SCM=MULTIVAL;
   MULTIVAL=a_undef;
}

void SCM_BA(ptr x){
   BA=SCM;
}

void BA_SCM(ptr x){
   SCM=BA;
}

void SCM_ST(ptr x){
   ST=SCM;
}
/***
void SCM_ARGS(ptr x){
   ptr s,args;
  s=SCM;
  args=ARGS;
   while(CONSP(s)){
     args=SCONS(CAR(s),args);
     s=CDR(s);
   }
   SCM=s;
   ARGS=args;
}
***/
void SCM_ARGS(ptr x){
   ARGS=SCM;
}

void ST_SCM(ptr x){
   SCM=ST;
}
void ENV_SCM(ptr x){
   SCM=VMENV;
}
 
extern ptr getvector();
extern ptr *get_vector();

ptr get_pcst(){
   int n;
   ptr v,*p,*q;
   n=mpu_stack-MPU;
   v=getvector(n);
   p=get_vector(v,&n);
   q=MPU;
   while(n--)
     *p++=*q++;
  return v;
}
void set_pcst(ptr v){
   int n;
   ptr *p,*q;
   p=get_vector(v,&n);
   q=MPU;
   while(n--)
     *q++=*p++;
   mpu_stack=q;
}

void COPY_CC(ptr x){    
   ptr s;
   s=CONS(VMENV,a_nil); 
   s=SCONS(ARGS,s); 
   s=SCONS(get_pcst(),s);
   s=SCONS(VPC,s);
   SCM=s;
}


void RESTORE_CC(ptr x){
  ptr s,v;
   s=SCM;
   VPC=CAR(s);
   s=CDR(s);
   v=CAR(s);  /** PCST  ***/
   set_pcst(v);
   s=CDR(s);
   ARGS=CAR(s);
   s=CDR(s);
   VMENV=CAR(s);
/***
  PRINT("RESTORE");
  prin1(VPC,STDOUT);
  newline(STDOUT);
****/
  if(CONSP(MULTIVAL))
    SCM=CAR(MULTIVAL);
  else
    SCM=a_undef;    /***  OK! undef means No-value!!!***/
}
/****  TOP  ***/
ptr s_TOP(int narg,ptr env){
  ptr p,m;
  ptr *memo;
  int n;
  psh(a_nil);
  input_flag=1;
  memo=stack;
  Errno=NULL;
  n=calljmp();  /*** jmp_level=1  ***/
  if(n){
    if(Errno){
       debug_level=0;
       error_top(Errno);
       Errno=NULL;
     }
    else if(sigcode){
        PRINT("signal received ");
        princ(MAKESINT(sigcode),STDOUT);
        newline(STDOUT);
        sigcode=0;
     }
    else
      print_SCM();  /**** jmp from errorhook ***/
   }

loop:
  if(stack!=memo){
       /** printf("SYSTEM stack %x abnormal %x\n",stack,memo);**/
      stack=memo;
}
  if(istty){
    princ(PROMPT,STDOUT);
    //PRINT("USER> ");
   lfflush(STDOUT);
   }
  ss_update();
     if(istty){
#ifdef USE_TK
            if(top_visible)  update();
#endif
        while(buffer_white()) {   /*** while ***/
                    ss_update();  /*** always check for cygwin   see timer.c ***/
                   if(sigcode) {
                        sigcode=0;
                        break;
                    }
#ifdef USE_TK
           if(top_visible){
              if(Tk_GetNumMainWindows()>0){  /*** 1 ***/
                 update();
                /*** Tcl_DoOneEvent(0); ***/
              }
             else
                long_jmp(0,p); /****  No window then , jump to tk_lisp Main and
                        initialize TK again     *****/
            }
#endif
     }
   }
    input_flag=1;
        if(silent_mode) {
           /** printf("silent visible %d\n",top_visible); ***/
              ss_update();
#ifdef USE_TK
           if(top_visible){
                 /*** update(); ***/
              if(Tk_GetNumMainWindows()>0){  /*** 1 ***/
                  update();
                /*** Tcl_DoOneEvent(0); ***/
              }
             else
                long_jmp(0,p); /****  No window then , jump to tk_lisp Main and
                        initialize TK again     *****/
            }
#endif
      goto loop;  /*** because we need ss_date ***/
     }

  p=s_gread(0,a_nil);
    input_flag=0;
     if(istty) line_history(input_line++);

     if(p==SEOF){
       s_bye(); /** xit(0); **/
      }

  *(stack-1)=p;
  p=s_vm_compile(1,a_nil);
  /***
  PRINT("compile:");
  prin1(p,STDOUT);
  newline(STDOUT);
  ***/
  *(stack-1)=p;
   /***  lfflush(STDOUT); ***/
  p=VM(p);
  *(stack-1)=p;
  print_SCM();
  if(p!=SCM) {  /*** Abnormal  ***/
  PRINT("Abnomal SCM Value:");
  prin1(SCM,STDOUT);
  newline(STDOUT);
  }
      
 goto loop;
}
  
void print_SCM(){
 ptr m;
 PRINT("Value: ");
  prin1(SCM,STDOUT);
  newline(STDOUT);
  m=MULTIVAL;
  if(CONSP(m)){
  PRINT("Multi-value:");
     while(CONSP(m)){
        prin1(CAR(m),STDOUT);
        newline(STDOUT);
        m=CDR(m);
     }
    MULTIVAL=a_undef;
  }
}

ptr vm_eval(ptr s,ptr env){
  psh(s);
  psh(env);
  s=s_vm_compile(2,a_nil);
  *(stack-1)=s;
  /***
  PRINT("vm_eval");
  prin1(s,STDOUT);
  newline(STDOUT);
  ***/
  s=call_vm(s,env);  /***  clear env  to be modify ***/
  stack-=2;
  return s;
}

ptr s_vm_eval(int narg,ptr env){
  ptr s;
   checknarg(narg-2);
  s=s_vm_compile(2,a_nil);
  *(stack-2)=s;
  s=call_vm(s,*(stack-1)); /*** to be modify ***/
  return s;
}

error_top(ptr err){
  PRINT("Error: ");
  prin1(err,STDOUT);
  newline(STDOUT);
  print_his(20);
}

