/*** alloc.c
        malloc data
        for m-compiler
      03.12.02
 ****/
#define  ALLOC_C

#include "lisp.h"
extern ptr k_q;

check_alloc(ptr x){
  if(SREGP(x)||!MALLOCP(x)) error(E_notalloc,x);
}

ptr  *get_alloc(Reg ptr mal,int *len){
   *len=(long)CDR(mal);
   return(ptr *)CAR(mal);
}

/***   MALLOC  (ptr-vector . size)    ***/
ptr make_alloc(int i){  /**** i is vector size  ***/
 int n;
      ptr c;
     ptr *p;
       c=new_cell(MALLOC);
      
       CDR(c)=(ptr)(long) i;/*** for gbc Caution!  ***/
    psh(c);
    CAR(c)=(ptr)-1;   /***  psh & car=-1 needs !!! because Mymalloc may call gbc!  ***/
   p=(ptr *)Mymalloc( i*sizeof(ptr));  /*** bind with next is error 64bit compiler ***/
   CAR(c)=(ptr)p; 
      while(i--) *p++=k_q; /***  init  :q ***/ 
   pull();
   return c;
  }

/*** for string data or pure biinary   **/
/**** MALLOC_BIN  (myalloc  .  size)   ***/
ptr make_alloc_bin(int i){
 int n;
      ptr c;
       c=new_cell(MALLOC|MALLOC_BIN);
       /*** if(i==0x90) printf("make_alloc_bin  called 0x90\n");   ***/
       CDR(c)=(ptr)(long) i;/*** for gbc Caution!  ***/
       CAR(c)=(ptr)(long)-1;
    psh(c);
    CAR(c)=(ptr)Mymalloc( i);  /*** ptr *  in real ***/
    pull();
   return c;
  }

ptr alloc_str(char *p,int n){
  ptr s;
  char *q,*memo;
  int m=n;
    s=make_alloc_bin(n+1);
       /*** if(n==0x8f) printf("alloc_str  called 0x8f \n");   ***/
    q=(char *)CAR(s);    /*** CAUTION  alloc data structure if change ***/
    while(n--) *q++=*p++;
    return s;
}


ptr s_alloc(int narg,ptr env){
   ptr s ;
       checknarg(narg-1);
    s=*(stack-1);
   return make_alloc(SINT_NUMB(s));
}

static ptr alloc_ref(ptr mal,int n){
  Reg  ptr *p ;
  int m;
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,MAKESINT(n));
   return *(p+n);
}

static ptr alloc_set(ptr mal,int n,ptr val){
   Reg ptr *p ;
  int m;
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,MAKESINT(n));
    *(p+n)=val;
  return a_undef;
}

  
ptr s_alloc_ref(int narg,ptr env){
  Reg  ptr mal,*p ;
  int n,m;
    mal=*(stack-2);
   n= SINT_NUMB(*(stack-1));
   checknarg(narg-2);
   check_alloc(mal);
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,*(stack-1));
   return *(p+n);
}

ptr s_alloc_set(int narg,ptr env){
   Reg ptr mal,*p ,val;
  int n,m;
    mal=*(stack-3);
   n= SINT_NUMB(*(stack-2));
    val=*(stack-1);
   checknarg(narg-3);
   check_alloc(mal);
   p=get_alloc(mal,&m);
   if(n>=m||n<0)  error(E_range,*(stack-2));
    *(p+n)=val;
  return a_undef;
}  

ptr s_alloc_length(Reg int narg,ptr env)
      /* (vector x1 x2 ....) */
{
   Reg ptr x;
    int n;
    checknarg(narg-1);
    x=*(stack-1);
   check_alloc(x);
    get_alloc(x,&n);
    return MAKESINT(n);
}

ptr s_alloc_copy(Reg int narg,ptr env)
      /* (alloc-copy  x  n  m) */
{
   Reg ptr x,*p,*q,y;
    int size,n,m;
      checknarg(narg-3);
    x=*(stack-3);
    checkvect(x);
    p=get_alloc(x,&size);
       n=SINT_NUMB(*(stack-2));
       m=SINT_NUMB(*(stack-1));

    m-=n;
    if(m<0) error(E_range,*(stack-1));
    y=make_alloc(m);
    q=get_alloc(y,&size);
    p+=n;
    m-=n;
    while(n--) {
        *q++=*p++;
    }
   return y;
}

ptr s_alloc_pred(Reg int narg,ptr env)
      /* (alloc?  x ) */
{
   Reg ptr x;
      checknarg(narg-1);
    x=*(stack-1);
  if(SREGP(x)||!MALLOCP(x)) return a_f;
   return a_t;
}

