/***  format.c 
***/
#include "lisp.h"
#include <stdio.h>
#include <ctype.h>
/*  89.6.15 format.c start */
/**  91.8.13  format_stream  is introduced ***/
/***  SS lisp version start 2003.9.22   ***/
/***  :  not supported for ss***/

extern int myupper(),mylower();
extern ptr formD();

static ptr format_stream=0,fm_str=0;

#define  KANJIP(x)   (kanji_mode&&((x)&0xff)>127)   /* 89.8.30*/

#define PAGE 12
#define SHIFT  10000   /*  for char-parameter ***/
#define UNGIVEN  -1000000000
    /*  c is default value */
#define  para_c(n,c)  ((para[n]!=UNGIVEN)?(para[n]+SHIFT):c)
#define  para_d(n,c)  ((para[n]!=UNGIVEN)?para[n]:c)
#define  given(n)   (para[n]!=UNGIVEN) 

/* int para[10];   used in llprin.c 89.7.7 ****/
#define atto  (modeb&2)
#define e_atto  (modeb==2)
#define e_katto  (modeb==3)

static ptr bformat(),prinA(),prinS(),prinR(),fmopen(),fmclose();
 ptr check_a();
Uchar *fpara(),*modef();
extern int just();

int skip_siji;

extern int skformat();
extern ptr capital();   /*** in s_str_cap.c  ***/
    /***   (ctrl,start)    return is len   ****/
/*** static ptr argv;  89.7.8 defined ,use for V-parame-ta- ***/
extern int col_loc[];  /*** 89.7.26 see file.c ***/

/*** #define pos(stream)  POS_OUT(stream)  col_loc[stream]*/


format_open(){
  if(format_stream){
    format_stream=reopen_str(format_stream,0);
       }
  else{
    format_stream=open_str(a_nullstr,write_ac);
    sys_pro(format_stream);  /*** only once!  ****/
   }
}   
static ptr format_close(){
return sys_close(format_stream);
}

static ptr fmopen(){
    if(fm_str){
    fm_str=reopen_str(fm_str,0);
       }
  else{
    fm_str=open_str(a_nullstr,write_ac);
    sys_pro(fm_str);  /*** only once!  ****/
   }
  return fm_str;
}

static ptr fmclose(){
return sys_close(fm_str);
}


static ptr sformat(stream, ctrl, narg)
  Reg ptr stream,ctrl;
  int narg;
 {
   ptr res;

   Reg int len;
      len=STRLEN(ctrl);
      /***  bformat returns ptr&& 
         skip_siji= 0  or ^ otherwise } ] ; ) > are error!!! ***/
     res=bformat(stream,ctrl,narg,0,len);
     if(skip_siji&&skip_siji!='^') 
            form_err(E_syntax,ctrl);
     /** printf("return from bformat res %d\n",res);  non zero will be error **/
     /** if(res) error(E_argover,*(stack-narg)); no error  CL p.301  ***/
     return res;  /**** 残りの引数を返す。必要  ***/
 }

/***  bformat  
        exec from p+start && only total bytes */
  
static ptr bformat(stream,ctrl,narg,startloc,total)
  Reg ptr stream;
  ptr ctrl;
  int narg,startloc,total;   
 {
   Reg int n,radix,exb,rem,ind_narg;
   Reg unsigned char *p,*r,*memo;
   Reg ptr q,arg_list,*argbuf,x,fm;   
   int narg_init=narg;
   int len=total;
   int siji_char,modeb,para[10],kanji_mode,esc=0;
    /**  kanji_mode=(CAR(a_kanji)!=a_nil);  ***  kanji ****/
     memo=get_string(ctrl,&len);
     len=total;
   loop:
      p=memo+startloc+total-len;
     skip_siji=0;   /**** for return information ****/
     if(len==0) return (ptr)(long)narg; /*** error check ???? MAKESINT(narg); ***/
     if(len<0) form_err(E_syntax,ctrl);
     if(esc||(*p!='~'))
      {
         if(esc)  esc=0;
         else
           if(KANJIP(*p)) esc=1;
        WRITE_CHAR(*p++,stream);
        len--;
        goto loop; /*** because stream maybe string, so may occur
              gbc in this case!!!!  89.7.12  ***/
      }
       n=0;
       r=p;
       r++; /* skip ~ */
        r=fpara(r,&narg,para);
      /**  printf("fpara  end  narg %d  r %s\n",narg,r); ***/
     modeb=0;
     r=modef(r,&modeb); /****  @,:  の解析  ***/
     skip_siji=siji_char=toupper(*r++);   /***  S,A,etc  ***/
     len-=(r-p);
     switch(siji_char)
      {
        case '{':  /*** 89.7.15  ****/
                    n=para_d(0,-1);  /* max kaisuu **/

                 exb=skformat(ctrl,startloc+total-len,len);
                   /* printf("format: %d\n",exb); */
                /***  mada  ***/
                 if(atto)
                    q=arg_list;   /***  @ || @: ***/
                 else 
                    q=check_a(narg);
                 
                 while(q!=a_nil&&(n--))
                 {
                      q=bformat(stream,ctrl,q,startloc+total-len,len-exb);
                      if(skip_siji=='^')  break;
                  /***  needs CTRL-EC   ***/
                if(skip_siji!='}'&&skip_siji!='^') 
                         form_err(E_syntax,ctrl);
                 }
                  len=exb;
                  if(atto)
                   {
                    arg_list=q;
                    goto loop;
                   }
                  break;
        case '}':
                   /* printf("format: '}'\n");*/
                   return arg_list;
        case '[':  /*** 89.7.15  ****/
               if(given(0)) 
                    n=para[0];  /* selection No **/
               else
                  {
                    q=check_a(narg);
                   if(atto)
                    {
                      if(q!=a_nil)
                       {
                         n=0;
                         goto ok;
                       }
                      n=-1;
                    }
                   else if(SINTP(q))
                     n=getnum(q);
                   else 
                      form_err(E_syntax,ctrl);
                  narg--;
                 }
              ok:
            /* printf("format: %d\n",n); */
                 while(n--)
                 {
                   /***  skip n-clause ***/
                 len=skformat(ctrl,startloc+total-len,len);
                 if(skip_siji==']') break;
                 if(skip_siji!=';') 
                        form_err(E_syntax,ctrl);
                 }
             if(skip_siji!=']') 
               {
                 exb=skformat(ctrl,startloc+total-len,len);
                if(skip_siji!=';'&&skip_siji!=']') 
                         form_err(E_syntax,ctrl);
                  
                q=bformat(stream,ctrl,narg,startloc+total-len,len-exb);
                    len=exb;
                    narg=(long)q;
                while(skip_siji!=']')
                 {
                 len=skformat(ctrl,startloc+total-len,len);
                 }
               }
               goto loop;
        case ']':
                   /* printf("format: ']'\n"); */
                   return (ptr)(long)narg;
        case ';':
                   /* printf("format: ';'\n"); */
                   return (ptr)(long)narg;
        case '^':
                   /* printf("format: '^'\n"); */
               if(given(0)) 
                {
                  if(given(1))
                     n=(para[0]==para[1]);
                  else
                    n=(para[0]==0);
                }
               else
                  n=(narg==0);
              if(n) return (ptr)(long)narg;
               goto loop;
        case '(':  /*** 89.7.16  ****/
                 exb=skformat(ctrl,startloc+total-len,len);

                  fm=fmopen();
                  /****  needs unwind protect!!! ***/
               narg=(long)bformat(fm,ctrl,narg,startloc+total-len,len-exb);
                if(skip_siji!=')'&&skip_siji!='^') 
                         form_err(E_syntax,ctrl);
                 fprinc(stream,capital(fmclose(),modeb,0,-1));
                  len=exb;
                    goto loop;
        case ')':
                   /* printf("format: '}'\n");*/
                   return arg_list;
        case '<':  /*** 89.7.16  ****/
               argbuf=l_sp;
               radix=0;/*** counter ****/
             do
               {
                 exb=skformat(ctrl,startloc+total-len,len);
                  rem=skip_siji;
                  fm=fmopen();
                  /****  needs unwind protect!!! ***/
                arg_list=bformat(fm,ctrl,arg_list,startloc+total-len,len-exb);
                    len=exb;
                  q=fmclose();/*** must open-close match in any case!!! ***/
                if(skip_siji=='^')
                      break; /***  see CL P.315-316 ***/
                if(skip_siji!=';'&&skip_siji!='>') 
                         form_err(E_syntax,ctrl);
                 psh(q);
                   radix++;
               }while(rem!='>');
                just(stream,argbuf,radix,para,modeb);
                sp_pull(radix);
                while(rem!='>')
                 {
                 /***  for ~^  ****/
                 len=skformat(ctrl,startloc+total-len,len);
                  rem=skip_siji;
                 }
               goto loop;
        case '>':
                   /* printf("format: ']'\n"); */
                   return arg_list;
        case 'A':q=prinA(check_a(narg),modeb);
               formA(q,stream,para,modeb);
               break;
        case 'S':q=prinS(check_a(narg));
               formA(q,stream,para,modeb);
               break;
        case 'X':radix=16;
                goto Fix;
        case 'B':radix=2;
                goto Fix;
        case 'O':radix=8;
                goto Fix;
        case 'D':radix=10;
           Fix:
               prinR(stream,check_a(narg),radix,para,modeb);
               
               break;
        case 'R':
              /*** need shift ***/
              /*** for(n=0;n<8;n++) para[n]=para[n+1]; ***/
             if(para[0]==UNGIVEN)
             {
                 para[0]=10;
               /***  ??? roman ???
               if(roman_chk(q=check_a(narg)));
               {
                    n=GETNUM(q);
                   if(atto)
                    q=roman_get(n);
                 if(q!=ERR)
                  {
                    psh(q);
                   fprinc(stream,q);
                   pull();
                   break;
                  }
                }
               ***/
                for(n=1;n<4;n++) para[n]=UNGIVEN;
                modeb=0;
              }
             prinR(stream,check_a(narg),para[0],para+1,modeb);
               /*** q=prinR(check_a(narg),para[0]);
               formD(q,stream,para+1,modeb); ***/
               break;
        case 'E':
               n=f_init(q=check_a(narg));
                if(n==-9999)
                    prinR(stream,q,10,para,modeb);
                else
                    formE(stream,para,modeb);
               break;
        case 'F':
               n=f_init(q=check_a(narg));
                if(n==-9999)
                    prinR(stream,q,10,para,modeb);
                else
                    formF(stream,para,modeb);
               break;
        case 'G':
               n=f_init(q=check_a(narg));
                if(n==-9999)
                    prinR(stream,q,10,para,modeb);
                else
                     formG(stream,para,modeb);
               break;
        case 'C':q=check_a(narg);
                if(INTP(q)||!CHARP(q))
                   form_err(E_notchar,q);
                if(atto)
                   fprin1(stream,q);
                else
                   fprinc(stream,q);
               break;
        case 'P':
                 q=check_a(narg);
                if(atto)
                  {
                    if(q==ONE)
                       WRITE_CHAR('y',stream);
                     else
                      pr_cstr(stream,"ies");
                  }
                else if(q!=ONE)
                     WRITE_CHAR('s',stream);
                break;
        case '?':
                 q=check_a(narg);
                 narg--;
                if(atto)
                  {
                   narg=(long)sformat(stream,q,narg); 
                  }
                else 
                 {
                  ind_narg=setpara(check_a(narg));
                  sformat(stream,q,ind_narg);
                  stack-=ind_narg;
                  narg--;
                 }
               goto loop;
        case '%':
               formFF('\n',stream,para);
               goto loop;
        case '&':   /* 7.26 */
               n=para_d(0,1);
               if(get_pos(stream))
                     formFF('\n',stream,para);
               if(n)
                {
                   while(--n>0)
                      WRITE_CHAR('\n',stream); 
                 }
               goto loop;
        case 'T':   /* tab 7.26 */
               formTAB(stream,para,atto);
               goto loop;
        case '|':
               formFF(PAGE,stream,para);
               goto loop;
        case '~':
               formFF('~',stream,para);
             /* WRITE_CHAR('~',stream); */
               goto loop;
        case '\n':
                 if(atto)
                   WRITE_CHAR('\n',stream);
                 p=FWSTR(ctrl);
                    p+=startloc+total-len;  /**** 7.13 ***/
                while(*p++==' '&&len)
                  len--;
               goto loop;
        case '*':
               n=para_d(0,0);
               if(n==0&&!atto) n=1;
               if(n<0) 
                    form_err(E_range,MAKENUM(n));
              if(atto)
               {
                 narg=narg_init;
               }
               while(n--)
                 {
                  check_a(narg);
                  narg--;
                 }
               goto loop;
         default:
            form_err(E_syntax,ctrl);
      }
  narg--;
    goto loop;     
 }

static ptr  prinA(p,modeb)
   Reg ptr p;
   Reg int modeb;
 {
    format_open();
    fprinc(format_stream,p);
    return format_close();
 }

static ptr prinS(p)
   Reg ptr p;
 {
    format_open();
    fprin1(format_stream,p);
    return format_close();
 }

/***  ~D ->~A if not integer : CL 303 *****/
static ptr prinR(stream,p,r,para,modeb)
   Reg ptr stream,p;
   Reg int r,*para,modeb;
 {
   Reg int temps;
   if(SINTP(p)||BIGINTP(p)||RATIOP(p))
     ;
   else
     {
        /** form_err(E_typemis,p);  ***/
        temps=print_base;
        print_base=r;
        for(r=1;r<4;r++) para[r]=UNGIVEN;
        p= prinA(p,modeb);
        psh(p);
        formA(p,stream,para,0);
        print_base=temps;
       return *pull();
     }
    format_open();
    pr_INT(format_stream,p,r);
    p=format_close();
   return  formD(p,stream,para,modeb);
 }

 ptr check_a(n)
   Reg int n;
  {
   if(n==0) form_err(E_shortarg,a_nil);
   return *(stack-n);
  }

Uchar *fpara(p,a_narg,para)
   Reg Uchar *p;
   int *a_narg;
   Reg int  *para;
  {
   Reg int n=8,k,sign;
   Reg unsigned char c;
   Reg ptr arg;
   
   while(n--)
    {
     para[n]=UNGIVEN;
    }
   n=0; /* need! */
  loop:
    sign=0;
    if(n>7) form_err(E_syntax,a_nil);
    while((c=*p)==' ') ++p;
    if(c==',')
     {
       p++;
       n++;
       goto loop;
     }
    /** while(c==' ') c=*++p; */
    if(c=='+'||c=='-')
      {
         sign=c;
         c=*++p;
      }
    if(isdigit(c))
     {
       k=0;
       while(isdigit(*p))
       {
         k=k*10+*p++-'0';
       }
       if(sign=='-') k=-k;
       para[n]=k;
       goto loop;
     }
    if(sign) form_err(E_syntax,a_nil);
    if(c=='v'||c=='V')
     {   
        /*** v-para  89.7.8 ***/
        arg=check_a(*a_narg);
        *a_narg=*a_narg-1;
        if(INTP(arg))
         {
           para[n]=getnum(arg);
         }
        else if(CHARP(arg))
         {
           para[n]=-SHIFT+CHAR_CODE(arg);
         }
        else if(arg==a_nil)
          ;
        else 
            form_err(E_typemis,p);
     }
    else if(c=='#')
     {
         /*** #-parame-ta  89.7.8***/
         /*** however, this is yakutatazu! genzai hane! ***/
       para[n]=*a_narg; /* s_lib.c */
     }
    else if(c=='\'')
     {
     /***  char ***/
       para[n]=-SHIFT+(*++p);
     }
    else
        return p;
    ++p;
  goto loop;
 }
Uchar *modef(p,mode)
   Reg Uchar *p;
   int *mode;
  {
   Reg int c;
   while(c=*p++)
   {
    if(c==':')
      *mode|=1;
    else if(c=='@')
      *mode|=2;
    else
      return p-1;
   }
  }

ptr s_format(int narg, ptr env)
{
  /***   lsubr ****/
  Reg ptr stream;
  Reg ptr ctrl,p,*sfree;
  if(narg<2) checknarg(narg-2);
  sfree=stack-narg;
  p=*sfree++;
  ctrl=*sfree++;
  narg-=2;
  if(p==a_f)
  { 
       /****   string   return ****/
    stream=fmopen();
      sformat(stream,ctrl,narg);
    return fmclose();
  }
 else if(p==a_t)
    stream=STDOUT;
 else{
    stream=p;
    check_output(p);
     }
  sformat(stream,ctrl,narg);
  return a_undef;
 }

/*****
alnum(c)
  Reg int c;
 {
   if(c<'0'||c>'z') return NO;
   if(c>'9')
    {
      if(c<'A') return NO;
      if(c<='Z') return YES;
      if(c<'a') return NO;
    }
   return YES;
 }

****/
