/*** func.c   ***/
/***   function object  ****/

#define  FUNC_C

#include "lisp.h"
ptr get_cell();
#define prin_s(p)   lwritestr(lpath,p)
#define format(p,obj)   sprintf(iobuff,p,obj)
#define WRITE         lwritestr(lpath,iobuff)
extern ptr k_T;


/***   compiled special,lambda, macro   */
ptr make_subr(ptr (*addr)(),ptr type,ptr env){
  Reg ptr f,g;
   /** printf("make_subr: addr %x type %x env %x\n",addr ,type,env); **/
  /** f=get_cell(); ***/
  f=new_cell(((long)type)&CLOSURE);
  CAR(f)=type;
  *stack++=f;
   g=new_cell(SUBRADD);  
                     /***  for gbc to easy, and this informs compiled! ***/
   CDR(f)=g;
   CAR(g)=env;
   CDR(g)=(ptr)addr;
   stack--;
  return f;
}

/***   lambda exp, macro exp   ***/
/*****
ptr  make_exp(ptr whole,ptr type,ptr env){
  Reg ptr f,g;
#ifdef DEBUG
   printf("make_exp ");
   pr_env(env);
   printf("make_exp2 ");
#endif
  f=new_cell(((int)type)&CLOSURE);
  CAR(f)=type;
  *stack++=f;
   g=get_cell();
   CDR(f)=g;
   CAR(g)=env;
   CDR(g)=whole;
   stack--;
  return f;
}
****/
/****  closure lambda whole =(args . body)****/
/***
ptr make_closure(ptr whole, ptr env){
  ptr type;
  ptr get_argtype();
    type=get_argtype(CAR(whole));
    type=(ptr)((int)type|LAMBDA);
    return    make_exp(whole,type,env);
}
***/

ptr get_argtype(ptr arg){
  int n=0,m=0;
   while(CONSP(arg)){
      n++;
      arg=CDR(arg);
   }
  if(SYMBOLP(arg)) m++;
  return (ptr)MAKESINT((n<<1)+m);
}


ptr subr_argtype(int n,int m){
return (ptr)MAKESINT((n<<1)+m);
}


/****  for debug     procedure information  *****/
/****     (procedure-info func)   ***/
ptr s_procedure(int narg,ptr env){
  int m,n;
  Reg ptr q,res;
    q=*(stack-1);
    checknarg(narg-1);
    m=ATTR(q);
    n=(long)FTYPE(q);
     if(m&LAMBDA){
       if(n&TKFUNC){
              res=a_tk;
          }
         else if(n&ALLOC){
             res=a_lambda;
           }
          else{
              res=a_system;
           }
        }
     else if(m&SPECIAL){
          res=a_special;
      }
     else if(m&MACRO){
           res=a_macro;
     }
     else
          return a_f;
     res=SCONS(res,a_nil);
     psh(res);
     n&=0xffff;
     n=GETNUM(n);
     m=n&1;
     n>>=1;
     res=CDR(res)=CONS(MAKESINT(n),a_nil);
      q=CDR(q);
     res=CDR(res)=CONS(MAKESINT(m),a_nil);

     res=CDR(res)=CONS(CAR(q),a_nil);
      if(SUBRADDP(q)){    /*** ver 1.7 ***/
           res=CDR(res)=CONS(q,a_nil);
       }
      else
       {
           res=CDR(res)=CONS(CDR(q),a_nil);  /***  alloc **/
       }
    res=*(stack-1);
    pull();
   return res;
}

ptr s_procedurep(int narg,ptr env){
  int m,n;
  Reg ptr q;
    q=*(stack-1);
    checknarg(narg-1);
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)) q=ATOMVAL(q);
    if(SREGP(q))  return a_f;
    m=ATTR(q);
     return PRED(m&LAMBDA);
}

ptr s_systemprocedurep(int narg,ptr env){ /*** system-procedure?  ***/
  int m,n;
  Reg ptr q;
    q=*(stack-1);
    checknarg(narg-1);
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)) q=ATOMVAL(q);
    if(SREGP(q))  return a_f;
    m=ATTR(q);
     return PRED(m==SLAMBDA);
}

ptr s_tk_procedurep(int narg,ptr env){
  int m,n;
  Reg ptr q;
    q=*(stack-1);
    checknarg(narg-1);
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)) q=ATOMVAL(q);
    if(SREGP(q))  return a_f;
    m=ATTR(q);
    if(m&LAMBDA)
        return PRED((int)(long)FTYPE(q)&TKFUNC);
    return a_f;
}


ptr function_name(ptr q){  
 again:
    if(SREGP(q))  return a_f;
    if(SYMBOLP(q)){
       q=ATOMVAL(q);
       goto again;
    }
    if(!CLOSUREP(q)) return a_f;
    if(ATTR(q)&MACRO) return a_f;
    q=FENV(q);
    q=assq(k_T,q);
    if(q!=a_f) return CDR(q);
    return q;
}

ptr s_function_name(int nar,ptr env){
  Reg ptr q;
   q=*(stack-1);
    checknarg(nar-1);
    return function_name(q);
}

