/***   03.12.29
    heap.c
    Mymalloc, Myfree,Myrealloc
   with prev link versin 04.1.2
   block head= short type,int size,prev-ad
   type=FREE,USED,END,START
   05.4.10  revised
      size is  byte unit
      free_record struct
      type  is int
      align 4 bytes   (for int Bus error )
   07.9.24  revised
     Align is  head_size  unit
     heap is
       [START][BLOCK1]...[END]
     each BLOCK begins a heap_head
         [type size prev]
     size is head_size of the Block (include head itself)
     START block has the size of TOTAL HEAP
     END block has  size=1
     BLOCK1 ...  has the typr of USED or FREE.
      free_table is vector of free_record  sorted by size
      it include   {SIZE, NULL} entry, which is deleted record.
      Null entry is useful for insert a record.
***/
#define HEAP_C

#include  "lisp.h"
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdlib.h>

/*** #define DEBUG 1  ****/

typedef struct heap_head {
   /*** short int type;         short==int for solaris ***/
   int type;
   int size;
   struct heap_head *prev;
} HEAPHEAD,*headp;

typedef struct free_record {
   int size;
   headp head;
} FREERECORD,*recordp;

typedef  unsigned int  hsize;  /***  headp size  ***/
typedef  unsigned int  bsize;  /***  byte size   **/

#define FREE 0
#define USED 1
#define END  -1
#define START  -2
/*** #define FREEMAX 32000   256K  ***/
#define FREEMAX 16000  /** 128K  ***/
#define HEAPMAX 30
/********    solaris need align int for Bus error  ***/
/** #define INT_SIZE 4  **/
/** #define INT_SHIFT 2    **  log2   INT_SIZE  ***/
/** #define INT_SHIFT 4    ***  log2   INT_SIZE  ***/
/*** #define HSIZE(p) (((struct heap_head *)p)->size) ***/
#define HTYPE(p) (((headp)p)->type)
#define HSIZE(p) (((headp)p)->size)
#define HPREV(p) (((headp)p)->prev)
#define HNEXT(p,s) ( p+s)
#define ALLOC_ADDR(p) ( p+1)
#define GET_HEADP(p) ( p-1)
#define RSIZE(p) (((recordp)p)->size)
#define RHEAD(p) (((recordp)p)->head)

static headp heap[HEAPMAX];
/*** static FREERECORD free_table[FREEMAX]; **/
/**  use malloc for free table **/
static recordp free_table;
static int AL_SIZE=300000;  /** 10M ***/
/*** static int AL_SIZE=3000000;  ** 100M  for test ***/
int heap_num=0;
static int head_size;
static recordp  free_end;
static int freemax;

int gbc_malloc;

#define isfree(p)  (HTYPE(p)==FREE)

void new_heap();
void delete_free();
void delete_record();
void free_record();
recordp find_start();
void free_record_check();
void free_insert();
static void ss_malloc_error();  /*** conflict to System of MACOSX  ***/
headp div_block();
int heap_check();
int malloc_info();
hsize get_free();
hsize free_add();

#ifndef MAIN
ptr s_malloc_info(int narg,ptr env){
 int s;
 checknarg(narg);
 s=malloc_info("");
 return MAKESINT(s);
}
#endif

int malloc_info(char *mes){
 headp p;
 recordp q;
 int i,ct,s;
  for(i=0;i<heap_num;i++){
    p=heap[i];
    s=HSIZE(p);
    printf("heap:%d  p %lx  end %lx  size %d\n",i,(UL)p,(UL)HNEXT(p,s),s);
 }
 q=free_table;
  printf("free table\n");
  ct=0;
 while(1){
   if(q>=free_end) {
    if(ct>0){
       p=RHEAD(--q);
      if(p!=NULL){
         s=HSIZE(p);
          printf("size %d  block %lx ",s,(UL)p);
       }
    }
      break;
  }
  else {
    p=RHEAD(q);
    if(p!=NULL){
      ct++;
       s=HSIZE(p);
       if(ct<10){
           printf("size %d  block %lx ",s,(UL)p);
        }
       else{
          if(ct%100==0)
          printf("*");
        }
    }
    q++;
  }
}
  ct--;
  /***
  q=free_table+((ct>>2)<<1);
  printf("\n free block %d  middle %d info end %s\n",ct,*q,mes);
  ***/
  printf("\n malloc_info end\n");
 /***   return heap_check(ct); ***  toriaezu * ??? ***/
}



init_heap(){
 int n;
 head_size=sizeof(HEAPHEAD);
#ifdef DEBUG
  printf("\n head_size %d  \n",head_size);
#endif
 free_table=malloc(sizeof(FREERECORD)*FREEMAX);
 freemax=FREEMAX;
 free_end=free_table;
 new_heap(0);
 gbc_malloc=0;
}

void Myfree(headp p){
  headp b;
  headp next;
  hsize size;
  ptr sss;
   if(p==NULL) return;
   b=GET_HEADP(p);
   if(HTYPE(b)!=USED){
       sss=CAR((ptr)p);
      sprintf(iobuff,"illegal free type=%ld p=%lx  car %lx attr %lx\n",(long)HTYPE(b),(UL)p,(UL)CAR((ptr)p),(UL)ATTR((ptr)p));
     lwritestr(STDERR,iobuff);
      if(OBJP(sss))
           prin1(sss,STDOUT);
      /*** why?   do IGO/Jikkou  ***/
      /** printf(" string? %s\n",p); ***/
      if(HTYPE(b)==FREE) return;
      ss_malloc_error(6000);
   }
   size=HSIZE(b);
   next=HNEXT(b,size);
   if(isfree(next)){
     delete_free(next);
     size=free_add(b,next);
   }
  free_record_check(size,b); 
}

hsize free_add(headp b,headp free){
 int s,k;
   s=HSIZE(b);
   k=HSIZE(free);
   s+=k;
   HSIZE(b)=s;
   return s;
}

hsize halign(bsize n){
  return 2+(n-1)/head_size;
}

void *Mymalloc(bsize n){
  hsize size,get_size;
 recordp record;
 headp free;
 headp new;
  /*** printf("Mymalloc %d\n",n);  ***/
  size=halign(n);
  get_size=get_free(size,&record);
  if(get_size<size){
      /**  printf("gbc from Mymalloc\n");  ***/
      /*** Never call gbc from here , it may cause gbc infinitely!!! ***/
     gbc_malloc=1; 
     new_heap(size);
     get_size=get_free(size,&record);
  }
 free=RHEAD(record);
 if(get_size<size+3){
   delete_record(record);
   HTYPE(free)=USED;
   return ALLOC_ADDR(free);
 }
   delete_record(record);
   div_block(free,size);
   /***  free_record(get_size-size,new);  ***/
  /*** printf("Mymalloc return  %x\n",free+head_size); ***/ 
   return ALLOC_ADDR(free);
}

void *Myrealloc(headp p,bsize old,bsize new){
  hsize size,n,h_old;
  headp base,q;
  char *sr,*r;
  if(p==NULL) return p;
  base=GET_HEADP(p);
   n=halign(new);   /*** head_size align ***/
  h_old=halign(old);   /*** head_size align ***/
  if(HTYPE(base)!=USED){
      printf("illegal Realloc %ld %lx\n",(long)HTYPE(base),(UL)p);
      ss_malloc_error(6100);
  }
  size=HSIZE(base);
  if(size<h_old){
      printf("illegal Realloc old %d %lx\n",old,(UL)p);
      ss_malloc_error(6110);
   }
  if(n<=size){
     if(size<=2*n||size<=10) return p;
     HSIZE(base)=n;
     q=(headp)(p+n);
     HTYPE(q)=USED;
     HSIZE(q)=size-n;
     HPREV(q)=base;
     Myfree(ALLOC_ADDR(q));
     return p;
   }
  Myfree(p);     
  r=Mymalloc(new); 
  if((headp)r==p) return p;  
  sr=(char *)p;
  base=(headp)r;
  /** n=(old+short_size)/short_size;***/
  while(old--) *r++=*sr++;
  return (void *)base;
}

headp div_block(headp free,hsize n){
 hsize s;
 headp new;
  HTYPE(free)=USED;
    s=HSIZE(free);
    HSIZE(free)=n;
   new=HNEXT(free,n);
   HTYPE(new)=USED;
   HSIZE(new)=s-n;
   HPREV(new)=free;
   free_record(s-n,new);
   return new;
}
  
void new_heap(hsize n){
  headp p;
  headp end;
/** printf("new heap start n  %d\n",n);  **/
  if(heap_num==HEAPMAX) ss_malloc_error(6200);
  if(heap_num<2) AL_SIZE<<=1;
  if(AL_SIZE>n) n=AL_SIZE;
  n+=4;
  p=heap[heap_num++]=malloc(n*head_size);
  if(p==NULL) ss_malloc_error(6250);
  
  HTYPE(p)=START;
#ifdef DEBUG
printf("new start %x %d  n %x end %x \n",p,START,n,(p)+n);
#endif
  HSIZE(p)=n;   /*** Caution!  start block has total size  ***/
  end=HNEXT(p,n-1);
  HTYPE(end)=END;
  HSIZE(end)=1;
  p++;
  HTYPE(p)=USED;
  HSIZE(p)=n-2;
  HPREV(p)=p-1;
  HPREV(end)=p;
  free_record(n-2,p);
#ifdef DEBUG
  malloc_info("new heap");
#endif
 }

void delete_free(headp b){
 recordp start;
 headp s;
 hsize n;
   n=HSIZE(b);
   start=find_start(n);
   while(start<free_end){
    s=RHEAD(start);
    if(s==b){
       delete_record(start);
       return;
     }
    else
        start++;
   }
     printf("free %lx %d not found\n",(UL)b,n);
        ss_malloc_error(6300); /** Never occur ***/
}

void clean_record(){
  recordp start=free_table;
  recordp p;
   headp he;
 int ct=0;
  p=start;
  while(p<free_end){
     he=RHEAD(p);
     if(he!=NULL){
       if(p!=start){
        RSIZE(start)=RSIZE(p);
        RHEAD(start)=RHEAD(p);
        }
        start++;
        p++;
      }
     else{
       ct++;
       p++;
     }
 }
#ifdef DEBUG
  printf("clean_record %d\n",ct);
#endif
 free_end=start;
}

void delete_record(recordp rec){
  RHEAD(rec)=NULL;
}

void free_record(hsize  size,headp p){
 headp next;
 HTYPE(p)=FREE;
 HSIZE(p)=size;
 next=HNEXT(p,size);
 HPREV(next)=p;
  free_insert(size,p);
} 

hsize get_free(hsize n, recordp *record){
   recordp start;
   recordp end=free_end;
   hsize s;
   headp h;
   start=find_start(n);
   while(1){
    if(start>=end) return 0;
     h=RHEAD(start);
    if(h!=NULL){
       s=RSIZE(start);
       if(s>=n) break;
    }
     start++;

   }
   *record=start;
  return s;   /*** return END or s>=n  **/
}

recordp find_start(hsize size){
  recordp start=free_table;
  recordp end=free_end;
  recordp mid;
  int n,s;

    /*** return start;  ***/

  n=end-start;
   while(n>8){
      mid=start+(n>>1);
      s=RSIZE(mid);
      if(s>=size){  /*** s> size is no good , because may be s=size
                    and start may be  after right record! ***/ 
          end=mid;
          n=mid-start;
      }
      else{
        start=mid;
        n=end-start;
      }
   }
  return start;
}

void free_record_check(hsize size, headp p){
 hsize s,n;
  headp b;
  headp next;
 HTYPE(p)=FREE;
 HSIZE(p)=size;
 b=HPREV(p);
 
 if(b&&isfree(b)){
    s=HSIZE(b);
    n=s+size;
    delete_free(b);
    free_record(n,b);
    return;
 } 
 next=HNEXT(p,size);
 HPREV(next)=p;
  free_insert(size,p);
}

  
void free_insert(hsize size,headp p){
  recordp start=free_table;
  recordp end=free_end;
  recordp mid;
  headp h;
  int s,n;
  n=end-start;
  if(n>=freemax) { 
       clean_record();
       end=free_end;
      n=end-start;
    if(n>=freemax) {
          freemax=freemax+FREEMAX;
          start=malloc(freemax*sizeof(FREERECORD));
          end=start+n;
          memcpy(start,free_table,n*sizeof(FREERECORD));
          free(free_table);
          free_table=start;
          free_end=end;
       /*** printf("freebegin %x end %x  n %d -> FREEMAX %d\n",start,end,n,freemax); ***/ 
         /***  malloc_error(5200); ***/
     }
   }
  start=find_start(size);
   while(1){
    if(start>=end) {
         h=(headp)END;
         break;
    }
    h=RHEAD(start);
    s=RSIZE(start);
    if(s>=size) {
       if(h==NULL) {
          RSIZE(start)=size;
          RHEAD(start)=p;
          return;
       }
      break;
     }
    start++;
    }

   if(h==(headp)END){
       RHEAD(end)=p;
       RSIZE(end)=size;
      free_end=end+1;
      return;
   }
/*** 
   free_end=end+1;
   while(end>start){
     mid=end;
     end--;
     *mid=*end;
   }
  RSIZE(start)=size;
  RHEAD(start)=p;
 ***/
  /**  h,s of start is given
       and  p, size must be inserted  **/
   while(end>=start){
     h=RHEAD(start);
     s=RSIZE(start);
     RHEAD(start)=p;
     RSIZE(start)=size;
     start++;
    if(h==NULL) break;  /**  This h is not the above, it is on the way  ***/
     p=h;
     size=s;
   }
   if(start>end) free_end=start;

}


static void ss_malloc_error(int n){
 printf("Malloc error %d\n",n);
 /*** exit(88888); ***/
 fatal_error(E_malloc,a_nil);
}  
       
int heap_check(int nfree){
  int i,s=0;
  for(i=0;i<heap_num;i++){
    s+=heap_check_sub(heap[i]);
  }
  if(s!=nfree){
       printf("Not match free block number %d %d\n",nfree,s);
       ss_malloc_error(6400);
   }
 return nfree;
}

int heap_check_sub(headp p){
 int n,s,ct=0;
 headp prev=p;
 while(1){
   n=HTYPE(p);
   s=HSIZE(p);
   if(n==START) p++;
   else if(n==END) break;
   else{
     if(prev!=HPREV(p))
           ss_malloc_error(6450);
     if(n==USED){
#ifdef DEBUG
            printf("U");
#endif
     }
     else if(n==FREE){
        /** printf("F %d %x ",s,p); ***/
#ifdef DEBUG
        printf("F");
#endif
        check_free(p);
        ct++;
     }
     else { 
       printf("illegal HEAD TYPE %d %lx\n",n,(UL)p);
           ss_malloc_error(6470);
     }
     prev=p;
     p=HNEXT(p,s);
   }
 }
   putchar('\n');
 return ct;
}

check_free(headp p){
  recordp start=free_table;
   headp h;
  int s,n;
   while(1){
     if(start>=free_end) break;
     h=RHEAD(start);
      if(p==h) return;
    start++;
  }
       printf(" free %lx not found!!!\n",(UL)p);
       ss_malloc_error(6500);
}

/****   for temporaly get strage   size  by  ptr   04.6.12  for set.c  ***/
ptr *ptr_alloc(int n,ptr init)
{
  Reg ptr *p;
  p=(ptr *)Mymalloc(n*sizeof(ptr));
  if(init){
    p+=n;
    while(n--) *--p=init;
  }
  return p;
}
 
    
  
  
