/***  key_init.c ***/

#include "lisp.h"

ptr  k_q,k_n,k_c,k_hatena,k_h;
ptr k_B,k_O,k_f,k_t,k_T,k_F,k_N,k_0,k_1,k__1,k_Q,k_u,k_C;
ptr k_J,k_TJ,k_JM,k_D,k_S,k_V,k_L,k_P,k_E,k_I,k_IT,k_IF,k_K,k_LM,k_LB,k_A,k_DA,k_ML,k_MM;
ptr k_load,k_set,k_warn,k_env,k_top,k_lambda,k_macro,k_func,k_tail_jump;
ptr k_define,k_jmp,k_label,k_block_out,k_block_in,k_bind,k_letbind,k_stack_narg;
ptr k_lambda_begin,k_lambda_bind,k_call_cc,k_jsr,k_exit,k_tail,k_frame,k_frame_list;
ptr k_lambda_end,k_macro_end,k_imm,k_alloc,k_dealloc,k_BIND,k_LT,k_reg;
ptr k_undef,k_make_lambda,k_make_macro;
ptr k_macroalias;   /*** for MACRO,compiler 04.4.18 ***/
ptr k_BSR,k_ESR,k_wait,k_open,k_close,k_flush,k_ready,k_input,k_output,k_append;
ptr k_end,k_nocase,k_repeat,k_unread,k_io,k_ia,k_reopen,k_unwrite,k_getpos,k_setpos;
ptr k_readpos,k_set_readpos,k_shift_readpos;
ptr k_ascii,k_jis,k_sjis,k_euc,k_utf8,k_ci,k_last;

struct keyword{char *name;ptr *addr;};

struct  keyword  keytbl[]=
  {
{":MACRO_ALIAS", &k_macroalias},
{":q", &k_q},
{":n", &k_n},
{":c", &k_c},
{":h", &k_h},
{":s", &k_set},
{":?", &k_hatena},
/***  M-compiled source ***/
{":B", &k_B},
{":O", &k_O},
{":f", &k_f},
{":t", &k_t},
{":T", &k_T},
{":F", &k_F},
{":N", &k_N},
{":J", &k_J},
{":0", &k_0},
{":1", &k_1},
{":-1", &k__1},
{":Q", &k_Q},
{":u", &k_u},
{":C", &k_C},
{":TJ", &k_TJ},
{":JM", &k_JM},
{":D", &k_D},
{":S", &k_S},
{":V", &k_V},
{":L", &k_L},
{":P", &k_P},
{":E", &k_E},
{":I", &k_I},
{":IT", &k_IT},
{":LT", &k_LT},  /*** :LETBIND  ***/
{":IF", &k_IF},
{":K", &k_K},
{":LM", &k_LM},
{":LB", &k_LB},
{":A", &k_A},
{":DA", &k_DA},
{":ML", &k_ML},
{":MM", &k_MM},
/***  stream  ***/
{":open", &k_open},
{":close", &k_close},
{":flush", &k_flush},
{":ready", &k_ready},
{":input", &k_input},
{":output", &k_output},
{":append", &k_append},
{":unread", &k_unread},  /** 1.99 ***/
{":io", &k_io},  /** 1.99 ***/
{":ia", &k_ia},  /** 1.99 ***/
{":reopen", &k_reopen},  /** 1.99 ***/
{":unwrite", &k_unwrite},  /** 1.99 ***/
{":getpos", &k_getpos},  /** 1.99 ***/
{":setpos", &k_setpos},  /** 1.99 ***/
{":readpos", &k_readpos},  /** 1.99 ***/
{":set_readpos", &k_set_readpos},  /** 1.99 ***/
{":shift_readpos", &k_shift_readpos},  /** 1.99 ***/
/*** string  ***/
{":end", &k_end},
{":nocase", &k_nocase},
{":ci", &k_ci},
{":repeat", &k_repeat},
{":last", &k_last},
/*** kanji-code ***/
{":ascii", &k_ascii},
{":jis", &k_jis},
{":sjis", &k_sjis},
{":euc", &k_euc},
{":utf8", &k_utf8},

/***  run-process ***/
{":wait", &k_wait},
/*** compiler use ***/
{":LOAD", &k_load},
{":IMMIDIATE", &k_imm},
{":SET", &k_set},
{":warning", &k_warn},
{":ENV", &k_env},
{":TOP", &k_top},
{":LAMBDA", &k_lambda},
{":LAMBDA-BEGIN", &k_lambda_begin},
{":LAMBDA-END", &k_lambda_end},
{":LAMBDA-BIND", &k_lambda_bind},
{":MACRO", &k_macro},
{":MACRO-END", &k_macro_end},
{":FUNC", &k_func},
{":TAIL-JUMP", &k_tail_jump},
{":DEFINE", &k_define},
{":JMP", &k_jmp},
{":LABEL", &k_label},
{":BLOCK-OUT", &k_block_out},
{":BLOCK-IN", &k_block_in},
{":BIND", &k_BIND},
{":LETBIND", &k_letbind},
{":STACK-NARG", &k_stack_narg},
{":CALL/CC", &k_call_cc},
{":JSR", &k_jsr},
{":EXIT", &k_exit},
{":TAIL", &k_tail},
{":FRAME", &k_frame},
{":FRAME-LIST", &k_frame_list},
{":ALLOC", &k_alloc},
{":DEALLOC", &k_dealloc},
{":REG", &k_reg},
{":UNDEF", &k_undef},
{":MAKE-LAMBDA", &k_make_lambda},
{":MAKE-MACRO", &k_make_macro},

/***  M-compiled file begin,end ***/
{":BEGIN-SR", &k_BSR},
{":END-SR", &k_ESR},

#ifdef USE_TK 
 /**** TK ***/
{":command", &k_command},
{":variable", &k_variable},
{":var", &k_var},
{":textvariable", &k_textvariable},
{":textvar", &k_textvar},
{":text", &k_text},
{":listvar", &k_listvar},
{":yscrollcommand", &k_yscroll},
{":xscrollcommand", &k_xscroll},
{":tk-obj-name", &k_widget_name},
{":invalidcommand", &k_invalid},
{":invcmd", &k_invcmd},
{":validatecommand", &k_validate},
{":vcmd", &k_vcmd},
{":bind", &k_bind},
{":offvalue", &k_offvalue},
{":postcommand", &k_postcommand},
{":tearoffcommand", &k_tearoffcommand},
#endif
      {NULL,NULL},
  };


init_keyword()
 {
  Reg  struct keyword *sptr;
  extern ptr key_intern_c();
  
   sptr=keytbl;
    while(1)
     {
       if(sptr->name==NULL) return;
         *(sptr->addr)=key_intern_c(sptr->name);
        sptr++;
     }
  }       


