/***  list.c ***/
#define LIST_PROG

#include "lisp.h"
#include <stdio.h>
/*** #define MULTIVAL SYSREG[3] ***/
extern ptr MULTIVAL;

/***  cyclic list check  2010.9.18 by hare and tortoise Algorithm **/

/***  return ATOM(a_nil or atom) or CONS (cyclic) ***/
ptr cyclic_check(ptr x){
  ptr hare=x,tor=x;
loop:
  if(SSATOM(hare)) return hare;
  hare=CDR(hare);
  if(hare==tor) return tor;
  if(SSATOM(hare)) return hare;
  hare=CDR(hare);
  if(hare==tor) return tor;
  if(SSATOM(hare)) return hare;
  tor=CDR(tor);
 goto loop;
} 

static int ENDP(q)
  Reg ptr q;
 {
   if(q==a_nil) return YES;
   if(SREGP(q)||ATTR(q)) error(E_notlist,q);
   return NO;
  }
/***
static ptr s_endp(int narg,ptr env)
  
 {
    return PRED(ENDP(*(stack-1)));
 }
***/
/****
int _length(p)
      * (length L) *
   Reg ptr p;
 {
    Reg int s=0;
  if(cyclic_check(p)) error(E_notlist,p);
  loop:
    if(ENDP(p)) return s;
    p=CDR(p);
    s++;
    goto loop;
 }
****/
int _length(ptr x){  /*** with cyclic check  ***/
  ptr hare=x,tor=x;
  int s=0;
loop:
  if(SSATOM(hare)) goto loop2;
  hare=CDR(hare);
  if(hare==tor) goto error;
  if(SSATOM(hare)) goto loop2;
  hare=CDR(hare);
  if(hare==tor) goto error;
  if(SSATOM(hare)) goto loop2;
  tor=CDR(tor);
  s++;
 goto loop;
loop2:
    if(tor==a_nil) return s;
    if(SSATOM(tor)) goto error;
    tor=CDR(tor);
    s++;
    goto loop2;
error:
   return (int)error(E_notlist,x);
}


ptr s_listp(int narg,ptr env){
      /* (list? L) */
   Reg ptr p;
    checknarg(narg-1);
    p=*(stack-1);
   p=cyclic_check(p);
  return PRED(p==a_nil);
/***
  loop:
    if(p==a_nil) return a_t;
    if(SSATOM(p)) return a_f;
    p=CDR(p);
    goto loop;
***/
 }


static ptr nthcdr(n,q)
      /* (nthcdr n p) */
    Reg int n;
    Reg ptr q;
 {
   Reg int k=n;
   while(n--)
    {
    /*** if(ENDP(q)) error(E_range,MAKESINT(k)); ***/
    if(SSATOM(q)) error(E_range,MAKESINT(k));
    q=CDR(q);
    }
   return q;
 }

ptr last_pair(Reg ptr p){
  Reg ptr q;
    /*** if(p==a_nil) return p; ****/
    if(SSATOM(p)) return a_f; /** error(E_notlist,p); ***/
   loop:
    q=CDR(p);
    if(SSATOM(q)) return p;  /*** see CL p.207 ***/
    p=q;
    goto loop;
 }

ptr s_last_pair(int narg,ptr env)
      /* (last L) */
 {
     checknarg(narg-1);
    return last_pair(*(stack-1));
 }

ptr s_last(int narg,ptr env)
      /* (last L) */
 {
   ptr s;
     checknarg(narg-1);
    s=last_pair(*(stack-1));
    if(s==a_f) error(E_notlist,*(stack-1));
    return CAR(s);
 }

/**** 
ptr s_length(int narg,ptr env)
 {
      return MAKENUM(g_length(*(stack-1))); ** sequence.c **
 }
****/
 
ptr s_nth(int narg,ptr env)
      /* (nth n L) */
    
 {
    Reg ptr p,q;
    Reg int s;
     checknarg(narg-2);
    p=*(stack-2);
    q=*(stack-1);
    s=GETNUM(q);
    /** if(ATOM(q)) error(E_notlist,q); in ENDP **/
     return CAR(nthcdr(s,p));
 }
ptr s_nthcdr(int narg,ptr env)
      /* (nthcdr n L) */
    
 {
    Reg ptr p,q;
    Reg int s;
     checknarg(narg-2);
    p=*(stack-2);
    q=*(stack-1);
    /** if(q==a_nil) return q; **/
    s=GETNUM(q);
    /** if(ATOM(q)) error(E_notlist,q); in ENDP **/
     return nthcdr(s,p);
 }

/****   no need  
ptr s_list_a(int narg,ptr env)
***/
 
ptr copy_list(l)
    Reg ptr l;
 {
    Reg ptr p;
    if(l==a_nil) return l;
    if(SSATOM(l)) error(E_notlist,l);
    psh(p=QCONS(a_nil,a_nil));
     while(CONSP(l))
      {
        p=CDR(p)=CONS(CAR(l),a_nil);
        l=CDR(l);
      }
     CDR(p)=l;  /*** dotted-list , must support **/
     return CDR(*pull());
 }

ptr s_copy_list(int narg,ptr env)
    
 {
    checknarg(narg-1);
     return copy_list(*(stack-1));
  }

static ptr s_copy_alist(int narg,ptr env)
    
 {
    Reg ptr p,l,q;
    checknarg(narg-1);
    l=*(stack-1);
    if(l==a_nil) return l;
    if(SSATOM(l)) error(E_notlist,l);
    psh(p=QCONS(a_nil,a_nil));
     while(CONSP(l))
      {
        q=CAR(l);
        if(SSATOM(q)) error(E_notlist,q);
        p=CDR(p)=CONS(CONS(CAR(q),CDR(q)),a_nil);
        l=CDR(l);
      }
     CDR(p)=l;
     return CDR(*pull());
 }

static ptr s_copy_tree(int narg,ptr env)
    
 {
    Reg ptr p,l,*r;
    checknarg(narg-1);
    l=*(stack-1);
    if(SSATOM(l)) return l;
    psh(p=QCONS(a_nil,a_nil));
    r=stack;
     psh(a_nil);    
     while(CONSP(l))
      {
        *r=CAR(l);
        p=CDR(p)=CONS(s_copy_tree(1,a_nil),a_nil);
        l=CDR(l);
      }
     CDR(p)=l;
     pull();
     return CDR(*pull());
 }
    
static ptr sub_list(l,start,end)
    Reg ptr l;
    Reg int start,end;  /*** end maybe -1 ̵ ***/
 {
    Reg ptr p;
    l=nthcdr(start,l);
    if(l==a_nil) return l;
    end=end-start;
    psh(p=QCONS(a_nil,a_nil));
     while(end--)
      {
        if(ENDP(l)) break;
        p=CDR(p)=CONS(CAR(l),a_nil);
        l=CDR(l);
      }
     /*** CDR(p)=l; ***/
     return CDR(*pull());
 }

/****  list_circle.c  
ptr s_list_length(int narg,ptr env)
****/
    
    /** see CL p.205  , ۴list ʤnil ֤->a_f for ss ***/
    /***  Խʬwrite.cΥ르ꥺǤ뤳ȡ  to be correct ***/
 /***{
    Reg int s=0;
    Reg ptr p,slow;
    p=slow=*(stack-1);
     checknarg(--narg);
  loop:
    if(ENDP(p)) return MAKENUM(s);
    slow=CDR(slow);
    p=CDR(p);
    s++;
    if(ENDP(p)) return MAKENUM(s);
    p=CDR(p);
    s++;
    if(slow==p) return a_f;
    goto loop;
 }
****/
 
static ptr  make_list(s,init)
  Reg int s;
  Reg ptr init;
 {
   Reg ptr p=a_nil;
   while(s--)
    {
       p=SCONS(init,p);
    }
   return p;
  }

ptr reverse_list(p)
    Reg ptr p;
 {
    Reg ptr q=a_nil;
    if(p==a_nil) return q;
    if(SSATOM(p)) return q;
   loop:
     q=SCONS(CAR(p),q);
    p=CDR(p);
    if(p==a_nil) return q;
    goto loop;
 }

ptr s_reverse(int narg,ptr env){
   Reg ptr x;
   x=*(stack-1);
  /**  *stack++=res; ***/
   checknarg(--narg);
   return reverse_list(x);
}

/***  (x1 x2 ...)  -> (xn.... x2 . x1)   ***/

ptr s_reverseS(int narg,ptr env){
   Reg ptr x,res;
   char *p;
   int n,s=0;
   checknarg(--narg);
   x=*(stack-1);
   *stack++=res=CAR(x);
   x=CDR(x);
   while(CONSP(x)){
     *(stack-1)=res=CONS(CAR(x),res);
     x=CDR(x);
   }
   return   *--stack;
}


ptr nreverse_list(p)
      /* (nreverse L) */
    Reg ptr p;
 {
    Reg ptr q=a_nil,r=a_nil;
    if(SSATOM(p)) return q;
   loop:
     q=p;
    p=CDR(p);
    CDR(q)=r;
    r=q;
    if(SSATOM(p)) return q;
    goto loop;
 }

ptr s_nreverse(int narg,ptr env)
 {
    checknarg(narg-1);
    return nreverse_list(*(stack-1));
}

ptr s_revappend(int narg,ptr env)
 {
    Reg ptr p,q;
    checknarg(narg-2);
    p=*(stack-2);
    q=*(stack-1);
   loop:
    if(SSATOM(p)) return q;
     q=SCONS(CAR(p),q);
    p=CDR(p);
    goto loop;
 }

ptr s_nreconc(int narg,ptr env)
 {
    Reg ptr p,q,r;
    checknarg(narg-2);
    p=*(stack-2);
    r=*(stack-1);
   loop:
    if(SSATOM(p)) return q;/*** () ***/
     q=p;
    p=CDR(p);
    CDR(q)=r;
    r=q;
    goto loop;
 }

static ptr s_butlast(int narg,ptr env)
 {
    Reg ptr p,q;
    Reg int n=1;
    checknarg(narg-2);
    p=*(stack-2);
    if((q=*(stack-1))!=a_nil) n=GETNUM(q);
    if(n>=_length(p)) return a_nil;
    p=reverse_list(p);
    p=nthcdr(n,p);
    return nreverse_list(p);
  }

static ptr s_nbutlast(int narg,ptr env)
 {
    Reg ptr p,q;
    Reg int n=1;
    checknarg(narg-2);
    p=*(stack-2);
    if((q=*(stack-1))!=a_nil) n=GETNUM(q);
    if(n>=_length(p)) return a_nil;
    p=nreverse_list(p);
    p=nthcdr(n,p);
    return nreverse_list(p);
  }

static ptr s_ldiff(int narg,ptr env)
 {
    Reg ptr l;
    Reg ptr p,q;
    checknarg(narg-2);
    l=*(stack-2);
    q=*(stack-1);
    
    if(l==a_nil) return l;
    if(SSATOM(l)) error(E_notlist,l);
    psh(p=QCONS(a_nil,a_nil));
     while(!SSATOM(l))
      {
        if(l==q) break;
        p=CDR(p)=CONS(CAR(l),a_nil);
        l=CDR(l);
      }
    if(l!=q)
         CDR(p)=l;  /*** dotted-list , must support **/
     return CDR(*pull());
 }

static ptr s_tailp(int narg,ptr env)
 {
    Reg ptr l;
    Reg ptr q;
    checknarg(narg-2);
    q=*(stack-2);
    l=*(stack-1);
    if(l==a_nil) return a_f;
    if(SSATOM(q))  return a_f;
     while(CONSP(l))
      {
        if(l==q) return a_t;
        l=CDR(l);
      }
    return a_f;
 }
    
ptr s_setcar(int narg,ptr env)
 {
    Reg ptr x;
    Reg ptr q;
    checknarg(narg-2);
    q=*(stack-2); /** pair **/
    x=*(stack-1);
   if(SSATOM(q)) error(E_notlist,q);
   CAR(q)=x; 
    return a_undef;
 }

ptr s_setcdr(int narg,ptr env)
 {
    Reg ptr x;
    Reg ptr q;
    checknarg(narg-2);
    q=*(stack-2); /** pair **/
    x=*(stack-1);
   if (SSATOM(q)) error(E_notlist,q);
   CDR(q)=x;
    return a_undef;
 }

ptr s_make_list(int narg,ptr env)
 {
    Reg ptr x;
    Reg ptr s;
    int n;
    if(narg==1){ 
         x=a_f;
        s=*(stack-1);
     }
    else if(narg==2){
        x=*(stack-1);
        s=*(stack-2);
     }
    else 
       checknarg(narg-2);
    n=GETNUM(s);
   return make_list(n,x);
 }

/***  take n elements of a list  (take x n)   ****/
ptr s_take(int narg,ptr env)
 {
    Reg ptr q,res,top;
    Reg int n;
    checknarg(narg-2);
    q=*(stack-2); /** pair **/
    n=GETNUM(*(stack-1));
   if(n==0) return a_nil;
   if (SREGP(q)||!CONSP(q)) error(E_notlist,q);  /*** () for n>0 ***/
   top=res=CONS(CAR(q),a_nil);
   psh(top);
   while(n-->1){
     q=CDR(q);
   if (SREGP(q)||!CONSP(q)) error(E_notlist,q);  
     res=CDR(res)=CONS(CAR(q),a_nil);
   } 
   pull();  
    return top;
 }

ptr s_ntake(int narg,ptr env)
 {
    Reg ptr q,top;
    Reg int n;
    checknarg(narg-2);
    q=*(stack-2); /** pair **/
    n=GETNUM(*(stack-1));
   if(n==0) return a_nil;
   if (SREGP(q)||!CONSP(q)) error(E_notlist,q);  /*** () for n>0 ***/
   top=q;
   while(n-->1){
     q=CDR(q);
   if (SREGP(q)||!CONSP(q)) error(E_notlist,q);
   }
   CDR(q)=a_nil;
    return top;
 }

/****  return values  ntake & rest  ***/
ptr s_nsplit_at(int narg,ptr env)
 {
    Reg ptr q,top,rest;
    Reg int n;
    checknarg(narg-2);
    q=*(stack-2); /** pair **/
    n=GETNUM(*(stack-1));
   if(n==0) return a_nil;
   if (SREGP(q)||!CONSP(q)) error(E_notlist,q);  /*** () for n>0 ***/
   top=q;
   while(n-->1){
     q=CDR(q);
   if (SREGP(q)||!CONSP(q)) error(E_notlist,q);
   }
   rest=CDR(q);
   CDR(q)=a_nil;
   q=CONS(rest,a_nil);
   q=SCONS(top,q);
    MULTIVAL=q; /*** V2.0  **/
   /**
   ATTR(q)=MULTI;
   multiscm=q;
    ***/
    return top;
 }

ptr s_split_at(int narg,ptr env)
 {
    Reg ptr q,top,rest;
    Reg int n;
    rest=s_nthcdr(narg,env);
    top=s_take(narg,env);
    psh(top);
   q=CONS(rest,a_nil);
   q=SCONS(top,q);
    MULTIVAL=q; /*** V2.0  **/
  /***
   ATTR(q)=MULTI;
   multiscm=q;
   ***/
    pull();
    return top;
 }
/*** safe list2,list3  ***/
ptr list2(ptr x,ptr y){
 Reg ptr res;
     psh(x);
      res=SCONS(y,a_nil);
      res=SCONS(x,res);
    pull();
    return res;
}

ptr list3(ptr x,ptr y, ptr z){
 Reg ptr res;
   psh(x);
   psh(y);
      res=SCONS(z,a_nil);
      res=SCONS(y,res);
      res=SCONS(x,res);
   stack-=2;
    return res;
}


/***  Ver2.0 needs common-tail  ***/
ptr s_common_tail(int narg,ptr env){
    Reg ptr x,y,top,rest;
    int lx,ly; 
    checknarg(narg-2);
     x=*(stack-2);
     y=*(stack-1);
     lx=_length(x);
     ly=_length(y);
     if(lx>ly){
        x=nthcdr(lx-ly,x);
     }
     else if(lx<ly){
        y=nthcdr(ly-lx,y);
     }
     else
      ;
     while(x!=y){
       x=CDR(x);
       y=CDR(y);
     }
    return x;
}

