/*** entry open expr 2 ***/ 
#define OPEN_PROG

#include "lisp.h" 
#include <stdio.h>
#include <fcntl.h>
#include <sys/stat.h>
#include "ss_stream.h" 
#define EOF (-1)
/****   04.7.19 we change read_ac ->1 ***/
/*** extern FILE *sys_fp[];  ***/

/***  "r" "w" "a"  ***/
 
extern int pstrcpy(); 

static ptr open_func();

static int open_keyword(ptr key)
{
  if(key==k_input) return read_ac;
  if(key==k_output) return write_ac;
  if(key==k_append) return append_ac;
  if(key==k_io) return both_ac;
  if(key==k_ia) return r_a_ac;
  error(E_keyword,key);
}

/****
ptr makestream(int  access, int filep ,ptr file){
 ptr s;
  s=*stack++=CONS(SEOF,file);
  s=*(stack-1)=CONS(filep,s);
  s=CONS(access,s);
  ATTR(s)=STREAM;
  stack--;
  return s;
}
********/
/*** New for string   ***/
static ptr make_strstream(int  access, int size ,int rloc,ptr file){
 ptr s;
 int rsize;
  rsize=size|1;
  file=SCONS((ptr)(long)rsize,file);   /*** extend 2nd cell CAR = true string size|1 to be SINT  ***/
  file=SCONS(SEOF,file);   /***  !!! extend 1 cell CAR=UNREADC  ***/
  s=*stack++=SCONS(0,file);  /****  WLOC   ***/
  s=*(stack-1)=CONS((ptr)(long)rloc,s);
  s=CONS((ptr)(long)access,s);
  ATTR(s)=STREAM;
  stack--;
  return s;
}

/****  New!  2005.9.20   for   FUNC, SOCKET  ***/
ptr makenewstream(int  access, int filep ,int wloc,ptr file){
 ptr s;
  file=SCONS(SEOF,file);   /***  !!! extend 1 cell CAR=UNREADC  ***/
  s=*stack++=SCONS((ptr)(long)wloc,file);  /****  WLOC   ***/
  s=*(stack-1)=CONS((ptr)(long)filep,s);
  s=CONS((ptr)(long)access,s);
  ATTR(s)=STREAM;
  stack--;
  return s;
}


ptr makefilestream(int  access, int filep ,ptr file){
 ptr s,fp;
  fp=make_alloc_bin(FILEBUFMAX);
  CDR(fp)=(ptr)(long)0;   /***  first location is 0!  ***/
   /***  2005.9.19  extend stream  ***/
  psh(fp);
  /***
  file=SCONS(a_nil,file);
  file=SCONS(fp,file);
  ***/
  file=SCONS(fp,file);
  file=SCONS(SEOF,file);
  s=SCONS(SEOF,file);
  s=*(stack-1)=CONS((ptr)(long)filep,s);
  s=CONS((ptr)(long)access,s);
  ATTR(s)=STREAM;
  pull();
  return s;
}


ptr s_open_input(int narg,ptr env){
  checknarg(narg-1);
  return  open_sub(*(stack-1),read_ac);
}

ptr s_open_output(int narg,ptr env){
  checknarg(narg-1);
  return  open_sub(*(stack-1),write_ac);
}

ptr s_open_append(int narg,ptr env){
  checknarg(narg-1);
  return  open_sub(*(stack-1),append_ac);
}
ptr s_str_input(int narg,ptr env){
  checknarg(narg-1);
  return  open_str(*(stack-1),read_ac);
}

ptr s_str_output(int narg,ptr env){
  checknarg(narg-1);
  return  open_str(*(stack-1),write_ac);
}

ptr s_str_append(int narg,ptr env){
  checknarg(narg-1);
  return  open_str(*(stack-1),append_ac);
}

ptr s_str_inout(int narg,ptr env){
  checknarg(narg-1);
  return  open_str(*(stack-1),both_ac);  /** read& write ***/
}

ptr s_str_inappend(int narg,ptr env){
  checknarg(narg-1);
  return  open_str(*(stack-1),r_a_ac);  /** read& append ***/
}

ptr s_func_input(int narg,ptr env){
  if(narg==0) checknarg(narg-1);
  env=stack_to_list(narg-1);
  return  open_func(*(stack-narg),env,read_ac);
}

ptr s_func_output(int narg,ptr env){
  if(narg==0) checknarg(narg-1);
  env=stack_to_list(narg-1);
  return  open_func(*(stack-narg),env,write_ac);  /*** stack-1 is Bug! ***/
}

ptr s_func_bidirection(int narg,ptr env){
  if(narg==0) checknarg(narg-1);
  env=stack_to_list(narg-1);
  return  open_func(*(stack-narg),env,both_ac);  /*** stack-1 is Bug! ***/
}


int open_sub_read(char *name){
  Reg int fd;
    fd=open(name,O_RDONLY|O_NDELAY);  /*** O_NDELAY is for FIFO ***/
   /*** fcntl(fd,F_SETFL,O_RDONLY);    clear O_NDELAY ***/
  return fd;
}
ptr s_fifo_delay(int narg,ptr env)
{
  ptr port,s;
  int fd,flag;
  flag=O_RDONLY;
  if (narg==1)
    port=*(stack-1);
  else if(narg==2){
     port=*(stack-2);
      if(*(stack-1)==a_f)  flag=O_RDONLY|O_NDELAY;
  }
 else
     checknarg(narg-2);
  check_input(port);
  fd=ssfileno(port);
  if(fd==-1) return a_f;
  fcntl(fd,F_SETFL,flag);   /***  clear O_NDELAY ***/
  return a_t;
}

int open_sub_write(char *name){
  Reg int fd;
    return open(name,O_WRONLY|O_CREAT|O_TRUNC,S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
}

int open_sub_append(char *name){
  Reg int fd;
    return open(name,O_WRONLY|O_CREAT|O_APPEND,S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH);
}

int open_sub_mode(char *name,int access)
{
  if(access==read_ac) return open_sub_read(name);
  else if(access==write_ac) return open_sub_write(name);
  else if(access==append_ac) return open_sub_append(name);
  else{
     sprintf(iobuff,"access %d\n",access);
     lwritestr(STDERR,iobuff);
     error(E_illegal,a_nil);
  }
}

 
ptr open_sub(file,action)
   Reg ptr file;   /*   string type */
   Reg int action;
 {
   Reg int fp;  /** FILE *fp; ***/
   /** FILE *fopen(); ***/
   Reg int i; 
   ptr s;
   
     pstrcpy(iobuff,file);
     fp=open_sub_mode(iobuff,action);
    /* printf(" no %d\n",fileno(fp)); */
     /*** if(fp==NULL||((i=fileno(fp))==0))    
                       because fopen's BUG ***/
     if(fp==-1)
         {
            return a_f;
         }
   file=makefilestream ( action,fp,file) ; 
   if(action==write_ac)
         set_pos('\n',file);    /**** top   ****/
   else if(action==append_ac)
         set_pos('\n',file);    /**** mada   ****/
   return  file; 
  }
 

static ptr  probe_file(ptr file)     /*  (probe-file 'file)  */
 {
    Reg ptr path;
    int n;
     pstrcpy(iobuff,file);
     n=get_filestat(iobuff);  /*** see system.c ***/
     return (n==-1)? a_f:file;
 }

ptr s_probe_file(int narg,ptr env){
  checknarg(narg-1);
  return probe_file(*(stack-1));
}
/****  string  ***/
ptr open_str(str,action)
   Reg ptr str;   /*   string  */
   Reg int action;
 {
   Reg int loc,line_loc,size;
   ptr lpath;

   if(SREGP(str)||!STRINGP(str)) error(E_notstr,str);
   loc=size=(long)CDR(str);
   if(action!=read_ac){
       if(str==a_nullstr)  { /***  nullstr used by only system  ***/
             str=makestring(32);  /*** always New str ***/
             size=32;
         }
       else if(size<8){
          extend_str(str,32);
          size=(long)CDR(str);
       }
  }
  if(action&write_ac) loc=0;
   CDR(str)=(ptr)(long)loc;
   /*** printf("open str size %d loc %d\n",size,loc); ***/
   psh(str);
   lpath=make_strstream ( action|STR_PORT,size,0,str) ;  /**** NEW199 ***/
   pull();
   if(action!=read_ac) str_set_pos(lpath);
   return lpath;
  }

str_set_pos(ptr lpath){    /*** for append string  ***/
 ptr str;
 Reg unsigned char *p;
  int line_loc,n,c;
        lpath=STB(lpath);
        str=STB_STR(lpath);
        p=get_string(str,&n);
       line_loc=0;
        while(n--){
           c=*p++;
           if(c=='\n'||c==PAGE) line_loc=0;
           else line_loc++;
        }
      STB_WLOC(lpath)=(ptr)(long)line_loc;
}

ptr reopen_str(ptr lpath,int mode){
Reg ptr p=lpath;
int n;
   n=check_port(lpath);
 /***printf("reopen str SIZE %d mode %d\n",STR_SIZE(lpath),mode);**/
 if(mode){
   n=(n&0xff0)|mode;
   ACCSET(p)=(ptr)(long)n;
  }
else{
      ACCSET(p)=(ptr)(long)(n&0xfff); /*** clear CLOSED  ***/
}
 n&=0xf;
 /*** if(n&read_ac)  ***/
          STR_RLOC(p)=0;  /*** read location ***/
 p=STB(p);
 if(n==write_ac){
     STB_WLOC(p)=0;
     CDR(STB_STR(p))=0;  /*** strlen  ***/
 }
 else if(n&append_ac)
    str_set_pos(lpath);  /*** append ***/     
 return lpath;
}


/***  func ****/
int get_facc_key(ptr x){
  if(x==k_unread) return unread_ac;
  else if(x==k_unwrite) return unwrite_ac;
  /*** else if(x==k_reopen) return reopen_ac; ***/
  else if(x==k_getpos) return getpos_ac;
  else if(x==k_setpos) return setpos_ac;
  else if(x==k_readpos) return readpos_ac;
  else if(x==k_set_readpos) return set_readpos_ac;
  else if(x==k_shift_readpos) return shift_readpos_ac;
  else  return 0;
}

int make_facc(ptr res){
 ptr x;
 int facc=0;
  if(KEYWORDP(res)) return get_facc_key(res);
  while(PAIRP(res)){
    x=CAR(res);
    facc|=get_facc_key(x);
    res=CDR(res);
  }
 return facc;
}

static ptr open_func(func,para,action)
   Reg ptr func,para;   /*   lambda  2  */
   Reg int action;
   
 {
   ptr res;
   Reg int loc,facc;
   if(SREGP(func)||!(ATTR(func)&LAMBDA)) error(E_nullfunc,func);
   psh(k_open);
   psh(para);
   res=funcall(func,2,a_nil);
   stack-=2;
   if(res==a_f) error(E_open,func);
   facc=make_facc(res);
   /*** printf("open facc %x\n",facc);  ***/
   func=makenewstream ( action|(long)FUNC_PORT,facc,(int)(long)SEOF,func) ; /** NEW199  **/
   if(action==write_ac){
        res=STB(func);
        STB_WLOC(res)=(ptr)0;   /***  mada    append  ***/
    } 
   return func;
  }

static ptr reopen_func(lpath,para)
   Reg ptr lpath,para;   /*   lambda  2  */
{
    ptr func,res;
   int n;
   n=check_port(lpath);
   ACCSET(lpath)=(ptr)(long)(n&0xfff); /*** clear CLOSED  ***/ 
   func=ST_FUNC(lpath);
   /*** printf("func wrtiec  %c func %x\n",c,func); ***/
   psh(k_reopen);
   psh(para);
   res=funcall(func,2,a_nil);
   stack-=2;
   if(res==a_f) error(E_open,func);
    STB_WLOC(STB(lpath))=0;
   return lpath;
}

ptr s_reopen_str(int narg,ptr env){
  int mode=0;
  ptr lpath;
  if(narg==1)
    lpath=*(stack-1);
  else if(narg==2){
    mode=open_keyword(*(stack-1));
    lpath=*(stack-2);
  }
  else
     checknarg(narg-2);
  return reopen_str(lpath,mode);
}

ptr s_func_reopen(int narg,ptr env){
  if(narg==0) checknarg(narg-1);
  env=stack_to_list(narg);  /****  all para ***/
  return  reopen_func(*(stack-narg),env);
}


 
