/*** readtable.h
***/
#define  READTABLE_C

#include "lisp.h"
#include "clread.h"
 
 extern ptr sh_array(),sh_hash();
 extern ptr sh_char(),sh_radix(),sh_vect(),sh_skip(),sh_logic(),sh_complex();
 extern ptr sh_shell(),sh_structure(),sh_regstr();

#define MAKEFUNC1(x)   make_subr(x,SLAMBDA|(int)(long)subr_argtype(1,0),a_nil)
#define MAKEFUNC2(x)   make_subr(x,SLAMBDA|(int)(long)subr_argtype(2,0),a_nil)
 
/***  ss readtable 
   vector of length 128  
  each element is the CONS 
    _type ( INT)
    _func (ptr)
  ただし, dispatchmacro の場合は,
     (_type   .  dispatch-func-vector)
  この場合の_func は, unique である。(rm-dispatch とする。)
  dispatch-func-vector も128である。
  dispatch されていないchar には, error を起こす関数である。
  dispatch macroとは#のように、次の文字によって、使うmacroが決定されるものである。
****/

ptr get_tbl_syntax();

static ptr get_dispatch(ptr c,ptr table){
    Reg ptr *s;
    int n;
       s=get_vector(table,&n);
       n=CHAR_CODE(c);
       if(n>=TSIZE) return a_undef;
       return *(s+(n));
}

        
static set_tbl_syntax(int c, ptr a, ptr fun, ptr table)
    {
     Reg ptr *s;
    int n;
       s=get_vector(table,&n);
       table=*(s+(c));
        CAR(table)=a; /*** type ***/
        CDR(table)=fun;
    }

static make_char_disp(int c,ptr a,ptr table)
 {
     Reg ptr *s;
    int n;
       s=get_vector(table,&n);
       table=*(s+(c));
        CAR(table)=a;
       CDR(table)=makevector(TSIZE,a_undef);
 }

static ptr set_char_disp(int c,int subc,ptr fun,ptr table)
    {
     Reg ptr x,*s;
     int n;
       s=get_vector(table,&n);
       table=*(s+(c));
        if((long)CAR(table)&dispatch)
        {
          x=CDR(table);
           s=get_vector(x,&n);
           *(s+(subc))=fun;
        }
       else
         error(E_illegal,c);
      return a_t;
    }

static ptr get_char_disp(ptr c,ptr subc,ptr table)
    {
     Reg ptr x,*s;
     int n;
      s=get_vector(table,&n);
       table=*(s+CHAR_CODE(c));
        if((long)CAR(table)&dispatch)
        {
          x=CDR(table);
           s=get_vector(x,&n);
           return *(s+CHAR_CODE(subc));
        }
       else
         error(E_illegal,c);
    }


ptr get_type(ptr c){
if((int)CHAR_CODE((int)(long)c)>=128) return constituent;
 return CAR((ptr)get_tbl_syntax(c,SVAL(a_readtable)));
} 

ptr s_get_type(int narg, ptr env){
 ptr c;
 c=*(stack-1);
 checknarg(narg-1);
 return get_type(c);
}

ptr get_tbl_syntax(ptr c,ptr table)
    {
     Reg ptr *s;
       int n;
      n=CHAR_CODE(c);
      if(n>=128) return get_tbl_syntax(MAKECHAR('A'),table);
      s=get_vector(table,&n);
       return  *(s+CHAR_CODE(c));
    }


ptr s_get_syntax(int narg, ptr env){
 ptr c;
 c=*(stack-1);
 checknarg(narg-1);
 return get_tbl_syntax(c,SVAL(a_readtable));
}

static ptr make_readtable()
 {
  Reg ptr table,*s,type;
  Reg int i;
  int size=TSIZE;
   table=makevector(size,a_undef);
    s=get_vector(table,&size);
   psh(table);
      for(i=0;i<size;i++)
       {
         if(i==127) type=t_space;
         else
           type=(i<=' ')?t_space:constituent;
         *s++=CONS(type,a_undef);
       }
  pull();
  return table;
}

extern ptr s_rm_left_p(),s_rm_right_p(),s_rm_quote(),s_rm_back_q(),s_rm_remark(),s_rm_komma(),s_rm_str();
extern ptr s_sh_char(),s_sh_radix(),s_sh_vect();

ptr make_std_readt()
 {
  Reg ptr x,*s;
  Reg int size=TSIZE,i,type;
    psh(x=make_readtable());
        set_tbl_syntax('\\',s_escape,a_undef,x);
        set_tbl_syntax('|',m_escape,a_undef,x);
        set_tbl_syntax('(',t_macro,MAKEFUNC1(s_rm_left_p),x);
        set_tbl_syntax(')',t_macro,MAKEFUNC1(s_rm_right_p),x);
        set_tbl_syntax('\'',t_macro,MAKEFUNC1(s_rm_quote),x);
        set_tbl_syntax('`',t_macro,MAKEFUNC1(s_rm_back_q),x);
        set_tbl_syntax(';',t_macro,MAKEFUNC1(s_rm_remark),x);
        set_tbl_syntax(',',t_macro,MAKEFUNC1(s_rm_komma),x);
        set_tbl_syntax('"',t_macro,MAKEFUNC1(s_rm_str),x);
        /** set_tbl_syntax(255,t_macro,a_rm_linker,x); **/
        make_char_disp('#',(ptr)sharp_macro,x); /*** #=35 **/
        set_char_disp('#','\\',MAKEFUNC2(sh_char),x);
        set_char_disp('#','x',MAKEFUNC2(sh_radix),x);
        set_char_disp('#','b',MAKEFUNC2(sh_radix),x);
        set_char_disp('#','o',MAKEFUNC2(sh_radix),x);
        set_char_disp('#','(',MAKEFUNC2(sh_vect),x);
        set_char_disp('#','|',MAKEFUNC2(sh_skip),x);
        set_char_disp('#','"',MAKEFUNC2(sh_regstr),x);
        set_char_disp('#','!',MAKEFUNC2(sh_shell),x);
        set_char_disp('#','t',MAKEFUNC2(sh_logic),x);
        set_char_disp('#','f',MAKEFUNC2(sh_logic),x);
        set_char_disp('#','c',MAKEFUNC2(sh_complex),x);
        set_char_disp('#','a',MAKEFUNC2(sh_array),x);
        set_char_disp('#','S',MAKEFUNC2(sh_structure),x);
        set_char_disp('#','s',MAKEFUNC2(sh_structure),x);
        set_char_disp('#','H',MAKEFUNC2(sh_hash),x);
        /*** mada
        set_char_disp('#','r',MAKEFUNC1(s_sh_radix),x);
         ***/
        /****
         set_char_disp('#','\'',MAKEFUNC1(s_sh_FUNC),x); 
        set_char_disp('#',':',MAKEFUNC1(s_sh_symb),x);
        set_char_disp('#','+',MAKEFUNC1(s_sh_plus),x);
        set_char_disp('#','-',MAKEFUNC1(s_sh_plus),x);
        set_char_disp('#','=',MAKEFUNC1(s_sh_labelL),x);
        set_char_disp('#','#',MAKEFUNC1(s_sh_label_ref),x);
        set_char_disp('#','A',MAKEFUNC1(s_sh_array),x);
        set_char_disp('#','*',MAKEFUNC1(s_sh_bitv),x);
        set_char_disp('#','.',MAKEFUNC1(s_sh_eval),x);
        set_char_disp('#',':',MAKEFUNC1(s_sh_symb),x);
        *****/
   /** printf("std  read-table make\n"); ***/
  return top_value_set(a_readtable,*pull());
 }


/****   dispatchは　table,lpathの	2引数とする。　***/
/***  used in gread.c  **/
ptr s_rm_dispatch(int narg,ptr env)
{
  Reg ptr f,lpath,table,k;
    lpath=*(stack-1);
    table=*(stack-2);
     /** printf("disp:  arg  %x %x\n",lpath,table); **/ 
    k=read_char(lpath);
    f=get_dispatch(k,table);
    if(f==a_undef) error(E_syntax_read,k);
     /***  dispathch は  (lpath  subchar)の２引数 ***/
     /*** printf("disp2:  k  %x f %x\n",k,f);  **/ 
    psh(k);
    f=funcall(f,2,env);
    pull();
    return f;
}

