/****   s_str.c  ***/
#include "lisp.h"

static ptr string_ci_eq();

ptr string_ci_eq();

checkstr(ptr x){
if(SREGP(x)||!STRINGP(x)){
     prin1(x,STDMSG);
     lwritestr(STDMSG,"s_str.c  not string %x\n");
     error(E_notstr,x);
   }
}

ptr s_str_eq(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
     return string_equal(x,y);
 }

ptr s_str_ci_eq(int narg,ptr env)

 {
    /*   expr 1 ,  double?  */
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
     return string_ci_eq(x,y);
 }

static ptr string_ci_eq(ptr sp,ptr sq){
 Reg unsigned char *p,*q;
 int n,m;
   p=get_string(sp,&n);
   q=get_string(sq,&m);
   if(n!=m) return a_f;
   while(n--){
   if(_lowercode(*p++)!=_lowercode(*q++)) return a_f;
  }
   return a_t;
}

/*** < 1or high , = 0, > -1  **/
static int string_cmp(ptr sp,ptr sq){
 Reg unsigned char *p,*q;
 int n,m; 
   p=get_string(sp,&n);
   q=get_string(sq,&m);
   if(n>m){
       while(m--){
         if(*p<*q)  return 1;
         if(*p++>*q++)  return -1;
       }
       return -1;
    }
    m=m-n;
   while(n--){
         if(*p<*q)  return 1;
         if(*p++>*q++)  return -1;
       }
     return m;
}     

static int  string_cmp_ci(ptr sp,ptr sq){
 Reg unsigned char *p,*q;
 int n,m;
 int cp,cq;
   p=get_string(sp,&n);
   q=get_string(sq,&m);
   if(n>m){
       while(m--){
         cp=_lowercode(*p++);
         cq=_lowercode(*q++);
         if(cp<cq)  return 1;
         if(cp>cq)  return -1;
       }
       return -1;
    }
    m=m-n;
   while(n--){
         cp=_lowercode(*p++);
         cq=_lowercode(*q++);
         if(cp<cq)  return 1;
         if(cp>cq)  return -1;
       }
     return m;
}


ptr s_str_lt(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp(x,y);
    return PRED(n>0);
 }

ptr s_str_gt(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp(x,y);
    return PRED(n<0);
 }

ptr s_str_le(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp(x,y);
    return PRED(n>=0);
 }

ptr s_str_ge(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp(x,y);
    return PRED(n<=0);
 }

ptr s_str_ci_lt(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp_ci(x,y);
    return PRED(n>0);
 }

ptr s_str_ci_gt(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp_ci(x,y);
    return PRED(n<0);
 }
ptr s_str_ci_le(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp_ci(x,y);
    return PRED(n>=0);
 }

ptr s_str_ci_ge(int narg,ptr env)

 {
    int n;
    Reg ptr x=*(stack-2);
    Reg ptr y=*(stack-1);
    checknarg(narg-2);
    checkstr(x);
    checkstr(y);
    n=string_cmp_ci(x,y);
    return PRED(n<=0);
 }



