/****  sint.c
     SINT  math 
***/
/***  correct check overflow!!! ***/
#define  SINT_C

#include "lisp.h"

#define unsafe 0xf0000000 
#define unsafemul  0xffffC000 
#define INT       Reg long int
extern mpz_t mpzwork1,mpzwork2;

ptr add(ptr p,ptr q){
INT n,m,s,safe=1;
  n=SINT_NUMB(p);
  m=SINT_NUMB(q);
  s=(long)p+(long)q;
  if((n>=0)&&(m>=0)) safe=(s>=0);
  else if((n<=0)&&(m<=0)) safe=(s<=0);
  /*** if((n&unsafe)&&(m&unsafe)){  **/
  if(!safe){
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
   mpz_add(mpzwork1,mpzwork1,mpzwork2);
   return mpz_check16(mpzwork1);
  } 
 return MAKESINT(n+m);
}

ptr sub(ptr p,ptr q){
INT n,m,s,safe=1;
  n=SINT_NUMB(p);
  m=SINT_NUMB(q);
  s=(long)p-(long)q;
  if((n>=0)&&(m<=0)) safe=(s>=0);
  else if((n<=0)&&(m>=0)) safe=(s<=0);
  
  /** if((n&unsafe)&&(m&unsafe)){  ***/
  if(!safe){
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
   mpz_sub(mpzwork1,mpzwork1,mpzwork2);
   return mpz_check16(mpzwork1);
  }
 return MAKESINT(n-m);
}

ptr mul(ptr p,ptr q){
INT n,m,sig=1;
  n=SINT_NUMB(p);
  if(n<0){
      sig=-sig;
      n=-n;
  }
  m=SINT_NUMB(q);
 if(m<0){
      sig=-sig;
      m=-m;
  }
  if((n&unsafemul)||(m&unsafemul)){
   if(sig<0) n=-n;
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
   mpz_mul(mpzwork1,mpzwork1,mpzwork2);
   return mpz_check16(mpzwork1);
  }
 if(sig<0) n=-n;
 return MAKESINT(n*m);
}

ptr mod(ptr p,ptr q){
INT n,m;
 n=SINT_NUMB(p);
 m=SINT_NUMB(q);
 n=n%m;
 if(m>0&&(n<0)) n+=m;
 if(m<0&&(n>0)) n+=m;
 return MAKESINT(n);
}

ptr remain(ptr p,ptr q){
INT n,m;
 n=SINT_NUMB(p);
 m=SINT_NUMB(q);
 return MAKESINT(n%m);
}


ptr intdiv_sint(ptr p,ptr q){
INT n,m,r;
  n=SINT_NUMB(p);
  m=SINT_NUMB(q);
  r=n%m;
  if(r==0) return MAKESINT(n/m);
   mpz_set_si(mpzwork1,n);
   mpz_set_si(mpzwork2,m);
  return mpz2rational(mpzwork1, mpzwork2);
}

/** quotient ***/
ptr div_sint(ptr p,ptr q){
INT n,m,r;
  n=SINT_NUMB(p);
  m=SINT_NUMB(q);
   return MAKESINT(n/m);
}

 
  

