/*** 
   str2num.c
    string->number 
    04.8.3 created
***/

#define STR2NUM

#include "lisp.h"
#include <ctype.h>
#include <strings.h>
#include "clread.h"


#define T_INT    1
#define T_RATIO  2
#define T_FLOAT  3
#define T_COMP   4
#define T_10dot     5     /***    digit .  **/

/***  No good  this macro!!!
     #define is_expo(c)  ((c)=='e'||(c)=='d'||(c)=='E'||(c)=='D')
     #define is_sign(c) ((c)=='+')||((c)=='-')
***/

extern ptr intdiv();

 int  base;  /*** used in token.c ***/
 static int  gl_sign; 
 static  char top_sig;

static ptr complex_match(), complex_match_i(), make_str2real();
static ptr make_str2complex(), str2number_c(),makeratio();

int is_exdigit(c)
   Reg int c;
  {
    if(c<'0') return NO;
    else if(c<='9')
      {
        c-='0';
        if(c<base) return YES;
      }
    else if(base>10)
      {
       c=tolower(c)-'a'+10;
       if(c>=10&&c<base) return YES;
      }
    return NO;
  }

int count_exdigit(p)
  Reg char *p;
 {
  Reg int n=0;
   while(is_exdigit(*p++))
    {
     n++;
    }
  return n;
 }

int count_digit(p)
  Reg char *p;
 {
  Reg int n=0;
   while(isdigit(*p++))
    {
     n++;
    }
  return n;
 }

int is_expo(int c)
{
  return 
  (c=='e'||c=='d'||c=='E'||c=='D');
}

int is_sign(int c)
{
   return (c=='+')||(c=='-');
}

static Uchar *skip_sign(p)
  Reg Uchar *p;
 {
    gl_sign=0;
    if(*p=='-')
     {
        top_sig='-';
        gl_sign=YES;
        p++;
     }
  else if(*p=='+'){
             p++;
             top_sig='+';
  }
   return p;
 }

int is_exponent(q)
  Reg Uchar *q;
 {
  Reg Uchar *p=q;
  Reg int c;

  if(is_expo(*p++))
  {
   p=skip_sign(p);
   p+=(c=count_digit(p));
   if(c&&(*p==0)){
      return T_FLOAT;
     }
  }
  return NO;
}

is_integer(Reg unsigned char *p) 
{
  Reg int sign=0,c,n;
  Reg unsigned char  *q;

  top_sig=0;
  p=skip_sign(p);
  n=count_exdigit(p);
  if(n){
    if(*(p+n)==0){
         return T_INT;
     }
  }
  if((base>=10)&&(n==0)) return NO;
  if(base!=10)
     n=count_digit(p);
  if(n){
     q=p+n;
    if((*q=='.')&&(*(q+1)==0))
          return T_10dot;
  }
  return NO;
}

is_ratio(Reg Uchar *p)
{
  Reg Uchar *q;
    q=(Uchar *)index((char *)p,'/');
    if(q==NULL) return NO;
    *q=0;
    if(is_sign(*(q+1))) goto notr;
    if(is_integer(p)&&is_integer(q+1)){
         *q='/';
         return T_RATIO;
    }
  notr: *q='/';
          return NO;
}

is_float(Reg unsigned char *p)
{
   Reg unsigned char *q;
   Reg int n;

   p=skip_sign(p);
   n=count_digit(p);
   if(n){
       q=p+n;
       if(*q==0) return NO;
       if(*q=='.') q=q+1+(n=count_digit(q+1));
       if(*q==0){
             if(n==0) return NO;
             return T_FLOAT;
        }
       if(is_exponent(q)) 
            return T_FLOAT;
       return NO;
    }
   if(*p=='.'){
     n=count_digit(p+1);
     if(n){
        q=p+1+n;
        if(*q==0) return T_FLOAT;
       if(is_exponent(q)) 
            return T_FLOAT;
     }
   }
  return NO;
}
        
is_real(Reg unsigned char *p)
{
 Reg int n;
 if(n=is_integer(p)) return n;
 if(n=is_ratio(p)) return n;
 if(n=is_float(p)) return n;
 return NO;
}

static ptr get_complex(Reg Uchar *p)
{
  Reg Uchar *q,*r=p;
  Reg int n,sig;
  ptr s;
   top_sig=0;
   p=skip_sign(p);
   sig=top_sig;  /** l_sign;**/
   if(*p=='i'){
     p++;
     if(top_sig){
        if(*p==0){
            return complex(ZERO,gl_sign?MINUSONE:ONE);
         }
        else{
         if(is_sign(*p)) return a_f; 
         if(n=is_real(p)){
           --p;
           *p=sig;
           s=make_str2complex(NULL,NULL,p,n);
           *p='i';
           /***
           if(sig){
              psh(s);
              s=genmul(MINUSONE,s);
              pull();
           }
           ***/
           return s;
            /***      return T_pureimag;   sgn i real  ***/
         }
       }
     }
     return a_f;
   }
  q=p+strlen((char *)p);
  if((*--q)=='i'){
     *q=0;
     if((n=is_real(r))){
        s= make_str2complex(NULL,NULL,r,n);
       *q='i';
       return s;
    }
    s=complex_match(r);
    *q='i';
    return s;
 }
 return complex_match_i(r); /***  real+i real ***/
} 

static unsigned char * index_sign(Reg unsigned char *p)
{
  Reg char c;
  while(c=*p++){
   if(is_sign(c)) return p-1;
  }
  return NULL;
}

/***   case  ........i  &&  the last  i is  set to 0 ****/       
/***   1+i   OK  ***/
static ptr complex_match(Reg unsigned char *p)
{
 Reg unsigned char *q,*r=p;
 Reg int n,m,sg;
 ptr s;

 if(n=is_real(r))  return make_str2complex(0,0,r,n); /** pure imag **/
 r++;
 while(1){
   q=index_sign(r);
   if(q==NULL) return a_f;
   sg=*q;
   *q=0;
   if(n=is_real(p)){
       if(*(q+1)==0){ /** 1-i***/
        s=make_str2real(p,n);
        psh(s);
        s=(sg=='+')?ONE:MINUSONE;
        s=complex(*(stack-1),s);
        pull();
        return s;
      } 
      else if((!is_sign(*(q+1)))&&(m=is_real(q+1))){
       s=make_str2real(p,n);
       psh(s);
       *q=sg;
       s=make_str2real(q,m);
       psh(s);
       s=complex(*(stack-2),s);
       sp_pull(2); 
       return s;
     }
   }
   *q=sg;
   r=q+1;
 }
}

/*** case  ....+i....  ***/
static ptr complex_match_i(Reg Uchar *p)
{
Reg Uchar *q,*r=p;
 Reg int n,m,sg;
 ptr s;
 r++;
 while(1){
   q=index_sign(r);
   if(q==NULL) return a_f;
   sg=*q;
   if(*(q+1)!='i'){
      r=q+1;
      continue;
   }
   sg=*q;
   *q=0;
   if(n=is_real(p)){
      *(q+1)=sg;
      if(m=is_real(q+1)){
       s=make_str2complex(p,n,q+1,m);
       *(q+1)='i';
       *q=sg;
       return s;
     }
       *(q+1)='i';
   }
   *q=sg;
   r=q+1;
 }
}  


static ptr make_str2real(Reg Uchar *p,Reg int type)
{
 Reg int n;
 double _atof();

   switch(type){
      case T_INT: p=skip_sign(p);
             return makenumsub(gl_sign,base,p);
      case T_10dot: return makenum(p,10);
      case T_RATIO:
                  return makeratio(p,base);
      case T_FLOAT:
             return MAKEDBL(_atof(p));
      default:
           break;
 }
 return a_f;
}

static ptr make_str2complex(Uchar *p,int n,Uchar *q,int m)
{
  ptr u;
 if(p==NULL) u=ZERO;
 else
  u=make_str2real(p,n);
 psh(u);
  u=make_str2real(q,m);
  psh(u);
  u=complex(*(stack-2),u);
  sp_pull(2);
  return u;
}

ptr str2number(Reg ptr str,int radix)
{
  int n;
  unsigned char *p;
   p=get_string(str,&n);
   return str2number_c(p,radix);
}   
  
static ptr str2number_c(Reg Uchar *p,int radix)
{
 Reg int n,b;
 ptr s;
  b=base;
  base=radix;
  n=is_real(p);
    /*** printf(" str2number  is_real %d %s\n",n,p); ***/ 
  if(n)  s=make_str2real(p,n);
  else s=get_complex(p);
  base=b;
  return s;
}

ptr str2num(Reg unsigned char *p)
{
 Reg int n;
  n=is_real(p);
   /** printf(" is_real %d\n",n); **/
  if(n) return make_str2real(p,n);
 return get_complex(p);
}

ptr s_str2num(int narg,ptr env)
{
  Reg unsigned char *p;    
  int n,b;
  Reg ptr  s;
  b=base;
  if(narg==1){
     s=*(stack-1);
     base=10;
  }

  else if(narg==2){
     s=*(stack-2);
     base=GETNUM(*(stack-1));
  }
  else checknarg(narg-2);
  p=get_string(s,&n);
  s=str2num(p);
  base=b;
  return s;
} 

/*** for sharp.c ***/
ptr g_radix(lpath,k,ch)
  ptr lpath;
  Reg int k;
  Reg ptr ch;
 {
    Reg Uchar *p=(Uchar *)tokstr;
    ptr s;
        extoken(lpath);
        s=str2number_c(p,k);
        if(s==a_f)
            error(E_syntax_read,ch);
        return s;
 }

double _atof(p)
  Reg char *p;
{
   Reg char *q=p,c,memo,*r=NULL;
   double x;
   double atof(); /*  C function */
   while(c=*q++)
    {
      c|=0x20;  /** tolower **/
      if(c=='d')  /*** ||c=='s'||c=='f'||c=='l')***/
       {
         r=q-1;
         memo=*r;
         *r='e';
         break;
       }
    }
   x=atof(p);
   if(r) *r=memo;
   return x;
 }

static ptr makeratio(p,radix)
  Reg Uchar *p;
  Reg int radix;
{
  Reg Uchar *q;
  Reg ptr u;
     q=(Uchar *)index((char *)p,'/');
       *q=0;
         u=makenum(p,radix);
        psh(u);
        *q='/';
        psh(makenum(q+1,radix));
        u=intdiv(u,*(stack-1));
      sp_pull(2);
   return u;
 }

