/*** stream.c   
****/
#define  STREAM_C

#include "lisp.h"
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include "ss_stream.h"
    
extern ptr socket_writestr();

ptr func_writestr();    /* for naibu-kansuu  */
ptr str_writestr();    /* for naibu-kansuu  */

/********
     lisp の総てのio をここに集中する。
     port による, file とstring,func へのread,write を
     可能にする。
     ただし,  open 関係はopen.c へ  
     次の拡張が考えられる。stream として任意の関数を含ませるのである。
　　　input streamに対しては、これは2paraの関数で値charを返す関数である。
　　　
      この関数は、第１引数に値 :open  を受けたときは初期化を行う。
      このとき弟2引数はoption parameterのリストである。
      :close
      を受けたとき
　　　close処理をする。第２引数は、常にeof-objである。
      openに失敗したときは、errorまたは#fを返す。
      :ready ならchar-ready?に対して答える。
      :input なら1文字を返す。
       [Ver1.99]
          :open    if support return :unread
          :unread char     

　　　　output streamに対しては、これは2para関数である。第１引数は,readと同じで
　　　第２引数はcharである。 close処理では
      関数に対して、:close,eof-obj を与える、そしてclose関数は
　　　関数の返す値を返す。
　　　flushは、関数に:flush ,eof-objを与える。これも関数の値を返すことにする。
      :outputのときは1文字出力を行なう。
　　　reopenは、関数に2,eof-objを与える。関数はclose,flushを無視して良いが、
　　　reopenに対しては、不可能なら#fを返さなければならない。成功は#t
      である。
　　　unreadc,漢字処理はシステムで行う。関数は漢字処理をしてもしなくても良い。
****/
extern ptr makestream();
extern ptr makefilestream();

static ptr lreadc_file(),close_socket( ),func_readc(), close_func(), str_readc();
/***  2004.1.3  New alloc buff by Mymalloc ***/
/***
ptr make_buff(int n){
     ptr c,s;
       s=(ptr )Mymalloc(n+1);
       c=new_cell(MALLOC);
       CDR(c)=(ptr) n;  ** for gbc Caution!  *
       CAR(c)=s;
   return c;
}
***/
static unsigned char readbuf[10];

/*** ptr a_stdin,a_stdout,a_stderr;   in lisp.h  ***/
/*** ptr a_stdin_r,a_stdout_r,a_stderr_r;  ** 保存用  ***/

    

/***  stream is a list & type=STREAM 
    ( access|state  (FILE *)   LOC .  file-name )
    ( access|state  location   LOC .  string   )
    ( access|state  location   LOC .  lambda  )
     caddr=LOC, cdddr string , cadr truesize, car  access
     location is  (INT,  not SINT, bytes)
     access is INT  , not SINT
     LOC is UNREADC (for input)
         is location of in 1-line (formatで使う)
            this is  INT   not SINT
     However socket stream is bi-direction
     so we can not use LOC for UNREADC 
      then we use location for UNREADC of SOCKET_PORT!!!
    ( access|state  UNREADC   LOC .  (socket-data . addr ) )  SOCKET
    GBC caution!!!    access,FILE* ,location LOC are not SS object!!    
    VER1.82
      we will use  fileno & don't use FILE *
      so we begin with
    ( access|state  FILE    LOC .  ( MALLOC . file-name  ))
         FILE = fp 
       this will be changed to 
         FILE = fileno    (not SINT) | input-location<<16
         MALLOC=(io-buffer . location)
    V2.0  change
       LOC  ---> (WLOC . RLOC)
      
***/ 


ptr close_sub(),close_str();

/*** int stdtbl[3];    0,1,2の保存用  ***/

int sed_flag=0;  /** line-editor用  mada ! ***/

void init_file(){
 ptr p;
   p=a_keyinput=makefilestream(read_ac,0,CMAKESTR("stdin")); /*** for ready ***/
   ATOMVAL(a_stdin)=CONS(p,a_nil);
   ATOMVAL(a_stdout)=CONS(p=makefilestream(write_ac,1,CMAKESTR("stdout")),a_nil);
   set_pos('\n',p);
   ATOMVAL(a_stderr)=CONS(p=makefilestream(write_ac,2,CMAKESTR("stderr")),a_nil);
   set_pos('\n',p);
   ATOMVAL(a_stdmsg)=STDERR;
   ATOMVAL(a_stdnull)=makefilestream(write_ac,NULLFDP,CMAKESTR("sdtnull"));
   /** istty=tty_raw(0); ***/  
   init_redirect();
   /** if(istty) tty_reset(0);  ***/
}

int check_port(ptr stream)
{  /*** check stream & return stream ***/
  int n;
   if(SREGP(stream)||!(ATTR(stream)&STREAM)) error(E_path,stream);
   return ACC(stream);
}

/******   write to closed port is error!, return acc  ****/
int check_closed(ptr port){
 Reg int acc;
 acc=check_port(port);
 if(acc&CLOSED) error(E_path,port);
 return acc;
}

int check_input(ptr port){
 Reg int acc;
 acc=check_port(port);
 if(acc&CLOSED) error(E_path,port);
 if(acc&read_ac) return acc;
 error(E_path,port);
 return acc;
}

int check_output(ptr port){
 Reg int acc;
 acc=check_port(port);
 if(acc&CLOSED) error(E_path,port);
 if(acc&write_ac) return acc;
 if(acc&append_ac) return acc;
  error(E_path,port);
 return acc;
}

ptr s_port_pred(int narg,ptr env){
ptr port;
Reg int acc;
checknarg(narg-1);
port=*(stack-1);
   if(SREGP(port)) return a_f;
if(ATTR(port)&STREAM) return a_t;
return a_f;
}

ptr s_input_port(int narg,ptr env){
ptr port;
Reg int acc;
checknarg(narg-1);
port=*(stack-1);
   if(SREGP(port)||!(ATTR(port)&STREAM)) return a_f;
acc=ACC(port);
return PRED(acc&read_ac);
}

ptr s_output_port(int narg,ptr env){
ptr port;
Reg int acc;
checknarg(narg-1);
port=*(stack-1);
   if(SREGP(port)||!(ATTR(port)&STREAM)) return a_f;
acc=ACC(port);
return PRED(acc&output_ac);  /*** output_ac=write or append ***/
}

ptr s_close_port(int narg,ptr env){
ptr port;
Reg int acc;

checknarg(narg-1);
port=*(stack-1);
   if(SREGP(port)||!(ATTR(port)&STREAM)) return a_f;
/** printf("%x ",port); ***/
acc=ACC(port);
return PRED(acc&CLOSED);
}

  
ptr s_close(int narg,ptr env){
ptr port,s;
checknarg(narg-1);
port=*(stack-1);
 check_port(port);
 s=sys_close(port);
return s;
}

ptr s_close_input(int narg,ptr env){
ptr port,s;
Reg int acc;
checknarg(narg-1);
port=*(stack-1);
check_input(port);
 s=sys_close(port);
return s;
}

ptr s_close_output(int narg,ptr env){
ptr port,s;
Reg int acc;
checknarg(narg-1);
port=*(stack-1);
check_output(port);
 s=sys_close(port);
return s;
}

int  ssfileno(lpath)
  Reg ptr lpath;
 {
   Reg int fp; 
   Reg int path,acc;
   acc=ACC(lpath);
   if(STR_PORT&acc)  return -1;
   if(FUNC_PORT&acc)  return -1;
   if(SOCKET_PORT&acc)  return get_socket_fdp(lpath);
   if(acc&CLOSED) return -1;
   fp=(long)FDP(lpath);  /** New ***/
   if(fp==-1) return fp;
      /*** return fileno(fp); ***/
  return fp&0xffff;
}

/****   Only for file-stream or socket-stream  ***/
void set_stream_fdp(ptr lpath,int fdp)   /*** used by redirect.c  ***/
{
  Reg int acc;
   acc=ACC(lpath);
     if(acc&SOCKET_PORT)
          set_socket_fdp(lpath,fdp);
     else
         FDP(lpath)=(ptr)(((long)FDP(lpath)&0xffff0000)|fdp); 
}

ptr s_fileno(int narg,ptr env){
   ptr port;
   Reg int fd;
  checknarg(narg-1);
  port=*(stack-1);
  check_port(port);
  fd=ssfileno(port);
  if(fd==-1) return a_f;
  return MAKESINT(fd);
}

ptr s_stfilename(int narg,ptr env){
   ptr port;
   Reg int acc;
  checknarg(narg-1);
  port=*(stack-1);
  check_port(port);
   acc=ACC(port);
   if(acc&EXT_PORT) return a_f; 
    return STFNAME(port);
}


ptr sys_close(lpath)
  Reg ptr lpath;
 {
   Reg int fp; /*** ILE *fp;  ***/
   Reg int path,acc;
   Reg ptr ret;
   acc=ACC(lpath);
    /*** printf("close %x sixe %d \n",acc,STR_RSIZE(lpath)); ***/
   ret=a_t;
   if(STR_PORT&acc){
          ret=close_str(lpath);
          goto out;
    }
   if(FUNC_PORT&acc){
       ret=close_func(lpath);
       goto out;
   }
   if(SOCKET_PORT&acc){
         ret= close_socket(lpath);
         goto out;
    }
   if(acc&CLOSED) return a_t;
   fp=(long)FDP(lpath);  
   if(fp!=EOF)
     {
   /** printf("close %d %x\n",path,fp); ***/
       if((acc&write_ac)||(acc&append_ac))
          ssflush(fp,SSFDP(lpath));
       /*** fclose(fp); ***/
        close(fp&0xffff);
     }
  out:
    if(ret!=a_f)
           ACCSET(lpath)=(ptr)((long)ACC(lpath)|CLOSED);
   return ret;
}

 
ptr  lreadc(lpath)    /* for naibu-kansuu  */
    Reg ptr lpath;
 {
   Reg int acc,c,ct;
   int fp;   /*** FILE *fp; ***/
     acc=check_input(lpath);
     if(STR_PORT&acc) return str_readc(lpath);
     if(FUNC_PORT&acc) return func_readc(lpath);
     if(SOCKET_PORT&acc) return socket_readc(lpath);
    if(acc&CLOSED) return SEOF;
    if(lpath==a_keyinput&&istty)    
    {
        return MAKECHAR(tty_getchar());
//        return MAKECHAR(getchar());
    }
    else
     {
       /** c=getc(fp); **/
       return lreadc_file(lpath,FDP(lpath),SSFDP(lpath));
      }
    /***  if EOF return SEOF ***/
 }

static ptr lreadc_file(ptr lpath,int fdp,ptr ssfdp)
{
  Reg int loc,ct,readloc;
  Reg unsigned char *p;
    loc=(long)FDLOC(ssfdp);
    readloc=fdp>>16;
    fdp&=0xffff;
     p=(unsigned char *)FDBUFF(ssfdp);
    if((loc==0)||(loc==readloc)){
        ct=read(fdp,p,FILEBUFMAX);
        if(ct<=0)  /*** ==EOF) ***/
           return SEOF;
        loc=ct;
        FDLOC(ssfdp)=(ptr)(long)loc;
        readloc=0;
     }
    ct=*(p+readloc++);
    /*** memcpydown_s(p,p+1,--loc); ***/
    /*** CDR(ssfdp)=loc;  ***/
    FDP(lpath)=(ptr)(long)((readloc<<16)|fdp);
    return MAKECHAR(ct);
}

int lwritec_file(ptr lpath,int fdp,ptr ssfdp,int c)
{
  Reg int loc,ct;
  Reg unsigned char *p;
    loc=(long)FDLOC(ssfdp);
     p=(unsigned char *)FDBUFF(ssfdp);
#ifdef DEBUG
 /** printf("lwritec-file fdp %d  c %x loc %d buff %x str %s\n",fdp,c,loc,p,p); **/
#endif
    *(p+loc++)=c;
    FDLOC(ssfdp)=(ptr)(long)loc;
   if((loc==FILEBUFMAX)||((c=='\n')&&((lpath==STDOUT)||(lpath==STDERR)))){
         ssflush(fdp,ssfdp);
         /*** loc=0; ***/
    }
}

ssflush(int fdp,ptr ssfdp)
{
  Reg int loc,ct;
  Reg unsigned char *p;
     /*** fdp=fdp;     *  to be change!!!  ***/
     if(fdp==NULLFDP) {
          FDLOC(ssfdp)=0;
            return;}  /***  null device !!! ****/
     loc=(long)FDLOC(ssfdp);
     if(loc==0) return;
     p=(unsigned char *)FDBUFF(ssfdp);
     ct=write(fdp,p,loc);   /***    Caution !!!!  ***/
     if(ct!=loc){
          perror("write failed");
          error(E_closed,a_nil);
     }
     FDLOC(ssfdp)=0;
}


void lwritec(ptr lpath, int c)    /* for naibu-kansuu  */
 {
   Reg int acc;
     acc=check_output(lpath);
#ifdef DEBUG
    /**  printf("lwritec lpath %x  c %x acc %x\n",lpath,c,acc); **/
#endif
     set_pos(c,lpath);
     if(STR_PORT&acc){
        str_writec(lpath,c);
        return;
      }
     if(FUNC_PORT&acc){
           func_writec(lpath,c);
          return;
     }
     if(SOCKET_PORT&acc){
           socket_writec(lpath,c);
          return;
     }
    /*** fputc(c,FDP(lpath));   **  New11! ***/
     lwritec_file(lpath,(int)(long)FDP(lpath),SSFDP(lpath),c);
 }

ptr lwritestr(ptr lpath, char *p)    /*  p is pointer of C-string for naibu-kansuu  */
 {
   Reg int acc,c;
    /** printf("lwritestr  lpath %x stdout %x  str %s\n",CADR(lpath),stdout,p); **/
     acc=check_output(lpath);
        if(STR_PORT&acc)  return str_writestr(lpath,p);
        if(FUNC_PORT&acc)  return func_writestr(lpath,p);
        if(SOCKET_PORT&acc)  return socket_writestr(lpath,p);
     while(c=*p++){
        set_pos(c,lpath);
     lwritec_file(lpath,(int)(long)FDP(lpath),SSFDP(lpath),c);
    }
   return a_undef;
 }


ptr lfflush(ptr lpath)    /* for naibu-kansuu  */
 {
   Reg int acc;
   Reg ptr func;
     acc=check_closed(lpath);
       if(STR_PORT&acc)  return a_undef;
       if(FUNC_PORT&acc) {
          psh(k_flush);
          psh(SEOF);
          func=ST_FUNC(lpath);
          func=funcall(func,2,a_nil);
          stack-=2;
          return func;
       }
       if(SOCKET_PORT&acc){
            if(acc&listen_ac) return a_f;
            socket_flush(lpath);
            return a_undef;
          }

       /*** fflush(FDP(lpath));  ** New!! ***/
      ssflush((int)(long)FDP(lpath),SSFDP(lpath));
      return a_undef;
 }


void str_writec(ptr lpath, int c)    /* for naibu-kansuu  */
 {
   ptr str,stb;
  int n,loc,m;
  Uchar *p,*q;
   stb= STB(lpath); 
   str=STB_STR(stb);
   m=(long)STB_RSIZE(stb);
   p=get_string(str,&n);
   /**  printf("**** ste writec get ****  %d \n",m); ***/
   loc=(long)CDR(str);
   if(loc+4>=m){
       extend_str(str,m+m+10);
       p=get_string(str,&n);
       STB_RSIZE(stb)=(ptr)(long)(n|1);
   /** printf(" str_writec  extend m  %d size %d\n",m,n); **/
   }
   *(p+loc)=c;
   CDR(str)=(ptr)(long)++loc;
}

ptr str_back_writec(ptr lpath)    /* New  1.99  */
 {
   ptr str,stb;
  int n,loc,c,wloc;
  Uchar *p;
   stb= STB(lpath);
   str=STB_STR(stb);
   wloc=(long)STB_WLOC(stb);
   p=get_string(str,&n);
   /**  printf("**** ste writec get ****  %d \n",m); ***/
   loc=(long)CDR(str);
  if(loc>0){
      if(wloc>0)
            STB_WLOC(stb)=(ptr)(long)--wloc;
      --loc;
      p+=loc;
       c=*p;
       *p=0;
       CDR(str)=(ptr)(long)loc;
       if(c=='\n'||c==PAGE) str_set_pos(lpath);
       return MAKECHAR(c&0xff);
    }
   return MAKECHAR(SEOF);
}

func_writec(ptr lpath, int c)    /* for naibu-kansuu  1 byte only  */
 {
   ptr func;
  int n,loc,m;
  char *p,*q;
   func=ST_FUNC(lpath);
   /*** printf("func wrtiec  %c func %x\n",c,func); ***/
   psh(k_output);
   psh(MAKECHAR(c&0xff));
   funcall(func,2,a_nil);
   stack-=2;
}

ptr func_rpos(ptr lpath)    /* for naibu-kansuu  1 byte only  */
 {
   ptr x,func;
  int n,loc,m;
  char *p,*q;
   func=ST_FUNC(lpath);
   /*** printf("func wrtiec  %c func %x\n",c,func); ***/
   psh(k_readpos);
   psh(SEOF);
   x=funcall(func,2,a_nil);
   stack-=2;
   return x;
}

ptr func_set_rpos(ptr lpath, ptr c)    /* for naibu-kansuu  1 byte only  */
 {
   ptr x,func;
   func=ST_FUNC(lpath);
   /*** printf("func wrtiec  %c func %x\n",c,func); ***/
   psh(k_set_readpos);
   psh(c);
   x=funcall(func,2,a_nil);
   stack-=2;
   return x;
}

ptr func_shift_rpos(ptr lpath, ptr c)    /* for naibu-kansuu  1 byte only  */
 {
   ptr x,func;
   func=ST_FUNC(lpath);
   /*** printf("func wrtiec  %c func %x\n",c,func); ***/
   psh(k_shift_readpos);
   psh(c);
   x=funcall(func,2,a_nil);
   stack-=2;
   return x;
}


ptr func_back_writec(ptr lpath)    /* New 1.99  */
 {
   ptr func,c;
  int n,loc;
  char *p,*q;
   func=ST_FUNC(lpath);
   /*** printf("func wrtiec  %c func %x\n",c,func); ***/
   psh(k_unwrite);
   psh(SEOF);
   c=funcall(func,2,a_nil);
   stack-=2;
   return c;
}

ptr back_writechar(ptr lpath){
 int acc;
  acc=check_output(lpath);
  if((acc&(long)FUNC_PORT)&&(F_ACC(lpath)&unwrite_ac))
          return func_back_writec(lpath);
   else if(acc&STR_PORT)
          return str_back_writec(lpath);
   else
       error(E_path,lpath);
   return a_f; /*** never reach  ***/
}




func_writestr_orig(ptr lpath, char *p)    /* for naibu-kansuu  */
 {
  int n;
    while(n=*p++){
      func_writec(lpath,n);
    }
}

ptr func_writestr(ptr lpath, char *pc)    /* for naibu-kansuu  */
 {
    ptr func,ch;
  int n,loc;

   func=ST_FUNC(lpath);
  /***  loc=F_WLOC(lpath);  ***/
   psh(k_output);
   stack++;
   while(n=*pc++){
     set_pos(n,lpath);
     /*** loc++; ***/
     *(stack-2)=k_output;
     *(stack-1)=MAKECHAR(n&0xff);
     funcall(func,2,a_nil);
  }
  stack-=2;
  /**  F_WLOC(lpath)=loc;   ***/
  return a_undef;
}


ptr str_writestr(ptr lpath, char *pc)    /* for naibu-kansuu  */
 {
    ptr str,stb;
  int n,loc,m,k;
  Reg Uchar *p,*q;
    /*** printf("**** ste writestr ****  %s\n",pc);  ***/
   stb=STB(lpath);
   str=STB_STR(stb);
   loc=(long)CDR(str);
   p=get_string(str,&n);
   m=(long)STB_RSIZE(stb);
   k=strlen(pc);
   if(loc+k+3>=m){
       extend_str(str,m+m+k+3);
      p=get_string(str,&n);
      STB_RSIZE(stb)=(ptr)(long)(n|1);
   }
   p+=loc;
   loc+=k;
   while(k--) {
     set_pos(n=*pc++,lpath);
    *p++=n;
    }
   CDR(str)=(ptr)(long)loc;
  return a_undef;
}


int sedinkey(int echo,int wait){
  Reg int n,m,s;
  n=inkey(echo,wait);
  if((!kanji_mode)||(n<128)) return n;
  m=inkey(echo,NO);
  if(m==-1) return n;
  if(kanji_mode==3){  /*** utf8  **/
  s=inkey(echo,NO);
  if(s==-1) return (n<<8)+m;
  return (n<<16)+(m<<8)+s;
  }
  return (n<<8)+m;
}

ptr s_inkey(int narg,ptr env)
 {
    Reg int echo,n,wait;
    wait=1;
    if(narg==0) echo=1;
    else if(narg==1)
      echo=(*(stack-1)!=a_f);
    else if(narg==2){
      echo=(*(stack-2)!=a_f);
      wait=(*(stack-1)!=a_f);
     }
    else
      checknarg(narg-2);
    n=sedinkey(echo,wait);
    return MAKECHAR(n);
 }

static ptr str_readc(ptr lpath)
 {
  ptr str;
  unsigned int loc,n;
  unsigned char *p;
   str=ST_STR(lpath);
   p=get_string(str,&n);
   loc=(unsigned long)STR_RLOC(lpath);
   /*** loc=(int)CDR(str);  ***/
  if(loc>=n) return SEOF;
   p+=loc;
   STR_RLOC(lpath)=(ptr)(long)++loc;   /***  kanji is handled upper routine, read-char ***/
  return MAKECHAR(*p);
}

static ptr str_rpos(ptr lpath)
 {
  ptr str;
  unsigned int loc;
   str=ST_STR(lpath);
   loc=(unsigned long)STR_RLOC(lpath);
  return MAKESINT(loc);
}

static ptr str_set_rpos(ptr lpath,int loc)
 {
  ptr str;
  unsigned int n;
   str=ST_STR(lpath);
   get_string(str,&n);
   /*** loc=(int)CDR(str);  ***/
  if(loc<0) error(E_range,loc);
  /*** if(loc>n) loc=n; ***/
   STR_RLOC(lpath)=(ptr)(long)loc; 
  return lpath;
}

static ptr str_shift_rpos(ptr lpath,int loc)
 {
  ptr str;
  unsigned int n;
   str=ST_STR(lpath);
   get_string(str,&n);
   /*** loc=(int)CDR(str);  ***/
   loc=loc+(long)STR_RLOC(lpath);   /***  loc+=  Don't work  ***/
   /*** printf("shift read pos %d\n",loc);  ***/
  if(loc<0) error(E_range,loc);
  /*** if(loc>n) loc=n;  ***/
   STR_RLOC(lpath)=(ptr)(long)loc;
  return lpath;
}


static ptr func_readc(ptr lpath)
 {
  ptr func,c;
  unsigned int loc;
   func=ST_FUNC(lpath);
   psh(k_input);
   psh(SEOF);
   c=funcall(func,2,a_nil);
  stack-=2;
  return c;
}

ptr func_unread(ptr x,ptr lpath)
 {
  ptr func,c;
  unsigned int loc;
   /*** loc=F_RLOC(lpath); ***/
   func=ST_FUNC(lpath);
   psh(k_unread);
   psh(x);
   c=funcall(func,2,a_nil);
  stack-=2;
  /***  F_RLOC(lpath)=--loc;   **  kanji is handled upper routine, read-char ***/
  return c;
}


ptr func_port_ready(ptr lpath)
 {
  ptr func,c;
  unsigned int loc;
   func=ST_FUNC(lpath);
   psh(k_ready);
   psh(SEOF);
   c=funcall(func,2,a_nil);
  stack-=2;
  return c;
}

static ptr func_get_pos(ptr lpath)
 {
  ptr func,c;
  unsigned int loc;
   func=ST_FUNC(lpath);
   psh(k_getpos);
   psh(SEOF);
   c=funcall(func,2,a_nil);
  stack-=2;
  return c;
}

static ptr func_set_pos(ptr x,ptr lpath)
 {
  ptr func,c;
  unsigned int loc;
   /*** loc=F_RLOC(lpath); ***/
   func=ST_FUNC(lpath);
   psh(k_setpos);
   psh(x);
   c=funcall(func,2,a_nil);
  stack-=2;
  /***  F_RLOC(lpath)=--loc;   **  kanji is handled upper routine, read-char ***/
  return c;
}
  
ptr close_str(lpath)
  Reg ptr lpath;
{
 Reg ptr q;
 Reg int n;
   q=ST_STR(lpath);
   return copy_str(q);
}

static ptr close_func(lpath)
  Reg ptr lpath;
{
 Reg ptr q;
   q=ST_FUNC(lpath);
   psh(k_close);
   psh(SEOF);
   q=funcall(q,2,a_nil);
  stack-=2;
   return q;
}

static ptr close_socket( ptr lpath)
{
 int soc,acc;
   if((int)ACC(lpath)&write_ac )
        socket_flush(lpath);
   close(soc=get_socket_fdp(lpath));
   return MAKESINT(soc);
}


/*****   (stdio-push! n stream)   n=0,1,2  ***/
ptr s_stdio_push(int narg,ptr env){
 ptr port;
 int path;

  checknarg(narg-2);
  port=*(stack-1);
  path=SINT_NUMB(*(stack-2));
 switch(path){
    case 0: ATOMVAL(a_stdin)=CONS(port,ATOMVAL(a_stdin));
       break;
    case 1: 
           ATOMVAL(a_stdout)=CONS(port,ATOMVAL(a_stdout));
         break;
    case 2: 
           ATOMVAL(a_stderr)=CONS(port,ATOMVAL(a_stderr));
          break;
  }
  return a_undef;
}

/****   (stdio-pull! n)   ***/
ptr s_stdio_pull(int narg,ptr env){
 ptr port;
 int path;

  checknarg(narg-1);
  path=SINT_NUMB(*(stack-1));
 switch(path){
    case 0: port=STDIN;
            ATOMVAL(a_stdin)=CDR(ATOMVAL(a_stdin));
         break;
    case 1: port=STDOUT;
            ATOMVAL(a_stdout)=CDR(ATOMVAL(a_stdout));
       break;
    case 2: port=STDERR;
            ATOMVAL(a_stderr)=CDR(ATOMVAL(a_stderr));
       break;
  }
  return port;
}

ptr s_stdin(int narg,ptr env){
  checknarg(narg);
  return STDIN;
}

ptr s_stdout(int narg,ptr env){
  checknarg(narg);
  return STDOUT;
}

ptr s_stderr(int narg,ptr env){
  checknarg(narg);
  return STDERR;
}

set_pos(int n,Reg ptr lpath){    /**** open.c stream.c  ***/
int pos;
   lpath=STB(lpath);
   pos=(long)STB_WLOC(lpath);
  if(n=='\n'||n==PAGE) pos=0;
  else pos++;
  STB_WLOC(lpath)=(ptr)(long)pos;
}

/***  get_pos called format.c formsub.c  ***/
get_pos(Reg ptr lpath){
   int acc=ACC(lpath);
   if((acc&FUNC_PORT)&&(F_ACC(lpath)&getpos_ac))
        return GETNUM(func_get_pos(lpath));
   lpath=STB(lpath);
   return (int)(long)STB_WLOC(lpath);
}

ptr s_get_pos(int narg,ptr env){
ptr p;
int acc;
if(narg==0)
  p=STDOUT;
else if(narg==1)
  p=*(stack-1);
else
  checknarg(narg-1);
acc=check_output(p);
if((acc&FUNC_PORT)&&(F_ACC(p)&getpos_ac))
     return func_get_pos(p);
else
   return MAKESINT(get_pos(p));
}

set_line_pos(int n,Reg ptr lpath){
   lpath=STB(lpath);
   STB_WLOC(lpath)=(ptr)(long)n;
}
                                                                                               
ptr s_set_line_pos(int narg,ptr env){
ptr p,pos;
int acc;
if(narg==1)
  p=STDOUT;
else if(narg==2)
  p=*(stack-1);
else
  checknarg(narg-2);
acc=check_output(p);
 pos=*(stack-narg);
 if((acc&FUNC_PORT)&&(F_ACC(p)&setpos_ac))
     return func_set_pos(pos,p);
else
 set_line_pos(GETNUM(pos),p);
 return p;
}


ptr s_flush(int narg,ptr env){
ptr p;
if(narg==0)
  p=STDOUT;
else if(narg==1)
  p=*(stack-1);
else
  checknarg(narg-1);
check_output(p);
return lfflush(p);
}

ptr s_read_pos(int narg,ptr env){
ptr p;
int acc;
if(narg==0)
  p=STDIN;
else if(narg==1)
  p=*(stack-1);
else
  checknarg(narg-1);

acc=check_input(p);
 if((acc&FUNC_PORT)&&(F_ACC(p)&readpos_ac))
      return func_rpos(p);
 else if(acc&STR_PORT)
      return str_rpos(p);
 else error(E_path,p);
return p;
}


ptr s_set_read_pos(int narg,ptr env){
ptr p,pos;
int acc;
if(narg==1)
  p=STDIN;
else if(narg==2)
  p=*(stack-1);
else
  checknarg(narg-2);
acc=check_input(p);
 pos=*(stack-narg);
 if((acc&FUNC_PORT)&&(F_ACC(p)&set_readpos_ac))
     return func_set_rpos(p,pos);
else if(acc&STR_PORT)
 str_set_rpos(p,GETNUM(pos));
else error(E_path,p);
 return p;
}

ptr s_shift_read_pos(int narg,ptr env){
ptr p,pos;
int acc;
if(narg==1)
  p=STDIN;
else if(narg==2)
  p=*(stack-1);
else
  checknarg(narg-2);
acc=check_input(p);
 pos=*(stack-narg);
 if((acc&FUNC_PORT)&&(F_ACC(p)&shift_readpos_ac))
     return func_shift_rpos(p,pos);
else if(acc&STR_PORT)
 str_shift_rpos(p,GETNUM(pos));
else error(E_path,p);
 return p;
}

                                                                                               
ptr s_port_function(int narg,ptr env){
ptr port;
int acc;
  checknarg(narg-1);
  port=*(stack-1);
 if(SREGP(port)||!(ATTR(port)&STREAM)) return a_f;
acc=ACC(port);
 if(acc&FUNC_PORT)
     return ST_FUNC(port);
 else
    return a_f;
}

ptr s_port_string(int narg,ptr env){
ptr port;
int acc;
  checknarg(narg-1);
  port=*(stack-1);
 if(SREGP(port)||!(ATTR(port)&STREAM)) return a_f;
acc=ACC(port);
 if(acc&STR_PORT)
     return ST_STR(port);
 else
    return a_f;
}

 
