/***   timer.c 
   timer_handler 
    04.07.10
    04.7.22  revised
    see note
    05.4.14   (after 100)
***/

#include "lisp.h"
#include <sys/time.h>
#include <signal.h>
#include <stdio.h>

extern ptr vm_eval();

/** #define DEBUG 1 **/
static struct itimerval val,oval;
static int timer_int,max_after,after_total,timer_active;
static int after_entry[AFTERMAX]; 
            /***  positive  interval( active) ,0 not entry, -1 reserve for que  ***/
static int after_timer[AFTERMAX];
static int time_past;
static int after_que;

static int after_sleep;  /***  for (after 100) only ***/

#define  SECMILI  2000    /****  Linux 1 sec is 2sec=2000 milisec in real time  ***/ 
#define  MICROMILI  500    
/****  Linux 1 micro is 2microsec=2/1000=1/500  milisec in real time***/ 

ptr after_cmd[AFTERMAX];   /***  needs gbc  ***/

void timer_start();
void timer_stop();
void exec_check();
ptr cmd_exec();
ptr s_update();

/*** init  ***/
void timer_init()
{
  Reg int i;
  for(i=0;i<AFTERMAX;i++){
    after_entry[i]=0;
    after_timer[i]=0;
    after_cmd[i]=a_nil;
  }
  after_total=max_after=0;
  timer_active=timer_int=0;  /** not active ***/ 
  time_past=0;
   sys_alarm=0;
   after_que=0;
}
/***  timer handler ***/
void timer_handler(int sig){
 sys_alarm++;
}

/*** timer_check should be re-entrant!!   05.4.22 ***/
void timer_check(){  /***  [1]3-5  ***/
 Reg int i,n,j,interval,min=100000000,exec_que=0;
  interval=sys_alarm*timer_int;
#ifdef DEBUG
 fprintf(stderr,"enter timer check  interval %d alarm %d total %d\n",
    interval,sys_alarm,after_total);  
#endif
  sys_alarm=0;
  after_total=0;
  after_que=0;
 for(i=0;i<=max_after;i++){
    j=after_entry[i];
    if(j==1){
        n=after_timer[i]-=interval;
       after_total++;
        if(n<=0){
#ifdef DEBUG
              printf("time come! %d\n",i); 
#endif
             after_entry[i]=2; /***  go state ***/
             exec_que++;
             after_total--;
             /*** cmd_exec(after_cmd[i]);  don't change after_cmd after this! ***/
                              /***  because cmd may call after!!! ***/
       }
      else if(n<min) min=n;
      else
          ;
    }
    else if(j==-1){
         after_entry[i]=1;
           n=after_timer[i];
          if(n<min) min=n;
          after_total++;
    }
   else
      ;
 }
  /*** timer_check_start();  ***/
  if(exec_que) exec_check();
  if(timer_active){
        timer_diff();
        timer_check();
 }
  else{
      if(after_total) timer_start(min); 
      else if(exec_que)
           timer_start(100);
      else
          ;
  } 
/***
  timer_diff();
  if(after_total) timer_start(min);
***/
#ifdef DEBUG
  printf("out timer check  after_total %d  min-interval %d que %d\n"
       ,after_total,min,after_que); 
#endif
}

void exec_check(){
  int i,j;
  for(i=0;i<=max_after;i++){
    j=after_entry[i];
    if(j==2){
#ifdef DEBUG
  printf("exec_check timer check  entry %d  d total %d\n",i,after_total);
#endif
             after_entry[i]=0; /***  clear ***/
             cmd_exec(after_cmd[i]); /***  don't change after_cmd after this! ***/
     }
  }
}

/***   interval is past time && return of MIN of rest time  ***/
int  timer_diff(){  /***  [2] 4-6  ***/
 Reg int i,n,min=100000000,interval;
  timer_stop();  /***  timer_int is set to 0 !!!***/
  interval=time_past;
 for(i=0;i<=max_after;i++){
    if(after_entry[i]==1){
        n=after_timer[i]-=interval;
        if(n<0){
            /*** min=0;   may be minus ****/
#ifdef DEBUG
               printf("minus timer ! %d\n",i);
#endif
       }
      else if(n<min) min=n;
      else
          ;
    }
 }
 return min;
}


void timer_start(int interval)
{
  Reg int sec=0,tint=interval;
            /***   printf("timer start interval %d\n",interval); ***/
  if(tint>=SECMILI){
      sec=tint/SECMILI;
     tint%=SECMILI;
  }
  val.it_interval.tv_sec=0;
  val.it_interval.tv_usec=0; /*** intial value ***/ 
  val.it_value.tv_sec=sec;
  val.it_value.tv_usec=tint*MICROMILI; /*** interval>= 10, 1unit=2 mu sec  ***/ 
    /***  10 m sec,  this is minimum in  current Linux system  **/
  setitimer(ITIMER_REAL,&val,0);
  if(interval)   /****  nedds!  because after timer stop , then timer check***/ 
      timer_int=interval;
  timer_active=interval;
}

void timer_stop()
{
  int time_rest;
    /***  10 m sec,  this is minimum in  current Linux system  **/
  getitimer(ITIMER_REAL,&oval);
  time_rest=oval.it_value.tv_usec/MICROMILI;
   time_rest+=oval.it_value.tv_sec*SECMILI;
  time_past=timer_int-time_rest;
  timer_start(0);
}


static ptr make_after_entry(int n,ptr cmd,int prop) /*** prop=1 entry prop=-1  for reserve **/
{
  Reg int i;
  for(i=0;i<AFTERMAX;i++){
    if(after_entry[i]==0) break;
  }
  if(i==AFTERMAX){
      lwritestr(STDERR,"after cmds over MAX!\n");
      error(E_after,a_nil);
   }
  if(prop==-1) 
       after_que++;
  else
       after_total++;
    
  after_entry[i]=prop;
  after_timer[i]=n;
  after_cmd[i]=cmd;
  if(i>max_after) max_after=i;
  return MAKESINT(i);
}

static ptr after_wait(){
  while(after_sleep){
    s_update(0,a_nil);
  }
 return a_undef;
}

ptr s_after(int narg,ptr env)
{
 ptr sec,cmd;
 int n,y,afsleep;
  if(narg==1){
  afsleep=after_sleep=1;
  sec=*(stack-1); 
  cmd=ZERO;
  }
  else  if(narg==2){
  sec=*(stack-2); 
  cmd=*(stack-1);
  afsleep=0;
  }
  else  checknarg(narg-2);

  if(!SINTP(sec)){
      lwritestr(STDERR,"interval < 500000000 (5 days)\n");
      error(E_range,sec);
  }
  n=GETNUM(sec);
  if(n<20) n=20;
  if(!timer_active)
   {
       if(after_total){  /*** never occur? ***/
           cmd=make_after_entry(n,cmd,-1); /*** reserve  **/
          timer_check();  
           goto afterout;
        }
        else{
           cmd=make_after_entry(n,cmd,1); /*** entry  **/
           timer_start(n);
           goto afterout;
        }
   }
  if(sys_alarm){
        /**  printf("s-after  sys_ alarm %d\n",sys_alarm);  ***/ 
         cmd=make_after_entry(n,cmd,-1); /*** reserve  **/
         timer_stop();
         timer_check();  
         goto afterout;
  }
  y=timer_diff(); 
   cmd=make_after_entry(n,cmd,1); /*** entry  **/
         /*** printf("s-after  diff y %d n %d\n",y,n); ***/ 
  if(n<=y) y=n;
  timer_start(y);
afterout:
   if(afsleep) return after_wait();
   return cmd;    
}

void ss_update(){
 int i=1000000;
 if((sys_alarm==0)&&(after_que==0)){ 
   /*** for cygwin   SIGALRM taken by TCL in cygwin ****/
   if(after_total&&(val.it_value.tv_sec==0)&&(val.it_value.tv_usec==0)){
        sys_alarm++;
       signal(SIGALRM,timer_handler);   /*** because TCL/TK take timer or block? ***/
       while(i) i--;
    }
   else
       return;
  }
  /*** fprintf(stderr,"ss_update   alarm %d\n",sys_alarm); ***/ 
  /*** timer_stop();  ***/  
  if(sys_alarm)
      timer_stop();
  else
      timer_diff();   
  timer_check();
  /** printf("ss_update\n"); ***/ 
}
    
ptr cmd_exec(ptr p)
{
  if(SREGP(p)){
    after_sleep=0;
    return;
  }
  if(CLOSUREP(p)){
     p=funcall(p,0,a_nil);
     return p;
  }
  psh(p);
  /*** p=meval(p,a_nil);    1.99  ***/
  p=vm_eval(p,a_nil);  /***  V2.0   2010.5.30  ***/
  pull();
  return p;
} 

static ptr after_cancel(int i)
{
  int n;
  n=after_entry[i];
  if(n==0) return a_f;
  after_entry[i]=0;
  after_cmd[i]=a_nil;
  after_total--;
  if(after_total==0){
       timer_start(0); /*** stop  **/
  }
 return a_t;
}

after_info(){
  Reg int i,n,past,sec,time_rest;
   getitimer(ITIMER_REAL,&oval);
   time_rest=oval.it_value.tv_usec/MICROMILI;
   sec=oval.it_value.tv_sec;
   time_rest+=sec*SECMILI;
   past=timer_int-time_rest;
    sprintf(iobuff,"interval %d time_rest %d past %d active %d\n",
     timer_int,time_rest,past,timer_active);

    lwritestr(STDOUT,iobuff);
    /** printf("sys_alarm %d\n",sys_alarm); ***/
  for(i=0;i<=max_after;i++){
     if(after_entry[i]>0){
         prin1(MAKESINT(i),STDOUT);
         lwritec(STDOUT,':');
         prin1(after_cmd[i],STDOUT);
         lwritec(STDOUT,' ');
         prin1(MAKESINT(after_timer[i]-past),STDOUT);
         newline(STDOUT);
       }
    }
 }

ptr s_after_cancel(int narg,ptr env)
{
 ptr sec;
 int n;

  checknarg(narg-1);
  sec=*(stack-1);
  n=GETNUM(sec);  
  if(n<0||n>=AFTERMAX) error(E_range,sec);
  return after_cancel(n);
}

ptr s_after_info(int narg,ptr env)
{
  checknarg(narg);
  after_info();
  return a_undef;
}

ptr s_update(int narg,ptr env)
{
  if(narg>1)
   checknarg(narg-1);
  ss_update();
  if(narg==1) return a_undef;
#ifdef USE_TK
  update();
  /*** signal(SIGALRM,timer_handler);   because TCL/TK take timer ***/
#endif
  return a_undef;
}


