/***  tk_conversion.c
***/
#define  TK_CONVERSION_C

#include "lisp.h"
#include <tcl.h>
#include <string.h>


/****  convert tk-result   ->   ss-obj   ****/
extern int euc_first(),conv_level;
static char convwork[256];

/***  conv_level
    0,-1   no conversion
    -1000       logical  return #f,#t
    -2000      "1.0"  -> (1 . 0)
    -3000      "1.0 1.2 ..."  -> ((1 . 0)(1 . 2) ....)
    -4000      text 'dump

    return tcl_return if conversion fails by some reason
****/

/****  convert tcl result  ---> ss ****/
/****   "    " -> string
      {....}   ->  string  .... may include #\"    04.9.5! 
      space is kugiri of list
      other is symbol or number 
***/
/****
 char *
       Tcl_UtfToExternalDString(encoding, src, srcLen, dstPtr)
     encoding=NULL,  char * src, int srcLen,
****/
/***
Tcl_DString argString;
char *q;
  q=Tcl_UtfToExternalDString(NULL, p,-1, &argString);
*****/

static unsigned char *readptr;

static ptr tcl_list(),tcl_token(), tcl_str(), tcl_list_str(),dump_conv();  

/***  level   10.20  ***/
static ptr list_index(char *p){
  char *q;
  ptr  res,tmp,x;
       if(*p==0) return a_nil;  /***  () ***/
      tmp=res=CONS(a_nil,a_nil);
      psh(res);
    while(1){
      q=strchr(p,'.');
      if(q==NULL) break;
      *q=0;
      x=MAKESINT(atoi(p));
      x=CONS(x,MAKESINT(atoi(q+1)));
      tmp=CDR(tmp)=SCONS(x,a_nil);
      *q='.';
      p=strchr(q+1,' ');
     if(p==NULL)break;
     p++;
   }
    res=*pull();
      return CDR(res);
}

ptr get_ss_obj(char *p,int level){  /**** from interp->result  ***/
 Tcl_DString argString;
 ptr x,res;
 char *q;

    if(*p==0&&level!=-2000){
          if(level==0) return a_nullstr; /*** get  etc.  **/
          return a_nil;  /***  else always ""-> () ***/
    }
    if(level==-1000){  /*** logical  ***/
      /** printf("conversion level %d p %x *p %x\n",level,p,*p); ***/
      return  PRED(*p!='0');
     }
    if(level==-2000){  /*** text index "1.0" ->(1 . 0)  ***/
       if(*p==0) return a_f;  /***  Not () ***/
      q=index(p,'.');
      *q=0;
      x=MAKESINT(atoi(p));      
      x=CONS(x,MAKESINT(atoi(q+1)));
      *q='.';
      return x;
    }
    if(level==-3000){  /*** ilist of text index "1.0 1.2" ->((1 . 0) (1 . 2))  ***/
       return list_index(p);
    }
   if(kanji_mode==2)
      p=Tcl_UtfToExternalDString(NULL, p,-1, &argString); /*** UTF->euc ***/
    /*** printf("get_ss_obj %s\n",p);  ***/
   if(level==0) {
    x=make_str_c(p);
   if(kanji_mode==2)
    Tcl_DStringFree(&argString);
    return x; 
   }
   readptr=(Uchar *)p;
    /*** if(level==-4000) **  txt dump   **
       level=1;
    ***/
    x=tcl_list(NO,level-1);
   if(kanji_mode==2)
    Tcl_DStringFree(&argString);
  /*** printf("get_ss_obj out %x\n",x);
   prin1(x,STDOUT); ***/	
   if(level==-4000) return dump_conv(x);
   return x;
}

static ptr list3pair(ptr x){  /***  (a b c d e f...)->((a b c) (d e f) ....)  ***/
 ptr res=x,next,tmp,top;
 char *p;
 int n;
  psh(x);
  psh(res=tmp=CONS(a_nil,a_nil));
  while(CONSP(x)){
    top=x;
    x=CDDR(x);
    next=CDR(x);
    if(SREGP(next)) break;  /*** error !! ***/
    tmp=CDR(tmp)=CONS(top,a_nil);
    CDR(x)=a_nil;
    x=next;
  } 
 res=CDR(*pull());
 pull();
 return res;
}    

static ptr dump_conv(ptr x){
 ptr res=x,ind;
 char *p;
 int n;
  psh(x);
  while(CONSP(x)){
    x=CDDR(x);
    ind=CAR(x);
    if(SREGP(ind)||!STRINGP(ind)) break;  /*** error !! ***/
    p=(char *)get_string(ind,&n);
    strncpy(convwork,p,n+1);
    ind=get_ss_obj(convwork,-2000);
    CAR(x)=ind;
    x=CDR(x);
  }
 return list3pair(*pull());
}
    

static ptr tcl_list(int lis,int level){  
 ptr x,res;
 int tokenlevel=level;
   res=CONS(a_nil,a_nil);
   psh(res);
   if(level<=-4000) level=0; /*** dump ***/
 loop:
   tcl_offsp();
   x=tcl_token(tokenlevel);
   /***   printf("tcl_token in tcl_list %x\n",x);
   if(x) prin1(x,STDOUT);
   prin1(CDR(*(stack-1)),STDOUT);
   ***/
   if(x==a_t) {   /*** left {   ***/
      lis=1;
    if(level==0) x=tcl_list_str();
    else{
      x=tcl_list(lis,level-1);
     }
      res=CDR(res)=SCONS(x,a_nil);
    goto loop;
    }
   if(x==a_f) goto end;  /*** }  ***/
   if(x)
       res=CDR(res)=SCONS(x,a_nil);
    tcl_offsp();
    if(*readptr) goto loop;
 end:
    res=*pull();
    res=CDR(res);
    if(lis) {
       if(res==a_nil) return a_nullstr;    /***   This OK?  10.25 ***/
       return res;
    }
    if(CDR(res)==a_nil){
        res=CAR(res);
        if(res==a_nil) return a_nullstr;   /**** This OK?  10.25 ***/
        return res;
     }
    return res;
}


tcl_offsp(){
  while(*readptr==' ') readptr++;
}
   
static ptr tcl_token(int level){
  ptr res,x;
  unsigned char *first,*end,*p;
  unsigned int c,n;
   if((c=*readptr++)=='{') return a_t;
   if(c=='}') return a_f;
   if(c==0) {
      --readptr;
      return 0;
       }       
   if(c=='"')
      return tcl_str();
   first=--readptr;
   while(c){
     c=*readptr++;
    /** 
        result is UTF code , but here euc!
    ***/
    if(euc_first(c)) 
       readptr++;
    else if(terminate(c)){
       end=--readptr;
       break;
     }
   }
   n=end-first;
   /***  printf("tcl_token n %d\n",n); ***/ 
   if(n==0) return 0;  /****  correct?   Right!  ***/
   res=makestring(n);
    psh(res);
   p=get_string(res,&n);
   c=*first;
   while(first<end)
      *p++=*first++;
   *p=0;
   /**** prin1(res,STDOUT); ***/
   x=str2number(res,10);
   if(x==a_f){
    /*** printf("token a_f n %c\n",c);   ***/
       if(c=='-'){
          /*** res=copy_str(res); ***/
          p=get_string(res,&n);
           *p=':';
          *(stack-1)=res;
          res=key_intern(res);
          pull();
          return res;
        }
       pull();
       return res;
   }
   pull();
   if(level<=-4000)
        return res;  /*** txt dump ***/
       /*** return intern(res,a_unbdd); ***/
   return x;
}

static ptr tcl_str(){
 ptr res;
  unsigned char *first=readptr,*end,*p;
  unsigned int c,n;
   while(1){
     c=*readptr++;
    /**
        result is UTF code, but here euc by the above! 
    ****/
    if(euc_first(c))  /**** kanji  on  ***/
       readptr++;
    else if(c=='"'){
       end=readptr-1;
       break;
     }
   }
    n=end-first;
   if(n==0) return 0;
   res=makestring(n);
   p=get_string(res,&n);
   while(first<end)
      *p++=*first++;
   *p=0;
   return res;
}

static ptr tcl_list_str(){
 ptr res;
  unsigned char *first=readptr,*end,*p;
  unsigned int c,n;
   while(1){
     c=*readptr++;
    /**
        result is UTF code, but here euc by the above!
    ****/
    if(euc_first(c))  /**** kanji  on  ***/
       readptr++;
    else if(c=='}'){
       end=readptr-1;
       break;
     }
   }
    n=end-first;
   if(n==0) return a_nullstr;
   res=makestring(n);
   p=get_string(res,&n);
   while(first<end)
      *p++=*first++;
   *p=0;
   return res;
}


int terminate(unsigned int c){
 return
   (c==0)||(c==' ')||(c=='{')||(c=='}')||(c=='"');
}

   
