#include "lisp.h"
#include <stdio.h>
/****  Circle print version 03.9.6   ***/
/****  stream version   03.9.9  ***/
/****   05.10.8   separated from write.c  ***/
/****   07.1.16  Bug fix of
         previous version can not print
            a=(.. a .. a ...)
        this cause infinite loop by simple Mark-method only
        Therefore we make the list of table 
****/
/***  07.3.22  print_list must re-entrant because (a b #((cd ...)   ***/


#define prin_s(p)   lwritestr(lpath,p)

#define circle_list  *(stack-4)
#define danger_list  *(stack-3)
#define cref_list    *(stack-2)
extern ptr print();
extern ptr copy_list(),memq();
/*** static ptr circle_list,danger_list,cref_list;  ***/
static ptr working_list;  
static int ref_no;

init_list_print(){
 working_list=NIL;
}
/*** called by write.c  ***/
ptr prin_circle(ptr q,ptr lpath){
   prin_s(" #--# ");
   /*** CLRCIRCLE(q); ***/
  return a_undef;
}

void print_circle_after(ptr q, ptr lpath){
 ptr n;
  /*** n=safe_assq(q,circle_list); ***/
   n=assq(q,cref_list); 
  if(n!=a_f) n=CDR(n);
  prin_s(" #-");
  prin1(n,lpath);
  prin_s(" ");
}


void print_circle_ref( ptr n,ptr lpath){
  prin_s(" #=");
  prin1(n,lpath);
  prin_s(" ");
}

static clear_circle(Reg ptr q) 
{
  ptr car;
     if(!CIRCLEP(q)) return;
      CLRCIRCLE(q);
      while(1)
       {
         car=CAR(q);
         if(!SREGP(car)&&CONSP(car)) 
              clear_circle(car);
        q=CDR(q);
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
                if(!CIRCLEP(q)){
                    break;
                }
             CLRCIRCLE(q);
           }
          else
           {  /***  dot   pair  ***/
            break;
           }
        }
}

static int after_appear(ptr q,ptr lpath){
  ptr x,n;
    x=memq(q,circle_list);
  if(x!=a_f){   /***  first appear  ***/
             n=MAKESINT(ref_no); 
              print_circle_ref(n,lpath); 
              /*** circle_list=remq(q, circle_list);  ***/
              CAR(x)=a_undef;   /***  remove!  **/
             x=CONS(q,n); 
             cref_list=SCONS(x,cref_list); 
              ref_no++; 
              return NO;
          }
        else{
           print_circle_after(q,lpath);
           return YES;
        }
}

static void list_print_aux(Reg ptr q,Reg ptr lpath,Reg int wflag) /*** wflag NO=display ***/
{   
  ptr car,z;
    /***  printf("print-aux %x\n",q);  ***/
     if(CIRCLEP(q)) {
         if(after_appear(q,lpath)) return;
      }
      lwritec(lpath,'(');
      while(1)
       {
         car=CAR(q);
         if(SREGP(car)||ATOM(car))
              print(car,lpath,wflag);
         else
              list_print_aux(car,lpath,wflag);
        q=CDR(q);
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
               lwritec(lpath,' ');
                if(CIRCLEP(q)){
                  if(after_appear(q,lpath)) 
                         break;  /***  return??  ***/
                }
           }
          else
           {  /***  dot   pair  ***/
            prin_s(" . ");
              print(q,lpath,wflag);
            break;
           }
        }
      lwritec(lpath,')');
}

static void list_print_simple(Reg ptr q,Reg ptr lpath,Reg int wflag) /*** wflag NO=display ***/
{
  ptr car;
      lwritec(lpath,'(');
      while(1)
       {
         car=CAR(q);
         if(SREGP(car)||ATOM(car))
              print(car,lpath,wflag);
         else
              list_print_simple(car,lpath,wflag);
        q=CDR(q);
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
               lwritec(lpath,' ');
           }
          else
           {  /***  dot   pair  ***/
            prin_s(" . ");
              print(q,lpath,wflag);
            break;
           }
        }
      lwritec(lpath,')');
}

void mark_circle();
void   clear_mark_circle();
void init_circle_print();
void check_circle();

ptr list_print(Reg ptr q,Reg ptr lpath,Reg int wflag) /*** wflag NO=display ***/
{
  ptr memo;
    if(memq(q,working_list)!=a_f){
         prin_circle(q,lpath);
         return a_undef;
      }
   init_circle_print(q);
   memo=danger_list;
   if((circle_list==NIL)&&(memo==NIL)){
      list_print_simple(q,lpath,wflag); /*** wflag NO=display ***/
       goto cpend;
     }
    /*** printf("circle print start\n");  ***/
   check_circle(memo); /***  circle_list is changed! **/
   if(circle_list==NIL){
         list_print_simple(q,lpath,wflag);
         goto cpend;
   }
   memo=copy_list(circle_list); /*** circle is modified by set-car! **/
   *(stack-1)=memo;
  /*** check_clist(q,circle_list);     DEBUG  ****/
    mark_circle(memo);
    working_list=SCONS(q,working_list);
    danger_list=working_list;
  list_print_aux(q,lpath,wflag); /*** wflag NO=display ***/
   working_list=CDR(working_list);
   clear_mark_circle(memo);
    /*** printf("circle print end\n");  ***/
cpend:
   stack-=4;
  return a_undef;
}

ptr s_circular_list_pred(int narg,ptr env) /*** wflag NO=display ***/
{
  ptr q;
     checknarg(narg-1);
     q=*(stack-1);
     if(q==a_nil) return a_f;
   if(SREGP(q)||!CONSP(q))
         error(E_notlist,q);
   init_circle_print(q);
   q=danger_list;
   if((circle_list==NIL)&&(q==NIL)){
       stack-=4;
       return a_f;
     }
    /*** printf("circle print start\n");  ***/
   check_circle(q); /***  circle_list is changed! **/
   q=circle_list; 
   stack-=4;
   if(q==NIL){
       return a_f;
   }
  return q;
}

/***  07.3.21  New!  ***/

static void regist_danger(ptr q,ptr root){
  ptr x;
   if(q==root){
                x=memq(q,circle_list);
                if(x==a_f)
                    circle_list=CONS(q,circle_list);
              }
         else {
                x=memq(q,danger_list);
                if(x==a_f)
                    danger_list=CONS(q,danger_list);
          }
}

static int regist_circle(ptr q,ptr root){
  ptr x;
   if(q==root){
                 x=memq(q,circle_list);
                if(x==a_f)
                    circle_list=CONS(q,circle_list);
            return YES;
    }
  return NO;
}


void make_danger(ptr q,ptr root){
    ptr car;
        if(CIRCLEP(q)) {
          regist_danger(q,root);
         return;
      }
     SETCIRCLE(q);
      while(1)
       {
         car=CAR(q);
         if(!(SREGP(car)||ATOM(car)))
              make_danger(car,root);
        q=CDR(q);
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
                if(CIRCLEP(q)){
                       regist_danger(q,root);
                    break;
                }
             SETCIRCLE(q);
           }
          else
           {  /***  dot   pair  ***/
            break;
           }
        }
}

static int make_circle(ptr q,ptr root){
    ptr car;
    int n=NO;
        if(CIRCLEP(q)) {
          return regist_circle(q,root);
      }
     SETCIRCLE(q);
      while(1)
       {
         car=CAR(q);
         if(!(SREGP(car)||ATOM(car))){
             if(n=make_circle(car,root)) break;
          }
        q=CDR(q);
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
                if(CIRCLEP(q)){
                       n=regist_circle(q,root);
                    break;
                }
             SETCIRCLE(q);
           }
          else
           {  /***  dot   pair  ***/
            break;
           }
        }
  return n;
}


void mark_circle(ptr p){
  /***  p=circle_list;  **/
 while(p!=a_nil){
    SETCIRCLE(CAR(p)); 
    p=CDR(p);
 }
}
void clear_mark_circle(ptr p){
  /***  p=circle_list;  **/
 while(p!=a_nil){
    CLRCIRCLE(CAR(p));
    p=CDR(p);
 }
}

void init_circle_print(ptr root){
   psh(NIL);
   psh(NIL);
   psh(NIL);
   psh(NIL);
   ref_no=0;
   make_danger(root,root);
   clear_circle(root);
}

void check_circle(ptr p){
  ptr x;
  while(p!=NIL){
    /*** printf("check circle %x\n",p); ***/
    x=CAR(p);
    mark_circle(circle_list);
    make_circle(x,x);
   clear_circle(x);
    p=CDR(p);
  }
    /*** danger_list=NIL; ***/
}

/****  Debug functions  ***/
int total_cell(ptr q){
  ptr car;
  int n=0;
        if(CIRCLEP(q)) {
         return 0;
      }
     SETCIRCLE(q);
     n++;
      while(1)
       {
         car=CAR(q);
         if(!(SREGP(car)||ATOM(car)))
              n+=total_cell(car);
        q=CDR(q);
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
                if(CIRCLEP(q)){
                    break;
                }
             SETCIRCLE(q);
             n++;
           }
          else
           {  /***  dot   pair  ***/
            break;
           }
        }
   return n;
}

   
int level_cell(ptr q,int lev){
  ptr car;
  int cdrlev=lev,carlev=lev,k=lev;
        if(CIRCLEP(q)) {
         return lev;
      }
     SETCIRCLE(q);
      while(1)
       {
         car=CAR(q);
         if(!(SREGP(car)||ATOM(car))){
              k=level_cell(car,cdrlev);
              if(k>carlev) carlev=k;
           }
        q=CDR(q);
        cdrlev++;
         if(q==NIL) break;
         if(!SREGP(q)&&CONSP(q))  /***  q maybe integer ***/
          {
                if(CIRCLEP(q)){
                    break;
                }
             SETCIRCLE(q);
           }
          else
           {  /***  dot   pair  ***/
            break;
           }
        }
   if(cdrlev>carlev)
        return cdrlev;
   else
        return carlev;
}


