;;;; read check of *scr*
;;;;   04.5.30
;;;;  check
;;;    (,)     |...|   #|...|#  \   ;   "..."
;;;attribute
;;;    (  )  nested   level =0 at first
;;;    (1   (2   )2  (2   )2  )1
;;;   #|  |#   nested  level  from -1000     attr given for # && |
;;;   ;      not nest    attr=  -1999 from ; to the end
;;;   " ... "      not nest   attr = -2999 for start  -3000 for end
;;;   \    no attr
;;;   |...|       attr -3999 for start -4000 for end
(define *paren-state* 0)
(define *comment-state* -1000)
(define *s-comment-state* -2000)
(define *str-state* -3000)
(define *escape-state* -4000)

(define (init-state)
   (set! *paren-state* 0)
   (set! *comment-state* -1000)
   (set!  *s-comment-state* -2000)
   (set! *str-state* -3000)
   (set! *escape-state* -4000)
)

(define (read-chk)
  (let* ((locx *cur-x*)(locy *cur-y*))
     (init-state)
     (cur-begin)
     (read-chk-main)
     (locate locx locy)
))

(define (get-ch)
  (let* ((c (getch)))
    (if (pair? c) (set! c (car c)))
    c
))

(define (read-chk-main)
    (do ((c 0))
        ((eq? c #f))
        (set! c (get-ch))
        (cond ((eq? c #\\ )  (cur-right))
              ((>  *comment-state* -1000)
                  (if (eq? c #\#) 
                      (sharp-chk)
                      (if (eq? c #\|) (sharp-chk-end))
                  )
                )
              ((> *str-state* -3000) 
                    (if (eq? c #\") (str-chk))
                 )     
              ((eq? c #\(  ) (paren-start))
              ((eq? c #\)  ) (paren-end))
              ((eq? c #\# ) (sharp-chk) )
              ((eq? c #\; ) (s-comment) )
              ((eq? c #\|  ) (escape-chk) )
              ((eq? c #\" ) (str-chk))
              (else
                 )
        )
       (set! c (cur-next))
    )
)

(define (cur-next)
   (let* ((c 0))
      (set! c (cur-right))
      (if (not c)    
        (when (< *cur-y* *cur-bottom*)
           (cur-down)
           (cur-top)
           (set! c #t)
        )
      )
   c
))

(define (scr-peek)
  (let* ((c 0)(locx *cur-x*)(locy *cur-y*))
    (if (cur-next)
      (begin
        (set! c (get-ch))
        (locate locx locy)
        c
      )
     #f
   )
))

(define (paren-start)
   (inc *paren-state*)
   (scr-set (cons #\( *paren-state*))
)

(define (paren-end)
   (scr-set (cons #\) *paren-state*))
   (dec *paren-state*)
)

(define (sharp-chk)
  (let* ((c 0))
    (set! c (scr-peek))
    (when(eq? c #\|)
         (inc *comment-state*)
         (scr-set (cons #\# *comment-state*))
         (cur-next)
         (scr-set (cons #\| *comment-state*))
    )
))

(define (sharp-chk-end)
  (let* ((c (scr-peek)))
     (when (eq? c #\#)
          (scr-set (cons #\| *comment-state*))
          (cur-next)
          (scr-set (cons #\# *comment-state*))
          (dec *comment-state*)
    )
))

(define (s-comment)
   (let* ((c 0))
     (while c
       (set! c (cur-next))
       (if c (set! c (get-ch)))
       (if (eq? c 'newline) (set! c #f))  ;;end
    )
))

(define (str-chk)
  (let* ((c 0))
    (if (= *str-state* -3000)
      (begin
        (inc *str-state*)
        (scr-set (cons #\" *str-state*))
      )
     (begin
        (dec *str-state*)
        (scr-set (cons #\" *str-state*))
    )
   )
))

(define (escape-chk)
    (let* ((c 0))
      (inc *escape-state*)
      (scr-set (cons #\| *escape-state*))
      (set! c (scr-skip-to #\| ))
      (when c
        (dec *escape-state*)
        (scr-set (cons #\|  *escape-state*))
     )
))

(define (scr-skip-to dest)
   (let* ((c 0))
     (while (and c  (not (eq? c dest)))
       (set! c (cur-next))
       (when c (set! c (get-ch)))
    )         
  c
))        
   
          

