;;;;  string compare
;;;;   Ver2.0
;;;;  2005.8.21
(in-package "regexp")

(define *eof-object* (integer->char -1))

(define (r-bag bag c)
  (let* ((x 0)(v 0)(not-f #f)(ans #f)(chars 0)(fbag 0)(cl #f)(cd 0)(cdl 0))
        (if (null? bag)  (error 553 bag) )   ;;; error
        (if (eq? (car bag) 'not)
             (set!  not-f (pop bag)) )
        (set! chars (pop bag))
        (set! fbag (pop bag))
        (set! ans (memq c chars))
        (when  (eq? regexp-char=? char-ci=?)   ;;;;  nocase  
             (set! cl (char-downcase c))
             (if (eq? c cl)  (set! cl (char-upcase c)))
             (if (eq? c cl)  (set! cl #f))
        )
        (if (and (not ans) cl)
          (set! ans (memq cl chars))
        )
       (when (and (pair? fbag) (not ans))
            (set! cd (char->integer c))
            (if cl (set! cdl (char->integer cl)))
       )
       (while (and (pair? fbag) (not ans))
           (set! x (pop fbag))
            (if (pair? x)
              (begin
                (set! ans (and (<= (cadr x) cd) (<= cd (caddr x))))
                (if (and (not ans) cl)
                   (set! ans (and (<= (cadr x) cdl) (<= cdl (caddr x))))
                )
              )
             ;; else
              (set! ans (funcall x c))
            )
       )
      (if not-f (not ans) ans)
))

(define r-space?
  char-whitespace? )
 ;; (or (eq? x #\space) (eq? x #\tab)
 ;;                            (eq? x  #\newline)(eq? x #\page) (eq? x #\return))
;;)
                                                                                             
(define (not-space? x) (not (r-space? x)))
                                                                                             
(define (r-digit? x)
  (char-numeric? x)
)
                                                                                             
(define (not-digit? x)
  (not (char-numeric? x))
)
                                                                                             
(define r-word?     char-word?)
;;  (or (char-numeric? x) (char-alphabetic? x)(eq? x #\_))
;;;)
                                                                                             
(define (not-word? x)
  (not (r-word? x))
)
                                                                                             
(define (r-dot x)
   ;;;(format #t "r-dot ~s~%" x)
  (if (eq?  *regexp-mode* :single)
        #t
     (if (eq? x #\newline)
           #f
           #t
     )
  )
)
                                                                                             
(define r-kanji?   char-kanji?)
;;;  (>= (char->integer x) 256)
;;;)
(define (not-kanji? x)
  (< (char->integer x) 256)
)

;;;;;

(define (R-char=?  state reg c)
   (if (char? reg)
        (regexp-char=? reg c) 
       (if (pair? reg)     ;;;(r-bag ... )  (r-pos ...) (group-ref ...)
            (if (eq? (car reg) 'r-bag)
                   (begin
                      (if (eof-object? c)
                           #f
                          (r-bag (cdr reg) c)
                      )
                   )
                     (funcall (car reg) (cdr reg) c state)
            )
           (begin
              (if (eof-object? c)
                 #f
                 (funcall  reg c)
              )
           )
       )
   )
)

(define (R-string-ref i)
  (if (or (< i 0) (>= i *regexp-length*))
      *eof-object*
     (string-ref *regexp-string* i)
  )
)

(define (ind-substring ind)    ;;; ind is a cons
    (if (pair? ind)
      (substring *regexp-string* (car ind)(cdr ind))
      #f
   )
)

(define (R-substring from to)    ;;; ind is a cons
   (if (< from to)
      (substring *regexp-string* from to)
      ""
   )
)



