;;;;  04.1.12
;;;;      separated from pat.ss
;;;; 04.4.04  New macro version
;;;;

(in-package "macro")

(define *exflag* 0)
(define *macro-bind* ())
(define *macro-env* ())
;;;(define *macro-alias* #t)
(define *macro-flag* #t)
;;;(define *recover-name* ())
(define *alias-name* ())   ;;;New
(define *macro-bind-local* ())   ;;;New  for recover original define macro  
;;;(define *system-let** let*)
;;;(define *system-define*  define)

(define (syntax-error p)
   (error 1000 (cons "illegal syntax" p))
)

(define (inc-exflag)
   (set! *exflag* (+ *exflag* 1))
   (if (> *exflag* 5000) (error 5000 "*** macro-expand over limit ****"))
)
;;;  define-syntax is only used top level!!!
(define-macro (define-syntax macro-key rules)
  (let* ((lite (cadr rules)))
    `(begin
       (remove-macro ',macro-key)
       (set! *literal* ',lite)
       (set! *macro-key* ',macro-key)

       (set! *macro-bind* (cons (list ',macro-key (gensym) #t  ',lite 
                (rule-trans (cddr ',rules) () )  ;;; New!
                           (cddr ',rules)  () ) ;;;; local-env is nil
                          ;;;*macro-bind* () ) ;;;; local-env is nil
                          ;;; *macro-bind* is included template-part
                          ;;; Now the second term from last is original rules 
                          *macro-bind*))
       (macro-alias ',macro-key)
       ',macro-key
    )
))
;;; 04.4.8
(define (macro-symbols)
  (let* ((s *macro-bind*) (res ()) (a 0)(flag 0))
     (while (pair? s)
        (set! a (car s))
        (set! flag (caddr a))
        (if (or (eq? flag #t) (eqv? flag 1))
             (push (car a) res)
         )
        (set! s (cdr s))
     )
   res
)) 
   
(define (macro-update . macros)
  (if (null? macros)
     (let* ((s *macro-bind*))
       (if (pair? s)
          (begin
             (set! s (macro-symbols))
             (map macro-update-aux s)
             s
          )
       )
     )
    (begin
     (map macro-update-aux macros)
      macros
    )
))

(define (macro-update-aux mac)
  (let*  ((def (get-macro mac)) (alias 0)(flag 0)(lite 0)(rules 0))
    (if def
      (begin
        (set! def (car def))
        (remove-macro mac)
        (set! alias (cadr def))
        (set! flag (caddr def))
        (set! def (cdddr def))
        (set! lite (car def))
        (set! rules (caddr def))
        (set! def (list mac alias flag lite (rule-trans rules ()) rules ()))
        (push def  *macro-bind*)
        (macro-alias mac)
        mac
      )
      #f
    )
))
;;;; 04.4.04
(define (rule-trans rules env)
   (map (lambda (x) (rule-trans-aux x env))   rules)
)

(define (rule-trans-aux rule env)
  (let* ((pat (car rule)))
    (set! pat (pat-trans pat env))
    (set! rule  (template-trans (cadr rule) env))
    (list *pat-variable* pat rule )
))
;;;  04.4.07   for let-syntax

(define  (rule-trans-nonrec  rules env)
   (map (lambda (x) (rule-trans-aux-nonrec x env))   rules)
)

(define (rule-trans-aux-nonrec  rule env)
  (let* ((pat (car rule))(memo *macro-key*))
    (set! pat (pat-trans pat env))
    (set! *macro-key* #f)
    (set! rule (template-trans (cadr rule) env))
    (set! *macro-key* memo)
    (list *pat-variable* pat rule )
))

(define-macro (special-syntax macro-key rules)
  (let* ((lite (cadr rules)))
    `(begin
       (remove-macro ',macro-key)
         (set! *literal* ',lite)
       (set! *macro-key* ',macro-key)

    (set! *macro-bind* (cons (list ',macro-key (gensym) 1  ',lite
                (rule-trans (cddr ',rules) () )  ;;; New!
                           (cddr ',rules)  () ) ;;;; local-env is nil
                          ;;;()   () ) ;;;; local-env is nil
                          ;;;*macro-bind* () ) ;;;; local-env is nil
                          *macro-bind*)))
))


(define (remove-macro key)
  (let* ((d (assq key *macro-bind*)))
    (if d
      (let* ((a (cadr d)))
         (set! *macro-bind* (remove d *macro-bind*))
         (set! d (assq a *macro-bind*))
         (if d
            (set! *macro-bind* (remove d *macro-bind*))
         )
         #t
       )
     #f
   )
))

(define (get-macro  key)
 (let* ((d (assq key *macro-bind*)))
    (if d
      (list d  (assq (cadr d) *macro-bind*)) ;;;(key-def alias-def)
     #f
    )
))

(define (set-macro data)
  (let* ((d 0))
   (when (pair? data)
      (set! d (car data))
      (remove-macro (car d))
      (push d *macro-bind*)
      (if (cadr data)
          (push (cadr data) *macro-bind*)
      )
     (car d)
   )
))

;;;  make alias data for global or rec macro
(define (macro-alias key)
  (let* ((x (assq key *macro-bind*))(y 0) (a 0) (flag #f) )
    (set! a (cadr x))
    (set! y (assq a *macro-bind*))
    (when (not y)
       (set! flag (caddr x))
       ;;;  this need if key is appead as a free variable in a form!!
       (if (symbol-bind? key)
           (symbol-value-set  a (symbol-value key))
       )
       ;;;
       (if (number? flag)
            (set! flag 0)   ;special-syntax
            (set! flag #f)  ; syntax
        )
       (set! x (cdddr x))
       (let* ((lit (car x)) (rules (cadr x)))
          (set! rules (exchange-tree rules key a))
          (set! y (list a key flag lit rules (caddr x) (cadddr x)))
          (set! *macro-bind* (cons y *macro-bind*))
       )
    )
 y
))

;;;  change key->new in tree
(define (exchange-tree lis key new)
  (if (pair? lis)
      (cons (exchange-tree (car lis) key new)
            (exchange-tree (cdr lis) key new) )
      (if (eq? lis key) 
              new
              lis
      )
  )
)

;;;  change key->new in template part in rules

(define (exchange-template rules key new)
  (let* ((res ())(x 0))
    (while (pair? rules)
      (set! x (car rules))
      (set! res (cons (list (car x) (exchange-tree (cadr x) key new)) res))
      (set! rules (cdr rules))
   )
   (reverse res)
))
 

(define (syntax-expand f env)
    (set! *exflag* 0)
    (set! *local-env* env)
    ;;;(set! *recover-name* ())
    (set! *name-change* ())
    (syntax-ex f )
)

(define (syntax-ex f )
  (let* ((top 0) (x 0)(c *exflag*) )
    ;;;(format #t "syntax-ex start ~s ~s~%" f *local-env*)
    (if (pair? f)
       (call/cc (lambda(break)
          (set! top (car f))
          (when (pair? top)
               (set! x (syntax-ex top ))
               (if (not (equal? top x))
                  (break
                     (syntax-ex (cons x (cdr f)) )
                  )
               )
           )
    ;;;(format #t "syntax-ex 1  ~s ~s~%" top *local-env*)
          (if (or (pair? top) (not (or (symbol? top) (special? top)(classic-macro? top))))
                  ;;; we assume function call
               (break
                  (syntax-ex-args (cons top (cdr f))  )
               )
           )
    ;;;(format #t "syntax-ex 2  ~s ~s~%" top *local-env*)
          ;;; top is symbol or special
          (set! x  (assq top *macro-bind-local*))  ;;;new 
          (if (not x)
                (set! x (assq top *macro-bind*))  ;;;new
          )
          (if (assq top *local-env*)
             (if (not (and x  (assq top *macro-env*)))
                (break
                   (syntax-ex-args (cons top (cdr f))  )
                )
              )
           )
          (when  x     ;;;  macro
              (set! f (macro-ex f x) )
              (if (> *exflag* c)
                  (break (syntax-ex f))
                  ;;(break  f)
               )
             ;;; (break  f)
             (set! top (car f)) ;;; may be top is special-syntax
             ;;;  here  top is  special-macro
          #|
            (break
                  ;;;(syntax-ex (macro-ex f x) )
                  (macro-ex f x) 
             )
           |#
          )
         ;;; top is not syntax-macro
         (set! x (classic-macro? top))
         (when x
             (inc-exflag)
             ;;;(break (macro-expand f))
             (break (syntax-ex (macro-expand f)))
         )
         (set! top  (syntax-special? top ))
         (if top
             (special-ex top f )
             (syntax-ex-args f )
         )
        )
      )
    f
   )
))

(define (syntax-ex-args  f  )
   (let* ( (res ())(x 0)(y 0) (ans #f)(args (cdr f)) )
     (push (car f) res)
     (while (pair? args)
        (set! x (car args))
        (set! y(syntax-ex  x ))
        (push y res)
        (if (not (equal? x y)) (set! ans #t))
        (set! args (cdr args))
     )
    (if ans
      (begin
        (push args res)   ;;;  may be dot-list
        (apply list* (reverse res))
        ;;;;(reverse res)
      )
     f
    )
))

(define  (let*-arg-ex  args  )
  (let* ((x 0) (res ()) (narg ())(init 0) (env *local-env*))
    (while (pair? args)
       (set! x (car args))
       (set! init (cadr x))
       (set! x (car x))
       (set! init (syntax-ex init ))
       (push (cons x init) env)
       (push (list x init) narg)
        (set! args (cdr args))
       (set! *local-env* env)
    )
    ;;;;(format #t "let*-arg-ex out ~s local-env ~s ~%" (reverse narg) env)
    (reverse narg) 
))

(define  (letrec-arg-ex  args  )
  (let*  ((x 0) (res ()) (narg args)(nenv *local-env*)(env nenv)(init 0))
    (while (pair? args)
       (set! x (car args))
       (set! init (cadr x))
       (set! x (car x))
       (push (cons x init) env)
       (set! args (cdr args))
     )
    (set! *local-env* env)
    (set! args narg)
    (set! narg ())
    (while (pair? args)
       (set! x (car args))
       (set! init (cadr x))
       (set! x (car x))
       (set! init (syntax-ex init))
       (push (list x init) narg)
       (push (cons x init) nenv)
       (set! args (cdr args))
    )
    (set! *local-env* nenv)
    (reverse narg) 
))

(define  (lambda-arg-env args )
 (let* ((env *local-env*))
    (while (pair? args)
      (push (cons (car args) #f) env)
      (set! args (cdr args))
    )
    (if (not (null? args))
        (push (cons  args #f) env)
    )
   (set! *local-env* env)
 env
))

(define  (special-ex top f )
  (let* ((args 0)(g 0)(env *local-env*) (name *name-change*))
   ;;;(format #t "special-ex ~s f ~s env ~s~%" top f env)
   (cond ( (eq? top 'let*)
            (set! *name-change* ())
            (set! args (let*-arg-ex  (cadr f) ))
  ;;; (format #t "special-ex inside let* ~s f ~s env ~s~%" top f *local-env*)
            (set! g (syntax-ex-args (cdr f)  ))
            (set! f(cons (car f) (cons args (cdr g))))
            (set! f (name-change-close f ))
            (set! *local-env* env)
            (set! *name-change* name)
  ;;; (format #t "special-ex out  let*    f ~s ~%"  f )
            f
          )
         ( (eq? top 'letrec)
            (set! *name-change* ())
            (set! args (letrec-arg-ex  (cadr f) ))
            (set! g (syntax-ex-args (cdr f) ))
            (set! f(cons (car f) (cons args (cdr g))))
            (set! f (name-change-close f ))
            (set! *name-change* name)
            (set! *local-env* env)
            f
            )
         ((eq? top 'define)   ;;;;;mada ꤢ
                              ;;;;  env
                              ;;;; (define (f x) ...)
                              ;;;;  need top-env?
              ;;;; 04.3.15
             (set! g  (cddr f))
             (set! args (cadr f))
             (if (pair? args)
                  (begin
                    (set! g (list* 'lambda (cdr args) g)) 
                    (set! args (car args))
                    (inc-exflag)
                  )
                 (if (null? (cdr g))
                    (set! g (car g)) ;;; (define x g))
                    (error 4443 f)
                 )
             )
             (set! g (syntax-ex g))
             (list top args g)
           )
         ((eq? top 'set!) 
             (set! g (syntax-ex (caddr f) ))
             (list (car f) (cadr f) g)
           )

         ((eq? top 'quote)
             f
           )
        ((or (eq? top 'begin) (eq? top 'if))
             (syntax-ex-args f  )
            )
        ((eq? top 'call/cc)
             (set! g (syntax-ex (cadr f) ))
             (list (car f) g)
           )
        ( (or (eq? top 'lambda) (eq? top 'macro))
            (lambda-arg-env (cadr f) )
            (set! g (syntax-ex-args (cdr f)  ))
            (set! *local-env* env)
            (cons (car f) g)
          )
        ((eq? top 'let-syntax)
            (set! *name-change* ())
            (set! f(letsyntax-ex (cadr f) (cddr  f)))
            (set! f (name-change-close f))
            (set! *name-change* name)
             f
          )
         ((eq? top 'letrec-syntax)
            (set! *name-change* ())
            (set! f (letrecsyntax-ex (cadr f) (cddr  f)))
            (set! f (name-change-close f ))
            (set! *name-change* name)
             f
          )
        (else
           (error 4444 f)
        )
     )
))
(define (ex f )
  (let* ((def ()))
    (set! def (assq (car f) *macro-bind*))
    (if def
      (macro-ex f def)
       f
    )
))

;;;;  04.4.04 New!!!
(define (macro-ex f def )
  (let* ((env ())(rule 0)(rules 0)(ans #f))
    ;;; (set! *name-change* ())
    (when def
         (set! *macro-key* (car f))
         ;;;;(set! *macro-alias* (cadr def))
         (set! def (cddr def))
         (set! *macro-flag* (car def))
         (set! *literal* (cadr def))
         (set! def (cddr def))
         (set! rules (car def))
         ;;;(set! *macro-closed*  (cadr def))
         (set! *macro-env*  (caddr def))
       (while (and (not ans) (pair? rules))
         (set! rule (car rules))
         (set! *pat-variable* (car rule))  ;;;New!
         (set! rule (cdr rule))
         (set! env (make-match-data  (car rule) f *local-env*)) ;;;New!!!
         (if env
           (begin
             (set! f  (template-exp (cadr rule) f ))  ;;; New!!!
             (inc-exflag)
             (set! ans #t)
           )
         )
         (set! rules (cdr rules))
        )
       (if (and (not ans) (not (number? *macro-flag*)))
            (syntax-error f))
     )
  f
))

;;;; New! 
;;;  *name-change*   assoc list of (var . alias)
(define (name-change-close f )
   (if  (pair? *name-change*)
     (let* ((x 0)(arg ())(v *name-change*) (var 0))
       (while (pair? v)
         (set! x (car v))
           (set! var (car x))
           (set! arg (cons (list (cdr x) var) arg))
         (set! v (cdr v))
      )
        ;;;;(list *system-let** arg f)
        (list (special-alias 'let*)  arg f)  ;;;05.5.7 
     )
     f
   )
)

#|
(define-macro (let-syntax m-bind . body)
    ;;;(letsyntax-ex m-bind body)
    ;;;˾ޤʤư
    `(eval  (letsyntax-ex ',m-bind ',body) (interaction-environment))
)

(define-macro (let-syntax m-bind . body)
  (let* ((memo (gensym))(ans (gensym)) )
    `(let* ((,memo  *macro-bind*))
        (set! ,ans  (letsyntax-ex ',m-bind ',body))
        (set! *macro-bind* memo)
        ,ans
     )
))
|#
   

;;;  need  (interactin-environment)!!!!

(define (letsyntax-ex mbind body)
     (let* ((memo *macro-bind*) (m 0)(res ())(key 0)(a #f)(rules 0) )
         (while (pair? mbind)
           (set! m (car mbind))
           (set! key (car m))
           (set! m (cadr m))  ;;; m is  (syntax-rules () ....)
           (set! rules (cddr m))
           ;;;  same name macro must be macro outside 
           (set! a (assq key *macro-bind*))
           (if a
             ()
             #|
             (begin
                 (set! a (cadr a))
            ;;   (macro-alias a)   ;;;  generate alias data -> always created
                 (set! rules (exchange-template rules key a))
               ;;;  (set! *recover-name* (cons (cons a key) *recover-name*))
              )
             |#
             (if (classic-macro? key)
               (begin
                  (set! a (gensym))
                  (symbol-value-set a (symbol-value key))
                  (set! rules (exchange-template rules key a))
               )
             )
            )
           (set! *macro-key* key)
           (set! *literal* (cadr m))
           (set! *macro-bind* 
                ;;;;  flag = () ?
               (cons (list key (gensym) #t *literal*  (rule-trans-nonrec  rules *local-env*)  ;;;New!
                         () *local-env*)
                         ;;;rules *local-env*)
                         ;;;*macro-bind* *local-env*)
                     *macro-bind*) )
           (macro-alias key)
           (set! mbind (cdr mbind))
         )
        (set! body (cons 'begin body))
        (set! body (syntax-ex-args  body ))
        (set! *macro-bind* memo)
        (inc-exflag)
        body
))
#|
(define-macro (letrec-syntax m-bind . body)
      ;;;(recsyntax-ex m-bind body)
     `(eval  (recsyntax-ex ',m-bind ',body) (interaction-environment))
)
|#

(define (letrecsyntax-ex mbind body)
     (let* ((memo *macro-bind*)(m 0)(res ())(key 0) (flag *exflag*) )
         (while (pair? mbind)
           (set! m (car mbind))
           (set! key (car m))
           (set! m (cadr m))
           (set! *macro-key* key)
           (set! *literal* (cadr m))
           (set! *macro-bind* 
              (cons (list key (gensym) #t *literal* 
                       (rule-trans (cddr m) *local-env*)  *macro-bind* *local-env*)
                     *macro-bind*) )
           (macro-alias key)
           (set! mbind (cdr mbind))
         )
        (set! body (cons 'begin body))
        (while flag
            (set! body (syntax-ex-args  body  ))
            (if (= flag *exflag*)
                  (set! flag #f)
                  (set! flag *exflag*)
            )
        )
        (set! *macro-bind* memo)
        body
))

(define (syntax-special? x . option)
  (let* ((v 0)(env *local-env*) (y 0))
    (if (not (eq? option ()))  (set! env (car option)))
   ;;; (format #t "syntax-special?  x ~s env ~s~%" x env)
    (set! v (assq x env))
     (if v 
       (set! x (cdr v))
       (begin
        (set! y (special? x))
        (if y (set! x y))
       )
    )
    (if (memq x '(quote let* letrec set! if define lambda macro call/cc begin let-syntax letrec-syntax))
        x
       #f
     )
))

(define (s1 f)
    ( syntax-expand  f ())
)

;;;New!
(define (quote-recover f  data)
  (let* ((s 0) (qqq 0))
    (if (pair? f)
       (begin
          (set! qqq (car f))
          (set! s (special? qqq))
          (if (and s (eq? s 'quote))
              (cons qqq (quote-recover-exec (cdr f) data))
              (cons (quote-recover qqq data)
                    (quote-recover (cdr f) data))
          )
       )
      f
     )
))

(define (quote-recover-exec f data)
  (let* ((s 0))
    ;;; (format #t "f ~s data ~s~%" f data)
    (if (pair? f)
           (cons (quote-recover-exec (car f) data)
                    (quote-recover-exec  (cdr f) data))
         (begin
           (set! s (special? f))
           (if s
               s
             (if (symbol? f)
               (begin
                  (set! s (assq f data))
                   (if s (cdr s) f)
               )
               f
             )
           )
          )
     )
))

(define (macro? x)
  (if (get-macro x)
        x
      (classic-macro? x)
  )
)
(format #t "debug1~%")

(define (macro-expand-rec  f env)
  (let* ((rec #t) (c 0))
  ;;; (format #t "macro-expand-rec ~s  env: ~s~%" f env)
    (set! *alias-name* ())
    (set! *macro-bind-local* ())
   (while rec
      (set! f (syntax-expand f env))
      (set! c (+ c 1))
      (when (= *exflag*  0)
          (set! rec #f)
      )
      (if (> c 1000) (syntax-error f))
   )
   ;;;(format #t "macro-expand-rec  result ~s~%" f)
  ;;; (read-char)
  ;;;  2004.3.17
 ;;; (let-define->rec f)   ;;;;;   let define 
   ;;;;   recover  (quote .....)
   ;;;;   ex.    (if (eq? x 'if)
   (if (pair? *alias-name*)
       (set! f (quote-recover f *alias-name*))
   )
f
))

(format #t "debug3~%")
;;; 04.9.5
(define (macro-expand-1  f env)
  (let* ((c 0))
  ;;; (format #t "macro-expand-rec ~s  env: ~s~%" f env)
    (set! *alias-name* ())
    (set! *macro-bind-local* ())
      (set! f (syntax-expand f env))
   ;;;(format #t "macro-expand-rec  result ~s~%" f)
  ;;; (read-char)
  ;;;  2004.3.17
 ;;; (let-define->rec f)   ;;;;;   let define 
   ;;;;   recover  (quote .....)
   ;;;;   ex.    (if (eq? x 'if)
   (if (pair? *alias-name*)
       (set! f (quote-recover f *alias-name*))
   )
  f
))

(format #t "debug4~%")


(define (s f)
    ( macro-expand-rec f  ())
)
(format #t "debug5~%")

;;;;  from spe.ss
(define-syntax special-syntax (syntax-rules
        (syntax-rules *literal* *macro-key* *macro-bind*)
  ((special-syntax key  (syntax-rules  lite
     (pat1 temp1) (pat2 temp2) ...) )
    ;;;;(let* ((alias (gensym)))
    (let* ((alias (special-alias 'key)))
       (remove-macro 'key)
       (set! *literal*  'lite)
       (set! *macro-key*  'key)
       (set! *macro-bind* (cons (list 'key alias 1 'lite
               (rule-trans '((pat1 temp1 )(pat2 temp2) ...) ())
               '((pat1 temp1 )(pat2 temp2) ...) ())
                *macro-bind*) )
       (if (symbol-bind? 'key)
            (symbol-value-set  alias (symbol-value 'key))
       )
       (macro-alias 'key)
     )
  ) )
)

(format #t "debug6~%")
;;; overwite macro-expand     -> Seg error!!! why?
;;(shadowing-intern "macro-expand"  "alias")
;;(define (macro-expand form . env)
;;    (if (pair? env) (set! env (car env)))
;;    (syntax-expand form env)
;;)

(export '(define-syntax  get-macro set-macro remove-macro))
(export '(special-syntax syntax-rules macro-update macro-symbols macro? ))
(export 'macro-expand-1)
(use-package "macro" "ss")

(format #t "debug2~%")
