;;; linear-data.ss
;;; 2005.10.17
;;;  make-match-data
;;;
;;; from data , make more simple dot-database
;;;

;;;(in-package "macro")

(define *match-data* ())
(define *match-tmp* ())
(define *dot-hash* (make-hash-table eq? 32))
(define *data-hash* (make-hash-table eq? 32))


;;;  p must be linear
(define (make-match-data p f env)
  (let ((s (match p f env)))
    (set! *match-data* ())
    (clear-hash *data-hash*)
    (if (pair? s)
      (begin 
         (make-match-data-main s)
         (reverse-data-hash)
         *data-hash*
      )
      #f
    )
   
))

(define (make-match-data-main s)
  (let* ((top 0 ) (dotp 0)(patv 0))
  (while  (pair? s)
     (set! top (pop s))
       (cond  
          ((eq? (car top) :end)
             ;;;(set! s (make-dot-data (cdr top)  s))
             (set! dotp (cdr top))
             (set! patv  (pat-vars (cadr dotp) ))
             (set! s (make-dot-data-high  dotp  patv  s 1))
               (if (pair? *match-tmp*) 
                   (set! patv (cons patv  (pop *match-tmp*)))
                   (set! patv (cons patv))
               )
             (patv-hash patv)
            )
          ( (symbol?  (car top))
             (push top   *match-data*))
          (else
             (error 8761 top)
          )
       )
    )
))

(define  (make-dot-data-high dotp patv s level)
   (let* ((x 0) (res ()) (high (list level)) (top 0)(cont #t))
   ;;; (format #t "high-dotp ~s ~% level ~s~%" dotp level)
    (set! *match-tmp* ())
   (while (and cont (pair? s))
      (set! x (pop s))
      (set! top (car x))
      (cond ( (eq? top :end)
               (set! s (make-dot-data-high (cdr x) patv s (+ level 1)))
                  (if (pair? *match-tmp*)
                     ;;;;(push (pop *match-tmp*) high)
                     (set! high (append  (pop *match-tmp*) high))
                  )
               )
            ((equal? x dotp)
                (set! cont #f)
               )
           (else
              (push x  res)
             )
       )
   )
  (set! res  (make-level-data res  level  patv) )
   (set! res (append res  high ))
   (set! res (cons level res ))
    (push res *match-tmp*)
  s
))

(define (make-level-data res  level  patv)
  (let* ((d ()) (vars (assq level patv)) (x 0)(v 0)(ha (clear-hash *dot-hash*)))
   (if vars  
    (begin
      (set! vars (cdr vars))
      (while (pair? vars)
        (set! v (pop vars))
        (set-hash ha v ())
      )
      (while (pair? res)
        (set! x (pop res))
        (set! v (car x))
        (set-hash ha v (cons (cdr x) (get-hash ha v)))
       )
        (map-hash (lambda (v data) (push (list* v level (reverse! data)) d)) ha)
       d
    )
   ;;;#f
   ()
 )
)) 
     

;;;  
(define (pat-vars p)
   (let* ((patv (pat-up p 1)) (n 0)(d ())(x 0)(v 0) (ha (clear-hash *dot-hash*)))
     (while (pair? patv)
        (set! x (pop patv))
        (set! n (cdr x))
        (set! v (get-hash ha n))
        (if v
               (set-hash ha n (cons (car x) v))
               (set-hash ha n (cons (car x) ()))
         )
     )
   (map-hash (lambda (n data) (push (cons n  data) d)) ha)
   d
))
     
(define (pat-up s n)
  (let* ((x 0) (res ()))
  (while (pair? s)
    (set! x (pop s))
      (if (pair? x)
        (if  (eq? (car x) 'pat)
             (push (cons (cadr x)  n) res)
           (if (eq? (car x) '...)
               (set! res (append (pat-up (cadr x) (+ n 1)) res))
           )
        )
      )
  )
  res
))

(define (patv-hash patv-data)
   (let* ((x 0)(patv (car patv-data)) (data (cdr patv-data))
          (vars (init-data-hash patv))   )
   ;;;   (format #t "~s ~s~%" patv data)
      
      (while (pair? data)
         (set! x (pop data))
         (if (number? x)
               (num-data-hash x patv vars)
               (set-data-hash x patv )
         )
        ;;; (set-hash *data-hash* (car x) (cdr x))
     )
))

(define   (num-data-hash n patv vars)
  (let* ((x 0) (lev 0))
    (while (pair? vars)
       (set! x (pop vars))
       (set! lev (assq x *pat-variable-level*))
       (if (>= (cdr lev) n)
             (set-hash  *data-hash* x (cons n (get-hash  *data-hash* x )))
       )
    )
))   

(define (set-data-hash x patv )
   (let* ((v (car x))(d (cddr x)))
       (set-hash  *data-hash* v (cons d (get-hash  *data-hash* v )))
))
   
(define (init-data-hash patv)
   (let* ((vars ()) (x 0)(v 0))
     (while (pair? patv)
       (set! x (pop patv))
       (set! x (cdr x))
       (while (pair? x )
          (set! v (pop x))
         (set-hash *data-hash* v ())
          (push v vars)
       )    
    )
   vars
))

(define (reverse-data-hash)
        (map-hash (lambda (v data) (set-hash *data-hash* v (reverse! data))) 
            *data-hash*)
)


#| test
  (define (test p f env) (make-match-data p f env)
       (format #t "data-org: ~s~%" *match-data-org*)
       (format #t "data: ~s~%" *match-data*)
       (format #t "dot-data: ~s~%" *match-dot-data*))

  (define p (pat-trans '(do ((var init step ...) ...)
         (test expr ...)
         command ...)   ()))

  (test p  '(do ((i 0 (+ i 1)) (j 5)) ( (= i 0)(write a )) h (yo s)) ())
  (test p  '(do ((i 0 (+ i 1)) (j 5) (k 7 (- k 1) foo)) ( (= i 0)(write a )) h (yo s)) ())

  (define (ttt )(dot-data-trans *match-dot-data*))

  (ttt)

  (define q  '((( b ...) (c ...)...)...))
  (define p (pat-trans q ()))
  (test p '((x 8 7 (s a)()(u)) (b c) (d (e)))  ())
 
  (ttt)

  (test p '(((x 8 7) (s a)(x )(u)) ((b)( )) ((d) (e)))  ())
  
  (test p '(((x 8 7) (s a)(x )(u)) (()( )) ((d) (e)))  ())

  (ttt)

 |#

#|
;;;;  New 05.10.15
;;;;
;;;  level is 0 for top 1 for ... 2 for ... ...
;;;;
;;;   mada!!!
(define *pvar-level* ())
(define *pvar-database* ())
   
(define (get-match-data pvar level)
  (let* ((v (assq pvar *match-data*)))
    (cond  ( v (cdr v) )
           ((= level 0) #f)
           (else (get-match-dot pvar level))
    )
))

;;;;(define (get-match-dot pvar level)    
   
|#

