;;;  2010.7.10  psyntax
;;;

(define *macro-bind* ())

(define (make-psyntax lite pat template)
  (let* ((vars 0)(env 0) (ans 0))
   (set! *literal* lite)
   (set! pat (s->pat pat)) 
   (set! template (template-trans template))
   (set! vars *vars*)
   (set! env *macro-env*)
   (lambda (x)
       (set! *vars* vars)
       (set! *macro-env* env)
       (set! ans (s-match pat x))
       (if ans
          (cons #t (template-exec template))
          #f
        )
     )
))

;;;;  yet, fender is not supported
 (define-macro ( syntax-case exp lite . clauses)
   `(let* ((form 0)(ans #f)(rule 0)(pat 0)(tem 0)(rules ',clauses))
       (set! *literal* ,lite)
          ;;;(set! form (eval exp ()))
       (while (and (not ans) (pair? rules))
          (set! rule (car rules))
          (set! pat (s->pat (car rule)))
          (set! ans (s-match pat ,exp))
          (if ans
               (set! form (eval (cadr rule)()))
          )
         (set! rules (cdr rules))
       )
      (if ans  form (error E_illegal ,exp))
    )
)

(define (expand-rules rules form)
  (let* ((rule 0))
    (if (pair? rules)
      (begin
         (set! rule (car rules))
         (if  (s-match (s->pat (car rule)) form)
                (if (null? (cddr rule))
                        (cons #t (eval (cadr rule)()))
                     ;;;;fender
                      (if (eval (cadr rule) *macro-env*)
                         (cons #t (eval (caddr rule)()))
                      )
                )
             (expand-rules (cdr rules) form)
         )
      )
     #f
    )
))

 (define-macro ( syntax-case exp lite . clauses)
   `(let* ((form 0)(ans #f)(rule 0)(pat 0)(tem 0)(rules ',clauses))
       (set! *literal* ',lite)
       (set! ans  (expand-rules rules ,exp))
      (if ans  (cdr ans) (error E_illegal ,exp))
    )
)

(define-macro  (syntax x)
    `(template-exec (template-trans ',x))
)


(define (f x)
     (syntax-case x () ((OR) (syntax #f))  ((OR x) (syntax x) )
         ((OR x y ...) (syntax (let*  ((temp x)) (if temp temp (OR y ...)))))) 
)
;;;;   see P192, DYBVIG
(define syntax-rules-trans
   (lambda(x)
    (eval
       (syntax-case x (syntax syntax-case *macro-key* *macro-env*)
          ((_ (i ...) ((keyword .  pattern) template )...)
             (syntax
               (let* ((macro-key *macro-key*)(syntax-env 
                (make-syntax-env '(i ...) '(pattern ...) '(template ...)
                       (interaction-environment))))  
                 (lambda (x) 
                    (set! *macro-env* syntax-env)
                    (set! *macro-key* macro-key)
                    (syntax-case x (i ...)
                       ((_ . pattern)(syntax template)) ...))
               )
             )
      ))    (interaction-environment))
   )
)

;;;(trace template-do read-env)

(define (make-syntax-env lit pat temp env)
   (let* ((p 0)(tm 0)(*literal* lit )(freev ()))
      (while (pair? pat)
         (set! p (pop pat))
         (s->pat p)
         (set! p *vars*)
         (set! tm (pop temp))
         (set! freev (free-var tm *vars* env freev))
       )
      freev
  )
)

(trace make-syntax-env)

(define (free-var temp vars env freev)
   (let* ((x 0))
   (cond ((symbol? temp)
             (cond ((assq temp vars)
                       freev)
                   ((assq temp freev)
                        freev)
                   ((assq temp *literal*)
                        freev)
                   ((eq? temp '...)
                        freev)
                   (else
                      (set! x (assq temp env))
                      (if x
                         (push x freev)
                         (if (symbol-bind? temp) 
                             (push (cons temp (eval temp ())) freev)
                             freev   ;;;No bind
                         )
                      )
                     )
               )
             )
          ((pair? temp)
               (set! freev (free-var (car temp) vars env freev))
               (free-var (cdr temp) vars env freev)
              )
          (else
             freev)
    )
 ))

(define g
   (list *alias-name*
    (syntax-rules-trans
      '(syntax-rules  (foo) ((OR )  #f)
         ((OR foo x) (foo x))
         ((OR x)  x )
         ((OR x y ...)  (let*  ((temp x)) (if temp temp (OR y ...)))))
    ))
)
(define v (cadr g))

(define-macro (define-syntax key syntax-rules)
    `(let* ((transformer ())(key-macro ())
               (macro-bind *macro-bind*)(memo ()))
          (set! *macro-key* ',key)
          (set! transformer (syntax-rules-trans ',syntax-rules))
          (set! key-macro  
               (macro x (set! *key-macro* key-macro)
                        (set! memo *macro-bind*)
                        (set! x (transformer (cons ,key x)))
                        (set! *macro-bind* memo)
                        (set! *macro-key* #f)
                        x
                )
           )
          (set! *macro-bind* (cons (cons ',key 
               (cons key-macro  transformer))
                   *macro-bind*))
             ;;;;  (key  key-macro  .  transformer )
          (set! *macro-key* #f)
          ',key
     )
)

          
