;;;  2010.7.2
;;; 2010.7.23
(define *key-macro* #f)    ;;;;  macro for key.   see psyntax.ss
(define macro-key  '(:macro))    ;;; for macro-alias
(define *local*  '(:local))    ;;; for local var
(define *macro*  '(:local))    ;;; for syntax-macro
(define *freev*  '(:local))    ;;; for free var
(define *syntax-loads* ())   ;;; for syntax-load  (alias var key)

(define *macro-flag* #f)

(define (syntax-alias s)
  (let* ((a (assq s *alias-name*)))
        (set! *macro-flag* #f)
     (if a 
         (cdr a)     ;;;; s already registered!
        (begin
          (set! a (assq s *macro-env*))
          (set! a (assq s *local-env*))
          (if a
             (begin
                (set! a (cdr a))
                (cond ((special? a )(special-alias s))
                      ((macro? a)   ;;; incomplete, for classic-macro
                                    ;;;  to be symbol as alias name!!!
                          (set! *macro-flag* #t)
                          (alias-name s)      
                          )
                      (else (alias-name s ))
                )
              ) 
            (syntax-alias-aux s)
          )
        )
      )
))
(define  (syntax-alias-aux s)
  (let* ((a ()))
       (if (symbol-bind? s)
            (if (special? (symbol-value s)) 
                  ;;;(symbol-value s)
                  (special-alias s)
               (begin
                 (set! a (alias-name s))
                 (push  (cons a (symbol-value s)) *macro-env*) 
                 a
               )
            )
          (begin
             (alias-name s )
          )
        )
))

(define  (alias-name s )
   (let* ((x (gensym)))
         (set! *alias-name* (cons (cons s x) *alias-name*))
    x
 ))    

(define (template-exec form)
   (dot-env)
   (init-read-env)
   (set! form (get-true-value (template-do form 0)))
   (if (null? *syntax-loads*)
         form
      (begin
         (if *local-syntax*
           ;;;;(list 'let-syntax-environment *syntax-loads* form)
            form
           (begin
             (set! form (list 'syntax-environment *syntax-loads* form))
             (set! *syntax-loads* ())
             form
           )
         )
      )
   )
)

;;;  env is of the syntax-rules
(define (template-trans  form )
    ;;;;(set! *syntax-loads* ())   
    (set! *alias-name*  ())
    (template-trans-do form)
)

(define (template-trans-do  form )
     ;;; (format #t "template-trans:local-env ~s~%" *local-env*)
      (cond ((symbol? form)
                 (template-symbol-change form ))
           ((pair? form)
                 (template-list-change form ))
           (else form)
       )
)

(define   (template-symbol-change form )
  (let* ((x 0)(a 0))
             (set! x (assq form *vars*))
             (if x 
                  (list patvar form) 
               (begin
                  (set! x (assq form *macro-env*))
                  (cond   ((eq? form *macro-key*) macro-key) ;;;New!!
                          ((member form  *literal*)  ;;;literal check is
                                                     ;;; done in pat-match
                              form)
                          (x  
                              (set! a (syntax-alias form))
                              (list *local* form a x)
                           )
                          (else
                              (template-symbol-change-aux form )
                          )
                 )
               )
             )  
))

(define (template-symbol-change-aux form )
   (let* ((x (assq form *macro-bind*)) )
     ;;; (format #t "local-env ~s~% macro-env ~s~%" *local-env* *macro-env*)
       (if x
             (list *macro* form (syntax-alias form) x)
            (if (special? form)
                 (special-alias form)
              (begin
               (set! x (syntax-alias form))
               (list *freev* form  x (symbol-value x))
              )
            )
        )
))


(define   (template-list-change form )
  (let* ((P (car form)) (Q (cdr form)))
     (cond 
          ((and (pair? Q) (eq? (car Q ) '...))
              (set! P (list dot (template-trans-do P )))
              (cons P (template-trans-do (cdr Q) ))
              )
          ((eq? P '...)  ;;;  (... A) means A
              form)   ;;;;  change A  at the last    
          (else
            (cons (template-trans-do P )(template-trans-do Q ))
          )
    )
))
;;;;;;

(define-macro (true-value f)
  `(cons patvar ,f)
)
(define (get-true-value f)
   (if (and (pair? f) (eq? (car f) patvar))
       (cdr f)
        f
   )
)

(define (template-do form level)
   (let* ((x 0))
      (if (pair? form)
          (if (eq? form macro-key)
              *macro-key*
              (template-list form  level)
          )
          ;;;;  form may be #f!!!
         (true-value  form)
      )
))

(define (template-list-dot P Q level)
   (let* ((x #t) (res ()))
         (inc level)
           (while x
             (set! x (template-do (cadr P)  level))
             (when x
                (push (get-true-value x) res)
                (set! x  (read-env-next level))
             )
           )
           (dec level)
           (set! x  (template-do Q level))
           (if (= level 0) (read-env-clear))
           (if x
              (append (reverse res) (get-true-value x))
               #f
           )
))

(define (template-list-local  Q level)
  (if (eq? (caddr Q) (assq (car Q) *local-env*))
          (car Q)
      (begin
       
         (push (list (cadr Q) (car Q) (caddr Q))  *syntax-loads* );;; incomplete
         (cadr Q)
       )
  )
)

(define (template-list-freev  Q level)
  (if (assq (car Q) *local-env*)
      (begin
         (push (list (cadr Q) (car Q) *macro-key*)  *syntax-loads* )
         (cadr Q)
      )
      (car Q)
  )
)

(define (template-list-macro  Q level)   ;;;; mada
    (if (assq (car Q) *local-env*)
           (begin
             (push (list (cadr Q) (car Q) (car Q))  *syntax-loads* )
             (cadr Q)
           )
         (car Q)
    )
)

(define (template-list-pairP P Q level)
   (let* ((x 0)(y 0)) 
       (set! x  (template-do P level))   ;;;  may be #f if ...
       (if x
           (begin
               (set! y  (template-do Q level))
               (if (or y (not (pair? Q)))
                    (cons (get-true-value x) (get-true-value y))
                #f)
           )
                   #f   ;;; (template-do Q level)
      )
))

(define (template-list form level)
  (let* ((x #t)(y #t)(P (car form)) (Q (cdr form))(res ()))
    (if (and (pair?   P) (eq? (car P) dot))
           (template-list-dot P Q level)
       (cond ( (eq? P patvar)
             (set! x (read-env (car Q)))
             (if x (true-value (cadr x)) #f)
               )
             ( (eq? P *local*)
                     (template-list-local  Q level))
             ( (eq? P *freev*)
                     (template-list-freev  Q level))
             ( (eq? P *macro*)   ;;;; mada
                     (template-list-macro  Q level)   ;;;; mada
                   )
          ( (pair? P)
                (template-list-pairP P Q level))
           (else
                      (set! y  (template-do Q level))
                  (if (or y (not (pair? Q)))
                    (begin
                      (set! x  (get-true-value (template-do P level) ))
                      (cons x  (get-true-value y))
                    )
                    #f
                  )
          )
       )
    )
) )
