;;;  2010.7.10  psyntax
;;;  2010.7.27  psyntax2.ss
;;;;

(define *syntax-binds*  ())
(define *local-syntax*  #f)

;;;;   syntax   is a macro like a quote
 (define-macro  ( syntax form)
     `(template-exec (template-trans ',form))
 )

(define (pre-expand-rules rules)
  (let* ((last (cons ()())))
     (if (pair? rules)
         (pre-expand-rules-aux rules last)
     )
    (cdr last)
))

(define (pre-expand-rules-aux rules last)
  (let* ((rule 0)(pat 0)(temp 0)(fender #t))
         (set! rule (car rules))
         (set! pat  (s->pat (car rule)))
         (set! pat  (list *vars* *max-level* pat))
         ;;;(set! pat   (car rule))
         (if (null? (cddr rule))
               (set! temp (cadr rule))
             ;;;;fender
               (begin
                   (set! fender  (cadr rule))
                   (set! temp (caddr rule))
               )
         )
        ;;;(set! temp (template-trans temp))
        (set-cdr! last (cons (list pat fender temp) ()))
       (if (pair? (cdr rules))
             (pre-expand-rules-aux (cdr rules) (cdr last))
       )
))

 (define-macro ( syntax-case-transformer  lite . rules)
   (let* ((form 0)(ans #f)(rule 0)(memo ())(pat 0)(env *local-env*))
       (set! *literal* lite)
       (set! *macro-env* env)
       (set!  rules (pre-expand-rules rules))
       (set! memo rules)
       (lambda (exp)
          (set! *macro-key* (car exp))
          (set! *macro-env* env)
          (set! ans #f)
          (set! rules memo)
         (while (and (not ans) (pair? rules))
           (set! rule (car rules))
           ;;;(set! pat (s->pat (car rule)))
           (set! pat  (car rule))
           (set! *vars* (car pat))
           (set! *max-level* (cadr pat))
           (set! pat (caddr pat))
           (set! ans (s-match pat exp))
           (if ans (set! ans (eval (cadr rule) *local-env*)))  ;;; fender
           (if ans
               (set! form (eval (caddr rule) *local-env*))
           )
           (set! rules (cdr rules))
         )
        (if *macro-key*
             (begin  (push-syntax-binds  *macro-key* *macro-env*)
                  (set! *macro-key* #f))
        )
        (if ans  form (error E_illegal exp))
       )
)) 

(define-macro ( syntax-case exp lite . clauses)
   `((syntax-case-transformer ,lite ,@clauses)
          ,exp)
 )

;;;;   see P192, DYBVIG
(define-syntax syntax-rules
     (lambda (x)
       (syntax-case x
          (*macro-key* *macro-env* *local-env* *alias-name*)
          ((_ (i ...) ((keyword .  pattern) template )...)
             (syntax
               (let* (
                 ;;;syntax-env   *macro-env*
                 (syntax-env   *local-env*
                   )
                 (alias-name ()) (memo ())
                  )  
                 (format #t "syntax-rules-local-env: ~s~%" *local-env*)
                   (lambda (y) 
                    (set!  memo *macro-env*)
                    (set! *macro-env* syntax-env)
                 (format #t "EX-syntax-rules-macro-env: ~s~%" *macro-env*)
                 (format #t "EX-syntax-rules-local-env: ~s~%" *local-env*)
                    (set! *alias-name* alias-name)
                    (set! y (syntax-case y (i ...)
                       ((_ . pattern)(syntax template)) ...))
                    (set! syntax-env *macro-env* )
                    (set! alias-name *alias-name*)
                    (set! *macro-env* memo)
                    y 
                   )
                 )
               )
             )
      ))   
)

(define  (push-syntax-binds key macro-env)
  (let* ((x (assq key  *syntax-binds*)))
    (if (pair? macro-env)
       (if x
          (set-cdr! x macro-env)
          (push (cons key macro-env) *syntax-binds*)
       )
    )
))
         
#|
(define-macro (define-syntax key syntax-rules)
    `(define ,key  (let* ((transformer ()))
          (set! *macro-key* ',key)
          (set! transformer (eval (syntax-rules-trans ,syntax-rules) *local-env*))
          ;;;(push (cons *macro-key* *macro-env*) *syntax-binds*) 
          (push (cons *macro-key* *bind-env*) *syntax-binds*) 
          (set! *bind-env* ())
             ;;;;  (key  key-macro  transformer )
          (set! *macro-key* #f)
          transformer
     )
))
|#
;;(trace template-trans)
(define-syntax syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias (syntax-load (quote var ) (quote key))) ...)
                 form
            )
        )
   )
)
(define-syntax let-syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias var) ...)
                 form
            )
        )
   )
)

(define (syntax-load var key)
    (let* ((x (assq key *syntax-binds*)))
       (if (not x )
              (error E_illegal key)
           (begin
              (set! x (assq var (cdr x)))
              (if x
                  (cdr x)
                  (error E_illegal var)
              )
           )
       )
))

;;;;
(define-syntax let-syntax-transformer 
   (syntax-rules 
      (*local-env* *syntax-loads* *macro-env* *local-syntax* )
       ((_ ((key  exp)...))
              (let*  ((env *local-env*) (memo 0))
               (format #t "let-syntax-local-env:~s~%" *local-env*)
                (define-syntax key exp) ...
                (set! env *local-env*)
                (lambda (x)  
                   (set! *syntax-loads* ())
                   (set! memo *macro-env*)
                   (set!  *macro-env* env)
                   (set!  *local-env* env)
               (format #t "let-syntax-macro-env:~s~%" env)
                   (set! *local-syntax* #t)
                   (set! x (syntax-expand  x *local-env*)) 
                   (format #t "let-syntax-loads:~s~%" *syntax-loads*)
                   (set! *local-syntax* #f)
                   (set! *macro-env* memo)
                    x
                ))
         ) 
      )
)

(define-macro (let-syntax key-exp . forms)
     (let*  ((form ()) (memo 0) )
         (set! memo *local-env*)
         (set! *macro-env* memo)
         (format #t "let-syntax env:~s~%" *macro-env*)
#|
           (set! form  (eval (syntax-expand
             `((let-syntax-transformer ,key-exp) '(begin ,@forms))
              *local-env*) ()) ) 
|#
           (set! form   
             (eval (syntax-ex `(let-syntax-transformer ,key-exp)) *local-env*))
         (set! *local-env* memo)
         (set! *macro-env* memo)
            (set! form  (form (cons begin forms)))
            (set! form `(let-syntax-environment
                ,*syntax-loads* ,form))
            (set! *syntax-loads* ())
            form  
     )
 )

(define-macro (letrec-syntax key-exp . forms)
     (let*  ((form ()) (memo 0) )
         (set! memo *local-env*)
         (set! *macro-env* memo)
           (set! form  (eval (syntax-ex
             `(letrec-syntax-transformer ,key-exp)) *local-env*))
        ;;; (set! *local-env* memo)
         (set! *macro-env* *local-env*)
            (set! form  (form (cons begin forms)))
            (set! form `(let-syntax-environment
                ,*syntax-loads* ,form))
            (set! *syntax-loads* ())
            form
     )
 )

(define (set-top-macro!)   ;;; mada
    (let* ((x ())(c 0))
       (format #t "set-top:macro ~s ~% local ~s~%"  *local-env*)
       ;;(set! x (car *local-env*))
       ;;(set! c (assq (car x) *local-env*))
       ;;(set-cdr! c (cdr x))
))

(define dummy (->syntax (lambda(x) (cdr x))))

(define-macro (letrec-syntax-helper . key-exps)
   (let* ((s key-exps) (res ()))
      (while (pair? s)
          (push (list 'set-top-macro!) res)
          (push (list 'define-syntax (caar s)(cadar s)) res)
          (set! s (cdr s))
      )
     (set! s key-exps)
      (while (pair? s)
         (push (list 'push (list 'cons (list 'quote (caar s)) dummy) '*local-env*)
                res)
         (set! s (cdr s))
      )
   (cons 'begin res)
))

(define-syntax letrec-syntax-transformer
   (syntax-rules ( *local-env* *macro-env* *local-syntax*)
       ((_ ((key  exp) ...))
              (let*  ((env *local-env*) (memo 0))
               (format #t "letrec-syntax-local-env:~s~%" *local-env*)
                (letrec-syntax-helper  (key exp) ...) 
               (format #t "After: let-syntax-local-env:~s~%" *local-env*)
                (set! env *local-env*)
                (lambda (x)
                   (set! *syntax-loads* ())
                   (set! memo *macro-env*)
                   (set!  *macro-env* env)
                   (set!  *local-env* env)
               (format #t "letrec-syntax-macro-env:~s~%" env)
                   (set! *local-syntax* #t)
                   (set! x (syntax-expand  x *local-env*))
                   (format #t "let-syntax-loads:~s~%" *syntax-loads*)
                   (set! *local-syntax* #f)
                   (set! *macro-env* memo)
                    x
                ))
         )
      )
)

