;;;;  名前の衝突の危険が常にあることに注意
;;;;   sr2lib.ss     from libmacro.ss
;;;   revised for ss2.0  2007.9.10
;;;  Not use macroexpand in 1.99  !!!
;;;;  2010.8.12   after macro-boot.ss
;;;;

;;;;  compiler needs
 (define (compiler-eval . x )
   x   ;;;; do nothing
       ;;; However this is a function. So, args are evaluate!!!
        ;;;   used in struct.ss
 )

(define-macro (compiler-not-eval . x )
   `(begin ,@x)    ;;;; do in ss   
)

;;; let
(define (gen-alias  args)
   (if (pair? args)
           (cons (gensym) (gen-alias  (cdr args)))
       ()
  )
)
#|
(define-macro (let bind . body)      ;;   supported named loop!!!
   (if (symbol? bind)
     (let* ((s bind) (arg ()) (ini ()))      ;;;;  named let
        (set! bind (car body))
        (set! body (cdr body))
        (set! arg (take-car bind))
        (set! ini (take-2nd bind))
     `(letrec ((,s (lambda ,arg ,@body)) )
          (,s ,@ini)
       )
     )

     (let* ((arg (gen-alias (take-car bind))))
      `(let*  ,(arg-bind arg (take-2nd bind))
           (let*  ,(arg-bind (take-car bind) arg)
                   ,@body
            )
       )
    )
  )
)
|#
(define (arg-bind arg values)
   (if (pair? arg)
      (cons (list (car arg) (car values))  (arg-bind (cdr arg) (cdr values)))
     ()
   )
)

(define (take-car lis)
  (if (pair? lis)
     (cons (caar lis) (take-car (cdr lis)))
     ()
  )
)

(define (take-2nd lis)
  (if (pair? lis)
     (cons (cadar lis) (take-2nd  (cdr lis)))
     ()
  )
)


#|   mada
(define-macro (case case-key . case-body)
   (let* ((case-key-res (gensym)) (get-case-body ()) )
     (set! get-case-body
          (map (lambda (case-c) (make-case-c case-key-res  case-c))
               case-body)  )
    `(let*  ((,case-key-res  ,case-key))
        (cond 
        ,@get-case-body
        )
     )
))
(define (make-case-c key case-c)
  (let* ((c-lis 0))
   (if (null? case-c) ()
     (begin
       (set! c-lis (car case-c))
       (set! case-c  (cdr case-c))
       (if (or (eq? c-lis 'else) (eq? c-lis #t))
         `(else  ,@case-c) 
         `((memv ,key (quote ,c-lis)) ,@case-c) 
       )
     )
   )
 ))
|#
#| test
 (case (* 2 3)
   ((2 3 5 7) 'prime)
   ((1 4 6 8 9) 'composite))
|#
#|
(define-macro (while  cond . body)
   `(do ()
        ((not ,cond))
        ,@body)
)
|#


(define-macro (do  inits test . do-body)
  (let*  ((loop-name (gensym)))
    `(letrec ((,loop-name
               (lambda ,(map car inits)
                 (if ,(car test)
                     (begin ,@(if (null? (cdr test))
                                  (list (make-unspecified))
                                  (cdr test)))
                     (begin ,@do-body
                            (,loop-name ,@(map (lambda (init)
                                                 (if (null? (cddr init))
                                                     (car init)
                                                     (caddr init)))
                                               inits)))))))
       (,loop-name ,@(map cadr inits)))))


(define-macro (trace . funcs)
  (let* ((fun 0))
    (if (pair? funcs)
        (begin
             (set! fun (car funcs))
             #|
              (if (eq? fun 'apply)
                     (set! apply trace-apply) ;;; see lib.scm
              )
             |#

          `(begin 
                (trace-f ',fun  ,fun)
                (trace ,@(cdr funcs))
           )
        )
        '*trace*
    )
))

(define-macro (inc var . step)
   (if (pair? step)
     `(set! ,var (+ ,var ,(car step)))
     `(set! ,var(1+ ,var))
   )
)

(define-macro (dec var .  step)
   (if (pair? step)
     `(set! ,var (- ,var ,(car step)))
     `(set! ,var(1- ,var))
  )
)
;;;; used OGL,  STk
#|
(define-macro (foreach foreach-var foreach-lis . foreach-body)
   (let*  ((foreach-lisvar (gensym)))
     `(do ((,foreach-var 0)(,foreach-lisvar ,foreach-lis))
          ((null? ,foreach-lisvar))
          (set! ,foreach-var (car ,foreach-lisvar))
          ,@foreach-body
          (set! ,foreach-lisvar (cdr ,foreach-lisvar))
      )
   )
)
|#
;;;;   eval-interaction
;;;;  -> (:LOAD :REG :ENV)
;;;;       for ss2.0
(define-macro (interaction-environment)
   ;;;;'(LOAD-REG  :ENV)
   '(INLINE ENV->SCM)    ;;; V2.0 5.22
)

;;;;   for debug
(define-macro (env)
  `(begin
     (write "env: ")
     (write (interaction-environment))
     (newline)
   )
)

;;;;  ***************** end libmacro  ***********************

;;;;;;   chk
#|  OK
(do ((x '( r t u)))
    ((null? x))
   (write (pop x))
   ; (read)
)

OK for x='(1)   Dame for x='(1 2)
OK!   see below

(define (f x)
  (letrec ((g (lambda(x) (if (null? x) x (begin (write (car x)) (g (cdr x)))))))
     (g x)
  )
)

(define (f x)
  (let ((y 9999))
     (write y)
))

(define (f x)
  (let*  ((y 9999)(z y))
     (write z)
))


    dame! for x='(1)   (cdr x) x unbdd!
OK!   changed begin_eval
(define (f x) (if (null? x ) x (begin (write (car x)) (f (cdr x)))))

 (map (lambda(x) (pair? x)) '(3 4 (5)))

|#

;;;  values.c  to be  deleted
;;;

(define thru  (lambda x x))
(define-macro (values->list  proc)
    `(call-with-values (lambda() ,proc) thru) 
)


