;;;  2010.7.10  psyntax
;;;  2010.7.27  psyntax2.ss
;;;; 2010.8.13  psyntax4.ss


(in-package "macro")
(define *syntax-binds*  ())
(define *local-syntax*  #f)
;;;;(define *transform-level*  0) ;;; transformer call level
                ;;;;   for keep patvar be special as literal in lower level

;;;  (load  "r5rs-env")  ->ini
(load "psyntax-aux")  ;;;incomplete

;;;;   syntax   is a macro like a quote
;;;;   *local-env* used in template-trans as *macro-env*
;;;;   'x is not expanded , but (syntax x) is expanded and quoted
 (define-macro  ( syntax form)
     ;;;`(template-exec (template-trans ',form ',*local-env*))
     ;;`(template-exec (template-trans ',form ))
     `(quote ,form )  ;;;;!!! quote
 )

(define (pre-expand-rules rules)
  (let* ((last (cons ()())))
     (if (pair? rules)
         (pre-expand-rules-aux rules last)
     )
    (cdr last)
))

(define (pre-expand-rules-aux rules last)
  (let* ((rule 0)(pat 0)(temp 0)(fender #t))
         (set! rule (car rules))
         (set! pat  (s->pat (car rule)))
         (set! pat  (list *vars* *max-level* pat))
         ;;;(set! pat   (car rule))
         (if (null? (cddr rule))
               (set! temp (cadr rule))
             ;;;;fender
               (begin
                   (set! fender  (cadr rule))
                   (set! temp (caddr rule))
               )
         )
        ;;;(set! temp (patvar-trans temp))
        (make-syntax-bind *macro-key* temp)
        (set-cdr! last (cons (list pat fender temp) ()))
       (if (pair? (cdr rules))
             (pre-expand-rules-aux (cdr rules) (cdr last))
       )
))

 (define-syntax syntax-case
   (lambda (x)
    `(let* ((form 0)(ans #f)(rule 0)(pat 0)(macro-env ',*local-env*)
             (exp ,(cadr x)) (lite ',(caddr x)) (rules ',(cdddr x))
             ;;;save
             (macro-env-memo *macro-env*)(macro-key *macro-key*)
           ;;;  (vars *vars*) (max-level *max-level*)
             (literal *literal*) (top-env *top-env*)(dot-env *dot-env*)
             (read-env *read-env*)(read-hash *read-hash*)(match-data *match-data*)
            )
          ;;;   x can not see here! on eval this form
          ;;;(format #t "syntax-case-transformer:exp ~s x:~s~%" exp x)
       ;;;(set! *transform-level* (+ *transform-level* 1))
       (set! *literal* lite)
       ;;;(set! *literal* (add-leteral lite vars)) ;;; uplevel pat-var 
                       ;;;;  should not change name
                       ;;;;   but we need change template by pattern &
                       ;;;;  with transform level
       (set! *macro-key*(if (pair? exp) (car exp) #f))
       (set! *alias-name* ())  ;;; This need
       (set! *macro-env* macro-env)
       (set!  rules (pre-expand-rules rules))
          (set! ans #f)
          ;;(format #t "case-transformer rules:~s~%" rules)
         (while (and (not ans) (pair? rules))
          ;;(format #t "case-transformer rule:~s~%" (car rules))
           (set! rule (car rules))
           (set! pat  (car rule))
           (set! *vars* (car pat))
           (set! *max-level* (cadr pat))
           (set! pat (caddr pat))
           (set! ans (s-match pat exp))
           ;;;(if ans (set! ans (eval (cadr rule) *local-env*)))  ;;; fender
           (if ans (set! ans (eval (cadr rule) (interaction-environment))))  ;;; fender
           (if ans(begin
                 (set! form (template-exec (template-trans (caddr rule))))
                 ;;(set! form (eval (caddr rule) *local-env*))
                 (set! form (eval form *local-env*))
              ))
           (set! rules (cdr rules))
         )
        (if (not *local-syntax*)  (begin  (push-syntax-binds  *macro-key* *macro-env*)
                  (set! *macro-key* #f))
        )
          ;;;;  recover syntax-environments
            (set! *macro-env* macro-env-memo)(set! *macro-key* macro-key)
           ;;;  (set! *vars* vars) (set! *max-level* max-level)
             (set! *literal* literal) (set! *top-env* top-env)
            (set! *dot-env* dot-env)
            (set! *read-env* read-env)(set! *read-hash* read-hash)
            (set! *match-data* match-data)
      ;;; (set! *transform-level* (- *transform-level* 1))

        (if ans  form (error E_illegal exp))
)) )

;;;;   see P192, DYBVIG
(define-syntax syntax-rules
     (lambda (x)
       (syntax-case x
          ()
          ((_ (i ...) ((keyword .  pattern) template )...)
             (syntax
                  (lambda (y) 
                    (syntax-case y (i ...)
                       ((_ . pattern)(syntax template)) ...)
                   )
             )
          )
       )
      )   
)
                   ;;;(->syntax (lambda (y)    Not need , perhaps

(define  (push-syntax-binds key macro-env)
  (let* ((x (assq key  *syntax-binds*)))
    (if (pair? macro-env)
       (if x
          ;;;(set-cdr! x macro-env)
          (modify-syntax-binds x macro-env)
          (push (cons key macro-env) *syntax-binds*)
       )
    )
))

(define  (modify-syntax-binds x macro-env)
  (let* ((env (cdr x)) (y 0)(c 0) (new #f))
   (while (pair? macro-env)
       (set! y (pop macro-env))
       (set! c  (assq (car y) env))
       (when (not c)   ;;; new
            (push  y env)
            (set! new #t)
        )
   )
  (if new (set-cdr! x env))
))
         
#|
(define-macro (define-syntax key syntax-rules)
    `(define ,key  (let* ((transformer ()))
          (set! *macro-key* ',key)
          (set! transformer (eval (syntax-rules-trans ,syntax-rules) *local-env*))
          ;;;(push (cons *macro-key* *macro-env*) *syntax-binds*) 
          (push (cons *macro-key* *bind-env*) *syntax-binds*) 
          (set! *bind-env* ())
             ;;;;  (key  key-macro  transformer )
          (set! *macro-key* #f)
          transformer
     )
))
|#
;;(trace template-trans)
(define-syntax syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias (syntax-load (quote var ) (quote key))) ...)
                 form
            )
        )
   )
)
(define-syntax let-syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias var) ...)
                 form
            )
        )
   )
)

(define (syntax-load var key)
    (let* ((x (assq key *syntax-binds*)))
       (if (not x )
              (error E_illegal key)
           (begin
              (set! x (assq var (cdr x)))
              (if x
                  (cdr x)
                  (error E_illegal var)
              )
           )
       )
))

;;;;
(define-syntax  let-syntax-exp
  (syntax-rules ()
    ((_  ((key rule) ...) )
         (let* ((env *local-env*))
         (push (cons 'key (->syntax (eval 'rule *local-env*))) env) ...
            ;;;(format #t "let-syntax-exp interaction: ~s~%" (interaction-environment))
       ;;     (push (cons 'key (->syntax (eval 'rule (interaction-environment)))) env) ...
         ;;;  (format #t "~%let-syntax-exp env: ~s~%" env)
            (lambda(x)  
                   (set! *local-syntax* #t)
                  (set! *macro-env* env)
               (set! x (syntax-expand (cons begin  x) env))
                   (set! *local-syntax* #f)
               x
            )
         ) 
     )
 ))

(define-macro  (let-syntax key . exp)  
  ;;; (sys-eval  (list let-syntax-exp (cons '_ exp)) ()) 
  ;;;   (format #t "let-syntax interaction: ~s~%" (interaction-environment))
   (set! key 
      (eval (syntax-ex `(let-syntax-exp ,key)) *local-env*)
      ;;;(eval (syntax-ex `(let-syntax-exp ,key)) (interaction-environment))
   )
   (set! key (key exp))
   (set! key`(let-syntax-environment
                ,*syntax-loads* ,key))
   (set! *syntax-loads* ())
   key
)
            
(define (letrec-syntax-args keys rules env)
  (let* ((memo keys)(key 0)(rule 0) (local *local-env*))
    (while (pair? keys)
      (push (cons (car keys) ()) env)
      (set! keys (cdr keys))
    )
   (set! keys memo)
   (set! *local-env* env)
  ;;; (set! *macro-env* env)
         ;;;   (format #t "letrec-syntax-args env: ~s~%" env)
   (while (pair? keys)
      (set! key (car keys))   
      (set! rule (->syntax (eval (car rules)env )))
      (set! key (assq key env))
      (set-cdr! key rule)
      (set! rules (cdr rules))
      (set! keys (cdr keys))
   )
   (set! *local-env* local)
  env
))

(define-syntax  letrec-syntax-exp
  (syntax-rules ()
    ((_  ((key rule) ...) )
         (let* ((env *local-env*))
            ;;;(push (cons 'key (eval 'rule *local-env*)) env) ...
            (set! env (letrec-syntax-args '(key ...)'( rule ...) env))
           ;;; (format #t "letrec-syntax-exp env: ~s~%" env)
            (lambda(x)
                   (set! *local-syntax* #t)
               ;;;    (set! *macro-env* env)
       ;;;     (format #t "letrec-syntax-lambda env: ~s~%" env)
               (set! x (syntax-expand (cons begin   x) env))
                   (set! *local-syntax* #f)
               x
            )
         )
     )
 ))

(define-macro  (letrec-syntax key . exp)
  ;;; (sys-eval  (list let-syntax-exp (cons '_ exp)) ())
   (set! key
      (eval (syntax-ex `(letrec-syntax-exp ,key)) *local-env*))
   ;;;  key is not transformer
   (set! key (key exp))
   (set! key`(let-syntax-environment
                ,*syntax-loads* ,key))
   (set! *syntax-loads* ())
   key
)

(define *fluid-recover* ())

(define (fluid-syntax-args keys rules  env)
 (let* ((recover ())
       (key 0)(rule 0)(def 0) (local *local-env*))
   (set! *local-env* env)
   (while (pair? keys)
      (set! key (car keys))
      (set! rule (->syntax (eval (car rules)env )))
      (set! def (assq key env))
      (if def
        (begin
           (push (cons key (cdr def)) recover)
           (set-cdr! def rule)
         )
         (push (cons key rule) env)
      )
      (set! rules (cdr rules))
      (set! keys (cdr keys))
   )
   (push recover *fluid-recover*)
   (set! *local-env* local)
  env
))
(define (fluid-recover)
   (let* ((def 0)(x 0)(recover (car *fluid-recover*)) (key 0)(env *local-env*))
      (while (pair? recover)
         (set! x (pop recover))
         (set! key (car x))
         (set! def (assq key env))
         (if def
              (set-cdr! def (cdr x)) )
      )
     (set! *fluid-recover* (cdr *fluid-recover*))
))

(define-syntax  fluid-let-syntax-exp
  (syntax-rules ()
    ((_  ((key rule) ...) )
         (let* ((env *local-env*))
            ;;;(push (cons 'key (eval 'rule *local-env*)) env) ...
            (set! env (fluid-syntax-args '(key ...)'( rule ...) env))
            (format #t "~%fluid env: ~s~%" env)
            (lambda(x)
                   (set! *local-syntax* #t)
               (set! x (syntax-expand (cons begin  x) env))
                   (set! *local-syntax* #f)
               x
            )
         )
     )
 ))
(define-macro  (fluid-let-syntax key . exp)
  ;;; (sys-eval  (list let-syntax-exp (cons '_ exp)) ())
   (set! key
      (eval (syntax-ex `(fluid-let-syntax-exp ,key)) *local-env*))
   (set! key (key exp))
   (set! key`(let-syntax-environment
                ,*syntax-loads* ,key))
   (set! *syntax-loads* ())
   (fluid-recover)
   key
)


(define dummy (->syntax (lambda(x) (cdr x))))

(export '(fluid-let-syntax syntax syntax-case syntax-rules syntax-load ))
(use-package "macro" "ss")

