;;;  2010.7.2
;;; 2010.7.23
;;;  2010.8.10  template2.ss
;;;  2010.8.15  macro-key   deleted
(in-package "macro")
(define *macro-key* #f)    ;;;;  macro for key.   see psyntax.ss
(define *syntax-loads* ())   ;;; for syntax-load  (alias var key)
(define *given-macro-env* #f)
(define *syntax-alias* ())

(define syntax-transformer? 
   syntax-lambda? 
)

(define (syntax-alias s)
  (let* ((a (assq s *alias-name*))(b 0))
     (if a 
         (cdr a)     ;;;; s already registered!
        (begin
          (set! b (assq s *macro-env*))
          (set! a (assq s *local-env*))
          (if (and a  (eq? a b))
             (begin
                (set! a (cdr a))
                (cond ((special? a )(special-alias s))
                      ((macro? a)   ;;; incomplete, for classic-macro
                                    ;;;  to be symbol as alias name!!!
                          ;;;(alias-name s)  
                           (push (cons s a) *alias-name*)
                           a    
                          )
                      (else  s )   ;;;(alias-name s)
                )
              ) 
             (if a   ;;; 2010.9.20
               (begin
                   (set! a (alias-name s)) 
                   (push (cons s a) *alias-name*)
                   a
               )
               (syntax-alias-aux s)
             )
          )
        )
      )
))
(define  (syntax-alias-aux s)   ;;;; not local-env or local-env != macro-env
  (let* ((a ())(v 0))
       (if (symbol-bind? s)
          (begin
            (set! v (symbol-value s))
            (if (special? v) 
                  ;;;(symbol-value s)
                  (special-alias s)
               ;;;(if (or (classic-macro? v)(syntax-lambda? v))
              ;; (if (syntax-lambda? v)   ;;;2010.9.20
              ;;      v
                (begin
                   (set! a (alias-name s))
                   ;;;;(push  (cons a (symbol-value s)) *macro-env*) 
                   a
                )
              ;; )
            )
          )
          (begin
             (alias-name s )
          )
        )
))

(define  (alias-name s )
   (let* ((x (gensym)))
         (set! *alias-name* (cons (cons s x) *alias-name*))
    x
 ))    

;;;  env is of the syntax-rules
(define (template-trans  form ) ;;; 8.28 
;  (if (not  *given-macro-env*)
;         (set! *macro-env* env)
;  )
     ;; (format #t "template-trans:~s   vars ~s~%" form *vars*)
    (set! *syntax-alias* ())
    (template-trans-do form)
)

(define (template-trans-do  form )
     ;;; (format #t "template-trans:local-env ~s~%" *local-env*)
      (cond ((symbol? form)
                ;; (if (syntax-symbol? form)  ;;;; may be changed in higher level
                ;;    (set! form (car (syntax-cdr form)))
                ;; )
              ;;; (format #t "assq ~s ~s ~s~%" form *vars* (assq form *vars*))
                (if (assq form *vars*)  ;;;; first need, may be syntax-symbol
                    (list patvar form)
                  (if (syntax-symbol? form)
                     form       ;;;  Caution
                     (template-symbol-change form )) 
                )  )
           ((pair? form)
              ;;(if (and (eq? (car form) 'quote) (not (assq form *macro-env*)))
              ;;   form 
                 (template-list-change form )
              ;;; )
            )
           (else form)
       )
)

(define   (template-symbol-change form )
  (let* ((x 0)(a 0)(y 0))
      ;;(format #t "template-symbol-change macro-env:~s~%" *macro-env*)
               (set! x (assq form *macro-env*))
               (cond  ;;; ((eq? form *macro-key*) macro-key) ;;;New!!
                      ((member form  *literal*)  ;;;literal check is
                                                 ;;; done in pat-match
                          form)
                      (x  
                          (set! y (assq form *syntax-alias*))
                          (if y
                              (cdr y)
                            (begin
                             (set! a (syntax-alias form))
                             (set! x
                            ;;; 2010.9.20 , *maro-env*  means let-syntax  
                              ;;(if (syntax-lambda? (cdr x))
                              ;;   (->syntax ( list :macro form  (cdr x)))
                                 (->syntax (list :local form a x))
                              ;;)
                             )
                             (push (cons form x) *syntax-alias*)
                            x
                            )
                          ))
                          (else
                              (template-symbol-change-aux form )
                          )
                 )
))

(define (template-symbol-change-aux form )
   (let* ((x (macro? form)) (v 0) )
     ;;; (format #t "local-env ~s~% macro-env ~s~%" *local-env* *macro-env*)      
      ;;; 2010.9.20  macro means  bound var? 
         ;;; (if  x
          ;;;   (->syntax (list :macro form  x))
            (if (special? form)
                 (special-alias form)
                 ;;;form
              (begin
                (set! x (assq form *syntax-alias*))
                (if x
                   (cdr x)
                  (begin
                    (set! x (syntax-alias form))
                    (set! x
                      (if (symbol-bind? form)
                       (begin
                          (set! v (symbol-value form))
                          (->syntax (list :bound form  x v))
                       )
                       (if (eq? form '_)   ;;; in template
                           form
                           (->syntax (list :freev form  x ))
                       )
                      )
                     )
                     (push (cons form x) *syntax-alias*)
                    x
                  )
                )
              )
            )
        ;;)
))


(define   (template-list-change form )
  (let* ((P (car form)) (Q (cdr form)))
     (cond 
          ((and (pair? Q) (eq? (car Q ) '...))
              (set! P (list dot (template-trans-do P )))
              (cons P (template-trans-do (cdr Q) ))
              )
          ((eq? P '...)  ;;;  (... A) means A
              form)   ;;;;  change A  at the last    
          (else
            (cons (template-trans-do P )(template-trans-do Q ))
          )
    )
))
