;;;; function stream
;;;   allow unread  str input port
;;;;

(in-package "allow-unread")

(define (make-unread-func open-func reopen-func)
   (let* ((input-buff ()) (stream #f))
     (lambda (op x)
   ;;;;    (format #t "test: ~s ~s~%" op x)
      (cond ((eq? op :input)
              (if (pair? input-buff)
                     (pop input-buff)
                     (read-char stream)
               )
             )
           ((eq? op :unread)
                  (push x input-buff)
                    x
             )
           ((eq? op :ready) #t)
           ((eq? op :open)
               (set! stream (apply (function open-func) x))
                :unread
              )
          ((eq? op :close)
               (close-port stream)  )
           ((eq? op :reopen)
               (funcall  reopen-func stream)
            )
          (else #f)
       )
    )
))
     
(define (make-unread-str-func)
   (make-unread-func open-input-str reopen-str)
)              

(define (allow-unread-str-port str)
     (open-input-func (make-unread-str-func) str)
)

;;;(define in (allow-unread-str-port  "step"))
(export 'allow-unread-str-port)
(use-package "allow-unread" "ss")    

