;;;  by Jonathan Rees
;;;  The Scheme of Things; The June 1992 Meeting
;;;  by  Dybvig

;;;  2010.4.12 modified by S.Sato
;;;; 2020.4.26   my3-> my4
;;;;   *here* ->  BA
(define dynamic-wind #f)

;;;;(define *here* (list #f))


(define  (call/cc proc)
   (let* ((there (INLINE BA->SCM)))   ;;;;  *here* ->there
      (CALL/CC (lambda (continue)
                   (proc (lambda results
                            ;;; (format #t "call/cc: *here* ~s~%" *here*)
                            (reroot! there)
                            (apply continue results)))))))
(define call-with-current-continuation call/cc)

(define ( dynamic-wind  before during after)
   (let* ((here (INLINE BA->SCM)))
     (cons #f here) ;;;  new dynamic level
      (INLINE SETENV here)
      (INLINE SCM->BA)
      (before)
      (cons (cons before after) here)
      (INLINE SETENV here)
      (INLINE SCM->BA)
      ;;;(set! *here* (cons (cons before after) *here*))
     ;;; (format #t "****  dynamic-wind execute during...~%")
      (call-with-values during
         (lambda results
            (cdr (INLINE BA->SCM))
            (INLINE SETENV here)
             (INLINE SCM->BA)
            (after)
            (cdr (INLINE BA->SCM))
            (INLINE SETENV here)
             (INLINE SCM->BA)
            (apply values results)
        ))))

(define (reroot! there)
   (let* ((here (INLINE BA->SCM)))
    (if  (not (eq? here there))
      (let* ( (tail (common-tail here there)))
        ;;;(format #t "***   reroot! called  there=~s~% ***  here=~s~%" there here)
             (while (not (eq? here tail))
                 (cdr here)
             (INLINE SCM->BA)
                (if (car here)
                     ((cdar here))   ;;; after
                )
                ;;;(set! here (cdr here))
            (set! here (INLINE BA->SCM))
               
             )
           (do-before there tail)
           there
          (INLINE SCM->BA)
       )
     )
))
(define (do-before there tail)
   (if (not  (eq? there tail))
       (do-before (cdr there) tail)
   )
   (if (car there)
       (begin
           (cdr there)
          (INLINE SCM->BA)
           ((caar there))  ;;;before
       )
     )
)
