;;;;   file util
;;;;

(define (get-file-ext file)
  (let* ((f (file-sepa-ext file)))
    (if (equal? (cdr f)  "")
        #f
        f
    )
))

(define get-temp-file  make-temp-file)

(define (backup-file-name file)
   (let ((n 0) (backup #f))
     (if (not (file-exists? file)) (error E_open file))
     (while (not backup)
        (set! backup (string-append file "-back" (number->string n)))
        (when (file-exists? backup)
               (set! backup #f)
               (set! n (+ 1 n))
        )
    )
   backup
))

(define (backup-file file)
  (let* ((back (backup-file-name file)))
     (copy-file file back)
))

(define (new-file-name file)
     (if (not (file-exists? file)) 
         (begin
            (close-port (open-output-file file))    ;;create file
            file    ;;; return file if not exist
         )
       (let* ((x (file-sepa-ext file)) (head (car x))(ext (cdr x))
                 (n 0) (new #f))
         (while (not new)
            (set! new (string-append head "-new" (number->string n) ext))
           (if (file-exists? new)
               (set! new #f)
               (close-port (open-output-file new))    ;;create new
          )
           (set! n (+ 1 n))
         )
        new  ;;; otherwise return new
      )
    )
)


