;;;  kconv
;;;     return string   even if conv fails
;;;  2004.11.27

(define (kconv str code)
   (let* ((x 0)(org (kanji-code? str)))
      (cond ( (or (eq? org :ascii) (not org))  str)
            ( (eq? org code)
                 str  )
            ( else
                (set! x (funcall (kconv-func org code) str))
                (if x 
                     x
                   (if (eq? code :sjis)
                        str
                       (begin
                          (set! x (funcall (kconv-func :sjis code) str))
                          (if x  x str)
                       )
                   )
               )
            )
       )
))

(define (sjis->jis x)
  (set! x (sjis->euc x))
  (if x (euc->jis x) x)
)

(define (sjis->utf8 x)
  (set! x (sjis->euc x))
  (if x (euc->utf8 x) x)
)

(define (jis->sjis x)
  (set! x (jis->euc x))
  (if x (euc->sjis x) x)
)

(define (jis->utf8 x)
  (set! x (jis->euc x))
  (if x (euc->utf8 x) x)
)

(define (utf8->jis x)
  (set! x (utf8->euc x))
  (if x (euc->jis x) x)
)

(define (utf8->sjis x)
  (set! x (utf8->euc x))
  (if x (euc->sjis x) x)
)



(define (kconv-func org code)
   (cond ( (eq? org code) (lambda(x) x))
         ( (eq? org :euc)
             (cond ((eq? code :jis) euc->jis)
                   ((eq? code :sjis) euc->sjis)
                   ((eq? code :utf8) euc->utf8)
             )
           )
         ( (eq? org :sjis)
             (cond ((eq? code :euc) sjis->euc)
                   ((eq? code :jis) sjis->jis)
                   ((eq? code :utf8) sjis->utf8)
             )
           )
         ( (eq? org :jis)
             (cond ((eq? code :euc) jis->euc)
                   ((eq? code :sjis) jis->sjis)
                   ((eq? code :utf8) jis->utf8)
             )
           )
         ( (eq? org :utf8)
             (cond ((eq? code :euc) utf8->euc)
                   ((eq? code :jis) utf8->jis)
                   ((eq? code :sjis) utf8->sjis)
             )
           )
         (else
            ;;;(format #t "kconv error ~s ~s~%" org code)
            (error 800 code)  )
   )
)

;;;;  file
(define (file-code? file)
  (let* ((x 0)(s 0)(k :ascii)(ct 8)(max-read 6000)(in (open-input-file file)) )
        (set! x (read-line in))
    (while (and (> ct 0) (> max-read 0)(not (eof-object? x)))
        (set!  s x)
        (dec max-read (string-byte-length s))
        (set! x (kanji-code? x))
        ;;;(format #t "~s " x)
        (if  x
           (when (not (eq? x :ascii))
              (cond ((eq? k :ascii) (set! k x))
                    ((eq? k x) (dec ct))
                    ((eq? k :jis) (set! k x) (set! ct 8))
                    ((eq? x :sjis) (set! k x) (set! ct 8))
                    ((eq? k :sjis) (dec ct))
                    ((eq? x :jis))
                    ((eq? x :utf8) (dec ct)) 
                    ((eq? x :euc) (set! k x) (set! ct 8))
              ) 
           )
           (begin
              (set! ct 0)
              (set! k  #f)
           )
        ) 
        (set! x (read-line in))
    )
   (close-port in)
  k
))

(define (kconv-file  file new code . org-code)
  (let* ((x 0) (in 0)(out 0)(tmp #f)(conv 0) (err 0))
     (when  (string=? file new) 
           (set! tmp new)
           (set! new (make-temp-file))
     )
     ;;; always overwrite!!!
     ;;;(when  (and (not tmp) (file-exists? new))
     ;;;        (format  (current-error-output-port ) "file exists ~s~%" new)
     ;;;        (error 810 new))
     (if (pair? org-code)
            (set! org-code (car org-code))
            (set! org-code (file-code? file))
     )
     (if  (and org-code (not (eq? org-code :ascii)))
        (if (eq? org-code code)
            (if tmp tmp (copy-file file new) )
          (begin
             (set! conv (kconv-func org-code code))  
             (set! in (open-input-file file))
             (set! out (open-output-file new))
             (set! x (read-line in))
             (while (not (eof-object? x))
                (set! s (funcall conv x))
                (if s  
                    (set! x s) 
                    (begin
                   ;;(format #t "~s~% " (map (lambda(x) (format #f "~x" (char->integer x)))
                   ;;                (string->byte-list x)))
                       (inc err)
                    )
                )
                (display x out)
                (newline out)
                (set! x (read-line in))
             )
            (close-port in)
            (close-port out)
            (when tmp
               (remove-file file)
               (copy-file new file)
               (remove-file new)
               (set! new file)
            )
           new
         )
       )
     (if tmp tmp (copy-file file new) )
    )
  (if (> err 0) (cons org-code err) (if tmp tmp new))
))
     
               
             
             
        


        
