;;;; function stream
;;;   for string
;;;;    read-pos  version

(in-package "string-port")

(define (make-unread-str)
   (let* ((stream #f))
     (lambda (op x)
     ;;;(format #t "test: ~s ~s  ~%" op x )
      (cond ((eq? op :input)
                (read-char stream)
             )
           ((eq? op :unread)
                 (if (not (eof-object? x) )  ;;;because peekc at the  end of string
                      (shift-read-pos -1 stream)   ;;; *****  Ignore x!!!   ********
                 )
                   x
             )
           ((eq? op :ready) #t)
           ((eq? op :open)
               (set! stream (open-input-str (car x)))
                :unread
              )
          ((eq? op :close)
               (close-port stream)  )
           ((eq? op :reopen)
               (reopen-str stream)
            )
          (else #f)
       )
    )
))
     

(define (readpos-str-port str)
     (open-input-func (make-unread-str) str)
)

(export 'readpos-str-port)
(use-package "string-port" "ss")    

;;;;(define user:in (readpos-str-port  "step"))
