;;; 2007.1.8
;;;  New VM
;;;;    list object version by vm-compiler.ss
;;;    2010.4.27
;;;   lambda, macro  ->  struct  2010.4.28
;;;  For ss2n     2010.5.9

(load "vm-compiler")
(load "vm-list-final")
(load "vm-op-table")

;;;  System register
(define SCM ())
(define ST ())      ;;;  for Stack value & Temp    
(define BA (list #f))      ;;;  BA=*here* in do-wind-my5.ss
(define MULTI ())
(define GENV ())
(define ENV ())
(define Stack 0)
(define Frame 0)
(define Frame-end 0)
(define ARGS ())
(define NARG 0)   ;;; Not important
(define LEVEL 0)

(define Debug #f)
(define Restore-times 0)

(define PC 0)
(define PCST ())  ;;;; PC stack list

;;; System stack
(define SV (make-vector 10000))
(define (Push val) 
   (push val PCST)
)
(define (Push-ENV)
   (push ENV PCST)
)

;;(define (Reg-Push reg)
;;   (push (symbol-value reg) PCST)
;;)


(define (Push-Frame val)
   (vector-set! SV Stack val)
   (inc Stack)
)

(define (Pull reg)
     (symbol-value-set reg  (pop PCST ))
)

(define (Pull-ENV)
     (set! ENV  (pop PCST ))
)

;;; For tail
(define (Pull-PCST n)
   (while (> n 0)
      (set! PCST (cdr PCST))
      (dec n)
   )
)

(define (Pull-Frame reg)
     (dec Stack)
     (symbol-value-set reg  (vector-ref SV Stack ))
)


(define (Free-Frame n)
     (dec Stack n)
)

;;;;   MC and VM
(define (VM  OBJ env)
  (let* ((x 0) (pc PC))
   (set!  ENV env)
   (set! PC OBJ)
     (while (pair? PC)
   ;;;(format #t "DO-VM PC ~s~%" PC  )
       (set! x (pop PC))  ;;;(vector-ref OBJ PC)
       (DO-VM x )
     )
   (set!  ENV env)
   (set!  PC pc)
   SCM    ;;; for Eval!!!
)) 

(define (DO-VM OP)
    (let* ((f 0))
   ;;;(format #t "Enter DO-VM  OP~%"  )
     (set! f (function (car OP)) )
   ;;;(format #t "VM  OP:  ~s  ~%" OP )
     ;;;(format #t "VM OP ~s  para  ~s ~%" (car OP)(cdr OP))
     ;;;(print-OP OP)
    ; (print-ENV)
     ;;;;(format #t "VM Apply~%")
     (apply f (cdr OP))
     ;;;(apply funcall OP)
     ;;;;(format #t "VM  end  SCM ~s~%"  SCM)
    (print-SCM)
))

;;;;   top-level
(define (TOP)
   (let* ((S 0)(OBJ 0))
     (while (not (eq? S :q))
        (format #t "USER> ")
        (flush)
        (set! S (read))
        (set! S (macro-expand-rec S ()))
         (let* ((genv GENV) (env ENV))
            (set! OBJ (final (Compile S)))
            (set! GENV genv)
            (set! ENV env)
         )
            (set! PCST ())
        (VM OBJ ())
        (format #t "Value: ~s~%"  SCM)
        (if (pair? MULTI)
           (if (eq? SCM (car MULTI))
               (print-MULTI)
               (set! MULTI #f)
          )
       )
     )
))


(define (print-MULTI)
  (let* ((m (cdr MULTI)))
    (while (pair? m)
       (format #t "MULTI-Value: ~s~%"  (pop m))
    )
))
;;; 
(define (LOAD s)
   (let* ((a (assq s GENV)))
     (set! SCM
        (if a
             (cdr a)
              (symbol-value s)
         )
    )
  SCM   ;;; not need for debug
))

(define (SET s)
   (let* ((a (assq s GENV)))
      ;;  (if (eq? s '*here*)
      ;;    (format #t "~%~% SET *here*  ~s~%~%" SCM)
      ;;  )
       ;;;(format #t "~%~% SET ~s  ~s~%~%" s SCM)
        (if a
             (set-cdr!  a SCM)
             (error "SYSTEM")
         ;;;     (symbol-value-set s SCM)   ;;;  Danger to be error!
         )
   ;;;;  (set! SCM UNDEF)  -> compiler
))


(define (IMM s)
   (set! SCM s)
)
(define (IMM-undef)
   (set! SCM UNDEF)
)
(define (IMM-null)
   (set! SCM ())
)
(define (IMM-t)
   (set! SCM #t)
)
(define (IMM-f)
   (set! SCM #f)
)
(define (IMM-0)
   (set! SCM 0)
)
(define (IMM-1)
   (set! SCM 1)
)


(define (LOADENV s)
   ;;;(format #t "LOADENV enter for ~s ~%" s)
   ;;;(format #t "LOADENV from ENV ~s ~%" ENV)
   (set! SCM (assq s ENV))
   ;;;(format #t "LOADENV  assq ~s ~%" SCM)
   (set! SCM (cdr SCM))
   ;;;;(format #t "LOADENV  ~s ~s~%" s SCM)
)

(define (SETENV s)
  (let* ((as 0))
   ;;;;(format #t "SETENV enter  s=~s ~%" s )
   (set! as (assq s ENV))
   ;;(format #t "SETENV assq ~s ~%" as )
   ;;;(format #t "SETENV SCM ~s ~%" SCM )
   (if (pair? as)
      ;;;  BUG?
      ;;;(if (or (eq? s 'CONT)(eq? s 'CC))
      ;;;   (push (cons s SCM) ENV)
         (set-cdr! as SCM )
      ;;;)
       (error 999 "BUG")   ;;; SYSTEM BUG!!!
   )
  ;;;(format #t "SETENV  s=~s  ~%" s )
 ;;; (format #t "SETENV  ENV ~s~%"  ENV)
  ;;;; (set! SCM UNDEF)  -> compiler
))


(define (LAMBDA def)
   ;;;(set! def (cdr def))  ;;; drop 1 head, CLOSURE-ENV
   (push (list 'CLOSURE-ENV ENV) def)   ;;; True ENV pushed as CLOSURE
   (set! def (make-struct 'sr2 () def))    ;;;;  structure OBJ
   (set! SCM def)
)
(define (MACRO def)
   ;;;(set! def (cdr def))  ;;; drop 1 head
   (push (list 'CLOSURE-ENV ENV) def)
   (set! def (make-struct 'sr2macro  () def))    ;;;;  structure OBJ
   (set! SCM def)
)

(define (DEFINE x)
  (let* ((a (assq x GENV)))
    ;;;(format #t "DEFINE ~s SCM ~s~%" x SCM)
    (if a
       (set-cdr! a SCM)
       (push (cons x SCM) GENV)
    )
   ;;;(set! SCM UNDEF)
   ;;;(set! SCM a)    ;;; for debug!!!
))

(define (BIND s)
  (push (cons s SCM) ENV)
)

(define (BLOCK n)
  (set! LEVEL n)
  (Push ENV)
)

(define (BLOCKEND  n)
  (set! LEVEL (- n 1))
  (Pull 'ENV)
)


(define (JMP n)
  (let* ((x n) (cont #t))
   (while (and cont (pair? PC))
     (set! x (pop PC))
     ;;; (format #t "JMP ~s~%" x)
    (if (and (eq? 'LABEL (car x)) (eq? n (cadr x)))
        (set! cont #f)
    )
  )
)) 

(define (IF-FALSE n)
    (if (eq? SCM #f)
       (JMP n)
    )
)
;;;  JMP by size
(define (JMP2 n)
     (set! PC (drop PC n))  ;;; nthcdr
)

(define (FALSE2 n)
    (if (eq? SCM #f)
       (JMP2 n)
    )
)



(define (LABEL n)   ;;; never occur ?
)

(define (LAMBDA-BIND x n)  ;;;; Not Frame version
  ;;;(format #t "BIND ~s ~s~%" x ARGS)
  (if (pair? x)
     (push (cons (car x) ARGS) ENV)
     (push (cons  x (pop ARGS)) ENV)
  )
)

(define (FUNC tail-f)
  ;;;;(format #t "FUNC ~s ~%" SCM)
  (if (not tail-f)
    (begin
      (Push ENV)
      (Push ARGS)
    )
  )
   (Push SCM) ;;; FUNC-object
   (set! ARGS ())
)

(define (PUSH)
   (push SCM ARGS)
)

(define (JSR n)
 (let* ((s 0))
  (Pull 'ST)   ;;; FUNC-object
;;;  (format #t "JSR ARGS ~s  ST ~s ~%" ARGS  ST)
  (print-ARGS )
  ;;;(print-FUNC ST)
  (if (number? n)
         (set! NARG n)
         (set! NARG (length ARGS))
  )
  (Push PC)
  ;;;;(set! ARGS (reverse ARGS))    in compiler eval para by reverse order!!
  (set! s  (structure? ST))  
  ;;;(format #t "JSR: structure? ~s~%" s)
  (if s  ;;;;;  (pair? ST)
     (if (eq? s 'sr2)     ;;;;  VM-CLOSURE!
       (begin
         (set! PC (structure-ref ST 'sr2 0))   ;;;  ST  def
    ;;;     (format #t "structure-ref OK~%")
         ;;;;(format #t "JSR: sr2 ~s~%" PC)
       )
       (error2 "system")
     )
     (begin    ;;;;  system or predefined in SS
       ;; (format #t "JSR-system ST ~s  ARGS ~s ~%" ST ARGS)
        (set! SCM (apply ST ARGS))
       ;; (format #t "JSR-system ~s~%" SCM)
        (RETURN)
     )
  )
))

(define (TAIL-JMP n level)
  (let* ((s 0))
  (Pull 'ST)   ;;; FUNC-object
;;;  (format #t "JSR ARGS ~s  ST ~s ~%" ARGS  ST)
  ;;(print-ARGS )
  ;;;(print-FUNC ST)
  ;;;(format #t "TAIL-JMP: level ~s ARGS ~s~%" level ARGS)
  (if (number? n)
         (set! NARG n)
         (set! NARG (length ARGS))
  )
  ;;;(set! ARGS (reverse ARGS))   ;;;  V1.2  in compiler eval para
                               ;;;   by normal order!!
  (Pull-PCST level)   ;;;  drop ENV  pushed by BLOCK
  (set! s (structure? ST))
  (if s
       (if (eq? s 'sr2)   ;;;;  VM-CLOSURE!
            (set! PC (structure-ref ST 'sr2 0))   ;;;  ST  def
            (error2 "system")
       )
     (begin    ;;;;  system or predefined in SS
        (set! SCM (apply ST ARGS))
        (RETURN)   ;;;;;  Need?
                   ;;;; This need because  Optimizer will neglect (RETURN)
     )
  )
))

(define (RETURN)
   (Pull 'PC)
   (Pull 'ARGS)
   (Pull 'ENV)
)


(define  (CLOSURE-ENV env)
   (set! ENV env)
)

(define (LAMBDA-ARGS args)
   (push (cons 'LAMBDA-ARGS  args)ENV)
)

(define (SCM->MULTI)
   (set! MULTI SCM)
)
(define (MULTI->SCM)
    (if (pair? MULTI)
        (set! SCM MULTI)
        (set! SCM ())
    )
)

(define (SCM->BA)
   (set! BA SCM)
)

(define (BA->SCM)
   (set! SCM BA)
)

(define (SCM->ST)
   (set! ST SCM)
)

(define (SCM->ARGS)
   (set! ARGS SCM)
)
                                                                                                 
(define (ST->SCM)
   ;;;(format #t "ST->SCM  ~s  ---->   ~s~%" ST SCM)
   (set! SCM ST)
)

(define (COPY-CC)
  ;;; (format #t "COPY-CC~%" )
   ;;; (print-PC)
    (print-PCST)
    (set! SCM (list PC PCST ARGS ENV ))
)

(define (RESTORE-CC)
   ;;;(format #t "~%  ***  RESTORE-CC ****~%~%")
   ;;; (inc Restore-times)
   (set! PC (pop SCM))
   (set! PCST (pop SCM))
 ;;;  (set! ENV (pop SCM))
   (set! ARGS (pop SCM))
   (set! ENV (pop SCM))
   (if (pair? MULTI)
       (set! SCM (car MULTI))
       (set! SCM UNDEF)    ;;; to be change
  )
)
#|
(define (call-thunk proc)
)
|#
   
#|
(define f (lambda x x))
 (f 2 3)
|#

(define (Eval form . env)
   (if (pair? env)
       (set! env (car env))
   )
  (set! form (macro-expand-rec form env))
    (let* ((genv GENV) (env ENV))
            (set! form (final (Compile (list 'let* () form ))))  ;;; in Level 1 compile
                                          ;;; define has no effect
          
            (set! GENV genv)
            (set! ENV env)
    )
  (VM form env)
)

;;;  for debug
(define (print-ENV)
  (let* ((env ENV)(x 0))
      (format #t "PRINT-ENV:~%" )
    (while (pair? env)
      (set! x (pop env))
      (format #t "~s = " (car x) )
      (write (cdr x))
      (newline)
    )
      (format #t "END-PRINT-ENV~%" )
))

(define (print-PC)
    (format #t "PC: ~s~%" PC)
)

(define (print-PCST)
  (when Debug
   (let* ((s PCST)(x 0))
     (format #t "PCST:~%" )
     (while (pair? s)
       (set! x (pop s))
       (format #t "~s ~% " x )
     )
    (format #t "PCST END~%" )
)))

(define (print-ARGS)
   (when  Debug 
    (format #t "JSR ARGS ~s~%" ARGS  )
))
                                                                                                      
(define (print-FUNC  s)
   (when Debug
    (format #t "JSR FUNC ~s~%" s  )
))
(define (print-FUNC  s)
    (format #t "JSR FUNC ~s~%" s  )
)
(define (print-SCM)
   ;; (format #t "SCM ~s~%" SCM  )
)

;;;  (format #t "JSR ARGS ~s  ST ~s ~%" ARGS  ST)
;;;;
;;;(load "vm-gui")
;;;;
;;; load
(define   (VM-load file)
   (let* ((level Level)(in (open-input-file file)) (x (read in)) (pcst PCST))
     (while (not (eof-object? x))
          (format #t "~s~%" x)
          (set! Level 0)  ;;; top-level
          (set! x (macro-expand-rec x ()))
         (let* ((genv GENV) (env ENV))
            (set! x (final (Compile x)))
            (set! GENV genv)
            (set! ENV env)
         )
      (set! PCST ())
       (format #t "LOAD VM:~s~%" x)
         ;;;(VM x ())
       (set! x (trans-num x))
       (format #t "trans-num:~s~%" x)
       (CALL-VM  x)
       ;;;(format #t "LOAD VM  SCM:~s~%" SCM)
       (set! x (read in))
    )
   (close-port in)
   (format #t "load ~s END~%" file)
   (set! Level level)
   (set! PCST pcst)
))
(VM-load "do-wind-my5.ss")
(VM-load "values.ss")
(VM-load "call-with.ss")
;;;(VM-load "do-wind-root.ss")
;;;(load "common-tail")
;;;(VM-load "do-wind-my3.ss")
;;;(VM-load "nqueen.ss")
;;;(VM-load "bug.ss")
;;;(VM-load "r6rs.ss")

;;;(bye)
 
        
         
 
      

   
   
