;;;(load "../initogl.scm")
(define *pictures* ())
;(define picture #f)
(define *color* '(0.0 0.0 0.0))
(define *linewidth* 1)

(define *xrot* 0)
(define *yrot* 0)
(define *mouse-x* 0)
(define *mouse-y* 0)

(define *scx* 1.0)
(define *scy* 1.0)
(define *scz* 1.0)

(define (set-scale)
  (set! *scx* (/ 1.4 (max (abs *axmin*) *axmax*)))
  (set! *scy* (/ 1.4 (max (abs *aymin*) *aymax*)))
  (set! *scz* (/ 1.4 (max (abs *azmin*) *azmax*)))
)   
(define (scale-tr pos)
  (list (* (car pos) *scx*)(* (cadr pos) *scy*)(* (caddr pos) *scz*))
)
  

(define (compute_picture line-points vertexs)
  (let ((l ()) (lines '(:end)) (vtxs ()) (vtxhead ()))
    (set-scale) 
   (set! l
	   ;'(:clear colorbuffer depthbuffer 
	    '(:shademodel flat 
	    :begin linestrip))
   (set! l (cons :color (append *color* l)))
   (set! l (cons :linewidth (cons *linewidth* l)))
    (do ((pt 0))
        ((null? line-points)) 
        (set! pt (pop line-points))
        (if (pair? pt)
	   (set! lines (cons :vertex (append (scale-tr pt) lines)))
           (begin
               (push 'linestrip lines)
               (push :begin lines) 
               (push :end lines)
           )
        ) 
         
    )
   ;(set! vtxhead '(:initnames :pushname -1 :pointsize 5)) 
    (do ((i 0 (+ i 1)))
        ((null? vertexs))
        (push :end vtxs )
        (set! vtxs (append (pop vertexs) vtxs))
	(set! vtxs (append  `(:loadname ,i :begin points 
                  :vertex ) vtxs))
    )
    (set! l (append l lines vtxhead vtxs))
   ;(format #t "l=~s~%" l)
   ;(if  picture (.my.gl 'deletelist   picture ))
   (push  (apply  .my.gl 'newlist  l) *pictures*)
))
(define (clear)
    (format #t "pictures ~s~%" *pictures*)
   (do ((x 0))
       ((null? *pictures*))
       (.my.gl 'deletelist   (pop *pictures*)) 
    )
   (redraw)
)
(define ( redraw)
  (let ((lis ()))
   (.my.gl 'eval :clear 'colorbuffer 'depthbuffer :clearcolor 1 1 1)
   (if *polymode* (set! lis *poly*)
            (set! lis *pictures*)) 
   
  (do ((picture 0) (sc 1.5))
      ( (null? lis)) 
      (set! picture (pop lis))
      ( .my.gl 'eval 
	    :matrixmode 'projection 
	    :loadidentity 
	    :ortho ;(* sc *axmin*)(* sc  *axmax*) (* sc *aymin*)
                ;(* sc  *aymax*) (* sc *azmin*)(* sc *azmax*)
                -2 2 -2 2 -2 2 
	    :matrixmode 'modelview 
	    :loadidentity 
	    :rotate *yrot* 1 0 0
	    :rotate *xrot* 0 1 0
	    :call picture
      )
    ;;; (format #t "~s ~%" picture)
  )
   (.my.gl 'redraw)
))

(define (make-ogl)
 (toplevel '.my)
 (oglwin '.my.gl :width *width* :height *height*)
 (pack  .my.gl :expand 'yes :fill 'both )

 ;(compute_picture '((1 1 0) (0 0 1) (0 1 1)) '((1 1 0)))
	
 (set! *xrot* 10) 
 (set!  *yrot* 10)

 (bind .my.gl "<Button-1>" (lambda (x y) (set!  *mouse-x* x)( set! *mouse-y* y)))

 (bind .my.gl "<B1-Motion>" 
  (lambda (x y) 
    (set! *xrot* (+  *xrot* (- x *mouse-x*))) 
    (set! *yrot* (+  *yrot* (- y *mouse-y*))) 
    (set!  *mouse-x* x)
    (set!  *mouse-y* y)
    (redraw)
))
)
;(bind .my.gl "<Button-3>" (lambda (x y)( pick_point x y )))

;(bind .my.gl "<B3-Motion>" (lambda (x y)(move_point x y )))
;(redraw)















