;;;;  toukousen
;;;;
(define *tokon* 20)   ;;; No of toko-sen
(define *toko-pts* ())   ;;; No of toko-sen
 
(define (toko-data data)
  (let ((h 0) (high 0)(low 0))
     (set! *color* '(1.0 0.0 0.0))
     (set! *toko-pts* ())
    (set! h (/ (- *azmax* *azmin*) *tokon*))
     (set! high (pop data))
    (do ( (p1 0)(p3 0))
        ( (null? data))
        (set! low (pop data))
        (set! p1 (pop high))
        (set! p3 (car low)) 
      (do ((low-d (cdr low)) (p2 0)(p4 0))
          ((or (null? low-d)(null? high)))
          (set! p2 (pop high))
          (set! p4 (pop low-d))
          (toko-sen p1 p2 p3 h)
          (toko-sen p4 p2 p3 h)
          (set! p1 p2)
          (set! p3 p4)
       )
       (set! high low)
    )
    (compute_picture *toko-pts* ())
  ;(redraw)
))
(define (toko-sen p1 p2 p3 h)
 (let ((z1 (caddr p1)) (z2 (caddr p2))(z3 (caddr p3))
        (mi 0)(ma 0))
   (set! mi (floor (/ (- (min z1 z2 z3) *azmin*) h)))
    (set! ma (floor (/ (-  (max  z1 z2 z3) *azmin*) h)))
  ; (when (< mi ma)
     (do ((i mi(+ i 1)))
         ((> i ma))
         (toko-sen-da  p1 p2 p3 z1 z2 z3 (* i h))
     )
   ;)
))
(define (toko-sen-da  p1 p2 p3 z1 z2 z3 v)
 (let ((res ()))
   (set! v (+ v *azmin*))
   (cond ((= z1 v)
            (push p1 res)
             (if (= z2 v)
                (if (= z3 v)
                       () ;;; do nothing for flat triangle
                    (push p2 res)  ;;; line p1,p2
                )
                (if (<= (* (- v z3)(- v z2)) 0)
                   (push (toko-p p3 p2 z3 z2 v) res) )
            )
           )
          ((= z2 v)
            (push p2 res)
               (if (= z3 v)
                (push p3 res)  ;;; line p2,p3
                (if (<= (* (- v z3)(- v z1)) 0)
                 (push (toko-p p3 p1 z3 z1 v) res) )
               )
           )
          ((= z3 v)
            (push p3 res)
                 (if (<= (* (- v z1)(- v z2)) 0)
                   (push (toko-p p1 p2 z1 z2 v) res) )
           )
         (#t 
            (if (<= (* (- v z1)(- v z2)) 0)
               (push (toko-p p1 p2 z1 z2 v) res) )
            (if (<= (* (- v z1)(- v z3)) 0)
               (push (toko-p p1 p3 z1 z3 v) res) )
             (if (<= (* (- v z3)(- v z2)) 0)
               (push (toko-p p3 p2 z3 z2 v) res) )
          )
     )
   ;;  above is need because z1,z2==v then toko-p will take 
   ;;  unreliable  value , and three points will be taken!
  (if (= (length res ) 3) (format #t "tokosen triple case ~s ~s ~s v=~s~%" z1 z2 z3 v))
  (when (= (length res) 2)
     ;(line (apply pos-proj (car res)) (apply pos-proj (cadr res)) 'blue)
   ; (compute_picture res ())
   (set! *toko-pts* (append res *toko-pts*))
   (push #t *toko-pts*)   ;;;; kugiri
  )
))
(define (toko-p p1 p2 z1 z2 v)
  (let ((k1 (- v z2))(k2 (- z1 v)))
    (set! k1 (/ k1 (- z1 z2)))
    (set! k2 (/ k2 (- z1 z2)))
    (map (lambda (x y) (+ (* k1 x)(* k2 y))) p1 p2)
))
  

           



